// NOSHIP ...
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 52 1.15.2.4 source/albert/graph2d/grassert.hpp, 2d, ioc.v400, 000302 
/*================
||
||  File:   MediaAssertions.h
||
||  What:   Assertion macros for media code
||
||  Change history:
||
*/


#ifndef _GRASSERT_
#define _GRASSERT_

#ifndef IC_GRAPHICEXCEPTION
#include <igrexept.hpp>
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IInternalGraphicException {
public:
	static void InternalAssert(bool condition, const char* str) {
		IGraphicException::InternalAssert(condition, str);
	}
	static void ParameterAssert(bool condition, const char* str) {
		IGraphicException::ParameterAssert(condition, str);
	}
	static void InitializedAssert(bool condition, const char* str) {
		IGraphicException::InitializedAssert(condition, str);
	}
	static void ImplementedAssert(const char* str) {
		IGraphicException::ImplementedAssert(str);
	}
	static void ParameterException(bool condition, int reason) {
		IGraphicException::ParameterException(condition, reason);
	}
	static void InternalException(bool condition, int reason) {
		IGraphicException::InternalException(condition, reason);
	}
	static void GrafDeviceException(const char* str) {
		IGraphicException::GrafDeviceException(str);
	}
	static void GraphicExceptionMod(int modErr) {
		IGraphicException::GraphicExceptionMod(modErr);
	}
	static void GraphicExceptionMod1(int modErr, const char* str) {
		IGraphicException::GraphicExceptionMod1(modErr, str);
	}
	static void TransformException(int reason) {
		IGraphicException::TransformException(reason);
	}
};

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

inline void InternalAssert(bool condition, const char* str) {
	IInternalGraphicException::InternalAssert(condition, str);
}

inline void ParameterAssert(bool condition, const char* str) {
	IInternalGraphicException::ParameterAssert(condition, str);
}

inline void InitializedAssert(bool condition, const char* str) {
	IInternalGraphicException::InitializedAssert(condition, str);
}

inline void ImplementedAssert(const char* str) {
	IInternalGraphicException::ImplementedAssert(str);
}

inline void ParameterException(bool condition, int reason) {
	IInternalGraphicException::ParameterException(condition, reason);
}

inline void InternalException(bool condition, int reason) {
	IInternalGraphicException::InternalException(condition, reason);
}

inline void GrafDeviceException(const char* str) {
	IInternalGraphicException::GrafDeviceException(str);
}

inline void GraphicExceptionMod(int modErr) {
	IInternalGraphicException::GraphicExceptionMod(modErr);
}

inline void GraphicExceptionMod1(int modErr, const char* str) {
	IInternalGraphicException::GraphicExceptionMod1(modErr, str);
}

inline void TransformException(int reason) {
	IInternalGraphicException::TransformException(reason);
}

#endif // _GRASSERT_

