/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 60 1.15.1.3 source/albert/graph2d/grtype.hpp, 2d, ioc.v400, 000302 

#ifndef _GRTYPE_
#define _GRTYPE_

#include <ilanglvl.hpp>

// global cloning functions...
#define GraphicCopy ::copy
#define GraphicCopyPointer ::copyPointer

// rtti...
#if IC_RTTI_ENABLED
#define GraphicTypeid(obj) (typeid(obj))
#else
#define GraphicTypeid(obj) (&((obj).typeRepresentation()))
#endif // IC_RTTI_ENABLED


#include <stdio.h>


#include <new.h>

// new (::kSameHeap) stuff...
#pragma enum(4)
enum EHeapType { kSameHeap };
#pragma enum(pop)

#ifdef __DEBUG_ALLOC__
inline void *
operator new(size_t howMuch,
             const char* filename,
						 size_t linenum ,
						 EHeapType, const void*)
{
return ::operator new(howMuch, filename, linenum);
}


inline void *
operator new[](size_t howMuch,
             const char* filename,
						 size_t linenum ,
						 EHeapType, const void*)
{
return ::operator new[](howMuch, filename, linenum);
}

#else  // !__DEBUG_ALLOC__
inline void *
operator new(size_t howMuch, EHeapType, const void*)
{
return ::operator new(howMuch);
}

inline void *
operator new[](size_t howMuch, EHeapType, const void*)
{
 return ::operator new[](howMuch);
}
#endif  // __DEBUG_ALLOC__


#endif // _GRTYPE_
