// Revision: 18 1.3.2.3 source/albert/graph2d/ixcolrns.hpp, 2d, ioc.v400, 000302  
/* NOSHIP */
#ifndef _IXCOLRNS_
#define _IXCOLRNS_
/*******************************************************************************
* FILE NAME: ixcolrns.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     class ClosestColor  - This class is used in the ISortedSet collection    *
*                           for finding the closest color to the requested     *
*                           color when the XAllocColor fails.                  *
*                                                                              *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
extern "C" 
  {
  #include <X11/Intrinsic.h> 
  }

#ifndef _IBASE_
  #include <ibase.hpp>
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class ClosestColor 
  { 
  public:
    ClosestColor( XColor xColor, long closeness )
    : xcClColor( xColor ),
      lClCloseness( closeness )
      { }
    bool operator== ( ClosestColor const &color ) const
      { return xcClColor.pixel == color.xcClColor.pixel; }
    bool operator< ( ClosestColor const& color) const
      {
      return lClCloseness < color.lClCloseness; 
      }
    XColor asXColor()
      { 
      return xcClColor; 
      }
  private:
    XColor xcClColor;
    long lClCloseness;
  };

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif
