// NOSHIP ...
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 76 1.6.2.4 source/albert/graph2d/xpoint.hpp, 2d, ioc.v400, 000302 

//xpoint.hpp

#ifndef _XPOINT_
#define _XPOINT_

#include <X11/Xlib.h>

#include <ibase.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IDataStream;

class IXPoint {
        XPoint fPoint;

        public:
        IXPoint();
        IXPoint(const XPoint& pt );
        ~IXPoint();
        XPoint&  point();
        IDataStream& operator>>= (IDataStream&) const;
        IDataStream& operator<<= (IDataStream&);
#if 0
        IXPoint operator- () const;
        IXPoint& operator+= ( const IXPoint& Src );
        IXPoint& operator-= ( const IXPoint& Src );
        IXPoint& operator*= ( const IXPoint& Src );
        IXPoint& operator/= ( const IXPoint& Src );
#endif
        IXPoint& operator= (const IXPoint& Src );
        bool operator== ( const IXPoint& Src ) const;
        bool operator!= ( const IXPoint& Src ) const;
#if 0
        short& operator[]( unsigned long index );
#endif
};

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _XPOINT_
