#ifndef _IBUFFER_INL_
#define _IBUFFER_INL_
/*----------------------------------------------------------------------------*/
/* FILE NAME: ibuffer.inl                                                     */
/*                                                                            */
/* DESCRIPTION:                                                               */
/*   This file contains the definition of the inline functions for the        */
/*   classes declared in ibuffer.hpp.                                         */
/*                                                                            */
/*                                                                            */
/* COPYRIGHT:                                                                 */
/*   IBM Open Class Library                                                   */
/*   Licensed Materials - Property of IBM                                     */
/*                                                                            */
#ifdef __MVS__
/*   5645-001                                                                 */
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __OS400__
/*   ????-???                                                                 */
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __OS2__
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __WINDOWS__
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef _AIX
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef _sparc
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __sparc
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
/*                                                                            */
/*----------------------------------------------------------------------------*/

extern "C" {
  #include <limits.h>
}

#include <iexcbase.hpp>

#pragma info(nopar)

/*---------------------------- Overflow Checking -----------------------------*/
inline unsigned IBuffer :: checkAddition ( unsigned addend1, unsigned addend2 )
  {
  return ( addend1 < UINT_MAX - addend2 ) ? addend1 + addend2 : overflow();
  }
inline unsigned IBuffer :: checkMultiplication ( unsigned factor1,
                                                 unsigned factor2 )
  {
  return ( factor1 < UINT_MAX / factor2 ) ? factor1 * factor2 : overflow();
  }
/*-------------------------------- Accessors ---------------------------------*/
inline unsigned IBuffer :: useCount ( ) const
  {
  return (unsigned)(this->count());
  }
inline unsigned IBuffer :: length ( ) const
  {
  return len;
  }
inline const char *IBuffer :: contents ( ) const
  {
  return data;
  }
inline char *IBuffer :: contents ( )
  {
  return data;
  }

#if 0     // moved these functions to ibuffer0.cpp for SOM

#if defined (__SOM_ENABLED__ ) && defined (__RRBC_LIB__)

inline IBuffer *IBuffer :: fromContents ( const char *p )
  {
  return (IBuffer*)( p - offsetof( IBuffer, data ) - sizeof(p) );
  }

#else

inline IBuffer *IBuffer :: fromContents ( const char *p )
  {
  return (IBuffer*)( p - offsetof( IBuffer, data ) );
  }

#endif    // SOM_ENABLED & RRBC_LIB

#endif // for SOM



#pragma info(restore)

#endif // _IBUFFER_INL_
