#ifndef _IDBCSBUF_INL_
#define _IDBCSBUF_INL_
/*----------------------------------------------------------------------------*/
/* FILE NAME: idbcsbuf.inl                                                    */
/*                                                                            */
/* DESCRIPTION:                                                               */
/*   This file contains the definition of the inline functions for the        */
/*   classes declared in idbcsbuf.hpp.                                        */
/*                                                                            */
/*                                                                            */
/* COPYRIGHT:                                                                 */
/*   IBM Open Class Library                                                   */
/*   Licensed Materials - Property of IBM                                     */
/*                                                                            */
#ifdef __MVS__
/*   5645-001                                                                 */
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __OS400__
/*   ????-???                                                                 */
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __OS2__
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __WINDOWS__
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef _AIX
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef _sparc
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __sparc
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
/*                                                                            */
/*----------------------------------------------------------------------------*/

#ifdef IC_NLS
  #include <istring.hpp>
#endif

inline size_t IDBCSBuffer :: charLength ( char const* p )
  {

#ifdef IC_NLS
  if (IString::isInternationalized())
  {
  if ( *p == 0 )
     return 1;
  else
  {
   int temp = 0;
   return ( ( (temp = mblen( p, MB_LEN_MAX ) ) > 0) ? temp : 1 );
  }
  }
  else
  {
#endif
#if defined(IC_PMWIN)
  return (IBuffer::isDBCSLead(*p) ? 2 : 1);
#endif   //IC_PMWIN
  if ( *p == 0 )
     return 1;
  else
  {
   int temp = 0;
   return ( ( (temp = mblen( p, MB_LEN_MAX ) ) > 0) ? temp : 1 );
  }

#ifdef IC_NLS
  }
#endif

  }

inline size_t IDBCSBuffer :: charLength ( unsigned pos ) const
  {
  return charLength ( contents() + pos - 1 );
  }

inline size_t IDBCSBuffer :: maxCharLength ( )
  {
  return MB_CUR_MAX;
  }

inline bool IDBCSBuffer :: isSBC ( char const* p )
  {
  return ( charLength ( p ) == 1 );
  }

#ifdef   IC_PM
inline bool IDBCSBuffer :: isDBCS1 ( unsigned pos ) const
  {
  return IBuffer::isDBCSLead( (unsigned) ( this->contents()[ pos-1 ] ) );
  }

inline bool IDBCSBuffer :: isPrevDBCS ( unsigned pos ) const
  {
  return ( pos < 3 ) ?
    false
  :
    this->charType( pos-1 ) == IStringEnum::dbcs2;
  }
#endif   //IC_PM
#endif // _IDBCSBUF_INL_
