/*----------------------------------------------------------------------------*/
/* FILE NAME: istrtest.cpp                                                    */
/*                                                                            */
/* DESCRIPTION:                                                               */
/*   This file contains the implementation of classes/functions declared      */
/*   in istrtest.hpp.                                                         */
/*                                                                            */
/*                                                                            */
/* COPYRIGHT:                                                                 */
/*   IBM Open Class Library                                                   */
/*   Licensed Materials - Property of IBM                                     */
/*                                                                            */
#ifdef __MVS__
/*   5645-001                                                                 */
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __OS400__
/*   ????-???                                                                 */
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __OS2__
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __WINDOWS__
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef _AIX
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef _sparc
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
#ifdef __sparc
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
#endif
/*                                                                            */
/*   US Government Users Restricted Rights - Use, duplication, or             */
/*   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.        */
/*                                                                            */
/*----------------------------------------------------------------------------*/
#ifdef __MVS__
    #pragma csect(code,"ISTRTEST")
    #pragma csect(static,"SSTRTEST")
    #pragma comment (copyright, \
    "Licensed Materials - Property of IBM  5645-001 (C) \
    Copyright IBM Corp. 1992, 1997  All Rights Reserved. \
    US Government Users Restricted Rights - Use, duplication, or \
    disclosure restricted by GSA ADP Schedule Contract with IBM Corp.")
#endif

#include <istrtest.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
  #define _ISTRTEST_CPP_
  #include <ipagetun.h>
#endif

/*------------------------------------------------------------------------------
| IStringTest::IStringTest                                                     |
------------------------------------------------------------------------------*/

#ifndef _MSC_VER
IStringTest :: IStringTest ( CFunction &cfunc )
#else
IStringTest :: IStringTest ( CFunction cfunc )
#endif
  : type( c )
  {
#ifndef _MSC_VER
  data.cFn = &cfunc;
#else
  data.cFn = cfunc;
#endif
  }


#ifdef IC_NOTYET
IStringTest :: IStringTest ( CPPFunction &cppfunc )
  : type( cpp )
  {
  data.cppFn =  &cppfunc;
  }
#endif


/*------------------------------------------------------------------------------
| IStringTest::~IStringTest                                                    |
------------------------------------------------------------------------------*/
IStringTest :: ~IStringTest ( )
  {
  }

bool IStringTest :: test ( int ch ) const
  {
  if ( this->type == c )
    return data.cFn( ch );
#ifdef IC_NOTYET
  else if ( this->type == cpp )
    return data.cppFn( ch );
#endif
  else
    return false;
  }

