// Revision: 07 1.3.1.4 source/core/base/itrace.inl, appsupport, ioc.v400, 000302 
#ifndef _ITRACE_INL_
#define _ITRACE_INL_
// ----------------------------------------------------------------------------
// FILE NAME: itrace.inl
//
// DESCRIPTION:
//   This file contains the definition of the inline functions for the
//   classes declared in itrace.hpp.
//
//
// COPYRIGHT:
//   IBM Open Class Library
//   Licensed Materials - Property of IBM
//   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.
//
// ----------------------------------------------------------------------------

#include <istring.hpp>

#ifndef IC_WIN
inline void ITrace :: enableWriteLineNumber()
{
  ITrace::iClState |= ITrace::writeLineNumber;
}

inline void ITrace :: disableWriteLineNumber()
{
  ITrace::iClState &= ~ITrace::writeLineNumber;
}


inline bool ITrace :: isWriteLineNumberEnabled()
{
  return (ITrace::iClState & ITrace::writeLineNumber);
}


inline void ITrace::enableTrace()
{
  ITrace::iClState |= ITrace::on;
}

inline void ITrace::disableTrace()
{
  ITrace::iClState &= ~ITrace::on;
}

inline bool ITrace::isTraceEnabled()
{
  return (ITrace::iClState & ITrace::on);
}

inline void ITrace::writeToQueue()
{
 ITrace::iClTraceLocation = ITrace::queue;
}


inline void ITrace::writeToStandardError()
{
   ITrace::iClTraceLocation = ITrace::standardError;
}

inline void ITrace::writeToStandardOutput()
{
   ITrace::iClTraceLocation = ITrace::standardOutput;
}

inline void ITrace::writeToFile()
{
   ITrace::iClTraceLocation = ITrace::file;
}

inline ITrace::Destination ITrace::traceDestination()
{
   return(ITrace::iClTraceLocation);
}

inline void ITrace::enableWritePrefix()
{
  ITrace::iClState |= ITrace::writePrefix;
}

inline void ITrace::disableWritePrefix()
{
  ITrace::iClState &= ~ITrace::writePrefix;
}

inline bool ITrace::isWritePrefixEnabled()
{
  return (ITrace::iClState & ITrace::writePrefix);
}
#endif // IC_WIN

#endif // _ITRACE_INL_
