// ----------------------------------------------------------------------------
// FILE NAME: ivbase.cpp
//
// DESCRIPTION:
//   This file contains the implementation of the class IVBase, used when
//   the derived class has or may have virtual functions (otherwise, derive
//   from IBase), declared in ivbase.hpp.
//
// COPYRIGHT:
//   IBM Open Class Library
//   Licensed Materials - Property of IBM
//
//   5645-001
//   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.
//
//   US Government Users Restricted Rights - Use, duplication, or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
//  Revision: 08  1.4.1.2  source/core/base/ivbase.cpp, appsupport, ioc.v400, 000302  
// ----------------------------------------------------------------------------*/

#include <ivbase.hpp>
#include <istring.hpp>

#ifdef IC_MVS
// Need _OPEN_THREADS for thread-safe version of USL
#include <ibhandle.hpp>
#endif

// Segment definitions
#ifdef IC_PAGETUNE
    #define _IVBASE_CPP_
    #include <ipagetun.h>
#endif

IVBase::~IVBase()
{
}

IString IVBase::asString() const
{
    return "IVBase object";
}

IString IVBase::asDebugInfo() const
{
    IString result = "IVBase(@";
    result += IString((unsigned long)this).d2x();
    result += ")";
    return result;
}
