// ----------------------------------------------------------------------------
// FILE NAME: iversion.cpp
//
// DESCRIPTION:
//   This file contains the implementation of classes/functions declared
//   in iversion.hpp.
//
//
// COPYRIGHT:
//   IBM Open Class Library
//   Licensed Materials - Property of IBM
//
//   5645-001
//   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.
//
//   US Government Users Restricted Rights - Use, duplication, or
//   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
// Revision: 03 1.3 source/core/base/iversion.cpp, appsupport, ioc.v400, 000302 
// ----------------------------------------------------------------------------

#include <iversion.hpp>

IString
IVersion::asString() const
{
    return IString(Major) + IString(".") + IString(Minor);
}

IVersion 
IVersion::libraryVersion()
{
    return IVersion(IC_MAJOR_VERSION, IC_MINOR_VERSION);
}

void
IVersion::writeToStream(IDataStream& toWhere) const
{
    Major >>= toWhere;
    Minor >>= toWhere;
}

void
IVersion::readFromStream(IDataStream& fromWhere)
{
    Major <<= fromWhere;
    Minor <<= fromWhere;
}
