// Revision: 51 1.2.1.4 source/core/base/win32/iwextprc.hpp, oss, ioc.v400, 000302 

#ifndef _IWEXTPRC_
#define _IWEXTPRC_

// ----------------------------------------------------------------------------
// FILE NAME: iwextprc.hpp
//
// DESCRIPTION:
//
//  This module implements the IWinExtProcImpl class, which is the
//  Win32 version of the IExtProcImplBase class from iextproc.hpp. The
//  IExternalProcess class manages processes this virtual base class and a
//  platform specific derivative is provided for each platform.
//
//
// COPYRIGHT:
//   IBM Open Class Library
//   Licensed Materials - Property of IBM
//
//   5645-001
//   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.
//
//   US Government Users Restricted Rights - Use, duplication, or
//   disclosure restricted by GSA ADP Schedule Contract with IBM
//   Corp.
// ----------------------------------------------------------------------------

#include    <iprcenv.hpp>
#include    <iextproc.hpp>
#include    <itext.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)

class IC_EXPORTB IWinExtProcImpl : public IExtProcImplBase
{
    public :
        IWinExtProcImpl();
        ~IWinExtProcImpl();

        // Getter methods
        void* getHandle() const;

        // We have to provide implementations for these
        virtual INonGUIApplication::PriorityClass getPriority() const;
        virtual bool exitStatus(unsigned long& status) const;
        virtual bool isRunning() const;
        virtual bool setPriority(INonGUIApplication::PriorityClass priority);
        virtual void start(const IText* argArray, const unsigned long argCount);
        virtual void kill();
        virtual bool wait(const long timeout) const;

    private :
        IWinExtProcImpl(const IWinExtProcImpl&) {}
        void operator=(const IWinExtProcImpl&) {}

        // For our internal purposes we store the handle
        void* fHandle;
        static bool fUseUnicode;
};

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif
