// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 12 1.5.1.4 source/core/collect/iabag.h, collection, ioc.v400, 000302 
#ifndef _IABAG_
#define _IABAG_

#include <iaequal.h>
#include <iiabag.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IABag :
  public IAEqualityCollection <Element> {

  typedef  IAEqualityCollection <Element> Inherited;

  typedef  IABagImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IABag
                            (INotifier&);

#endif
          ~IABag
                            ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addDifference    (IABag <Element> const&,
                             IABag <Element> const&); 

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addIntersection  (IABag <Element> const&,
                             IABag <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addUnion         (IABag <Element> const&,
                             IABag <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     differenceWith   (IABag <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     intersectionWith (IABag <Element> const&);

  INumber  numberOfDifferentElements
                            () const;

  bool     setToNextDifferentElement
                            (ICursor&) const;

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     unionWith        (IABag <Element> const&);

  bool     operator==       (IABag
                              <Element> const&) const;

  bool     operator!=       (IABag
                              <Element> const&) const;

protected:

           IABag
                            ();

           IABag
                            (IABag <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IABag <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           addDifference    (IABag <Element> const,\
                             IABag <Element> const&),\
           addIntersection  (IABag <Element> const&,\
                             IABag <Element> const&),\
           addUnion         (IABag <Element> const&,
                             IABag <Element> const&),\
           differenceWith   (IABag <Element> const&),\
           intersectionWith (IABag <Element> const&),\
           numberOfDifferentElements\
                            () const,\
           setToNextDifferentElement
                            (ICursor&) const,\
           unionWith        (IABag <Element> const&),\
           operator==       (IABag\
                              <Element> const&) const,\
           operator!=       (IABag\
                              <Element> const&) const,\
           ImplOf           (IABag <Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iabag.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IABAG_
