// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 26 1.4.1.3 source/core/collect/iaequal.h, collection, ioc.v400, 000302 
#ifndef _IAEQUAL_
#define _IAEQUAL_

#include <iacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IAEqualityCollection : public virtual IACollection <Element>
{
  typedef  IACollectionImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IAEqualityCollection
                            (INotifier&);

#endif
          ~IAEqualityCollection
                            ();

  bool contains         (Element const&) const;

  bool containsAllFrom  (IACollection <Element> const&) const;

  bool locate           (Element const&, ICursor&) const;

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  bool locateOrAdd      (Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  bool locateOrAdd      (Element const&, ICursor&);

  bool locateNext       (Element const&, ICursor&) const;

  INumber  numberOfOccurrences
                            (Element const&) const;

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  bool remove           (Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  INumber  removeAllOccurrences
                            (Element const&);

protected:

           IAEqualityCollection
                            ();

           IAEqualityCollection
                            (IAEqualityCollection <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IAEqualityCollection <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           contains        (Element const&) const,\
           containsAllFrom (IACollection <Element> const&) const,\
           locate          (Element const&, ICursor&) const,\
           locateOrAdd     (Element const&),\
           locateOrAdd     (Element const&, ICursor&),\
           locateNext      (Element const&, ICursor&) const,\
           numberOfOccurrences\
                           (Element const&) const,\
           remove          (Element const&),\
           removeAllOccurrences\
                           (Element const&),\
           ImplOf          (IAEqualityCollection <Element> const&))
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <iaequal.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAEQUAL_
