// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 31 1.4.1.3 source/core/collect/iahp.h, collection, ioc.v400, 000302 
#ifndef _IAHP_
#define _IAHP_

#include <iacllct.h>
#include <iiahp.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IAHeap :
  public IACollection <Element> {

  typedef  IACollection <Element> Inherited;

  typedef  IAHeapImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IAHeap
                            (INotifier&);

#endif
          ~IAHeap
                            ();

protected:

           IAHeap
                            ();

           IAHeap
                            (IAHeap <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IAHeap <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ImplOf           (IAHeap <Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iahp.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAHP_
