// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 33 1.4.1.3 source/core/collect/iakb.h, collection, ioc.v400, 000302 
#ifndef _IAKB_
#define _IAKB_

#include <iakey.h>
#include <iiakb.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key>
class IAKeyBag :
  public IAKeyCollection <Element, Key> {

  typedef  IAKeyCollection <Element, Key> Inherited;

  typedef  IAKeyBagImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IAKeyBag
                            (INotifier&);

#endif
          ~IAKeyBag
                            ();

protected:

           IAKeyBag
                            ();

           IAKeyBag
                            (IAKeyBag <Element, Key> const&);

private:

  static
  Implementation&
           ImplOf           (IAKeyBag <Element, Key> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ImplOf           (IAKeyBag <Element, Key> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iakb.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAKB_
