// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 41 1.4.1.3 source/core/collect/iaksb.h, collection, ioc.v400, 000302 
#ifndef _IAKSB_
#define _IAKSB_

#include <iaksrt.h>
#include <iiaksb.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key>
class IAKeySortedBag :
  public IAKeySortedCollection <Element, Key> {

  typedef  IAKeySortedCollection <Element, Key> Inherited;

  typedef  IAKeySortedBagImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IAKeySortedBag
                            (INotifier&);

#endif
          ~IAKeySortedBag
                            ();

  long     compare          (IAKeySortedBag <Element, Key> const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;
 
protected:

           IAKeySortedBag
                            ();

           IAKeySortedBag
                            (IAKeySortedBag <Element, Key> const&);

private:

  static
  Implementation&
           ImplOf           (IAKeySortedBag <Element, Key> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           compare          (IAKeySortedBag <Element, Key> const&,\
                             long (*)\
                              (Element const&, Element const&) const,\
           ImplOf           (IAKeySortedBag <Element, Key> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iaksb.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAKSB_
