// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 47 1.4.1.2 source/core/collect/iakss.inl, collection, ioc.v400, 000302  
#ifndef _IAKSS_INL_
#define _IAKSS_INL_

// ---
// IAKeySortedSet
// ---

#include <ilanglvl.hpp>

#if ! defined (__INO_AVALON__)
template <class Element, class Key>
inline
IAKeySortedSet <Element, Key>::
IAKeySortedSet (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element, class Key>
inline
IAKeySortedSet <Element, Key>::
~IAKeySortedSet ()
{
}

template <class Element, class Key>
inline long
IAKeySortedSet <Element, Key>::
compare (IAKeySortedSet <Element, Key> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

// protected members

template <class Element, class Key>
inline
IAKeySortedSet <Element, Key>::
IAKeySortedSet ()
{
}

template <class Element, class Key>
inline
IAKeySortedSet <Element, Key>::
IAKeySortedSet (IAKeySortedSet <Element, Key> const& collection)
: Inherited (collection)
{
}

template <class Element, class Key>
inline INumber
IAKeySortedSet <Element, Key>::
numberOfDifferentKeys () const
{ return IAKeyCollection <Element, Key>::numberOfDifferentKeys ();
}

template <class Element, class Key>
inline INumber
IAKeySortedSet <Element, Key>::
numberOfElementsWithKey (Key const& key) const
{ return IAKeyCollection <Element, Key>::numberOfElementsWithKey (key);
}

template <class Element, class Key>
inline INumber
IAKeySortedSet <Element, Key>::
removeAllElementsWithKey (Key const& key)
{ return IAKeyCollection <Element, Key>::removeAllElementsWithKey (key);
}

template <class Element, class Key>
inline bool
IAKeySortedSet <Element, Key>::
setToNextWithDifferentKey (ICursor& cursor) const
{ return
    IAKeyCollection <Element, Key>::setToNextWithDifferentKey (cursor);
}

// private members

template <class Element, class Key>
inline TYPENAME IAKeySortedSet <Element, Key>::Implementation&
IAKeySortedSet <Element, Key>::
ImplOf (IAKeySortedSet <Element, Key> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IAKSS_INL_
