// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 55 1.4.1.3 source/core/collect/iappl.h, collection, ioc.v400, 000302 
#ifndef _IAPPL_
#define _IAPPL_

#include <iglobals.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IApplicator
{
public:

  virtual
  bool applyTo          (Element&) = 0;

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           applyTo          (Element&)\
                        )
#endif

};

template <class Element>
class IConstantApplicator 
{
public:

  virtual
  bool applyTo          (Element const&) = 0;

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           applyTo          (Element const&)\
                        )
#endif

};

class IInternalApplicator 
{
public:

  virtual
  bool applyTo          (void*)
           { return true;
           }

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           applyTo          (void*)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

inline bool
__applFunc (void* element, void* applicator)
{
#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
  static IInternalApplicator dummyApplicator;
#endif
  return ((IInternalApplicator*)applicator)->applyTo (element);
}

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAPPL_
