// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 59 1.4.1.3 source/core/collect/iaqu.h, collection, ioc.v400, 000302 
#ifndef _IAQU_
#define _IAQU_

#include <iarstrct.h>
#include <iaorder.h>
#include <iiaseq.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IAQueue :
  public IARestrictedAccessCollection <Element> {

  typedef  IARestrictedAccessCollection <Element> Inherited;

  typedef  IASequenceImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IAQueue
                            (INotifier&);

#endif
          ~IAQueue
                            ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsLast        (Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsLast        (Element const&, ICursor&);

  long     compare          (IAQueue <Element> const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;
 
#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     dequeue          ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     dequeue          (Element&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     enqueue          (Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     enqueue          (Element const&, ICursor&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     removeFirst      ();

protected:

           IAQueue
                            ();

           IAQueue
                            (IAQueue <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IAQueue <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           addAsLast        (Element const&),\
           addAsLast        (Element const&, ICursor&),\
           compare          (IAQueue <Element> const&,\
                             long (*)\
                              (Element const&, Element const&) const,\
           dequeue          (),\
           dequeue          (Element&),\
           enqueue          (Element const&),\
           enqueue          (Element const&, ICursor),\
           removeFirst      (),\
           ImplOf           (IAQueue <Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iaqu.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IAQU_
