// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 67 1.5.1.3 source/core/collect/iasb.h, collection, ioc.v400, 000302 
#ifndef _IASB_
#define _IASB_

#include <iaeqsrt.h>
#include <iiasb.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IASortedBag :
  public IAEqualitySortedCollection <Element> {

  typedef  IAEqualitySortedCollection <Element> Inherited;

  typedef  IASortedBagImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IASortedBag
                            (INotifier&);

#endif
          ~IASortedBag
                            ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addDifference    (IASortedBag <Element> const&,
                             IASortedBag <Element> const&); 

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addIntersection  (IASortedBag <Element> const&,
                             IASortedBag <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addUnion         (IASortedBag <Element> const&,
                             IASortedBag <Element> const&);

  long     compare          (IASortedBag <Element> const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;
 
#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     differenceWith   (IASortedBag <Element> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     intersectionWith (IASortedBag <Element> const&);

  INumber  numberOfDifferentElements
                            () const;

  bool     setToNextDifferentElement
                            (ICursor&) const;

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     unionWith        (IASortedBag <Element> const&);

  bool     operator==       (IASortedBag
                              <Element> const&) const;

  bool     operator!=       (IASortedBag
                              <Element> const&) const;

protected:

           IASortedBag
                            ();

           IASortedBag
                            (IASortedBag <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IASortedBag <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           addDifference    (IASortedBag <Element> const,\
                             IASortedBag <Element> const&),\
           addIntersection  (IASortedBag <Element> const&,\
                             IASortedBag <Element> const&),\
           addUnion         (IASortedBag <Element> const&,
                             IASortedBag <Element> const&),\
           compare          (IASortedBag <Element> const&,\
                             long (*)\
                              (Element const&, Element const&) const,\
           differenceWith   (IASortedBag <Element> const&),\
           intersectionWith (IASortedBag <Element> const&),\
           numberOfDifferentElements\
                            () const,\
           setToNextDifferentElement
                            (ICursor&) const,\
           unionWith        (IASortedBag <Element> const&),\
           operator==       (IASortedBag\
                              <Element> const&) const,\
           operator!=       (IASortedBag\
                              <Element> const&) const,\
           ImplOf           (IASortedBag <Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iasb.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IASB_
