// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 68 1.4.1.2 source/core/collect/iasb.inl, collection, ioc.v400, 000302  
#ifndef _IASB_INL_
#define _IASB_INL_

// ---
// IASortedBag
// ---

#include <ilanglvl.hpp>

#if ! defined (__INO_AVALON__)
template <class Element>
inline
IASortedBag <Element>::
IASortedBag (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element>
inline
IASortedBag <Element>::
~IASortedBag ()
{
}

template <class Element>
inline void
IASortedBag <Element>::
addDifference (IASortedBag <Element> const& collection1,
               IASortedBag <Element> const& collection2)
{ this->ImplOf (*this).
    AddDifference (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline void
IASortedBag <Element>::
addIntersection (IASortedBag <Element> const& collection1,
                 IASortedBag <Element> const& collection2)
{ this->ImplOf (*this).
    AddIntersection (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline void
IASortedBag <Element>::
addUnion (IASortedBag <Element> const& collection1,
          IASortedBag <Element> const& collection2)
{ this->ImplOf (*this).
    AddUnion (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline long
IASortedBag <Element>::
compare (IASortedBag <Element> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

template <class Element>
inline void
IASortedBag <Element>::
differenceWith (IASortedBag <Element> const& collection)
{ this->ImplOf (*this).Difference (this->ImplOf (collection));
}

template <class Element>
inline void
IASortedBag <Element>::
intersectionWith (IASortedBag <Element> const& collection)
{ this->ImplOf (*this).Intersection (this->ImplOf (collection));
}

template <class Element>
inline INumber
IASortedBag <Element>::
numberOfDifferentElements () const
{ return this->ImplOf (*this).NumberOfDifferentElements ();
}

template <class Element>
inline bool
IASortedBag <Element>::
setToNextDifferentElement (ICursor& cursor) const
{ return this->ImplOf (*this).SetToNextDifferentElement (this->CrsrImplOf (cursor));
}

template <class Element>
inline void
IASortedBag <Element>::
unionWith (IASortedBag <Element> const& collection)
{ this->ImplOf (*this).Union (this->ImplOf (collection));
}

template <class Element>
inline bool
IASortedBag <Element>::
operator== (IASortedBag <Element> const& collection) const
{ return this->ImplOf (*this).operator== (this->ImplOf (collection));
}

template <class Element>
inline bool
IASortedBag <Element>::
operator!= (IASortedBag <Element> const& collection) const
{ return this->ImplOf (*this).operator!= (this->ImplOf (collection));
}

// protected members

template <class Element>
inline
IASortedBag <Element>::
IASortedBag ()
{
}

template <class Element>
inline
IASortedBag <Element>::
IASortedBag (IASortedBag <Element> const& collection)
: Inherited (collection)
{
}

// private members

template <class Element>
inline TYPENAME IASortedBag <Element>::Implementation&
IASortedBag <Element>::
ImplOf (IASortedBag <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IASB_INL_
