// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 72 1.4.1.2 source/core/collect/iaset.inl, collection, ioc.v400, 000302  
#ifndef _IASET_INL_
#define _IASET_INL_

// ---
// IASet
// ---

#include <ilanglvl.hpp>

#if ! defined (__INO_AVALON__)
template <class Element>
inline
IASet <Element>::
IASet (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element>
inline
IASet <Element>::
~IASet ()
{
}

template <class Element>
inline void
IASet <Element>::
addDifference (IASet <Element> const& collection1,
               IASet <Element> const& collection2)
{ this->ImplOf (*this).
    AddDifference (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline void
IASet <Element>::
addIntersection (IASet <Element> const& collection1,
                 IASet <Element> const& collection2)
{ this->ImplOf (*this).
    AddIntersection (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline void
IASet <Element>::
addUnion (IASet <Element> const& collection1,
          IASet <Element> const& collection2)
{ this->ImplOf (*this).
    AddUnion (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline void
IASet <Element>::
differenceWith (IASet <Element> const& collection)
{ this->ImplOf (*this).Difference (this->ImplOf (collection));
}

template <class Element>
inline void
IASet <Element>::
intersectionWith (IASet <Element> const& collection)
{ this->ImplOf (*this).Intersection (this->ImplOf (collection));
}

template <class Element>
inline void
IASet <Element>::
unionWith (IASet <Element> const& collection)
{ this->ImplOf (*this).Union (this->ImplOf (collection));
}

template <class Element>
inline bool
IASet <Element>::
operator== (IASet <Element> const& collection) const
{ return this->ImplOf (*this).operator== (this->ImplOf (collection));
}

template <class Element>
inline bool
IASet <Element>::
operator!= (IASet <Element> const& collection) const
{ return this->ImplOf (*this).operator!= (this->ImplOf (collection));
}

// protected members

template <class Element>
inline
IASet <Element>::
IASet ()
{
}

template <class Element>
inline
IASet <Element>::
IASet (IASet <Element> const& collection)
: Inherited (collection)
{
}

template <class Element>
inline bool
IASet <Element>::
locateNext (Element const& element, ICursor& cursor) const
{ return IAEqualityCollection <Element>::locateNext (element, cursor);
}

template <class Element>
inline INumber
IASet <Element>::
numberOfOccurrences (Element const& element) const
{ return IAEqualityCollection <Element>::numberOfOccurrences (element);
}

template <class Element>
inline INumber
IASet <Element>::
removeAllOccurrences (Element const& element)
{ return IAEqualityCollection <Element>::removeAllOccurrences (element);
}

// private members

template <class Element>
inline TYPENAME IASet <Element>::Implementation&
IASet <Element>::
ImplOf (IASet <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IASET_INL_
