// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 75 1.4.1.3 source/core/collect/iasqntl.h, collection, ioc.v400, 000302 
#ifndef _IASQNTL_
#define _IASQNTL_

#include <iaorder.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template  <class Element>
class IASequentialCollection : public IAOrderedCollection <Element> 
{
  typedef IACollectionImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IASequentialCollection
                            (INotifier&);

#endif
          ~IASequentialCollection
                            ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsFirst       (Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsFirst       (Element const&, ICursor&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsLast        (Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsLast        (Element const&, ICursor&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsNext        (Element const&, ICursor&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsPrevious    (Element const&, ICursor&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAtPosition    (IPosition, Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAtPosition    (IPosition, Element const&, ICursor&);

  Element& any              ();

  Element const&
           any              () const;

  Element& elementAtPosition
                            (IPosition);

  Element const&
           elementAtPosition
                            (IPosition) const;

  Element& first            ();

  Element const&
           first            () const;

  Element& last             ();

  Element const&
           last             () const;

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     reverse          ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     sort             (long (*comparisonFunction)
                              (Element const&, Element const&));

protected:

           IASequentialCollection
                            ();

           IASequentialCollection
                            (IASequentialCollection <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IASequentialCollection <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           addAsFirst       (Element const&),\
           addAsFirst       (Element const&, ICursor&),\
           addAsLast        (Element const&),\
           addAsLast        (Element const&, ICursor&),\
           addAsNext        (Element const&, ICursor&),\
           addAsPrevious    (Element const&, ICursor&),\
           addAtPosition    (IPosition, Element const&),\
           addAtPosition    (IPosition, Element const&, ICursor&),\
           sort             (long (*)\
                              (Element const&, Element const&)),\
           ImplOf           (IASequentialCollection <Element> const&))
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <iasqntl.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IASQNTL_
