// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 77 1.5.1.3 source/core/collect/iasr.h, collection, ioc.v400, 000302 
#ifndef _IASR_
#define _IASR_

#include <iaeqksrt.h>
#include <iiasr.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key>
class IASortedRelation :
  public IAEqualityKeySortedCollection <Element, Key> {

  typedef  IAEqualityKeySortedCollection <Element, Key> Inherited;

  typedef  IASortedRelationImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IASortedRelation
                            (INotifier&);

#endif
          ~IASortedRelation
                            ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addDifference    (IASortedRelation <Element, Key> const&,
                             IASortedRelation <Element, Key> const&); 

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addIntersection  (IASortedRelation <Element, Key> const&,
                             IASortedRelation <Element, Key> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addUnion         (IASortedRelation <Element, Key> const&,
                             IASortedRelation <Element, Key> const&);

  long     compare          (IASortedRelation <Element, Key> const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;
 
#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     differenceWith   (IASortedRelation <Element, Key> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     intersectionWith (IASortedRelation <Element, Key> const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     unionWith        (IASortedRelation <Element, Key> const&);

  bool     operator==       (IASortedRelation
                              <Element, Key> const&) const;

  bool     operator!=       (IASortedRelation
                              <Element, Key> const&) const;

protected:

           IASortedRelation
                            ();

           IASortedRelation
                            (IASortedRelation <Element, Key> const&);

  INumber  numberOfOccurrences
                            (Element const&) const;

  INumber  removeAllOccurrences
                            (Element const&);

private:

  static
  Implementation&
           ImplOf           (IASortedRelation <Element, Key> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           addDifference    (IASortedRelation <Element, Key> const,\
                             IASortedRelation <Element, Key> const&),\
           addIntersection  (IASortedRelation <Element, Key> const&,\
                             IASortedRelation <Element, Key> const&),\
           addUnion         (IASortedRelation <Element, Key> const&,
                             IASortedRelation <Element, Key> const&),\
           compare          (IASortedRelation <Element, Key> const&,\
                             long (*)\
                              (Element const&, Element const&) const,\
           differenceWith   (IASortedRelation <Element, Key> const&),\
           intersectionWith (IASortedRelation <Element, Key> const&),\
           unionWith        (IASortedRelation <Element, Key> const&),\
           operator==       (IASortedRelation\
                              <Element, Key> const&) const,\
           operator!=       (IASortedRelation\
                              <Element, Key> const&) const,\
           ImplOf           (IASortedRelation <Element, Key> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iasr.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IASR_
