// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 78 1.4.1.2 source/core/collect/iasr.inl, collection, ioc.v400, 000302  
#ifndef _IASR_INL_
#define _IASR_INL_

// ---
// IASortedRelation
// ---

#include <ilanglvl.hpp>

#if ! defined (__INO_AVALON__)
template <class Element, class Key>
inline
IASortedRelation <Element, Key>::
IASortedRelation (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element, class Key>
inline
IASortedRelation <Element, Key>::
~IASortedRelation ()
{
}

template <class Element, class Key>
inline void
IASortedRelation <Element, Key>::
addDifference (IASortedRelation <Element, Key> const& collection1,
               IASortedRelation <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddDifference (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline void
IASortedRelation <Element, Key>::
addIntersection (IASortedRelation <Element, Key> const& collection1,
                 IASortedRelation <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddIntersection (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline void
IASortedRelation <Element, Key>::
addUnion (IASortedRelation <Element, Key> const& collection1,
          IASortedRelation <Element, Key> const& collection2)
{ this->ImplOf (*this).
    AddUnion (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element, class Key>
inline long
IASortedRelation <Element, Key>::
compare (IASortedRelation <Element, Key> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

template <class Element, class Key>
inline void
IASortedRelation <Element, Key>::
differenceWith (IASortedRelation <Element, Key> const& collection)
{ this->ImplOf (*this).Difference (this->ImplOf (collection));
}

template <class Element, class Key>
inline void
IASortedRelation <Element, Key>::
intersectionWith (IASortedRelation <Element, Key> const& collection)
{ this->ImplOf (*this).Intersection (this->ImplOf (collection));
}

template <class Element, class Key>
inline void
IASortedRelation <Element, Key>::
unionWith (IASortedRelation <Element, Key> const& collection)
{ this->ImplOf (*this).Union (this->ImplOf (collection));
}

template <class Element, class Key>
inline bool
IASortedRelation <Element, Key>::
operator== (IASortedRelation <Element, Key> const& collection) const
{ return this->ImplOf (*this).operator== (this->ImplOf (collection));
}

template <class Element, class Key>
inline bool
IASortedRelation <Element, Key>::
operator!= (IASortedRelation <Element, Key> const& collection) const
{ return this->ImplOf (*this).operator!= (this->ImplOf (collection));
}

// protected members

template <class Element, class Key>
inline
IASortedRelation <Element, Key>::
IASortedRelation ()
{
}

template <class Element, class Key>
inline
IASortedRelation <Element, Key>::
IASortedRelation (IASortedRelation <Element, Key> const& collection)
: Inherited (collection)
{
}

template <class Element, class Key>
inline INumber
IASortedRelation <Element, Key>::
numberOfOccurrences (Element const& element) const
{ return IAEqualityCollection <Element>::numberOfOccurrences (element);
}

template <class Element, class Key>
inline INumber
IASortedRelation <Element, Key>::
removeAllOccurrences (Element const& element)
{ return IAEqualityCollection <Element>::removeAllOccurrences (element);
}

// private members

template <class Element, class Key>
inline TYPENAME IASortedRelation <Element, Key>::Implementation&
IASortedRelation <Element, Key>::
ImplOf (IASortedRelation <Element, Key> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IASR_INL_
