// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 88 1.4.1.3 source/core/collect/iastk.h, collection, ioc.v400, 000302 
#ifndef _IASTK_
#define _IASTK_

#include <iarstrct.h>
#include <iaorder.h>
#include <iiaseq.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element>
class IAStack :
  public IARestrictedAccessCollection <Element> {

  typedef  IARestrictedAccessCollection <Element> Inherited;

  typedef  IASequenceImpl Implementation;

public:

#if ! defined (__INO_AVALON__)
           IAStack
                            (INotifier&);

#endif
          ~IAStack
                            ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsLast        (Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     addAsLast        (Element const&, ICursor&);

  long     compare          (IAStack <Element> const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;
 
#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     pop              ();

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     pop              (Element&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     push             (Element const&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     push             (Element const&, ICursor&);

#if ! defined (INO_VIRTUAL)
  virtual
#endif
  void     removeLast       ();

  Element const&
           top              () const;

protected:

           IAStack
                            ();

           IAStack
                            (IAStack <Element> const&);

private:

  static
  Implementation&
           ImplOf           (IAStack <Element> const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           addAsLast        (Element const&),\
           addAsLast        (Element const&, ICursor&),\
           compare          (IAStack <Element> const&,\
                             long (*)\
                              (Element const&, Element const&) const,\
           pop              (),\
           pop              (Element&),\
           push             (Element const&),\
           push             (Element const&, ICursor&),\
           removeLast       (),\
           top              () const,\
           ImplOf           (IAStack <Element> const&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iastk.inl>

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IASTK_
