// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 89 1.4.1.2 source/core/collect/iastk.inl, collection, ioc.v400, 000302  
#ifndef _IASTK_INL_
#define _IASTK_INL_

// ---
// IAStack
// ---

#include <ilanglvl.hpp>

#if ! defined (__INO_AVALON__)
template <class Element>
inline
IAStack <Element>::
IAStack (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}

#endif
template <class Element>
inline
IAStack <Element>::
~IAStack ()
{
}

template <class Element>
inline void
IAStack <Element>::
addAsLast (Element const& element)
{ this->ImplOf (*this).AddAsLast (&element);
}

template <class Element>
inline void
IAStack <Element>::
addAsLast (Element const& element, ICursor& cursor)
{ this->ImplOf (*this).AddAsLast (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline long
IAStack <Element>::
compare (IAStack <Element> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

template <class Element>
inline void
IAStack <Element>::
pop ()
{ this->ImplOf (*this).RemoveLast ();
}

template <class Element>
inline void
IAStack <Element>::
pop (Element& element)
{ element = *(Element const*) this->ImplOf (*this).Last ();
  this->ImplOf (*this).RemoveLast ();
}

template <class Element>
inline void
IAStack <Element>::
push (Element const& element)
{ this->ImplOf (*this).AddAsLast (&element);
}

template <class Element>
inline void
IAStack <Element>::
push (Element const& element, ICursor& cursor)
{ this->ImplOf (*this).AddAsLast (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline void
IAStack <Element>::
removeLast ()
{ this->ImplOf (*this).RemoveLast ();
}

template <class Element>
inline Element const&
IAStack <Element>::
top () const
{ return *(Element const*) this->ImplOf (*this).Last ();
}

// protected members

template <class Element>
inline
IAStack <Element>::
IAStack ()
{
}

template <class Element>
inline
IAStack <Element>::
IAStack (IAStack <Element> const& collection)
: Inherited (collection)
{
}

// private members

template <class Element>
inline TYPENAME IAStack <Element>::Implementation&
IAStack <Element>::
ImplOf (IAStack <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IASTK_INL_
