// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 00 1.4.1.4 source/core/collect/ibagdil.inl, collection, ioc.v400, 000302  
#ifndef _IBAGDIL_INL_
#define _IBAGDIL_INL_

// ---
// IGBagAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGBagAsDilTableCursor <Element, ElementOps>::
IGBagAsDilTableCursor
  (IGBagAsDilTable
    <Element, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGBagAsDilTableCursor <Element, ElementOps>&
IGBagAsDilTableCursor <Element, ElementOps>::
operator=
  (IGBagAsDilTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGBagAsDilTableCursor <Element, ElementOps>::
IGBagAsDilTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGBagAsDilTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGBagAsDilTableMngCursor <Element, ElementOps>::
IGBagAsDilTableMngCursor
  (IGBagAsDilTable
    <Element, ElementOps> const& collection)
: IGBagAsDilTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGBagAsDilTableMngCursor <Element, ElementOps>::
IGBagAsDilTableMngCursor (ICursorImpl* impl)
: IGBagAsDilTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGBagAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGBagAsDilTable <Element, ElementOps>::
IGBagAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGBagAsDilTable <Element, ElementOps>::
IGBagAsDilTable
  (IGBagAsDilTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGBagAsDilTable <Element, ElementOps>&
IGBagAsDilTable <Element, ElementOps>::
operator= (IGBagAsDilTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGBagAsDilTable <Element, ElementOps>::
IGBagAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGBagAsDilTable
 <Element, ElementOps>::Implementation&
IGBagAsDilTable <Element, ElementOps>::
ImplOf (IGBagAsDilTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IBagAsDilTable
// ---

// public members

template <class Element>
inline
IBagAsDilTable <Element>::
IBagAsDilTable (INumber numberOfElements)
: IGBagAsDilTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IBagAsDilTable <Element>::
IBagAsDilTable (PureImplementation& impl)
: IGBagAsDilTable
   <Element, ICOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGBagAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGBagAsDilTable <Element, ElementOps>::
IVGBagAsDilTable (INumber numberOfElements)
: IGBagAsDilTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGBagAsDilTable <Element, ElementOps>::
IVGBagAsDilTable (PureImplementation& impl)
: IGBagAsDilTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVBagAsDilTable
// ---

// public members

template <class Element>
inline
IVBagAsDilTable <Element>::
IVBagAsDilTable (INumber numberOfElements)
: IVGBagAsDilTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVBagAsDilTable <Element>::
IVBagAsDilTable (PureImplementation& impl)
: IVGBagAsDilTable
   <Element, ICOps <Element> > (impl)
{
}
#endif

#endif // _IBAGDIL_INL_
