// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 13 1.2.1.2 source/core/collect/ibcllct.inl, collection, ioc.v400, 000302 
#ifndef _IBCLLCT_INL_
#define _IBCLLCT_INL_

// -------
// ICursor
// -------

// public members

inline void
ICursor::
copy (ICursor const& cursor)
{ ImplOf (*this).Copy (*cursor.ivImpl);
}

inline void
ICursor::
invalidate ()
{ ImplOf (*this).Invalidate ();
}

#if ! defined (__INO_MNGCURSOR__)
inline bool
ICursor::
isInBetween () const
{ return ImplOf (*this).IsInBetween ();
}

inline bool
ICursor::
isMngCursor () const
{ return ImplOf (*this).IsMngCursor ();
}

#endif
inline bool
ICursor::
isValid () const
{ return ImplOf (*this).IsValid ();
}

inline bool
ICursor::
setToFirst ()
{ return ImplOf (*this).SetToFirst ();
}

inline bool
ICursor::
setToNext ()
{ return ImplOf (*this).SetToNext ();
}

inline void
ICursor::
operator= (ICursor const& cursor)
{ ImplOf (*this).Copy (ImplOf (cursor));
}

inline bool
ICursor::
operator== (ICursor const& cursor) const
{ return ImplOf (*this).operator== (*cursor.ivImpl);
}

inline bool
ICursor::
operator!= (ICursor const& cursor) const
{ return ImplOf (*this).operator!= (*cursor.ivImpl);
}

// protected members

inline
ICursor::
ICursor (Implementation* impl)
: ivImpl (impl)
{
}

inline
ICursor::
ICursor (ICursor const& cursor)
: ivImpl (ImplOf (cursor).Clone ())
{
}

inline ICursor::Implementation&
ICursor::
ImplOf (ICursor const& cursor)
{ return *cursor.ivImpl;
}

// ----------------
// IACollectionBase
// ----------------

// protected members

inline
IACollectionBase::
IACollectionBase ()
: IMetaCollection ()
{
}

inline
IACollectionBase::
IACollectionBase (IACollectionBase const& collection)
: IMetaCollection (collection)
{
}

inline
IACollectionBase::
~IACollectionBase ()
{
}

inline ICursorImpl&
IACollectionBase::
CrsrImplOf (ICursor& cursor)
{ return *cursor.ivImpl;
}

inline ICursorImpl const&
IACollectionBase::
CrsrImplOf (ICursor const& cursor)
{ return *cursor.ivImpl;
}

#endif // _IBCLLCT_INL_
