// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 04 1.3.1.3 source/core/collect/icoltmpl.cpp, oss, ioc.v400, 000302 
#include <iibagkb.h>
#include <iiesseq.h>
#include <iihpseq.h>
#include <iikskb.h>
#include <iikskss.h>
#include <iiksbseq.h>
#include <iikssseq.h>
#include <iirelkb.h>
#include <iismkss.h>
#include <iisskss.h>
#include <iikbksb.h>
#include <iikskss.h>
#include <iimapks.h>
#include <iisetks.h>
#include <iisbksb.h>
#include <iismkss.h>
#include <iisrksb.h>

#include <iikbhsh.h>
#include <iikssavl.h>
#include <iiseqlst.h>
#include <iiseqtab.h>
#include <iiseqdil.h>
#include <iikssbst.h>


#include <iibagkb.cxx>
#include <iiesseq.cxx>
#include <iihpseq.cxx>
#include <iikskb.cxx>
#include <iikskss.cxx>
#include <iiksbseq.cxx>
#include <iikssseq.cxx>
#include <iirelkb.cxx>
#include <iismkss.cxx>
#include <iisskss.cxx>
#include <iikbksb.cxx>
#include <iimapks.cxx>
#include <iisetks.cxx>
#include <iisbksb.cxx>
#include <iisrksb.cxx>

#ifdef IC_PAGETUNE
    #define _ICOLTMPL_CPP_
    #include <ipagetun.h>
#endif

#pragma define( IBagOnKeyBagImpl<IKeyBagAsHshTableImpl> )
#pragma define( IEqualitySequenceOnSequenceImpl<ISequenceAsDilTableImpl> )
#pragma define( IEqualitySequenceOnSequenceImpl<ISequenceAsListImpl> )
#pragma define( IEqualitySequenceOnSequenceImpl<ISequenceAsTableImpl> )
#pragma define( IHeapOnSequenceImpl<ISequenceAsDilTableImpl> )
#pragma define( IHeapOnSequenceImpl<ISequenceAsListImpl> )
#pragma define( IHeapOnSequenceImpl<ISequenceAsTableImpl> )
#pragma define( IKeySetOnKeyBagImpl<IKeyBagAsHshTableImpl> )
#pragma define( IKeySetOnKeySortedSetImpl<IKeySortedSetAsAvlTreeImpl> )
#pragma define( IKeySetOnKeySortedSetImpl<IKeySortedSetAsBstTreeImpl> )
#pragma define( IKeySortedBagOnSequenceImpl<ISequenceAsDilTableImpl> )
#pragma define( IKeySortedBagOnSequenceImpl<ISequenceAsListImpl> )
#pragma define( IKeySortedBagOnSequenceImpl<ISequenceAsTableImpl> )
#pragma define( IKeySortedSetOnSequenceImpl<ISequenceAsDilTableImpl> )
#pragma define( IKeySortedSetOnSequenceImpl<ISequenceAsListImpl> )
#pragma define( IKeySortedSetOnSequenceImpl<ISequenceAsTableImpl> )
#pragma define( IRelationOnKeyBagImpl<IKeyBagAsHshTableImpl> )
#pragma define( ISortedMapOnKeySortedSetImpl<IKeySortedSetAsAvlTreeImpl> )
#pragma define( ISortedMapOnKeySortedSetImpl<IKeySortedSetAsBstTreeImpl> )
#pragma define( ISortedSetOnKeySortedSetImpl<IKeySortedSetAsAvlTreeImpl> )
#pragma define( ISortedSetOnKeySortedSetImpl<IKeySortedSetAsBstTreeImpl> )
#pragma define( IKeyBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsDilTableImpl> > )
#pragma define( IKeyBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsListImpl> > )
#pragma define( IKeyBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsTableImpl> > )
#pragma define( IKeySetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsDilTableImpl> > )
#pragma define( IKeySetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsListImpl> > )
#pragma define( IKeySetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsTableImpl> > )
#pragma define( IMapOnKeySetImpl<IKeySetOnKeyBagImpl<IKeyBagAsHshTableImpl> > )
#pragma define( IMapOnKeySetImpl<IKeySetOnKeySortedSetImpl<IKeySortedSetAsAvlTreeImpl> > )
#pragma define( IMapOnKeySetImpl<IKeySetOnKeySortedSetImpl<IKeySortedSetAsBstTreeImpl> > )
#pragma define( ISetOnKeySetImpl<IKeySetOnKeyBagImpl<IKeyBagAsHshTableImpl> > )
#pragma define( ISetOnKeySetImpl<IKeySetOnKeySortedSetImpl<IKeySortedSetAsAvlTreeImpl> > )
#pragma define( ISetOnKeySetImpl<IKeySetOnKeySortedSetImpl<IKeySortedSetAsBstTreeImpl> > )
#pragma define( ISortedBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsDilTableImpl> > )
#pragma define( ISortedBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsListImpl> > )
#pragma define( ISortedBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsTableImpl> > )
#pragma define( ISortedMapOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsDilTableImpl> > )
#pragma define( ISortedMapOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsListImpl> > )
#pragma define( ISortedMapOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsTableImpl> > )
#pragma define( ISortedRelationOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsDilTableImpl> > )
#pragma define( ISortedRelationOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsListImpl> > )
#pragma define( ISortedRelationOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsTableImpl> > )
#pragma define( ISortedSetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsDilTableImpl> > )
#pragma define( ISortedSetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsListImpl> > )
#pragma define( ISortedSetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsTableImpl> > )
#pragma define( IBagOnKeyBagImpl<IKeyBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsDilTableImpl> > > )
#pragma define( IBagOnKeyBagImpl<IKeyBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsListImpl> > > )
#pragma define( IBagOnKeyBagImpl<IKeyBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsTableImpl> > > )
#pragma define( IMapOnKeySetImpl<IKeySetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsDilTableImpl> > > )
#pragma define( IMapOnKeySetImpl<IKeySetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsListImpl> > > )
#pragma define( IMapOnKeySetImpl<IKeySetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsTableImpl> > > )
#pragma define( IRelationOnKeyBagImpl<IKeyBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsDilTableImpl> > > )
#pragma define( IRelationOnKeyBagImpl<IKeyBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsListImpl> > > )
#pragma define( IRelationOnKeyBagImpl<IKeyBagOnKeySortedBagImpl<IKeySortedBagOnSequenceImpl<ISequenceAsTableImpl> > > )
#pragma define( ISetOnKeySetImpl<IKeySetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsDilTableImpl> > > )
#pragma define( ISetOnKeySetImpl<IKeySetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsListImpl> > > )
#pragma define( ISetOnKeySetImpl<IKeySetOnKeySortedSetImpl<IKeySortedSetOnSequenceImpl<ISequenceAsTableImpl> > > )
