// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 38 1.5.1.4 source/core/collect/iesdil.h, collection, ioc.v400, 000302 
#ifndef _IESDIL_
#define _IESDIL_

#include <ilanglvl.hpp>
#include <iaes.h>
#include <iices.h>
#if ! defined (__INO_AVALON__)
#include <iives.h>
#endif
#include <iiesdil.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class ElementOps>
class IGEqualitySequenceAsDilTable;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class ElementOps>
class IGEqualitySequenceAsDilTableCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef TYPENAME IGEqualitySequenceAsDilTable
            <Element, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGEqualitySequenceAsDilTableCursor
                            (IGEqualitySequenceAsDilTable
                              <
                               Element, ElementOps> const&);

  IGEqualitySequenceAsDilTableCursor <Element, ElementOps>&
           operator=        (IGEqualitySequenceAsDilTableCursor
                              <
                               Element, ElementOps> const&);

protected:

           IGEqualitySequenceAsDilTableCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceAsDilTableCursor\
                            (IGEqualitySequenceAsDilTable\
                              <\
                               Element, ElementOps> const&),\
           operator=,\
           IGEqualitySequenceAsDilTableCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class ElementOps>
class IGEqualitySequenceAsDilTableMngCursor :
  public IGEqualitySequenceAsDilTableCursor <Element, ElementOps>  {

  typedef  IGEqualitySequenceAsDilTableCursor
            <Element, ElementOps> Cursor;

  typedef TYPENAME IGEqualitySequenceAsDilTable
            <Element, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGEqualitySequenceAsDilTableMngCursor
                            (IGEqualitySequenceAsDilTable
                              <
                               Element, ElementOps> const&);

protected:

           IGEqualitySequenceAsDilTableMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceAsDilTableMngCursor\
                            (IGEqualitySequenceAsDilTable\
                              <\
                               Element, ElementOps> const&),\
           IGEqualitySequenceAsDilTableMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class ElementOps>
class IGEqualitySequenceAsDilTable :
  public IAEqualitySequence <Element> {
protected:

  typedef  IGEqualitySequenceAsDilTable <Element, ElementOps> Self;

  typedef  IEqualitySequenceAsDilTableImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICEqualitySequenceImpl
            <PureImplementation> Implementation;
#endif

#define IGEqualitySequenceAsDilTableTypedef(Element, ElementOps)\
  typedef  IEqualitySequenceAsDilTableOps\
            <Element,\
             IWEOps <Element, ElementOps>,\
             Implementation> Instantiation

           IGEqualitySequenceAsDilTableTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

  typedef  IGEqualitySequenceAsDilTableCursor
            <Element, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGEqualitySequenceAsDilTableMngCursor
            <Element, ElementOps> MngCursor;
#endif

           IGEqualitySequenceAsDilTable
                            (INumber = 100);

           IGEqualitySequenceAsDilTable
                            (IGEqualitySequenceAsDilTable
                              <
                               Element, ElementOps> const&);

  IGEqualitySequenceAsDilTable <Element, ElementOps>&
           operator=        (IGEqualitySequenceAsDilTable
                              <
                               Element, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGEqualitySequenceAsDilTable
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGEqualitySequenceAsDilTable
                              <
                               Element, ElementOps> const&);

private:

  friend
  class    IGEqualitySequenceAsDilTableCursor <Element, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGEqualitySequenceAsDilTableMngCursor
            <Element, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceAsDilTable\
                            (INumber),\
           operator=,\
           IGEqualitySequenceAsDilTable\
                            (PureImplementation&),\
           ImplOf           (IGEqualitySequenceAsDilTable\
                              <\
                               Element, ElementOps> const&)\
                        )
#endif

};

template <class Element>
class IEqualitySequenceAsDilTable :
  public IGEqualitySequenceAsDilTable
          <Element, IEOps <Element> > {

  typedef  IGEqualitySequenceAsDilTable
            <Element,
             IEOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IEqualitySequenceAsDilTable <Element> Self;

#define IEqualitySequenceAsDilTableTypedef(Element)\
  typedef  IEqualitySequenceAsDilTableOps\
            <Element,\
             IWEOps <Element, IEOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IEqualitySequenceAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IEqualitySequenceAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IEqualitySequenceAsDilTable\
                              (INumber),\
           IEqualitySequenceAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class ElementOps>
class IVGEqualitySequenceAsDilTable :
  public IGEqualitySequenceAsDilTable
          <Element, ElementOps > {

  typedef  IVGEqualitySequenceAsDilTable
            <Element, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGEqualitySequenceAsDilTable
            <Element, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVEqualitySequenceImpl
            <PureImplementation> Implementation;
#else
  typedef  ICEqualitySequenceImpl
            <IVEqualitySequenceImpl
              <PureImplementation> > Implementation;
#endif

#define IVGEqualitySequenceAsDilTableTypedef(Element, ElementOps)\
  typedef  IEqualitySequenceAsDilTableOps\
            <Element,\
             IWEOps <Element, ElementOps>,\
             Implementation> Instantiation

           IVGEqualitySequenceAsDilTableTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVGEqualitySequenceAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGEqualitySequenceAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGEqualitySequenceAsDilTable\
                              (INumber),\
           IVGEqualitySequenceAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element>
class IVEqualitySequenceAsDilTable :
  public IVGEqualitySequenceAsDilTable
          <Element, IEOps <Element> > {

  typedef  IVGEqualitySequenceAsDilTable
            <Element,
             IEOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVEqualitySequenceAsDilTable <Element> Self;

#define IVEqualitySequenceAsDilTableTypedef(Element)\
  typedef  IVEqualitySequenceAsDilTableOps\
            <Element,\
             IWEOps <Element, IEOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVEqualitySequenceAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVEqualitySequenceAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVEqualitySequenceAsDilTable\
                              (INumber),\
           IVEqualitySequenceAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <iesdil.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IESDIL_
