// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 40 1.5.1.4 source/core/collect/ieslst.h, collection, ioc.v400, 000302 
#ifndef _IESLST_
#define _IESLST_

#include <ilanglvl.hpp>
#include <iaes.h>
#include <iices.h>
#if ! defined (__INO_AVALON__)
#include <iives.h>
#endif
#include <iieslst.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class ElementOps>
class IGEqualitySequenceAsList;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class ElementOps>
class IGEqualitySequenceAsListCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef TYPENAME IGEqualitySequenceAsList
            <Element, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGEqualitySequenceAsListCursor
                            (IGEqualitySequenceAsList
                              <
                               Element, ElementOps> const&);

  IGEqualitySequenceAsListCursor <Element, ElementOps>&
           operator=        (IGEqualitySequenceAsListCursor
                              <
                               Element, ElementOps> const&);

protected:

           IGEqualitySequenceAsListCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceAsListCursor\
                            (IGEqualitySequenceAsList\
                              <\
                               Element, ElementOps> const&),\
           operator=,\
           IGEqualitySequenceAsListCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class ElementOps>
class IGEqualitySequenceAsListMngCursor :
  public IGEqualitySequenceAsListCursor <Element, ElementOps>  {

  typedef  IGEqualitySequenceAsListCursor
            <Element, ElementOps> Cursor;

  typedef TYPENAME IGEqualitySequenceAsList
            <Element, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGEqualitySequenceAsListMngCursor
                            (IGEqualitySequenceAsList
                              <
                               Element, ElementOps> const&);

protected:

           IGEqualitySequenceAsListMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceAsListMngCursor\
                            (IGEqualitySequenceAsList\
                              <\
                               Element, ElementOps> const&),\
           IGEqualitySequenceAsListMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class ElementOps>
class IGEqualitySequenceAsList :
  public IAEqualitySequence <Element> {
protected:

  typedef  IGEqualitySequenceAsList <Element, ElementOps> Self;

  typedef  IEqualitySequenceAsListImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICEqualitySequenceImpl
            <PureImplementation> Implementation;
#endif

#define IGEqualitySequenceAsListTypedef(Element, ElementOps)\
  typedef  IEqualitySequenceAsListOps\
            <Element,\
             IWEOps <Element, ElementOps>,\
             Implementation> Instantiation

           IGEqualitySequenceAsListTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

  typedef  IGEqualitySequenceAsListCursor
            <Element, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGEqualitySequenceAsListMngCursor
            <Element, ElementOps> MngCursor;
#endif

           IGEqualitySequenceAsList
                            (INumber = 100);

           IGEqualitySequenceAsList
                            (IGEqualitySequenceAsList
                              <
                               Element, ElementOps> const&);

  IGEqualitySequenceAsList <Element, ElementOps>&
           operator=        (IGEqualitySequenceAsList
                              <
                               Element, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGEqualitySequenceAsList
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGEqualitySequenceAsList
                              <
                               Element, ElementOps> const&);

private:

  friend
  class    IGEqualitySequenceAsListCursor <Element, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGEqualitySequenceAsListMngCursor
            <Element, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceAsList\
                            (INumber),\
           operator=,\
           IGEqualitySequenceAsList\
                            (PureImplementation&),\
           ImplOf           (IGEqualitySequenceAsList\
                              <\
                               Element, ElementOps> const&)\
                        )
#endif

};

template <class Element>
class IEqualitySequenceAsList :
  public IGEqualitySequenceAsList
          <Element, IEOps <Element> > {

  typedef  IGEqualitySequenceAsList
            <Element,
             IEOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IEqualitySequenceAsList <Element> Self;

#define IEqualitySequenceAsListTypedef(Element)\
  typedef  IEqualitySequenceAsListOps\
            <Element,\
             IWEOps <Element, IEOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IEqualitySequenceAsList
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IEqualitySequenceAsList
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IEqualitySequenceAsList\
                              (INumber),\
           IEqualitySequenceAsList\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class ElementOps>
class IVGEqualitySequenceAsList :
  public IGEqualitySequenceAsList
          <Element, ElementOps > {

  typedef  IVGEqualitySequenceAsList
            <Element, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGEqualitySequenceAsList
            <Element, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVEqualitySequenceImpl
            <PureImplementation> Implementation;
#else
  typedef  ICEqualitySequenceImpl
            <IVEqualitySequenceImpl
              <PureImplementation> > Implementation;
#endif

#define IVGEqualitySequenceAsListTypedef(Element, ElementOps)\
  typedef  IEqualitySequenceAsListOps\
            <Element,\
             IWEOps <Element, ElementOps>,\
             Implementation> Instantiation

           IVGEqualitySequenceAsListTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVGEqualitySequenceAsList
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGEqualitySequenceAsList
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGEqualitySequenceAsList\
                              (INumber),\
           IVGEqualitySequenceAsList\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element>
class IVEqualitySequenceAsList :
  public IVGEqualitySequenceAsList
          <Element, IEOps <Element> > {

  typedef  IVGEqualitySequenceAsList
            <Element,
             IEOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVEqualitySequenceAsList <Element> Self;

#define IVEqualitySequenceAsListTypedef(Element)\
  typedef  IVEqualitySequenceAsListOps\
            <Element,\
             IWEOps <Element, IEOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVEqualitySequenceAsList
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVEqualitySequenceAsList
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVEqualitySequenceAsList\
                              (INumber),\
           IVEqualitySequenceAsList\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <ieslst.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IESLST_
