// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 42 1.5.1.4 source/core/collect/iestab.h, collection, ioc.v400, 000302 
#ifndef _IESTAB_
#define _IESTAB_

#include <ilanglvl.hpp>
#include <iaes.h>
#include <iices.h>
#if ! defined (__INO_AVALON__)
#include <iives.h>
#endif
#include <iiestab.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class ElementOps>
class IGEqualitySequenceAsTable;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class ElementOps>
class IGEqualitySequenceAsTableCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef TYPENAME IGEqualitySequenceAsTable
            <Element, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGEqualitySequenceAsTableCursor
                            (IGEqualitySequenceAsTable
                              <
                               Element, ElementOps> const&);

  IGEqualitySequenceAsTableCursor <Element, ElementOps>&
           operator=        (IGEqualitySequenceAsTableCursor
                              <
                               Element, ElementOps> const&);

protected:

           IGEqualitySequenceAsTableCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceAsTableCursor\
                            (IGEqualitySequenceAsTable\
                              <\
                               Element, ElementOps> const&),\
           operator=,\
           IGEqualitySequenceAsTableCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class ElementOps>
class IGEqualitySequenceAsTableMngCursor :
  public IGEqualitySequenceAsTableCursor <Element, ElementOps>  {

  typedef  IGEqualitySequenceAsTableCursor
            <Element, ElementOps> Cursor;

  typedef TYPENAME IGEqualitySequenceAsTable
            <Element, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGEqualitySequenceAsTableMngCursor
                            (IGEqualitySequenceAsTable
                              <
                               Element, ElementOps> const&);

protected:

           IGEqualitySequenceAsTableMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceAsTableMngCursor\
                            (IGEqualitySequenceAsTable\
                              <\
                               Element, ElementOps> const&),\
           IGEqualitySequenceAsTableMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class ElementOps>
class IGEqualitySequenceAsTable :
  public IAEqualitySequence <Element> {
protected:

  typedef  IGEqualitySequenceAsTable <Element, ElementOps> Self;

  typedef  IEqualitySequenceAsTableImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICEqualitySequenceImpl
            <PureImplementation> Implementation;
#endif

#define IGEqualitySequenceAsTableTypedef(Element, ElementOps)\
  typedef  IEqualitySequenceAsTableOps\
            <Element,\
             IWEOps <Element, ElementOps>,\
             Implementation> Instantiation

           IGEqualitySequenceAsTableTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

  typedef  IGEqualitySequenceAsTableCursor
            <Element, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGEqualitySequenceAsTableMngCursor
            <Element, ElementOps> MngCursor;
#endif

           IGEqualitySequenceAsTable
                            (INumber = 100);

           IGEqualitySequenceAsTable
                            (IGEqualitySequenceAsTable
                              <
                               Element, ElementOps> const&);

  IGEqualitySequenceAsTable <Element, ElementOps>&
           operator=        (IGEqualitySequenceAsTable
                              <
                               Element, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGEqualitySequenceAsTable
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGEqualitySequenceAsTable
                              <
                               Element, ElementOps> const&);

private:

  friend
  class    IGEqualitySequenceAsTableCursor <Element, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGEqualitySequenceAsTableMngCursor
            <Element, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGEqualitySequenceAsTable\
                            (INumber),\
           operator=,\
           IGEqualitySequenceAsTable\
                            (PureImplementation&),\
           ImplOf           (IGEqualitySequenceAsTable\
                              <\
                               Element, ElementOps> const&)\
                        )
#endif

};

template <class Element>
class IEqualitySequenceAsTable :
  public IGEqualitySequenceAsTable
          <Element, IEOps <Element> > {

  typedef  IGEqualitySequenceAsTable
            <Element,
             IEOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IEqualitySequenceAsTable <Element> Self;

#define IEqualitySequenceAsTableTypedef(Element)\
  typedef  IEqualitySequenceAsTableOps\
            <Element,\
             IWEOps <Element, IEOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IEqualitySequenceAsTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IEqualitySequenceAsTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IEqualitySequenceAsTable\
                              (INumber),\
           IEqualitySequenceAsTable\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class ElementOps>
class IVGEqualitySequenceAsTable :
  public IGEqualitySequenceAsTable
          <Element, ElementOps > {

  typedef  IVGEqualitySequenceAsTable
            <Element, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGEqualitySequenceAsTable
            <Element, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVEqualitySequenceImpl
            <PureImplementation> Implementation;
#else
  typedef  ICEqualitySequenceImpl
            <IVEqualitySequenceImpl
              <PureImplementation> > Implementation;
#endif

#define IVGEqualitySequenceAsTableTypedef(Element, ElementOps)\
  typedef  IEqualitySequenceAsTableOps\
            <Element,\
             IWEOps <Element, ElementOps>,\
             Implementation> Instantiation

           IVGEqualitySequenceAsTableTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVGEqualitySequenceAsTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGEqualitySequenceAsTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGEqualitySequenceAsTable\
                              (INumber),\
           IVGEqualitySequenceAsTable\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element>
class IVEqualitySequenceAsTable :
  public IVGEqualitySequenceAsTable
          <Element, IEOps <Element> > {

  typedef  IVGEqualitySequenceAsTable
            <Element,
             IEOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVEqualitySequenceAsTable <Element> Self;

#define IVEqualitySequenceAsTableTypedef(Element)\
  typedef  IVEqualitySequenceAsTableOps\
            <Element,\
             IWEOps <Element, IEOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVEqualitySequenceAsTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVEqualitySequenceAsTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVEqualitySequenceAsTable\
                              (INumber),\
           IVEqualitySequenceAsTable\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <iestab.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IESTAB_
