// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <iexc.h>
#include <iexctxt.h>

#ifdef IC_PAGETUNE
  #define _IEXC_CPP_
  #include <ipagetun.h>
#endif


#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#define ICCEXCLASSIMPLEMENT(child,parent)\
  child :: child(const char* a, unsigned long b,\
                 Severity c)\
    : parent (a, b, c)\
        { }\
  char const* child :: name () const\
    { return (#child);\
    }\
  child :: ~child() {;}\
  child :: child(const child & a) : parent(a) {;}\
  void child :: operator= (child const&) {;}\
  void child :: throwIt (unsigned long msgID,\
              char const* fileName, unsigned long lineNumber)\
    { ICollectionExceptionText msgText (msgID); child exc (msgText);\
      exc.addLocation (IExceptionLocation (fileName, "", lineNumber));\
      exc.logExceptionData (); ITHROW (exc); }

#if ! defined(__INO_L1_LOCKING__)
ICCEXCLASSIMPLEMENT(ICollectionResourceException,IException);
ICCEXCLASSIMPLEMENT(ICollectionLockException,IException);
ICCEXCLASSIMPLEMENT(ICollectionLockTimeOutException,IException);
ICCEXCLASSIMPLEMENT(ICollectionUnlockException,IException);
#endif

#if ! defined (__INO_STREAMING__)
ICCEXCLASSIMPLEMENT(IStreamErrorException,IException);
ICCEXCLASSIMPLEMENT(IStreamerInvalidException,IException);
#endif

ICCEXCLASSIMPLEMENT(IPreconditionViolation,IException);
  ICCEXCLASSIMPLEMENT(IFullException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IEmptyException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(INotEmptyException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(INotBoundedException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(ICursorInvalidException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IPositionInvalidException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(INotContainsKeyException,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IKeyAlreadyExistsException,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IRootAlreadyExistsException,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IChildAlreadyExistsException,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IIdenticalCollectionException,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IInvalidReplacementException,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(ICyclicAttachException,IPreconditionViolation);

  ICCEXCLASSIMPLEMENT(IOutOfCollectionMemory,IOutOfMemory);

#if ! defined (__INO_CONCUR__)
  ICCEXCLASSIMPLEMENT(IUnlockInvalidException,IPreconditionViolation);
#endif

#if ! defined (__INO_OBJSTR__)
  ICCEXCLASSIMPLEMENT(IContainedStreamedBeforeEnclosing,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(IContainerObjectIsNotReadYet,
                      IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(INoRestoreFunctionDefined,IPreconditionViolation);
  ICCEXCLASSIMPLEMENT(INoConversionFunctionDefined,
                      IPreconditionViolation);
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
