// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <iexctxt.h>
#include <icconsta.h>

#ifdef IC_PAGETUNE
  #define _IEXCTXT_CPP_
  #include <ipagetun.h>
#endif


#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#pragma SOMAsDefault (off)
#endif
#if defined (__OS2__)
extern "C"
{
   #define INCL_WINERRORS
   #define INCL_DOSMODULEMGR
   #define INCL_DOSFILEMGR
   #define INCL_DOSMISC
   #define INCL_WINWINDOWMGR
   #include <os2.h>
   #include <stdlib.h>
}
#endif
#if defined (__MVS__)
#include <fstream.h>
#endif
#include <string.h>
#if defined (__SOM_ENABLED__)
#pragma SOMAsDefault (pop)
#endif

ICollectionExceptionText::ICollectionExceptionText (unsigned long resid)
{
  ivMsgTxt = new IMessageText (resid);

  if (ivMsgTxt != 0)
  {
    switch (resid)
    {
      case IC_CHILD_ALREADY_EXISTS:
        ivMsgTxt->setDefaultText ("child already exists");
        break;
      case IC_COLLECTION_IS_EMPTY:
        ivMsgTxt->setDefaultText ("collection is empty");
        break;
      case IC_CURSOR_NOT_CONTAINED:
        ivMsgTxt->setDefaultText ("cursor not contained in collection");
        break;
      case  IC_CURSOR_NOT_FOR_GIVEN:
        ivMsgTxt->setDefaultText ("cursor not for given collection");
        break;
      case  IC_CURSOR_NOT_FOR_THIS:
        ivMsgTxt->setDefaultText ("cursor not for this collection");
        break;
      case  IC_IDENTICAL_COLLECTION:
        ivMsgTxt->setDefaultText ("identical collection");
        break;
      case IC_INVALID_CURSOR:
        ivMsgTxt->setDefaultText ("invalid cursor");
        break;
      case IC_INVALID_POSITION:
        ivMsgTxt->setDefaultText ("invalid position");
        break;
      case IC_INVALID_REPLACEMENT:
        ivMsgTxt->setDefaultText ("invalid replacement");
        break;
      case IC_KEY_ALREADY_EXISTS:
        ivMsgTxt->setDefaultText ("key already exists");
        break;
      case IC_KEY_NOT_CONTAINED:
        ivMsgTxt->setDefaultText ("key not contained");
        break;
      case IC_NOT_BOUNDED:
        ivMsgTxt->setDefaultText ("collection is unbounded");
        break;
      case IC_ROOT_ALREADY_EXISTS:
        ivMsgTxt->setDefaultText ("root already exists");
        break;
      case IC_CYCLIC_CHILD_ATTACHMENT:
        ivMsgTxt->setDefaultText ("cyclic child attachment");
        break;
      case IC_OUT_OF_COLLECTION_MEMORY:
        ivMsgTxt->setDefaultText ("out of collection memory");
        break;
#if ! defined (__INO_L1_LOCKING__)
      case IC_NO_MUTEX_AVAILABLE:
        ivMsgTxt->setDefaultText ("internal mutex error occurred");
        break;
      case IC_LOCK_FAILED:
        ivMsgTxt->setDefaultText ("internal lock error occurred");
        break;
      case IC_UNLOCK_FAILED:
        ivMsgTxt->setDefaultText ("internal unlock error occurred");
        break;
      case IC_LOCK_TIMEOUT:
        ivMsgTxt->setDefaultText ("a time-out occurred");
        break;
#endif
#if ! defined (__INO_STREAMING__)
      case IC_STREAM_VERSION_ERROR:
        ivMsgTxt->setDefaultText ("invalid stream data");
        break;
      case IC_STREAMER_INVALID:
        ivMsgTxt->setDefaultText ("invalid stream helper object");
        break;
#endif
#if ! defined (__INO_CONCUR__)
      case IC_UNLOCK_INVALID:
        ivMsgTxt->setDefaultText ("unlocking a resource not owned");
        break;
#endif
#if ! defined (__INO_MNGCURSOR__)
      case IC_CURSOR_IN_BETWEEN:
        ivMsgTxt->setDefaultText ("cursor is in between");
        break;
#endif
      default:
        ivMsgTxt->setDefaultText ("unknown exception text");
    }
  }
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
