// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 57 1.5.1.4 source/core/collect/ihpdil.h, collection, ioc.v400, 000302 
#ifndef _IHPDIL_
#define _IHPDIL_

#include <ilanglvl.hpp>
#include <iahp.h>
#include <iichp.h>
#if ! defined (__INO_AVALON__)
#include <iivhp.h>
#endif
#include <iihpdil.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class ElementOps>
class IGHeapAsDilTable;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class ElementOps>
class IGHeapAsDilTableCursor :
  public IElementCursor <Element> {

  typedef  IElementCursor <Element> Inherited;

  typedef TYPENAME IGHeapAsDilTable
            <Element, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGHeapAsDilTableCursor
                            (IGHeapAsDilTable
                              <
                               Element, ElementOps> const&);

  IGHeapAsDilTableCursor <Element, ElementOps>&
           operator=        (IGHeapAsDilTableCursor
                              <
                               Element, ElementOps> const&);

protected:

           IGHeapAsDilTableCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGHeapAsDilTableCursor\
                            (IGHeapAsDilTable\
                              <\
                               Element, ElementOps> const&),\
           operator=,\
           IGHeapAsDilTableCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class ElementOps>
class IGHeapAsDilTableMngCursor :
  public IGHeapAsDilTableCursor <Element, ElementOps>  {

  typedef  IGHeapAsDilTableCursor
            <Element, ElementOps> Cursor;

  typedef TYPENAME IGHeapAsDilTable
            <Element, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGHeapAsDilTableMngCursor
                            (IGHeapAsDilTable
                              <
                               Element, ElementOps> const&);

protected:

           IGHeapAsDilTableMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGHeapAsDilTableMngCursor\
                            (IGHeapAsDilTable\
                              <\
                               Element, ElementOps> const&),\
           IGHeapAsDilTableMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class ElementOps>
class IGHeapAsDilTable :
  public IAHeap <Element> {
protected:

  typedef  IGHeapAsDilTable <Element, ElementOps> Self;

  typedef  IHeapAsDilTableImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICHeapImpl
            <PureImplementation> Implementation;
#endif

#define IGHeapAsDilTableTypedef(Element, ElementOps)\
  typedef  IHeapAsDilTableOps\
            <Element,\
             IWStdOps <Element, ElementOps>,\
             Implementation> Instantiation

           IGHeapAsDilTableTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

  typedef  IGHeapAsDilTableCursor
            <Element, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGHeapAsDilTableMngCursor
            <Element, ElementOps> MngCursor;
#endif

           IGHeapAsDilTable
                            (INumber = 100);

           IGHeapAsDilTable
                            (IGHeapAsDilTable
                              <
                               Element, ElementOps> const&);

  IGHeapAsDilTable <Element, ElementOps>&
           operator=        (IGHeapAsDilTable
                              <
                               Element, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGHeapAsDilTable
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGHeapAsDilTable
                              <
                               Element, ElementOps> const&);

private:

  friend
  class    IGHeapAsDilTableCursor <Element, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGHeapAsDilTableMngCursor
            <Element, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGHeapAsDilTable\
                            (INumber),\
           operator=,\
           IGHeapAsDilTable\
                            (PureImplementation&),\
           ImplOf           (IGHeapAsDilTable\
                              <\
                               Element, ElementOps> const&)\
                        )
#endif

};

template <class Element>
class IHeapAsDilTable :
  public IGHeapAsDilTable
          <Element, IStdOps <Element> > {

  typedef  IGHeapAsDilTable
            <Element,
             IStdOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IHeapAsDilTable <Element> Self;

#define IHeapAsDilTableTypedef(Element)\
  typedef  IHeapAsDilTableOps\
            <Element,\
             IWStdOps <Element, IStdOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IHeapAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IHeapAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IHeapAsDilTable\
                              (INumber),\
           IHeapAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class ElementOps>
class IVGHeapAsDilTable :
  public IGHeapAsDilTable
          <Element, ElementOps > {

  typedef  IVGHeapAsDilTable
            <Element, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGHeapAsDilTable
            <Element, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVHeapImpl
            <PureImplementation> Implementation;
#else
  typedef  ICHeapImpl
            <IVHeapImpl
              <PureImplementation> > Implementation;
#endif

#define IVGHeapAsDilTableTypedef(Element, ElementOps)\
  typedef  IHeapAsDilTableOps\
            <Element,\
             IWStdOps <Element, ElementOps>,\
             Implementation> Instantiation

           IVGHeapAsDilTableTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVGHeapAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGHeapAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGHeapAsDilTable\
                              (INumber),\
           IVGHeapAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element>
class IVHeapAsDilTable :
  public IVGHeapAsDilTable
          <Element, IStdOps <Element> > {

  typedef  IVGHeapAsDilTable
            <Element,
             IStdOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVHeapAsDilTable <Element> Self;

#define IVHeapAsDilTableTypedef(Element)\
  typedef  IVHeapAsDilTableOps\
            <Element,\
             IWStdOps <Element, IStdOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVHeapAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVHeapAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVHeapAsDilTable\
                              (INumber),\
           IVHeapAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <ihpdil.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IHPDIL_
