// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 58 1.4.1.4 source/core/collect/ihpdil.inl, collection, ioc.v400, 000302  
#ifndef _IHPDIL_INL_
#define _IHPDIL_INL_

// ---
// IGHeapAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGHeapAsDilTableCursor <Element, ElementOps>::
IGHeapAsDilTableCursor
  (IGHeapAsDilTable
    <Element, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGHeapAsDilTableCursor <Element, ElementOps>&
IGHeapAsDilTableCursor <Element, ElementOps>::
operator=
  (IGHeapAsDilTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGHeapAsDilTableCursor <Element, ElementOps>::
IGHeapAsDilTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGHeapAsDilTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGHeapAsDilTableMngCursor <Element, ElementOps>::
IGHeapAsDilTableMngCursor
  (IGHeapAsDilTable
    <Element, ElementOps> const& collection)
: IGHeapAsDilTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGHeapAsDilTableMngCursor <Element, ElementOps>::
IGHeapAsDilTableMngCursor (ICursorImpl* impl)
: IGHeapAsDilTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGHeapAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGHeapAsDilTable <Element, ElementOps>::
IGHeapAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGHeapAsDilTable <Element, ElementOps>::
IGHeapAsDilTable
  (IGHeapAsDilTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGHeapAsDilTable <Element, ElementOps>&
IGHeapAsDilTable <Element, ElementOps>::
operator= (IGHeapAsDilTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGHeapAsDilTable <Element, ElementOps>::
IGHeapAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGHeapAsDilTable
 <Element, ElementOps>::Implementation&
IGHeapAsDilTable <Element, ElementOps>::
ImplOf (IGHeapAsDilTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IHeapAsDilTable
// ---

// public members

template <class Element>
inline
IHeapAsDilTable <Element>::
IHeapAsDilTable (INumber numberOfElements)
: IGHeapAsDilTable
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IHeapAsDilTable <Element>::
IHeapAsDilTable (PureImplementation& impl)
: IGHeapAsDilTable
   <Element, IStdOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGHeapAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGHeapAsDilTable <Element, ElementOps>::
IVGHeapAsDilTable (INumber numberOfElements)
: IGHeapAsDilTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGHeapAsDilTable <Element, ElementOps>::
IVGHeapAsDilTable (PureImplementation& impl)
: IGHeapAsDilTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVHeapAsDilTable
// ---

// public members

template <class Element>
inline
IVHeapAsDilTable <Element>::
IVHeapAsDilTable (INumber numberOfElements)
: IVGHeapAsDilTable
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVHeapAsDilTable <Element>::
IVHeapAsDilTable (PureImplementation& impl)
: IVGHeapAsDilTable
   <Element, IStdOps <Element> > (impl)
{
}
#endif

#endif // _IHPDIL_INL_
