// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 66 1.5.1.3 source/core/collect/iiabag.h, collection, ioc.v400, 000302 
#ifndef _IIABAG_
#define _IIABAG_

#include <iiacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IABagImpl : public IACollectionImpl {
public:

          ~IABagImpl
                            ();

  virtual
  void     Antivalence      (IABagImpl const&);

  virtual
  void     AddAntivalence   (IABagImpl const&,
                             IABagImpl const&); 

  virtual
  void     AddDifference    (IABagImpl const&,
                             IABagImpl const&); 

  virtual
  void     AddIntersection  (IABagImpl const&,
                             IABagImpl const&);

  virtual
  void     AddUnion         (IABagImpl const&,
                             IABagImpl const&);

  virtual
  void     Difference       (IABagImpl const&);

  virtual
  void     Intersection     (IABagImpl const&);

  virtual
  INumber  NumberOfDifferentElements
                            () const = 0;

  virtual
  bool     SetToNextDifferentElement
                            (ICursorImpl&) const = 0;

  virtual
  void     Union            (IABagImpl const&);

  virtual
  bool     operator==       (IABagImpl const&) const = 0;

  bool     operator!=       (IABagImpl const&) const;

protected:

           IABagImpl
                            (Ops&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Antivalence      (IABagImpl const&),\
           AddAntivalence   (IABagImpl const&,\
                             IABagImpl const&),\
           AddDifference    (IABagImpl const&,\
                             IABagImpl const&),\
           AddIntersection  (IABagImpl const&,\
                             IABagImpl const&),\
           AddUnion         (IABagImpl const&,\
                             IABagImpl const&),\
           Difference       (IABagImpl const&),\
           Intersection     (IABagImpl const&),\
           NumberOfDifferentElements\
                            () const,\
           SetToNextDifferentElement\
                            (ICursorImpl&) const,\
           Union            (IABagImpl const&),\
           operator==       (IABagImpl const&) const,\
           operator!=       (IABagImpl const&) const,\
           IABagImpl\
                            (Ops&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIABAG_
