// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 81 1.5.1.3 source/core/collect/iiakss.h, collection, ioc.v400, 000302 
#ifndef _IIAKSS_
#define _IIAKSS_

#include <iiacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IAKeySortedSetImpl : public IACollectionImpl {
public:

          ~IAKeySortedSetImpl
                            ();

  virtual
  long     Compare          (IAKeySortedSetImpl const&,
                             ICompFunc, void*) const;

protected:

           IAKeySortedSetImpl
                            (Ops&);

  INumber  NumberOfDifferentKeys
                            () const;

  INumber  NumberOfElementsWithKey
                            (void const*) const;

  INumber  RemoveAllElementsWithKey
                            (void const*);

  bool     SetToNextWithDifferentKey
                            (ICursorImpl&) const;

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Compare          (IAKeySortedSetImpl const&,\
                             ICompFunc, void*) const,\
           IAKeySortedSetImpl\
                            (Ops&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIAKSS_
