// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 83 1.5.1.3 source/core/collect/iiamap.h, collection, ioc.v400, 000302 
#ifndef _IIAMAP_
#define _IIAMAP_

#include <iiacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IAMapImpl : public IACollectionImpl {
public:

          ~IAMapImpl
                            ();

  virtual
  void     Antivalence      (IAMapImpl const&);

  virtual
  void     AddAntivalence   (IAMapImpl const&,
                             IAMapImpl const&); 

  virtual
  void     AddDifference    (IAMapImpl const&,
                             IAMapImpl const&); 

  virtual
  void     AddIntersection  (IAMapImpl const&,
                             IAMapImpl const&);

  virtual
  void     AddUnion         (IAMapImpl const&,
                             IAMapImpl const&);

  virtual
  void     Difference       (IAMapImpl const&);

  virtual
  void     Intersection     (IAMapImpl const&);

  virtual
  void     Union            (IAMapImpl const&);

  virtual
  bool     operator==       (IAMapImpl const&) const = 0;

  bool     operator!=       (IAMapImpl const&) const;

protected:

           IAMapImpl
                            (Ops&);

  bool     LocateNext       (void const*, ICursorImpl&) const;

  bool     LocateNextElementWithKey
                            (void const*, ICursorImpl&) const;

  INumber  NumberOfDifferentKeys
                            () const;

  INumber  NumberOfElementsWithKey
                            (void const*) const;

  INumber  NumberOfOccurrences
                            (void const*) const;

  INumber  RemoveAllOccurrences
                            (void const*);

  INumber  RemoveAllElementsWithKey
                            (void const*);

  bool     SetToNextWithDifferentKey
                            (ICursorImpl&) const;

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Antivalence      (IAMapImpl const&),\
           AddAntivalence   (IAMapImpl const&,\
                             IAMapImpl const&),\
           AddDifference    (IAMapImpl const&,\
                             IAMapImpl const&),\
           AddIntersection  (IAMapImpl const&,\
                             IAMapImpl const&),\
           AddUnion         (IAMapImpl const&,\
                             IAMapImpl const&),\
           Difference       (IAMapImpl const&),\
           Intersection     (IAMapImpl const&),\
           Union            (IAMapImpl const&),\
           operator==       (IAMapImpl const&) const,\
           operator!=       (IAMapImpl const&) const,\
           IAMapImpl\
                            (Ops&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIAMAP_
