// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 85 1.5.1.3 source/core/collect/iiarel.h, collection, ioc.v400, 000302 
#ifndef _IIAREL_
#define _IIAREL_

#include <iiacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IARelationImpl : public IACollectionImpl {
public:

          ~IARelationImpl
                            ();

  virtual
  void     Antivalence      (IARelationImpl const&);

  virtual
  void     AddAntivalence   (IARelationImpl const&,
                             IARelationImpl const&); 

  virtual
  void     AddDifference    (IARelationImpl const&,
                             IARelationImpl const&); 

  virtual
  void     AddIntersection  (IARelationImpl const&,
                             IARelationImpl const&);

  virtual
  void     AddUnion         (IARelationImpl const&,
                             IARelationImpl const&);

  virtual
  void     Difference       (IARelationImpl const&);

  virtual
  void     Intersection     (IARelationImpl const&);

  virtual
  void     Union            (IARelationImpl const&);

  virtual
  bool     operator==       (IARelationImpl const&) const = 0;

  bool     operator!=       (IARelationImpl const&) const;

protected:

           IARelationImpl
                            (Ops&);

  bool     LocateNext       (void const*, ICursorImpl&) const;

  INumber  NumberOfOccurrences
                            (void const*) const;

  INumber  RemoveAllOccurrences
                            (void const*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Antivalence      (IARelationImpl const&),\
           AddAntivalence   (IARelationImpl const&,\
                             IARelationImpl const&),\
           AddDifference    (IARelationImpl const&,\
                             IARelationImpl const&),\
           AddIntersection  (IARelationImpl const&,\
                             IARelationImpl const&),\
           AddUnion         (IARelationImpl const&,\
                             IARelationImpl const&),\
           Difference       (IARelationImpl const&),\
           Intersection     (IARelationImpl const&),\
           Union            (IARelationImpl const&),\
           operator==       (IARelationImpl const&) const,\
           operator!=       (IARelationImpl const&) const,\
           IARelationImpl\
                            (Ops&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIAREL_
