// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 87 1.5.1.3 source/core/collect/iiasb.h, collection, ioc.v400, 000302 
#ifndef _IIASB_
#define _IIASB_

#include <iiacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IASortedBagImpl : public IACollectionImpl {
public:

          ~IASortedBagImpl
                            ();

  virtual
  void     Antivalence      (IASortedBagImpl const&);

  virtual
  void     AddAntivalence   (IASortedBagImpl const&,
                             IASortedBagImpl const&); 

  virtual
  void     AddDifference    (IASortedBagImpl const&,
                             IASortedBagImpl const&); 

  virtual
  void     AddIntersection  (IASortedBagImpl const&,
                             IASortedBagImpl const&);

  virtual
  void     AddUnion         (IASortedBagImpl const&,
                             IASortedBagImpl const&);

  virtual
  long     Compare          (IASortedBagImpl const&,
                             ICompFunc, void*) const;

  virtual
  void     Difference       (IASortedBagImpl const&);

  virtual
  void     Intersection     (IASortedBagImpl const&);

  virtual
  INumber  NumberOfDifferentElements
                            () const = 0;

  virtual
  bool     SetToNextDifferentElement
                            (ICursorImpl&) const = 0;

  virtual
  void     Union            (IASortedBagImpl const&);

  virtual
  bool     operator==       (IASortedBagImpl const&) const = 0;

  bool     operator!=       (IASortedBagImpl const&) const;

protected:

           IASortedBagImpl
                            (Ops&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Antivalence      (IASortedBagImpl const&),\
           AddAntivalence   (IASortedBagImpl const&,\
                             IASortedBagImpl const&),\
           AddDifference    (IASortedBagImpl const&,\
                             IASortedBagImpl const&),\
           AddIntersection  (IASortedBagImpl const&,\
                             IASortedBagImpl const&),\
           AddUnion         (IASortedBagImpl const&,\
                             IASortedBagImpl const&),\
           Compare          (IASortedBagImpl const&,\
                             ICompFunc, void*) const,\
           Difference       (IASortedBagImpl const&),\
           Intersection     (IASortedBagImpl const&),\
           NumberOfDifferentElements\
                            () const,\
           SetToNextDifferentElement\
                            (ICursorImpl&) const,\
           Union            (IASortedBagImpl const&),\
           operator==       (IASortedBagImpl const&) const,\
           operator!=       (IASortedBagImpl const&) const,\
           IASortedBagImpl\
                            (Ops&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIASB_
