// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 88 1.5.1.2 source/core/collect/iiaseq.cpp, collection, ioc.v400, 000302  
#ifdef IC_PAGETUNE
  #define _IIASEQ_CPP_
  #include <ipagetun.h>
#endif

#include <iiaseq.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif


// ---
// IASequenceImpl
// ---

// public members

IASequenceImpl::
~IASequenceImpl ()
{
}

long
IASequenceImpl::
Compare (IASequenceImpl const& collection,
         ICompFunc compFunc, void* addArg) const
{ long result = 0;

  if (this != &collection) {
    ICursorImpl& thisCursor = CursorOf (*this),
               & thatCursor = CursorOf (collection);
    bool thisHasNext,
             thatHasNext;

    for (thisHasNext = SetToFirst (thisCursor),
         thatHasNext = collection.SetToFirst (thatCursor);
         result == 0 && thisHasNext && thatHasNext;
         thisHasNext = SetToNext (thisCursor),
         thatHasNext = collection.SetToNext (thatCursor)) {
      result = (*compFunc) (ElementAt (thisCursor),
                            collection.ElementAt (thatCursor), addArg);
    }

    if (result == 0) {
      if (thisHasNext && ! thatHasNext)
        result = 1;
      else if (! thisHasNext && thatHasNext)
        result = -1;
    }
  }
  return result;
}

// protected members

IASequenceImpl::
IASequenceImpl (Ops& ops)
: IACollectionImpl (ops)
{
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
