// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 97 1.5.1.3 source/core/collect/iiass.h, collection, ioc.v400, 000302 
#ifndef _IIASS_
#define _IIASS_

#include <iiacllct.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__) 
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

class IC_EXPORTC IASortedSetImpl : public IACollectionImpl {
public:

          ~IASortedSetImpl
                            ();

  virtual
  void     Antivalence      (IASortedSetImpl const&);

  virtual
  void     AddAntivalence   (IASortedSetImpl const&,
                             IASortedSetImpl const&); 

  virtual
  void     AddDifference    (IASortedSetImpl const&,
                             IASortedSetImpl const&); 

  virtual
  void     AddIntersection  (IASortedSetImpl const&,
                             IASortedSetImpl const&);

  virtual
  void     AddUnion         (IASortedSetImpl const&,
                             IASortedSetImpl const&);

  virtual
  long     Compare          (IASortedSetImpl const&,
                             ICompFunc, void*) const;

  virtual
  void     Difference       (IASortedSetImpl const&);

  virtual
  void     Intersection     (IASortedSetImpl const&);

  virtual
  void     Union            (IASortedSetImpl const&);

  virtual
  bool     operator==       (IASortedSetImpl const&) const = 0;

  bool     operator!=       (IASortedSetImpl const&) const;

protected:

           IASortedSetImpl
                            (Ops&);

  INumber  NumberOfOccurrences
                            (void const*) const;

  INumber  RemoveAllOccurrences
                            (void const*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Antivalence      (IASortedSetImpl const&),\
           AddAntivalence   (IASortedSetImpl const&,\
                             IASortedSetImpl const&),\
           AddDifference    (IASortedSetImpl const&,\
                             IASortedSetImpl const&),\
           AddIntersection  (IASortedSetImpl const&,\
                             IASortedSetImpl const&),\
           AddUnion         (IASortedSetImpl const&,\
                             IASortedSetImpl const&),\
           Compare          (IASortedSetImpl const&,\
                             ICompFunc, void*) const,\
           Difference       (IASortedSetImpl const&),\
           Intersection     (IASortedSetImpl const&),\
           Union            (IASortedSetImpl const&),\
           operator==       (IASortedSetImpl const&) const,\
           operator!=       (IASortedSetImpl const&) const,\
           IASortedSetImpl\
                            (Ops&)\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIASS_
