// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 10 1.4.1.2 source/core/collect/iibaglst.c, collection, ioc.v400, 000302 
#ifndef _IIBAGLST_C_
#define _IIBAGLST_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IBagAsListOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
IBagAsListOps <Element, ElementOps, Implementation>::
IBagAsListOps (INumber numberOfElements)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsListOps <Element, ElementOps, Implementation>::
IBagAsListOps (INumber numberOfElements, void* opsArg)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsListOps <Element, ElementOps, Implementation>::
IBagAsListOps
  (IBagAsListOps
    <Element, ElementOps, Implementation> const& collection)
: Inherited (__isDTSClass (Element)),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
IBagAsListOps <Element, ElementOps, Implementation>::
~IBagAsListOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
IBagAsListOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
IBagAsListOps <Element, ElementOps, Implementation>::
operator IKeyBagAsListImpl& ()
{ return *(IKeyBagAsListImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
IBagAsListOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIBAGLST_C_
