// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <ilanglvl.hpp>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ----------------------------------------
// IEqualitySequenceOnSequenceMngCursorImpl
// ----------------------------------------

// public members

template <class Base>
IEqualitySequenceOnSequenceMngCursorImpl <Base>::
IEqualitySequenceOnSequenceMngCursorImpl
  (IEqualitySequenceOnSequenceImpl <Base> const& collection)
: Inherited
    (IEqualitySequenceOnSequenceImpl <Base>::BaseOf (collection))
{ this->ivCollection = &collection;
}

template <class Base>
IEqualitySequenceOnSequenceMngCursorImpl <Base>::
~IEqualitySequenceOnSequenceMngCursorImpl ()
{
}

// -------------------------------
// IEqualitySequenceOnSequenceImpl
// -------------------------------

// inline protected members

template <class Base>
inline bool
IEqualitySequenceOnSequenceImpl <Base>::
EqualElements (void const* element1, void const* element2) const
{ return OpsOf (*this).EqualElements (element1, element2);
}

// inline private members

template <class Base>
inline Base&
IEqualitySequenceOnSequenceImpl <Base>::
BaseOf (IEqualitySequenceOnSequenceImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline TYPENAME IEqualitySequenceOnSequenceImpl <Base>::Ops&
IEqualitySequenceOnSequenceImpl <Base>::
OpsOf (IEqualitySequenceOnSequenceImpl <Base> const& collection)
{ return (Ops&) IACollectionImpl::OpsOf (collection);
}

// public members

template <class Base>
IEqualitySequenceOnSequenceImpl <Base>::
IEqualitySequenceOnSequenceImpl (Ops& ops, INumber)
: IAEqualitySequenceImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IEqualitySequenceOnSequenceImpl <Base>::
IEqualitySequenceOnSequenceImpl
  (Ops& ops, IEqualitySequenceOnSequenceImpl <Base> const&)
: IAEqualitySequenceImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IEqualitySequenceOnSequenceImpl <Base>::
~IEqualitySequenceOnSequenceImpl ()
{
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
AddAllFrom (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    BaseOf (*this).Base::AddAllFrom (BaseOf ((Self const&)collection));
  else
    Inherited::AddAllFrom (collection);

}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
AddAsFirst (void const* element, ICursorImpl &cursor)
{ BaseOf (*this).Base::AddAsFirst (element, cursor);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
AddAsLast (void const* element, ICursorImpl &cursor)
{ BaseOf (*this).Base::AddAsLast (element, cursor);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
AddAsNext (void const* element, ICursorImpl &cursor)
{ BaseOf (*this).Base::AddAsNext (element, cursor);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
AddAsPrevious (void const* element, ICursorImpl &cursor)
{ BaseOf (*this).Base::AddAsPrevious (element, cursor);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
AddAtPosition (IPosition position,
               void const* element, ICursorImpl &cursor)
{ BaseOf (*this).Base::AddAtPosition (position, element, cursor);
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
IEqualitySequenceOnSequenceImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
char const*
IEqualitySequenceOnSequenceImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
IEqualitySequenceOnSequenceImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
Contains (void const* element) const
{ return Self::LocateFirst (element, CursorOf (*this));
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
ContainsAllFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    bool result = true;
    if (this != &collection) {
      Self const& es = (Self const&)collection;
      ICursorImpl& cursor = CursorOf (es);

      for (es.Self::SetToFirst (cursor);
           cursor.IsValid ();
           es.Self::SetToNext (cursor)) {
        if (! Self::Contains (es.Self::ElementAt (cursor))) {
          result = false;
          break;
        }
      }
    }
    return result;
  }
  else
    return Inherited::ContainsAllFrom (collection);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
TYPENAME IEqualitySequenceOnSequenceImpl <Base>::Cursor*
IEqualitySequenceOnSequenceImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
TYPENAME IEqualitySequenceOnSequenceImpl <Base>::MngCursor*
IEqualitySequenceOnSequenceImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
IEqualitySequenceOnSequenceImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
void*
IEqualitySequenceOnSequenceImpl <Base>::
ElementAtPosition (IPosition position) const
{ return BaseOf (*this).Base::ElementAtPosition (position);
}

template <class Base>
void*
IEqualitySequenceOnSequenceImpl <Base>::
First () const
{ return BaseOf (*this).Base::First ();
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
IsFirstAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsFirstAt (cursor);
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
IsLastAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsLastAt (cursor);
}

template <class Base>
void*
IEqualitySequenceOnSequenceImpl <Base>::
Last () const
{ return BaseOf (*this).Base::Last ();
}

template <class Base>
bool IEqualitySequenceOnSequenceImpl <Base>::
Locate (void const* element, ICursorImpl& cursor) const
{ return Self::LocateFirst (element, cursor);
}

template <class Base>
bool IEqualitySequenceOnSequenceImpl <Base>::
LocateFirst (void const* element, ICursorImpl& cursor) const
{ for (Self::SetToFirst (cursor);
       cursor.IsValid ();
       Self::SetToNext (cursor)) {
    if (EqualElements (Self::ElementAt (cursor), element))
      return true;
  }
  return false;
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
LocateLast (void const* element, ICursorImpl& cursor) const
{ for (Self::SetToLast (cursor);
       cursor.IsValid ();
       Self::SetToPrevious (cursor)) {
    if (EqualElements (Self::ElementAt (cursor), element))
      return true;
  }
  return false;
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
LocateNext (void const* element, ICursorImpl& cursor) const
{ while (Self::SetToNext (cursor)) {
    if (EqualElements (Self::ElementAt (cursor), element))
      return true;
  }
  return false;
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
LocateOrAdd (void const* element, ICursorImpl& cursor)
{ bool isContained = Self::Locate (element, cursor);

  if (! isContained)
    Self::Add (element, cursor);

  return isContained;
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
LocatePrevious (void const* element, ICursorImpl& cursor) const
{ while (Self::SetToPrevious (cursor)) {
    if (EqualElements (Self::ElementAt (cursor), element))
      return true;
  }
  return false;
}

template <class Base>
INumber
IEqualitySequenceOnSequenceImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
INumber
IEqualitySequenceOnSequenceImpl <Base>::
NumberOfOccurrences (void const* element) const
{ INumber result = 0;

  for (Self::Locate (element, CursorOf (*this));
       CursorOf (*this).IsValid ();
       Self::LocateNext (element, CursorOf (*this))) {
    result++;
  }

  return result;
}

template <class Base>
IPosition
IEqualitySequenceOnSequenceImpl <Base>::
PositionAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::PositionAt (cursor);
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
Remove (void const* element)
{ bool isContained = Self::LocateFirst (element, CursorOf (*this));

  if (isContained)
    Self::RemoveAt (CursorOf (*this));

  return isContained;
}

template <class Base>
INumber
IEqualitySequenceOnSequenceImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
IEqualitySequenceOnSequenceImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
INumber
IEqualitySequenceOnSequenceImpl <Base>::
RemoveAllOccurrences (void const* element)
{ ivElement = element;
  return RemoveAll (Predicate::IsEqual, this);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
RemoveAtPosition (IPosition position)
{ BaseOf (*this).Base::RemoveAtPosition (position);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
RemoveFirst ()
{ BaseOf (*this).Base::RemoveFirst ();
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
RemoveLast ()
{ BaseOf (*this).Base::RemoveLast ();
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
ReplaceAtPosition (IPosition position, void const* element)
{ BaseOf (*this).Base::ReplaceAtPosition (position, element);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
Reverse ()
{ BaseOf (*this).Base::Reverse ();
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
SetToLast (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToLast (cursor);
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
SetToPosition (IPosition position, ICursorImpl& cursor) const
{ BaseOf (*this).Base::SetToPosition (position, cursor);
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
SetToPrevious (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToPrevious (cursor);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
Sort (ICompFunc compFunc, void* addArg)
{ BaseOf (*this).Base::Sort (compFunc, addArg);
}

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::
operator== (IAEqualitySequenceImpl const& collection) const
{ bool result =
      Self::NumberOfElements () == collection.NumberOfElements ();
  if (result && this != &collection) {
    ICursorImpl& thisCursor = CursorOf (*this),
               & thatCursor = CursorOf (collection);

    for (Self::SetToFirst (thisCursor),
           collection.SetToFirst (thatCursor);
         result && thisCursor.IsValid ();
         Self::SetToNext (thisCursor),
           collection.SetToNext (thatCursor)) {
      result = EqualElements (Self::ElementAt (thisCursor),
                              collection.ElementAt (thatCursor));
    }
  }
  return result;
}

#if ! defined (__INO_STREAMING__)
template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
StreamIn (IDataStream& stream)
{ ReadVersion (stream);
  BaseOf (*this).Base::StreamIn (stream);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
StreamOut (IDataStream& stream) const
{ WriteVersion (stream);
  BaseOf (*this).Base::StreamOut (stream);
}

template <class Base>
void
IEqualitySequenceOnSequenceImpl <Base>::
AdoptStreamer (IACollectionStreamer *streamer)
{ (BaseOf (*this).Base::AdoptStreamer(streamer));
}

template <class Base>
IStreamerPtr&
IEqualitySequenceOnSequenceImpl <Base>::
StreamerOf (IACollectionImpl const& collection)
{ return (BaseOf (*this).Base::StreamerOf(collection));
}
#endif

// ------------------------------------------
// IEqualitySequenceOnSequenceImpl::Predicate
// ------------------------------------------

// public members

template <class Base>
bool
IEqualitySequenceOnSequenceImpl <Base>::Predicate::
IsEqual (void const* element, void* thisPtr)
{ return ((ES*)thisPtr)->EqualElements (element,
                                        ((ES*)thisPtr)->ivElement);
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
