// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <iiexc.h>
#include <icconsta.h>

#ifdef IC_PAGETUNE
  #define _IIEXC_CPP_
  #include <ipagetun.h>
#endif


#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#define ICCEXCLASSIMPLEMENT(exc, excMsgID)\
  exc::exc (char const* msgText)\
  : exc::InheritedIBM (msgText)\
  { InheritedIBM::logExceptionData (); }\
  exc::exc (char const* /*className*/, char const* methodName,\
            char const* fileName, unsigned long lineNumber,\
            unsigned long msgID)\
  : exc::InheritedIBM (ICollectionExceptionText (msgID))\
  { InheritedIBM::addLocation\
      (IExceptionLocation (fileName, methodName, lineNumber));\
    InheritedIBM::logExceptionData (); }\
  exc::exc (exc const& e)\
  : exc::InheritedIBM (e) { }\
  exc::~exc () { }\
  void exc::throwIt (char const* className, char const* methodName,\
            char const* fileName, unsigned long lineNumber)\
  { exc e (className, methodName, fileName, lineNumber, excMsgID);\
    ITHROW (e); }\
  void exc::operator= (exc const&) { }

ICCEXCLASSIMPLEMENT(IFullExceptionImpl, IC_COLLECTION_IS_FULL);
ICCEXCLASSIMPLEMENT(IEmptyExceptionImpl, IC_COLLECTION_IS_EMPTY);
ICCEXCLASSIMPLEMENT(INotEmptyExceptionImpl, IC_COLLECTION_NOT_EMPTY);
ICCEXCLASSIMPLEMENT(INotBoundedExceptionImpl, IC_NOT_BOUNDED);
ICCEXCLASSIMPLEMENT(ICursorInvalidExceptionImpl, IC_INVALID_CURSOR);
ICCEXCLASSIMPLEMENT(ICursorNotForThisExceptionImpl, IC_CURSOR_NOT_FOR_THIS);
ICCEXCLASSIMPLEMENT(ICursorNotForGivenExceptionImpl, IC_CURSOR_NOT_FOR_GIVEN);
ICCEXCLASSIMPLEMENT(ICursorNotContainedExceptionImpl, IC_CURSOR_NOT_CONTAINED);
ICCEXCLASSIMPLEMENT(IPositionInvalidExceptionImpl, IC_INVALID_POSITION);
ICCEXCLASSIMPLEMENT(INotContainsKeyExceptionImpl, IC_KEY_NOT_CONTAINED);
ICCEXCLASSIMPLEMENT(IKeyAlreadyExistsExceptionImpl, IC_KEY_ALREADY_EXISTS);
ICCEXCLASSIMPLEMENT(IRootAlreadyExistsExceptionImpl, IC_ROOT_ALREADY_EXISTS);
ICCEXCLASSIMPLEMENT(IChildAlreadyExistsExceptionImpl, IC_CHILD_ALREADY_EXISTS);
ICCEXCLASSIMPLEMENT(IIdenticalCollectionExceptionImpl, IC_IDENTICAL_COLLECTION);
ICCEXCLASSIMPLEMENT(IInvalidReplacementExceptionImpl, IC_INVALID_REPLACEMENT);
ICCEXCLASSIMPLEMENT(ICyclicAttachExceptionImpl, IC_CYCLIC_CHILD_ATTACHMENT);

#if !defined(__INO_L1_LOCKING__)
ICCEXCLASSIMPLEMENT(ICollectionResourceExceptionImpl, IC_NO_MUTEX_AVAILABLE);
ICCEXCLASSIMPLEMENT(ICollectionLockExceptionImpl, IC_LOCK_FAILED);
ICCEXCLASSIMPLEMENT(ICollectionLockTimeOutExceptionImpl, IC_LOCK_TIMEOUT);
ICCEXCLASSIMPLEMENT(ICollectionUnlockExceptionImpl, IC_UNLOCK_FAILED);
#endif

#if ! defined (__INO_STREAMING__)
ICCEXCLASSIMPLEMENT(IStreamErrorExceptionImpl, IC_STREAM_VERSION_ERROR);
ICCEXCLASSIMPLEMENT(IStreamerInvalidExceptionImpl, IC_STREAMER_INVALID);
#endif

ICCEXCLASSIMPLEMENT(IOutOfCollectionMemoryImpl, IC_OUT_OF_COLLECTION_MEMORY);

#if ! defined (__INO_CONCUR__)
ICCEXCLASSIMPLEMENT(IUnlockInvalidExceptionImpl);
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
