// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <ilanglvl.hpp>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ----------------------------
// IHeapOnSequenceMngCursorImpl
// ----------------------------

// public members

template <class Base>
IHeapOnSequenceMngCursorImpl <Base>::
IHeapOnSequenceMngCursorImpl
  (IHeapOnSequenceImpl <Base> const& collection)
: Inherited (IHeapOnSequenceImpl <Base>::BaseOf (collection))
{ this->ivCollection = &collection;
}

template <class Base>
IHeapOnSequenceMngCursorImpl <Base>::
~IHeapOnSequenceMngCursorImpl ()
{
}

// -------------------
// IHeapOnSequenceImpl
// -------------------

// inline private members

template <class Base>
inline Base&
IHeapOnSequenceImpl <Base>::
BaseOf (IHeapOnSequenceImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline TYPENAME IHeapOnSequenceImpl <Base>::Ops&
IHeapOnSequenceImpl <Base>::
OpsOf (IHeapOnSequenceImpl <Base> const& collection)
{ return (Ops&) IACollectionImpl::OpsOf (collection);
}

// public members

template <class Base>
IHeapOnSequenceImpl <Base>::
IHeapOnSequenceImpl (Ops& ops, INumber)
: IAHeapImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IHeapOnSequenceImpl <Base>::
IHeapOnSequenceImpl (Ops& ops, IHeapOnSequenceImpl <Base> const&)
: IAHeapImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IHeapOnSequenceImpl <Base>::
~IHeapOnSequenceImpl ()
{
}

template <class Base>
bool
IHeapOnSequenceImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
void
IHeapOnSequenceImpl <Base>::
AddAllFrom (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    BaseOf (*this).Base::AddAllFrom (BaseOf ((Self const&)collection));
  else
    Inherited::AddAllFrom (collection);
}

template <class Base>
bool
IHeapOnSequenceImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
IHeapOnSequenceImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
bool
IHeapOnSequenceImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
char const*
IHeapOnSequenceImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
IHeapOnSequenceImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
void
IHeapOnSequenceImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
TYPENAME IHeapOnSequenceImpl <Base>::Cursor*
IHeapOnSequenceImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
TYPENAME IHeapOnSequenceImpl <Base>::MngCursor*
IHeapOnSequenceImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
IHeapOnSequenceImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
bool
IHeapOnSequenceImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
bool
IHeapOnSequenceImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
bool
IHeapOnSequenceImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
bool
IHeapOnSequenceImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
INumber
IHeapOnSequenceImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
INumber
IHeapOnSequenceImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
IHeapOnSequenceImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
void
IHeapOnSequenceImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
void
IHeapOnSequenceImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
bool
IHeapOnSequenceImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
bool
IHeapOnSequenceImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

#if ! defined (__INO_STREAMING__)
template <class Base>
void
IHeapOnSequenceImpl <Base>::
StreamIn (IDataStream& stream)
{ ReadVersion (stream);
  BaseOf (*this).Base::StreamIn (stream);
}

template <class Base>
void
IHeapOnSequenceImpl <Base>::
StreamOut (IDataStream& stream) const
{ WriteVersion (stream);
  BaseOf (*this).Base::StreamOut (stream);
}

template <class Base>
void
IHeapOnSequenceImpl <Base>::
AdoptStreamer (IACollectionStreamer *streamer)
{ (BaseOf (*this).Base::AdoptStreamer(streamer));
}

template <class Base>
IStreamerPtr&
IHeapOnSequenceImpl <Base>::
StreamerOf (IACollectionImpl const& collection)
{ return (BaseOf (*this).Base::StreamerOf(collection));
}
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
