// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 70 1.6.1.3 source/core/collect/iihpseq.h, collection, ioc.v400, 000302 
#ifndef _IIHPSEQ_
#define _IIHPSEQ_

#include <ilanglvl.hpp>
#include <iiahp.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Base>
class IHeapOnSequenceMngCursorImpl;

template <class Base>
class IHeapOnSequenceImpl;

#pragma pack(push,4)
#pragma enum(4)

template <class Base>
class IC_EXPORTC IHeapOnSequenceMngCursorImpl : public Base::MngCursor 
{

  typedef TYPENAME Base::MngCursor Inherited;

public:

           IHeapOnSequenceMngCursorImpl
                            (IHeapOnSequenceImpl <Base> const&);

          ~IHeapOnSequenceMngCursorImpl
                            ();

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
            IHeapOnSequenceMngCursorImpl\
                            (IHeapOnSequenceImpl <Base> const&)\
                        )
#endif

};

template <class Base>
class IAHeapOnSequenceOps;

template <class Base>
class IC_EXPORTC IHeapOnSequenceImpl : public IAHeapImpl {

  typedef  IAHeapImpl Inherited;

  typedef  IHeapOnSequenceImpl <Base> Self;

public:

  typedef  IAHeapOnSequenceOps <Base> Ops;

  typedef TYPENAME Base::Cursor Cursor;

  typedef  IHeapOnSequenceMngCursorImpl <Base> MngCursor;

           IHeapOnSequenceImpl
                            (Ops&, INumber);

           IHeapOnSequenceImpl
                            (Ops&, IHeapOnSequenceImpl <Base> const&);

          ~IHeapOnSequenceImpl
                            ();

  bool Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  bool AllElementsDo    (IApplFunc, void*);

  void*    Any              () const;

  bool CheckCursor      (ICursorImpl const&) const;

  char const*
           ClassName        () const;

  IACollectionImpl*
           Clone            () const;

  void     Copy             (IACollectionImpl const&);

  Cursor*  CreateCursor     () const;

  MngCursor*
           CreateMngCursor  () const;

  void*    ElementAt        (ICursorImpl const&) const;

  bool IsBounded        () const;

  bool IsConsistent     () const;

  bool IsEmpty          () const;

  bool IsFull           () const;

  INumber  NumberOfElements () const;

  INumber  RemoveAll        ();

  INumber  RemoveAll        (IPredFunc, void*);

  void     RemoveAt         (ICursorImpl&);

  void     ReplaceAt        (ICursorImpl const&, void const*);

  bool SetToFirst       (ICursorImpl&) const;

  bool SetToNext        (ICursorImpl&) const;

  void     operator=        (IHeapOnSequenceImpl <Base> const&);

protected:

private:

  static
  char const*
           cvClassName;

  Base&    ivBase;

  static
  Base&    BaseOf           (IHeapOnSequenceImpl <Base> const&);

  static
  Ops&     OpsOf            (IHeapOnSequenceImpl <Base> const&);

  friend
  class    IHeapOnSequenceMngCursorImpl <Base>;

#if ! defined (__INO_STREAMING__)
public:
  IStreamerPtr&
           StreamerOf       (IACollectionImpl const&);

  void     StreamIn         (IDataStream&);

  void     StreamOut        (IDataStream&) const;

  void     AdoptStreamer    (IACollectionStreamer*);
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IHeapOnSequenceImpl\
                            (Ops&, INumber),\
           IHeapOnSequenceImpl\
                            (Ops&,\
                             IHeapOnSequenceImpl <Base> const&),\
           CheckCursor      (ICursorImpl const&) const,\
           operator=,\
           cvClassName,\
           BaseOf           (IHeapOnSequenceImpl <Base> const&),\
           OpsOf            (IHeapOnSequenceImpl <Base> const&)\
#if ! defined (__INO_STREAMING__)
           ,StreamerOf       (IACollectionImpl const&)\
           ,StreamIn         (IDataStream&)\
           ,StreamOut        (IDataStream&) const\
           ,AdoptStreamer    (IACollectionStreamer*)\
#endif
)
#endif

};

template <class Base>
class IC_EXPORTC IAHeapOnSequenceOps {
public:

  virtual ~IAHeapOnSequenceOps
                            ();

  virtual
  IACollectionImpl*
           Clone            () const = 0;

  virtual  operator Base&   () = 0;

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMReleaseOrder (\
           Clone            () const,\
           operator Base&   ()\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__)
#pragma SOMAsDefault (pop)
#endif

#include <iihpseq.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIHPSEQ_
