// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 81 1.4.1.2 source/core/collect/iikbhsh.inl, collection, ioc.v400, 000302 
#ifndef _IIKBHSH_INL_
#define _IIKBHSH_INL_

#include <iiexc.h>

// --------------------------
// IAKeyBagAsHshTableNodeImpl
// --------------------------

// public members

inline
IAKeyBagAsHshTableNodeImpl::
IAKeyBagAsHshTableNodeImpl ()
: ivNext (0)
{
}

// -------------------------
// IKeyBagAsHshTableNodeImpl
// -------------------------

// public members

template <class Element>
inline
IKeyBagAsHshTableNodeImpl <Element>::
IKeyBagAsHshTableNodeImpl (Element const& element)
: IAKeyBagAsHshTableNodeImpl (), ivElement (element)
{
}

template <class Element>
inline
IKeyBagAsHshTableNodeImpl <Element>::
~IKeyBagAsHshTableNodeImpl ()
{
}

#if ! defined(__INO_STREAMING__)
template <class Element>
inline void
IKeyBagAsHshTableNodeImpl<Element>::
StreamIn (IACollectionStreamer *streamer, IDataStream& fromWhere)
{ ivNext = 0;
  streamer->streamIn(fromWhere, &ivElement);
}
#endif

// ---------------------------
// IKeyBagAsHshTableCursorImpl
// ---------------------------

// public members

inline void
IKeyBagAsHshTableCursorImpl::
Invalidate ()
{ ivNode = 0;
}

inline bool
IKeyBagAsHshTableCursorImpl::
IsInBetween () const
{ return false;
}

inline bool
IKeyBagAsHshTableCursorImpl::
IsValid () const
{ return (ivNode != 0);
}

inline void
IKeyBagAsHshTableCursorImpl::
operator= (IKeyBagAsHshTableCursorImpl const& cursor)
{ Inherited::operator= (cursor);
  ivNode   = cursor.ivNode;
  ivBucket = cursor.ivBucket;
}

inline bool
IKeyBagAsHshTableCursorImpl::
operator== (ICursorImpl const& cursor) const
{ return (Inherited::operator== (cursor) &&
          ivNode   == ((Self const&)cursor).ivNode &&
          ivBucket == ((Self const&)cursor).ivBucket);
}


// ---------------------
// IAKeyBagAsHshTableOps
// ---------------------

// public members

inline
IAKeyBagAsHshTableOps::
~IAKeyBagAsHshTableOps ()
{
}

// protected members

inline
IAKeyBagAsHshTableOps::
IAKeyBagAsHshTableOps (bool containsDTSObjects)
: ivContainsDTSObjects (containsDTSObjects)
{
}

#endif // _IIKBHSH_INL_
