// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <ilanglvl.hpp>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// --------------------------
// IKeyBagOnKeySortedBagMngCursorImpl
// --------------------------

// public members

template <class Base>
IKeyBagOnKeySortedBagMngCursorImpl <Base>::
IKeyBagOnKeySortedBagMngCursorImpl
  (IKeyBagOnKeySortedBagImpl <Base> const& collection)
: Inherited (IKeyBagOnKeySortedBagImpl <Base>::BaseOf (collection))
{ this->ivCollection = &collection;
}

template <class Base>
IKeyBagOnKeySortedBagMngCursorImpl <Base>::
~IKeyBagOnKeySortedBagMngCursorImpl ()
{
}

// -------------------------
// IKeyBagOnKeySortedBagImpl
// -------------------------

// inline public members

#define inline

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
AddOrReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).AddOrReplaceElementWithKey (element, cursor);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
inline void*
IKeyBagOnKeySortedBagImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
inline char const*
IKeyBagOnKeySortedBagImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
ContainsElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ContainsElementWithKey (key);
}

template <class Base>
inline void*
IKeyBagOnKeySortedBagImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
inline void*
IKeyBagOnKeySortedBagImpl <Base>::
ElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ElementWithKey (key);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
inline void*
IKeyBagOnKeySortedBagImpl <Base>::
Key (void const* element) const
{ return BaseOf (*this).Key (element);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
LocateElementWithKey (void const* key, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateElementWithKey (key, cursor);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
LocateNextElementWithKey (void const* key, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateNextElementWithKey (key, cursor);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
LocateOrAddElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
inline INumber
IKeyBagOnKeySortedBagImpl <Base>::
NumberOfDifferentKeys () const
{ return BaseOf (*this).Base::NumberOfDifferentKeys ();
}

template <class Base>
inline INumber
IKeyBagOnKeySortedBagImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}


template <class Base>
inline INumber
IKeyBagOnKeySortedBagImpl <Base>::
NumberOfElementsWithKey (void const* key) const
{ return BaseOf (*this).Base::NumberOfElementsWithKey (key);
}

template <class Base>
inline INumber
IKeyBagOnKeySortedBagImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
inline INumber
IKeyBagOnKeySortedBagImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
inline INumber
IKeyBagOnKeySortedBagImpl <Base>::
RemoveAllElementsWithKey (void const* key)
{ return BaseOf (*this).Base::RemoveAllElementsWithKey (key);
}

template <class Base>
inline void
IKeyBagOnKeySortedBagImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
RemoveElementWithKey (void const* key)
{ return BaseOf (*this).Base::RemoveElementWithKey (key);
}

template <class Base>
inline void
IKeyBagOnKeySortedBagImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
ReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).ReplaceElementWithKey (element, cursor);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
SetToNextWithDifferentKey (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNextWithDifferentKey (cursor);
}

#undef inline

// inline protected members

template <class Base>
inline bool
IKeyBagOnKeySortedBagImpl <Base>::
EqualKeys (void const* arg1, void const* arg2, IArgType argType) const
{ return (BaseOf (*this).CompareKeys (arg1, arg2, argType) == 0);
}

// inline private members

template <class Base>
inline Base&
IKeyBagOnKeySortedBagImpl <Base>::
BaseOf (IKeyBagOnKeySortedBagImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline TYPENAME IKeyBagOnKeySortedBagImpl <Base>::Ops&
IKeyBagOnKeySortedBagImpl <Base>::
OpsOf (IKeyBagOnKeySortedBagImpl <Base> const& collection)
{ return (Ops&) Inherited::OpsOf (collection);
}

// public members

template <class Base>
IKeyBagOnKeySortedBagImpl <Base>::
IKeyBagOnKeySortedBagImpl (Ops& ops, INumber)
: IAKeyBagImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IKeyBagOnKeySortedBagImpl <Base>::
IKeyBagOnKeySortedBagImpl
  (Ops& ops, IKeyBagOnKeySortedBagImpl <Base> const&)
: IAKeyBagImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IKeyBagOnKeySortedBagImpl <Base>::
~IKeyBagOnKeySortedBagImpl ()
{
}

template <class Base>
void
IKeyBagOnKeySortedBagImpl <Base>::
AddAllFrom (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& ks = (Self const&)collection;
    BaseOf (*this).Base::AddAllFrom (BaseOf (ks));
  }
  else
    Inherited::AddAllFrom (collection);
}

template <class Base>
IACollectionImpl*
IKeyBagOnKeySortedBagImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
bool
IKeyBagOnKeySortedBagImpl <Base>::
ContainsAllKeysFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    return BaseOf (*this).
      Base::ContainsAllKeysFrom (BaseOf ((Self const&)collection));
  }
  else
    return Inherited::ContainsAllKeysFrom (collection);
}

template <class Base>
void
IKeyBagOnKeySortedBagImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
TYPENAME IKeyBagOnKeySortedBagImpl <Base>::Cursor*
IKeyBagOnKeySortedBagImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
TYPENAME IKeyBagOnKeySortedBagImpl <Base>::MngCursor*
IKeyBagOnKeySortedBagImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

#if ! defined (__INO_STREAMING__)
template <class Base>
void
IKeyBagOnKeySortedBagImpl <Base>::
StreamIn (IDataStream& stream)
{ ReadVersion (stream);
  BaseOf (*this).Base::StreamIn (stream);
}

template <class Base>
void
IKeyBagOnKeySortedBagImpl <Base>::
StreamOut (IDataStream& stream) const
{ WriteVersion (stream);
  BaseOf (*this).Base::StreamOut (stream);
}

template <class Base>
void
IKeyBagOnKeySortedBagImpl <Base>::
AdoptStreamer (IACollectionStreamer *streamer)
{ (BaseOf (*this).Base::AdoptStreamer(streamer));
}

template <class Base>
IStreamerPtr&
IKeyBagOnKeySortedBagImpl <Base>::
StreamerOf (IACollectionImpl const& collection)
{ return (BaseOf (*this).Base::StreamerOf(collection));
}
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
