// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 92 1.2.1.2 source/core/collect/iikeyops.inl, collection, ioc.v400, 000302 
#ifndef _IIKEYOPS_INL_
#define _IIKEYOPS_INL_

#include <stddef.h>

// -----------
// IKeyFromOps
// -----------

template <class Key>
inline void* IKeyFromOps (Key const& k)
{ return (void*)&k;
}

// ----------
// IKeyForOps
// ----------

template <class Key>
inline Key const& IKeyForOps (Key const* k)
{ return *k;
}

// -----------
// IOpsWithKey
// -----------

// public members

template <class Element, class ElementOps>
inline
IOpsWithKey <Element, ElementOps>::
IOpsWithKey ()
{
}

template <class Element, class ElementOps>
inline
IOpsWithKey <Element, ElementOps>::
IOpsWithKey (void* opsArg)
: ElementOps (opsArg), keyOps (opsArg)
{
}

template <class Element, class ElementOps>
inline Element const&
IOpsWithKey <Element, ElementOps>::
Key (Element const& e) const
{ return e;
}

#endif // _IIKEYOPS_INL_
