// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 96 1.5.1.2 source/core/collect/iiksbdil.c, collection, ioc.v400, 000302 
#ifndef _IIKSBDIL_C_
#define _IIKSBDIL_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IKeySortedBagAsDilTableOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySortedBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeySortedBagAsDilTableOps (INumber numberOfElements)
: ivElementOps (),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySortedBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeySortedBagAsDilTableOps (INumber numberOfElements, void* opsArg)
: ivElementOps (opsArg),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class _Key,
          class ElementOps, class Implementation>
IKeySortedBagAsDilTableOps <Element, _Key, ElementOps, Implementation>::
IKeySortedBagAsDilTableOps
  (IKeySortedBagAsDilTableOps
    <Element, _Key, ElementOps, Implementation> const& collection)
: ivElementOps (collection.ivElementOps),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySortedBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
~IKeySortedBagAsDilTableOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IKeySortedBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class _Key,
          class ElementOps, class Implementation>
long
IKeySortedBagAsDilTableOps <Element, _Key, ElementOps, Implementation>::
CompareKeys (void const* arg1, void const* arg2, IArgType argType) const
{ long comp = 0;
  switch (argType) {
    case kElementElement: {
      comp = ivElementOps.keyOps.Compare
        (ivElementOps.Key (*(Element const*)arg1),
         ivElementOps.Key (*(Element const*)arg2));
      break;
    }
    case kElementKey: {
      comp = ivElementOps.keyOps.Compare
        (ivElementOps.Key (*(Element const*)arg1),
         IKeyForOps ((_Key const*)arg2));
      break;
    }
    case kKeyKey: {
      comp = ivElementOps.keyOps.Compare
        (IKeyForOps ((_Key const*)arg1), IKeyForOps ((_Key const*)arg2));
    }
  }
  return comp;
}

template <class Element, class _Key,
          class ElementOps, class Implementation>
void*
IKeySortedBagAsDilTableOps <Element, _Key, ElementOps, Implementation>::
Key (void const* element) const
{ return IKeyFromOps (ivElementOps.Key (*(Element const*)element));
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySortedBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
operator ISequenceAsDilTableImpl& ()
{ return *(ISequenceAsDilTableImpl*)ivBase;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySortedBagAsDilTableOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIKSBDIL_C_
