// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <ilanglvl.hpp>
#include <iiexc.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ------------------------------------
// IKeySortedBagOnSequenceMngCursorImpl
// ------------------------------------

// public members

template <class Base>
IKeySortedBagOnSequenceMngCursorImpl <Base>::
IKeySortedBagOnSequenceMngCursorImpl
  (IKeySortedBagOnSequenceImpl <Base> const& collection)
: Inherited (IKeySortedBagOnSequenceImpl <Base>::BaseOf (collection))
{ this->ivCollection = &collection;
}

template <class Base>
IKeySortedBagOnSequenceMngCursorImpl <Base>::
~IKeySortedBagOnSequenceMngCursorImpl ()
{
}

// ---------------------------
// IKeySortedBagOnSequenceImpl
// ---------------------------

// inline public members

#define inline

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return (CompareKeys
    (Self::ElementAt (cursor), element, kElementElement) == 0);
}

template <class Base>
inline char const*
IKeySortedBagOnSequenceImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
ContainsElementWithKey (void const* key) const
{ return LocateKey (key, CursorOf (*this));
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
ElementAtPosition (IPosition position) const
{ return BaseOf (*this).Base::ElementAtPosition (position);
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
First () const
{ return BaseOf (*this).Base::First ();
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
IsFirstAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsFirstAt (cursor);
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
IsLastAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsLastAt (cursor);
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
Key (void const* element) const
{ return OpsOf (*this).Key (element);
}

template <class Base>
inline void*
IKeySortedBagOnSequenceImpl <Base>::
Last () const
{ return BaseOf (*this).Base::Last ();
}

template <class Base>
inline INumber
IKeySortedBagOnSequenceImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
inline IPosition
IKeySortedBagOnSequenceImpl <Base>::
PositionAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::PositionAt (cursor);
}

template <class Base>
inline INumber
IKeySortedBagOnSequenceImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
inline INumber
IKeySortedBagOnSequenceImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
inline INumber
IKeySortedBagOnSequenceImpl <Base>::
RemoveAllElementsWithKey (void const* key)
{ ivKey = key;
  return RemoveAll (Predicate::IsEqual, this);
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
RemoveAtPosition (IPosition position)
{ BaseOf (*this).Base::RemoveAtPosition (position);
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
RemoveFirst ()
{ BaseOf (*this).Base::RemoveFirst ();
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
RemoveLast ()
{ BaseOf (*this).Base::RemoveLast ();
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
ReplaceAtPosition (IPosition position, void const* element)
{ BaseOf (*this).Base::ReplaceAtPosition (position, element);
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
SetToLast (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToLast (cursor);
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
inline void
IKeySortedBagOnSequenceImpl <Base>::
SetToPosition (IPosition position, ICursorImpl& cursor) const
{ BaseOf (*this).Base::SetToPosition (position, cursor);
}

template <class Base>
inline bool
IKeySortedBagOnSequenceImpl <Base>::
SetToPrevious (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToPrevious (cursor);
}

#undef inline

// inline protected members

template <class Base>
inline long
IKeySortedBagOnSequenceImpl <Base>::
CompareKeys (void const* arg1, void const* arg2, IArgType argType) const
{ return OpsOf (*this).CompareKeys (arg1, arg2, argType);
}

// inline private members

template <class Base>
inline Base&
IKeySortedBagOnSequenceImpl <Base>::
BaseOf (IKeySortedBagOnSequenceImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline TYPENAME IKeySortedBagOnSequenceImpl <Base>::Ops&
IKeySortedBagOnSequenceImpl <Base>::
OpsOf (IKeySortedBagOnSequenceImpl <Base> const& collection)
{ return (Ops&) IACollectionImpl::OpsOf (collection);
}

// public members

template <class Base>
IKeySortedBagOnSequenceImpl <Base>::
IKeySortedBagOnSequenceImpl (Ops& ops, INumber)
: IAKeySortedBagImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IKeySortedBagOnSequenceImpl <Base>::
IKeySortedBagOnSequenceImpl
  (Ops& ops, IKeySortedBagOnSequenceImpl <Base> const&)
: IAKeySortedBagImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IKeySortedBagOnSequenceImpl <Base>::
~IKeySortedBagOnSequenceImpl ()
{
}

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ if (LocateKey (Key (element), cursor))
    Self::SetToNextWithDifferentKey (cursor);
  if (cursor.IsValid ())
    BaseOf (*this).Base::AddAsPrevious (element, cursor);
  else
    BaseOf (*this).Base::AddAsLast (element, cursor);
  return true;
}

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
AddOrReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ bool isContained = LocateKey (Key (element), cursor);

  if (isContained)
    BaseOf (*this).Base::ReplaceAt (cursor, element);
  else
    Self::Add (element, cursor);

  return ! isContained;
}

template <class Base>
IACollectionImpl*
IKeySortedBagOnSequenceImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
ContainsAllKeysFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    if (this != &collection) {
      Self const& ksb = (Self const&)collection;
      ICursorImpl& thisCursor = CursorOf (*this),
                 & thatCursor = CursorOf (ksb);

      long comp;
      Self::SetToFirst (thisCursor);
      for (ksb.Self::SetToFirst (thatCursor);
           thatCursor.IsValid ();
           ksb.Self::SetToNext (thatCursor)) {
        bool found = false;
        while (! found && thisCursor.IsValid ()) {
          comp = CompareKeys (Self::ElementAt (thisCursor),
                              ksb.Self::ElementAt (thatCursor),
                              kElementElement);
          if (comp <= 0) {
            Self::SetToNext (thisCursor);
            if (comp == 0) {
              found = true;
            }
          }
          else {
            return false;
          }
        }
        if (! found) {
          return false;
        }
      }
    }
    return true;
  }
  else
    return Inherited::ContainsAllKeysFrom (collection);
}

template <class Base>
void
IKeySortedBagOnSequenceImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
TYPENAME IKeySortedBagOnSequenceImpl <Base>::Cursor*
IKeySortedBagOnSequenceImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
TYPENAME IKeySortedBagOnSequenceImpl <Base>::MngCursor*
IKeySortedBagOnSequenceImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
IKeySortedBagOnSequenceImpl <Base>::
ElementWithKey (void const* key) const
{ ICursorImpl& cursor = CursorOf (*this);
  ICHECK_ContainsKey (ClassName (), "ElementWithKey")
  return ElementAt (cursor);
}

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
LocateElementWithKey (void const* key, ICursorImpl& cursor) const
{ bool isContained = LocateKey (key, cursor);

  if (! isContained)
    cursor.Invalidate ();

  return isContained;
}

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
LocateNextElementWithKey (void const* key, ICursorImpl& cursor) const
{ Self::SetToNext (cursor);
  bool isContained = LocateNextKey (key, cursor);

  if (! isContained)
    cursor.Invalidate ();

  return isContained;
}

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
LocateOrAddElementWithKey (void const* element, ICursorImpl& cursor)
{ bool isContained = LocateKey (Key (element), cursor);

  if (! isContained)
    Self::Add (element, cursor);

  return isContained;
}

template <class Base>
INumber
IKeySortedBagOnSequenceImpl <Base>::
NumberOfDifferentKeys () const
{ INumber result = 0;
  for (Self::SetToFirst (CursorOf (*this));
       CursorOf (*this).IsValid ();
       Self::SetToNextWithDifferentKey (CursorOf (*this)))
    result++;
  return result;
}

template <class Base>
INumber
IKeySortedBagOnSequenceImpl <Base>::
NumberOfElementsWithKey (void const* key) const
{ INumber result = 0;
  for (Self::LocateElementWithKey (key, CursorOf (*this));
       CursorOf (*this).IsValid ();
       Self::LocateNextElementWithKey (key, CursorOf (*this)))
    result++;
  return result;
}

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
RemoveElementWithKey (void const* key)
{ bool isContained = LocateKey (key, CursorOf (*this));

  if (isContained)
    Self::RemoveAt (CursorOf (*this));

  return isContained;
}

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
ReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ bool isContained = LocateKey (Key (element), cursor);

  if (isContained)
    BaseOf (*this).Base::ReplaceAt (cursor, element);
  else
    cursor.Invalidate ();

  return isContained;
}

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
SetToNextWithDifferentKey (ICursorImpl& cursor) const
{ void const* key = Key (Self::ElementAt (cursor));
  while (Self::SetToNext (cursor)) {
    if (CompareKeys (Self::ElementAt (cursor), key, kElementKey) != 0)
      return true;
  }
  return false;
}

// private members

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
LocateKey (void const* key, ICursorImpl& cursor) const
{ Self::SetToFirst (cursor);
  return LocateNextKey (key, cursor);
}

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::
LocateNextKey (void const* key, ICursorImpl& cursor) const
{ for (; cursor.IsValid (); Self::SetToNext (cursor)) {
    long comp =
      CompareKeys (Self::ElementAt (cursor), key, kElementKey);
    if (comp >= 0)
      return (comp == 0);
  }
  return false;
}

#if ! defined (__INO_STREAMING__)
template <class Base>
void
IKeySortedBagOnSequenceImpl <Base>::
StreamIn (IDataStream& stream)
{ ReadVersion (stream);
  BaseOf (*this).Base::StreamIn (stream);
}

template <class Base>
void
IKeySortedBagOnSequenceImpl <Base>::
StreamOut (IDataStream& stream) const
{ WriteVersion (stream);
  BaseOf (*this).Base::StreamOut (stream);
}

template <class Base>
void
IKeySortedBagOnSequenceImpl <Base>::
AdoptStreamer (IACollectionStreamer *streamer)
{ (BaseOf (*this).Base::AdoptStreamer(streamer));
}

template <class Base>
IStreamerPtr&
IKeySortedBagOnSequenceImpl <Base>::
StreamerOf (IACollectionImpl const& collection)
{ return (BaseOf (*this).Base::StreamerOf(collection));
}
#endif

// ---------------------------------------------
// IKeySortedBagOnSequenceImpl <Base>::Predicate
// ---------------------------------------------

// public members

template <class Base>
bool
IKeySortedBagOnSequenceImpl <Base>::Predicate::
IsEqual (void const* element, void* thisPtr)
{ return ((KSB*)thisPtr)->
    CompareKeys (element , ((KSB*)thisPtr)->ivKey, kElementKey) == 0;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
