// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 05 1.4.1.2 source/core/collect/iiksbst.c, collection, ioc.v400, 000302 
#ifndef _IIKSBST_C_
#define _IIKSBST_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IKeySetAsBstTreeOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsBstTreeOps <Element, Key, ElementOps, Implementation>::
IKeySetAsBstTreeOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsBstTreeOps <Element, Key, ElementOps, Implementation>::
IKeySetAsBstTreeOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsBstTreeOps <Element, Key, ElementOps, Implementation>::
IKeySetAsBstTreeOps
  (IKeySetAsBstTreeOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsBstTreeOps <Element, Key, ElementOps, Implementation>::
~IKeySetAsBstTreeOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IKeySetAsBstTreeOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsBstTreeOps <Element, Key, ElementOps, Implementation>::
operator IKeySortedSetAsBstTreeImpl& ()
{ return *(IKeySortedSetAsBstTreeImpl*)ivBase ;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsBstTreeOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIKSBST_C_
