// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 11 1.4.1.2 source/core/collect/iiksdil.c, collection, ioc.v400, 000302 
#ifndef _IIKSDIL_C_
#define _IIKSDIL_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// IKeySetAsDilTableOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeySetAsDilTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeySetAsDilTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeySetAsDilTableOps
  (IKeySetAsDilTableOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
~IKeySetAsDilTableOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
operator IKeySortedSetAsDilTableImpl& ()
{ return *(IKeySortedSetAsDilTableImpl*)ivBase ;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIKSDIL_C_
