// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ----------------------------
// IKeySetOnKeyBagMngCursorImpl
// ----------------------------

// public members

template <class Base>
IKeySetOnKeyBagMngCursorImpl <Base>::
IKeySetOnKeyBagMngCursorImpl
  (IKeySetOnKeyBagImpl <Base> const& collection)
: Inherited (IKeySetOnKeyBagImpl <Base>::BaseOf (collection))
{ this->ivCollection = &collection;
}

template <class Base>
IKeySetOnKeyBagMngCursorImpl <Base>::
~IKeySetOnKeyBagMngCursorImpl ()
{
}

// -------------------
// IKeySetOnKeyBagImpl
// -------------------

// inline public members

#define inline

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return ! BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
AddOrReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).AddOrReplaceElementWithKey (element, cursor);
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
inline void*
IKeySetOnKeyBagImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
inline char const*
IKeySetOnKeyBagImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
ContainsElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ContainsElementWithKey (key);
}

template <class Base>
inline void*
IKeySetOnKeyBagImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
inline void*
IKeySetOnKeyBagImpl <Base>::
ElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ElementWithKey (key);
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
inline void*
IKeySetOnKeyBagImpl <Base>::
Key (void const* element) const
{ return BaseOf (*this).Key (element);
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
LocateElementWithKey (void const* key, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateElementWithKey (key, cursor);
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
LocateOrAddElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
inline INumber
IKeySetOnKeyBagImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
inline INumber
IKeySetOnKeyBagImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
inline INumber
IKeySetOnKeyBagImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
inline void
IKeySetOnKeyBagImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
RemoveElementWithKey (void const* key)
{ return BaseOf (*this).Base::RemoveElementWithKey (key);
}

template <class Base>
inline void
IKeySetOnKeyBagImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
ReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).ReplaceElementWithKey (element, cursor);
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

#undef inline

// inline protected members

template <class Base>
inline bool
IKeySetOnKeyBagImpl <Base>::
EqualKeys (void const* arg1, void const* arg2, IArgType argType) const
{ return BaseOf (*this).EqualKeys (arg1, arg2, argType);
}

// inline private members

template <class Base>
inline Base&
IKeySetOnKeyBagImpl <Base>::
BaseOf (IKeySetOnKeyBagImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline TYPENAME IKeySetOnKeyBagImpl <Base>::Ops&
IKeySetOnKeyBagImpl <Base>::
OpsOf (IKeySetOnKeyBagImpl <Base> const& collection)
{ return (Ops&) Inherited::OpsOf (collection);
}

// public members

template <class Base>
IKeySetOnKeyBagImpl <Base>::
IKeySetOnKeyBagImpl (Ops& ops, INumber)
: IAKeySetImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IKeySetOnKeyBagImpl <Base>::
IKeySetOnKeyBagImpl (Ops& ops, IKeySetOnKeyBagImpl <Base> const&)
: IAKeySetImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IKeySetOnKeyBagImpl <Base>::
~IKeySetOnKeyBagImpl ()
{
}

template <class Base>
IACollectionImpl*
IKeySetOnKeyBagImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
bool
IKeySetOnKeyBagImpl <Base>::
ContainsAllKeysFrom (IACollectionImpl const& collection) const
{ if (ClassName () == collection.ClassName ()) {
    Self const& ks = (Self const&)collection;
    return BaseOf (*this).Base::ContainsAllKeysFrom (BaseOf (ks));
  }
  else
    return Inherited::ContainsAllKeysFrom (collection);
}

template <class Base>
void
IKeySetOnKeyBagImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
ICursorImpl*
IKeySetOnKeyBagImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
ICursorImpl*
IKeySetOnKeyBagImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

#if ! defined (__INO_STREAMING__)
template <class Base>
void
IKeySetOnKeyBagImpl <Base>::
StreamIn (IDataStream& stream)
{ ReadVersion (stream);
  BaseOf (*this).Base::StreamIn (stream);
}

template <class Base>
void
IKeySetOnKeyBagImpl <Base>::
StreamOut (IDataStream& stream) const
{ WriteVersion(stream);
  BaseOf (*this).Base::StreamOut (stream);
}

template <class Base>
void
IKeySetOnKeyBagImpl <Base>::
AdoptStreamer (IACollectionStreamer *streamer)
{ (BaseOf (*this).Base::AdoptStreamer(streamer));
}

template <class Base>
IStreamerPtr&
IKeySetOnKeyBagImpl <Base>::
StreamerOf (IACollectionImpl const& collection)
{ return (BaseOf (*this).Base::StreamerOf(collection));
}
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
