// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <ilanglvl.hpp>
#include <iiexc.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ------------------------------------
// IKeySortedSetOnSequenceMngCursorImpl
// ------------------------------------

// public members

template <class Base>
IKeySortedSetOnSequenceMngCursorImpl <Base>::
IKeySortedSetOnSequenceMngCursorImpl
  (IKeySortedSetOnSequenceImpl <Base> const& collection)
: Inherited (IKeySortedSetOnSequenceImpl <Base>::BaseOf (collection))
{ this->ivCollection = &collection;
}

template <class Base>
IKeySortedSetOnSequenceMngCursorImpl <Base>::
~IKeySortedSetOnSequenceMngCursorImpl ()
{
}

// ---------------------------
// IKeySortedSetOnSequenceImpl
// ---------------------------

// inline public members

#define inline

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
inline void*
IKeySortedSetOnSequenceImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return (CompareKeys (Self::ElementAt (cursor),
                       element, kElementElement) == 0);
}

template <class Base>
inline char const*
IKeySortedSetOnSequenceImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
ContainsElementWithKey (void const* key) const
{ return LocateKey (key, CursorOf (*this));
}

template <class Base>
inline void*
IKeySortedSetOnSequenceImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
inline void*
IKeySortedSetOnSequenceImpl <Base>::
ElementAtPosition (IPosition position) const
{ return BaseOf (*this).Base::ElementAtPosition (position);
}

template <class Base>
inline void*
IKeySortedSetOnSequenceImpl <Base>::
First () const
{ return BaseOf (*this).Base::First ();
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
IsFirstAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsFirstAt (cursor);
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
IsLastAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsLastAt (cursor);
}

template <class Base>
inline void*
IKeySortedSetOnSequenceImpl <Base>::
Key (void const* element) const
{ return OpsOf (*this).Key (element);
}

template <class Base>
inline void*
IKeySortedSetOnSequenceImpl <Base>::
Last () const
{ return BaseOf (*this).Base::Last ();
}

template <class Base>
inline INumber
IKeySortedSetOnSequenceImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
inline IPosition
IKeySortedSetOnSequenceImpl <Base>::
PositionAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::PositionAt (cursor);
}

template <class Base>
inline INumber
IKeySortedSetOnSequenceImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
inline INumber
IKeySortedSetOnSequenceImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
inline void
IKeySortedSetOnSequenceImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
inline void
IKeySortedSetOnSequenceImpl <Base>::
RemoveAtPosition (IPosition position)
{ BaseOf (*this).Base::RemoveAtPosition (position);
}

template <class Base>
inline void
IKeySortedSetOnSequenceImpl <Base>::
RemoveFirst ()
{ BaseOf (*this).Base::RemoveFirst ();
}

template <class Base>
inline void
IKeySortedSetOnSequenceImpl <Base>::
RemoveLast ()
{ BaseOf (*this).Base::RemoveLast ();
}

template <class Base>
inline void
IKeySortedSetOnSequenceImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
inline void
IKeySortedSetOnSequenceImpl <Base>::
ReplaceAtPosition (IPosition position, void const* element)
{ BaseOf (*this).Base::ReplaceAtPosition (position, element);
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
SetToLast (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToLast (cursor);
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
inline void
IKeySortedSetOnSequenceImpl <Base>::
SetToPosition (IPosition position, ICursorImpl& cursor) const
{ BaseOf (*this).Base::SetToPosition (position, cursor);
}

template <class Base>
inline bool
IKeySortedSetOnSequenceImpl <Base>::
SetToPrevious (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToPrevious (cursor);
}

#undef inline

// inline protected members

template <class Base>
inline long
IKeySortedSetOnSequenceImpl <Base>::
CompareKeys (void const* arg1, void const* arg2, IArgType argType) const
{ return OpsOf (*this).CompareKeys (arg1, arg2, argType);
}

// inline private members

template <class Base>
inline Base&
IKeySortedSetOnSequenceImpl <Base>::
BaseOf (IKeySortedSetOnSequenceImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline TYPENAME IKeySortedSetOnSequenceImpl <Base>::Ops&
IKeySortedSetOnSequenceImpl <Base>::
OpsOf (IKeySortedSetOnSequenceImpl <Base> const& collection)
{ return (Ops&) IACollectionImpl::OpsOf (collection);
}

// public members

template <class Base>
IKeySortedSetOnSequenceImpl <Base>::
IKeySortedSetOnSequenceImpl (Ops& ops, INumber)
: IAKeySortedSetImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IKeySortedSetOnSequenceImpl <Base>::
IKeySortedSetOnSequenceImpl
  (Ops& ops, IKeySortedSetOnSequenceImpl <Base> const& collection)
: IAKeySortedSetImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IKeySortedSetOnSequenceImpl <Base>::
~IKeySortedSetOnSequenceImpl ()
{
}

template <class Base>
bool
IKeySortedSetOnSequenceImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ bool isContained = LocateKey (Key (element), cursor);

  if (! isContained) {
    if (cursor.IsValid ())
      BaseOf (*this).Base::AddAsPrevious (element, cursor);
    else
      BaseOf (*this).Base::AddAsLast (element, cursor);
  }

  return ! isContained;
}

template <class Base>
bool
IKeySortedSetOnSequenceImpl <Base>::
AddOrReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ bool isContained = LocateKey (Key (element), cursor);

  if (isContained)
    BaseOf (*this).Base::ReplaceAt (cursor, element);
  else
    Self::Add (element, cursor);

  return ! isContained;
}

template <class Base>
IACollectionImpl*
IKeySortedSetOnSequenceImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
bool
IKeySortedSetOnSequenceImpl <Base>::
ContainsAllKeysFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    if (this != &collection) {
      Self const& kss = (Self const&)collection;
      ICursorImpl& thisCursor = CursorOf (*this),
                 & thatCursor = CursorOf (collection);

      Self::SetToFirst (thisCursor);
      for (kss.Self::SetToFirst (thatCursor);
           thatCursor.IsValid ();
           kss.Self::SetToNext (thatCursor)) {
        bool found = false;
        while (! found && thisCursor.IsValid ()) {
          long comp = CompareKeys (Self::ElementAt (thisCursor),
                                   kss.Self::ElementAt (thatCursor),
                                   kElementElement);
          if (comp < 0)
            Self::SetToNext (thisCursor);
          else if (comp == 0)
            found = true;
          else
            return false;
        }
        if (! found)
          return false;
      }
    }
    return true;
  }
  else
    return Inherited::ContainsAllKeysFrom (collection);
}

template <class Base>
void
IKeySortedSetOnSequenceImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
TYPENAME IKeySortedSetOnSequenceImpl <Base>::Cursor*
IKeySortedSetOnSequenceImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
TYPENAME IKeySortedSetOnSequenceImpl <Base>::MngCursor*
IKeySortedSetOnSequenceImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
IKeySortedSetOnSequenceImpl <Base>::
ElementWithKey (void const* key) const
{ Cursor cursor (*this);
  ICHECK_ContainsKey (ClassName (), "ElementWithKey")
  return Self::ElementAt (cursor);
}

template <class Base>
bool
IKeySortedSetOnSequenceImpl <Base>::
LocateElementWithKey (void const* key, ICursorImpl& cursor) const
{ bool isContained = LocateKey (key, cursor);

  if (! isContained)
    cursor.Invalidate ();

  return isContained;
}

template <class Base>
bool
IKeySortedSetOnSequenceImpl <Base>::
LocateNextElementWithKey (void const* key, ICursorImpl& cursor) const
{ SetToNext (cursor);
  bool isContained = LocateNextKey (key, cursor);

  if (! isContained)
    cursor.Invalidate ();

  return isContained;
}

template <class Base>
bool
IKeySortedSetOnSequenceImpl <Base>::
LocateOrAddElementWithKey (void const* element, ICursorImpl& cursor)
{ bool isContained = LocateKey (Key (element), cursor);

  if (! isContained)
    Self::Add (element, cursor);

  return isContained;
}

template <class Base>
bool
IKeySortedSetOnSequenceImpl <Base>::
RemoveElementWithKey (void const* key)
{ bool isContained = LocateKey (key, CursorOf (*this));

  if (isContained)
    Self::RemoveAt (CursorOf (*this));

  return isContained;
}

template <class Base>
bool
IKeySortedSetOnSequenceImpl <Base>::
ReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ bool isContained = LocateKey (Key (element), cursor);

  if (isContained)
    BaseOf (*this).Base::ReplaceAt (cursor, element);
  else
    cursor.Invalidate ();

  return isContained;
}

// private members

template <class Base>
bool
IKeySortedSetOnSequenceImpl <Base>::
LocateKey (void const* key, ICursorImpl& cursor) const
{ Self::SetToFirst (cursor);
  return LocateNextKey (key, cursor);
}

template <class Base>
bool
IKeySortedSetOnSequenceImpl <Base>::
LocateNextKey (void const* key, ICursorImpl& cursor) const
{ for (; cursor.IsValid (); Self::SetToNext (cursor)) {
    long comp =
      CompareKeys (Self::ElementAt (cursor), key, kElementKey);
    if (comp >= 0)
      return comp == 0;
  }
  return false;
}

#if ! defined (__INO_STREAMING__)
template <class Base>
void
IKeySortedSetOnSequenceImpl <Base>::
StreamIn (IDataStream& stream)
{ ReadVersion (stream);
  BaseOf (*this).Base::StreamIn (stream);
}

template <class Base>
void
IKeySortedSetOnSequenceImpl <Base>::
StreamOut (IDataStream& stream) const
{ WriteVersion (stream);
  BaseOf (*this).Base::StreamOut (stream);
}

template <class Base>
void
IKeySortedSetOnSequenceImpl <Base>::
AdoptStreamer (IACollectionStreamer *streamer)
{ (BaseOf (*this).Base::AdoptStreamer(streamer));
}

template <class Base>
IStreamerPtr&
IKeySortedSetOnSequenceImpl <Base>::
StreamerOf (IACollectionImpl const& collection)
{ return (BaseOf (*this).Base::StreamerOf(collection));
}
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
