// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <ilanglvl.hpp>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// -------------------------------------
// ISortedBagOnKeySortedBagMngCursorImpl
// -------------------------------------

// public members

template <class Base>
ISortedBagOnKeySortedBagMngCursorImpl <Base>::
ISortedBagOnKeySortedBagMngCursorImpl
  (ISortedBagOnKeySortedBagImpl <Base> const& collection)
: Inherited (ISortedBagOnKeySortedBagImpl <Base>::BaseOf (collection))
{ this->ivCollection = &collection;
}

template <class Base>
ISortedBagOnKeySortedBagMngCursorImpl <Base>::
~ISortedBagOnKeySortedBagMngCursorImpl ()
{
}

// ----------------------------
// ISortedBagOnKeySortedBagImpl
// ----------------------------

// inline private members

template <class Base>
inline Base&
ISortedBagOnKeySortedBagImpl <Base>::
BaseOf (ISortedBagOnKeySortedBagImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline TYPENAME ISortedBagOnKeySortedBagImpl <Base>::Ops&
ISortedBagOnKeySortedBagImpl <Base>::
OpsOf (ISortedBagOnKeySortedBagImpl <Base> const& collection)
{ return (Ops&) Inherited::OpsOf (collection);
}

// public members

template <class Base>
ISortedBagOnKeySortedBagImpl <Base>::
ISortedBagOnKeySortedBagImpl (Ops& ops, INumber)
: IASortedBagImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISortedBagOnKeySortedBagImpl <Base>::
ISortedBagOnKeySortedBagImpl
  (Ops& ops, ISortedBagOnKeySortedBagImpl <Base> const& collection)
: IASortedBagImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISortedBagOnKeySortedBagImpl <Base>::
~ISortedBagOnKeySortedBagImpl ()
{
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
AddAllFrom (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    BaseOf (*this).Base::AddAllFrom (BaseOf ((Self const&)collection));
  else
    Inherited::AddAllFrom (collection);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
ISortedBagOnKeySortedBagImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
char const*
ISortedBagOnKeySortedBagImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
ISortedBagOnKeySortedBagImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
Contains (void const* element) const
{ return BaseOf (*this).Base::ContainsElementWithKey (element);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
ContainsAllFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    return BaseOf (*this).
      Base::ContainsAllKeysFrom (BaseOf ((Self const&)collection));
  }
  else
    return Inherited::ContainsAllFrom (collection);
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
TYPENAME ISortedBagOnKeySortedBagImpl <Base>::Cursor*
ISortedBagOnKeySortedBagImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
TYPENAME ISortedBagOnKeySortedBagImpl <Base>::MngCursor*
ISortedBagOnKeySortedBagImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
ISortedBagOnKeySortedBagImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
void*
ISortedBagOnKeySortedBagImpl <Base>::
ElementAtPosition (IPosition position) const
{ return BaseOf (*this).Base::ElementAtPosition (position);
}

template <class Base>
void*
ISortedBagOnKeySortedBagImpl <Base>::
First () const
{ return BaseOf (*this).Base::First ();
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
IsFirstAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsFirstAt (cursor);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
IsLastAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsLastAt (cursor);
}

template <class Base>
void*
ISortedBagOnKeySortedBagImpl <Base>::
Last () const
{ return BaseOf (*this).Base::Last ();
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
Locate (void const* element, ICursorImpl& cursor) const
{ return BaseOf (*this).LocateElementWithKey (element, cursor);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
LocateNext (void const* element, ICursorImpl& cursor) const
{ return BaseOf (*this).
    Base::LocateNextElementWithKey (element, cursor);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
LocateOrAdd (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
INumber
ISortedBagOnKeySortedBagImpl <Base>::
NumberOfDifferentElements () const
{ return BaseOf (*this).Base::NumberOfDifferentKeys ();
}

template <class Base>
INumber
ISortedBagOnKeySortedBagImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
INumber
ISortedBagOnKeySortedBagImpl <Base>::
NumberOfOccurrences (void const* element) const
{ return BaseOf (*this).Base::NumberOfElementsWithKey (element);
}

template <class Base>
IPosition
ISortedBagOnKeySortedBagImpl <Base>::
PositionAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::PositionAt (cursor);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
Remove (void const* element)
{ return BaseOf (*this).Base::RemoveElementWithKey (element);
}

template <class Base>
INumber
ISortedBagOnKeySortedBagImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
ISortedBagOnKeySortedBagImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
INumber
ISortedBagOnKeySortedBagImpl <Base>::
RemoveAllOccurrences (void const* element)
{ return BaseOf (*this).Base::RemoveAllElementsWithKey (element);
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
RemoveAtPosition (IPosition position)
{ BaseOf (*this).Base::RemoveAtPosition (position);
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
RemoveFirst ()
{ BaseOf (*this).Base::RemoveFirst ();
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
RemoveLast ()
{ BaseOf (*this).Base::RemoveLast ();
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
ReplaceAtPosition (IPosition position, void const* element)
{ BaseOf (*this).Base::ReplaceAtPosition (position, element);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
SetToLast (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToLast (cursor);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
SetToPosition (IPosition position, ICursorImpl& cursor) const
{ BaseOf (*this).Base::SetToPosition (position, cursor);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
SetToPrevious (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToPrevious (cursor);
}


template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
SetToNextDifferentElement (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNextWithDifferentKey (cursor);
}

template <class Base>
bool
ISortedBagOnKeySortedBagImpl <Base>::
operator== (IASortedBagImpl const& collection) const
{ return (Self::NumberOfElements () == collection.NumberOfElements () &&
          Self::ContainsAllFrom (collection));
}

#if ! defined (__INO_STREAMING__)
template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
StreamIn (IDataStream& stream)
{ ReadVersion (stream);
  BaseOf (*this).Base::StreamIn (stream);
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
StreamOut (IDataStream& stream) const
{ WriteVersion (stream);
  BaseOf (*this).Base::StreamOut (stream);
}

template <class Base>
void
ISortedBagOnKeySortedBagImpl <Base>::
AdoptStreamer (IACollectionStreamer *streamer)
{ (BaseOf (*this).Base::AdoptStreamer(streamer));
}

template <class Base>
IStreamerPtr&
ISortedBagOnKeySortedBagImpl <Base>::
StreamerOf (IACollectionImpl const& collection)
{ return (BaseOf (*this).Base::StreamerOf(collection));
}
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
