// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 98 1.4.1.2 source/core/collect/iisbtab.c, collection, ioc.v400, 000302 
#ifndef _IISBTAB_C_
#define _IISBTAB_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// ISortedBagAsTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISortedBagAsTableOps <Element, ElementOps, Implementation>::
ISortedBagAsTableOps (INumber numberOfElements)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsTableOps <Element, ElementOps, Implementation>::
ISortedBagAsTableOps (INumber numberOfElements, void* opsArg)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsTableOps <Element, ElementOps, Implementation>::
ISortedBagAsTableOps
  (ISortedBagAsTableOps
    <Element, ElementOps, Implementation> const& collection)
: Inherited (__isDTSClass (Element)),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsTableOps <Element, ElementOps, Implementation>::
~ISortedBagAsTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISortedBagAsTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsTableOps <Element, ElementOps, Implementation>::
operator IKeySortedBagAsTableImpl& ()
{ return *(IKeySortedBagAsTableImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IISBTAB_C_
