// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <ilanglvl.hpp>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// --------------------------
// ISetOnKeySetMngCursorImpl
// --------------------------

// public members

template <class Base>
ISetOnKeySetMngCursorImpl <Base>::
ISetOnKeySetMngCursorImpl
  (ISetOnKeySetImpl <Base> const& collection)
: Inherited (ISetOnKeySetImpl <Base>::BaseOf (collection))
{ this->ivCollection = &collection;
}

template <class Base>
ISetOnKeySetMngCursorImpl <Base>::
~ISetOnKeySetMngCursorImpl ()
{
}

// ----------------
// ISetOnKeySetImpl
// ----------------

// inline private members

template <class Base>
inline Base&
ISetOnKeySetImpl <Base>::
BaseOf (ISetOnKeySetImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline TYPENAME ISetOnKeySetImpl <Base>::Ops&
ISetOnKeySetImpl <Base>::
OpsOf (ISetOnKeySetImpl <Base> const& collection)
{ return (Ops&) Inherited::OpsOf (collection);
}

// public members

template <class Base>
ISetOnKeySetImpl <Base>::
ISetOnKeySetImpl (Ops& ops, INumber)
: IASetImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISetOnKeySetImpl <Base>::
ISetOnKeySetImpl (Ops& ops, ISetOnKeySetImpl <Base> const&)
: IASetImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISetOnKeySetImpl <Base>::
~ISetOnKeySetImpl ()
{
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
void
ISetOnKeySetImpl <Base>::
AddAllFrom (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& set = (Self const&)collection;
    BaseOf (*this).Base::AddAllFrom (BaseOf (set));
  }
  else
    Inherited::AddAllFrom (collection);
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
ISetOnKeySetImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
char const*
ISetOnKeySetImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
ISetOnKeySetImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
Contains (void const* element) const
{ return BaseOf (*this).ContainsElementWithKey (element);
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
ContainsAllFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& set = (Self const&)collection;
    return BaseOf (*this).
      Base::ContainsAllKeysFrom (BaseOf (set));
  }
  else
    return Inherited::ContainsAllFrom (collection);
}

template <class Base>
void
ISetOnKeySetImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
TYPENAME ISetOnKeySetImpl <Base>::Cursor*
ISetOnKeySetImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
TYPENAME ISetOnKeySetImpl <Base>::MngCursor*
ISetOnKeySetImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
ISetOnKeySetImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
Locate (void const* element, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateElementWithKey (element, cursor);
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
LocateOrAdd (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
INumber
ISetOnKeySetImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
Remove (void const* element)
{ return BaseOf (*this).Base::RemoveElementWithKey (element);
}

template <class Base>
INumber
ISetOnKeySetImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
ISetOnKeySetImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
void
ISetOnKeySetImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
void
ISetOnKeySetImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
bool
ISetOnKeySetImpl <Base>::
operator== (IASetImpl const& collection) const
{ return (Self::NumberOfElements () == collection.NumberOfElements () &&
          ContainsAllFrom (collection));
}

#if ! defined (__INO_STREAMING__)
template <class Base>
void
ISetOnKeySetImpl <Base>::
StreamIn (IDataStream& stream)
{ ReadVersion (stream);
  BaseOf (*this).Base::StreamIn (stream);
}

template <class Base>
void
ISetOnKeySetImpl <Base>::
StreamOut (IDataStream& stream) const
{ WriteVersion (stream);
  BaseOf (*this).Base::StreamOut (stream);
}

template <class Base>
void
ISetOnKeySetImpl <Base>::
AdoptStreamer (IACollectionStreamer *streamer)
{ (BaseOf (*this).Base::AdoptStreamer(streamer));
}

template <class Base>
IStreamerPtr&
ISetOnKeySetImpl <Base>::
StreamerOf (IACollectionImpl const& collection)
{ return (BaseOf (*this).Base::StreamerOf(collection));
}
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
