// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 28 1.4.1.2 source/core/collect/iisetlst.c, collection, ioc.v400, 000302 
#ifndef _IISETLST_C_
#define _IISETLST_C_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---
// ISetAsListOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISetAsListOps <Element, ElementOps, Implementation>::
ISetAsListOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsListOps <Element, ElementOps, Implementation>::
ISetAsListOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsListOps <Element, ElementOps, Implementation>::
ISetAsListOps
  (ISetAsListOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsListOps <Element, ElementOps, Implementation>::
~ISetAsListOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISetAsListOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISetAsListOps <Element, ElementOps, Implementation>::
operator IKeySetAsListImpl& ()
{ return *(IKeySetAsListImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISetAsListOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IISETLST_C_
