// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <ilanglvl.hpp>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// -------------------------------------
// ISortedMapOnKeySortedSetMngCursorImpl
// -------------------------------------

// public members

template <class Base>
ISortedMapOnKeySortedSetMngCursorImpl <Base>::
ISortedMapOnKeySortedSetMngCursorImpl
  (ISortedMapOnKeySortedSetImpl <Base> const& collection)
: Inherited (ISortedMapOnKeySortedSetImpl <Base>::BaseOf (collection))
{ this->ivCollection = &collection;
}

template <class Base>
ISortedMapOnKeySortedSetMngCursorImpl <Base>::
~ISortedMapOnKeySortedSetMngCursorImpl ()
{
}

// -----------------------------
// ISortedMapOnKeySortedSetImpl
// -----------------------------

// inline protected members

template <class Base>
inline bool
ISortedMapOnKeySortedSetImpl <Base>::
EqualElements (void const* element1, void const* element2) const
{ return OpsOf (*this).EqualElements (element1, element2);
}

// inline private members

template <class Base>
inline Base&
ISortedMapOnKeySortedSetImpl <Base>::
BaseOf (ISortedMapOnKeySortedSetImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline TYPENAME ISortedMapOnKeySortedSetImpl <Base>::Ops&
ISortedMapOnKeySortedSetImpl <Base>::
OpsOf (ISortedMapOnKeySortedSetImpl <Base> const& collection)
{ return (Ops&) Inherited::OpsOf (collection);
}

// public members

template <class Base>
ISortedMapOnKeySortedSetImpl <Base>::
ISortedMapOnKeySortedSetImpl (Ops& ops, INumber)
: IASortedMapImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISortedMapOnKeySortedSetImpl <Base>::
ISortedMapOnKeySortedSetImpl
  (Ops& ops, ISortedMapOnKeySortedSetImpl <Base> const&)
: IASortedMapImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISortedMapOnKeySortedSetImpl <Base>::
~ISortedMapOnKeySortedSetImpl ()
{
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
AddOrReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).AddOrReplaceElementWithKey (element, cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
ISortedMapOnKeySortedSetImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
char const*
ISortedMapOnKeySortedSetImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
ISortedMapOnKeySortedSetImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
Contains (void const* element) const
{ bool isContained = false;
  Cursor cursor (*this);

  if (Self::LocateElementWithKey (Self::Key (element), cursor)) {
    isContained = EqualElements (Self::ElementAt (cursor), element);
  }

  return isContained;
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
ContainsAllKeysFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& sm = (Self const&)collection;
    return BaseOf (*this).Base::ContainsAllKeysFrom (BaseOf (sm));
  }
  else
    return Inherited::ContainsAllKeysFrom (collection);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
ContainsElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ContainsElementWithKey (key);
}

template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
TYPENAME ISortedMapOnKeySortedSetImpl <Base>::Cursor*
ISortedMapOnKeySortedSetImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
TYPENAME ISortedMapOnKeySortedSetImpl <Base>::MngCursor*
ISortedMapOnKeySortedSetImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
ISortedMapOnKeySortedSetImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
void*
ISortedMapOnKeySortedSetImpl <Base>::
ElementAtPosition (IPosition position) const
{ return BaseOf (*this).Base::ElementAtPosition (position);
}

template <class Base>
void*
ISortedMapOnKeySortedSetImpl <Base>::
ElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ElementWithKey (key);
}

template <class Base>
void*
ISortedMapOnKeySortedSetImpl <Base>::
First () const
{ return BaseOf (*this).Base::First ();
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
IsFirstAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsFirstAt (cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
IsLastAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsLastAt (cursor);
}

template <class Base>
void*
ISortedMapOnKeySortedSetImpl <Base>::
Key (void const* element) const
{ return BaseOf (*this).Key (element);
}

template <class Base>
void*
ISortedMapOnKeySortedSetImpl <Base>::
Last () const
{ return BaseOf (*this).Base::Last ();
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
Locate (void const* element, ICursorImpl& cursor) const
{ bool isContained =
    Self::LocateElementWithKey (Self::Key (element), cursor);

  if (isContained)
    isContained = EqualElements (Self::ElementAt (cursor), element);
  if (! isContained)
    cursor.Invalidate ();

  return isContained;
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
LocateElementWithKey (void const* key, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateElementWithKey (key, cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
LocateNext (void const* element, ICursorImpl& cursor) const
{ if (BaseOf (*this).CompareKeys (element, Self::ElementAt (cursor),
                                  kElementElement) <= 0) {
    cursor.Invalidate ();
    return false;
  }
  else
    return Self::Locate (element, cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
LocateNextElementWithKey (void const* key, ICursorImpl& cursor) const
{ if (BaseOf (*this).CompareKeys (Self::ElementAt (cursor),
                                  key, kElementKey) >= 0) {
    cursor.Invalidate ();
    return false;
  }
  else
    return Self::LocateElementWithKey (key, cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
LocateOrAdd (void const* element, ICursorImpl& cursor)
{ bool isContained = Self::Locate (element, cursor);

  if (! isContained)
    Add (element, cursor);

  return isContained;
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
LocateOrAddElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
INumber
ISortedMapOnKeySortedSetImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
IPosition
ISortedMapOnKeySortedSetImpl <Base>::
PositionAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::PositionAt (cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
Remove (void const* element)
{ bool isContained =
    Self::LocateElementWithKey (Self::Key (element), CursorOf (*this));

  if (isContained)
    isContained = EqualElements
      (Self::ElementAt (CursorOf (*this)), element);
  if (isContained)
    Self::RemoveAt (CursorOf (*this));

  return isContained;
}

template <class Base>
INumber
ISortedMapOnKeySortedSetImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
ISortedMapOnKeySortedSetImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
RemoveAtPosition (IPosition position)
{ BaseOf (*this).Base::RemoveAtPosition (position);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
RemoveElementWithKey (void const* key)
{ return BaseOf (*this).Base::RemoveElementWithKey (key);
}

template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
RemoveFirst ()
{ BaseOf (*this).Base::RemoveFirst ();
}

template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
RemoveLast ()
{ BaseOf (*this).Base::RemoveLast ();
}

template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
ReplaceAtPosition (IPosition position, void const* element)
{ BaseOf (*this).Base::ReplaceAtPosition (position, element);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
ReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).ReplaceElementWithKey (element, cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
SetToLast (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToLast (cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
SetToPosition (IPosition position, ICursorImpl& cursor) const
{ BaseOf (*this).Base::SetToPosition (position, cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
SetToPrevious (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToPrevious (cursor);
}

template <class Base>
bool
ISortedMapOnKeySortedSetImpl <Base>::
operator== (IASortedMapImpl const& collection) const
{ return (Self::NumberOfElements () == collection.NumberOfElements () &&
          Self::ContainsAllFrom (collection));
}

#if ! defined (__INO_STREAMING__)
template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
StreamIn (IDataStream& stream)
{ ReadVersion (stream);
  BaseOf (*this).Base::StreamIn (stream);
}

template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
StreamOut (IDataStream& stream) const
{ WriteVersion (stream);
  BaseOf (*this).Base::StreamOut (stream);
}

template <class Base>
void
ISortedMapOnKeySortedSetImpl <Base>::
AdoptStreamer (IACollectionStreamer *streamer)
{ (BaseOf (*this).Base::AdoptStreamer(streamer));
}

template <class Base>
IStreamerPtr&
ISortedMapOnKeySortedSetImpl <Base>::
StreamerOf (IACollectionImpl const& collection)
{ return (BaseOf (*this).Base::StreamerOf(collection));
}
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
