// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <ilanglvl.hpp>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ------------------------------------------
// ISortedRelationOnKeySortedBagMngCursorImpl
// ------------------------------------------

// public members

template <class Base>
ISortedRelationOnKeySortedBagMngCursorImpl <Base>::
ISortedRelationOnKeySortedBagMngCursorImpl
  (ISortedRelationOnKeySortedBagImpl <Base> const& collection)
: Inherited
    (ISortedRelationOnKeySortedBagImpl <Base>::BaseOf (collection))
{ this->ivCollection = &collection;
}

template <class Base>
ISortedRelationOnKeySortedBagMngCursorImpl <Base>::
~ISortedRelationOnKeySortedBagMngCursorImpl ()
{
}

// ---------------------------------
// ISortedRelationOnKeySortedBagImpl
// ---------------------------------

// inline protected members

template <class Base>
inline bool
ISortedRelationOnKeySortedBagImpl <Base>::
EqualElements (void const* element1, void const* element2) const
{ return OpsOf (*this).EqualElements (element1, element2);
}

// inline private members

template <class Base>
inline Base&
ISortedRelationOnKeySortedBagImpl <Base>::
BaseOf (ISortedRelationOnKeySortedBagImpl <Base> const& collection)
{ return collection.ivBase;
}

template <class Base>
inline TYPENAME ISortedRelationOnKeySortedBagImpl <Base>::Ops&
ISortedRelationOnKeySortedBagImpl <Base>::
OpsOf (ISortedRelationOnKeySortedBagImpl <Base> const& collection)
{ return (Ops&) IACollectionImpl::OpsOf (collection);
}

// public members

template <class Base>
ISortedRelationOnKeySortedBagImpl <Base>::
ISortedRelationOnKeySortedBagImpl (Ops& ops, INumber)
: IASortedRelationImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISortedRelationOnKeySortedBagImpl <Base>::
ISortedRelationOnKeySortedBagImpl
  (Ops& ops, ISortedRelationOnKeySortedBagImpl <Base> const&)
: IASortedRelationImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISortedRelationOnKeySortedBagImpl <Base>::
~ISortedRelationOnKeySortedBagImpl ()
{
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return ! Self::LocateOrAdd (element, cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
AddOrReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).AddOrReplaceElementWithKey (element, cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
ISortedRelationOnKeySortedBagImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
char const*
ISortedRelationOnKeySortedBagImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
ISortedRelationOnKeySortedBagImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
Contains (void const* element) const
{ return Self::Locate (element, CursorOf (*this));
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
ContainsAllKeysFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& sr = (Self const&)collection;
    return BaseOf (*this).ContainsAllKeysFrom (BaseOf (sr));
  }
  else
    return Inherited::ContainsAllKeysFrom (collection);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
ContainsElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ContainsElementWithKey (key);
}

template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
TYPENAME ISortedRelationOnKeySortedBagImpl <Base>::Cursor*
ISortedRelationOnKeySortedBagImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
TYPENAME ISortedRelationOnKeySortedBagImpl <Base>::MngCursor*
ISortedRelationOnKeySortedBagImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
ISortedRelationOnKeySortedBagImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
void*
ISortedRelationOnKeySortedBagImpl <Base>::
ElementAtPosition (IPosition position) const
{ return BaseOf (*this).Base::ElementAtPosition (position);
}

template <class Base>
void*
ISortedRelationOnKeySortedBagImpl <Base>::
ElementWithKey (void const* key) const
{ return BaseOf (*this).Base::ElementWithKey (key);
}

template <class Base>
void*
ISortedRelationOnKeySortedBagImpl <Base>::
First () const
{ return BaseOf (*this).Base::First ();
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
IsFirstAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsFirstAt (cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
IsLastAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::IsLastAt (cursor);
}

template <class Base>
void*
ISortedRelationOnKeySortedBagImpl <Base>::
Key (void const* element) const
{ return BaseOf (*this).Key (element);
}

template <class Base>
void*
ISortedRelationOnKeySortedBagImpl <Base>::
Last () const
{ return BaseOf (*this).Base::Last ();
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
Locate (void const* element, ICursorImpl& cursor) const
{ void const* key = Self::Key (element);
  for (Self::LocateElementWithKey (key, cursor);
       cursor.IsValid ();
       Self::LocateNextElementWithKey (key, cursor)) {
    if (EqualElements (Self::ElementAt (cursor), element))
      return true;
  }
  return false;
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
LocateElementWithKey (void const* key, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateElementWithKey (key, cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
LocateNext (void const* element, ICursorImpl& cursor) const
{ if (BaseOf (*this).CompareKeys
        (element, Self::ElementAt (cursor), kElementElement) <= 0) {
    cursor.Invalidate ();
    return false;
  }
  else
    return Self::Locate (element, cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
LocateNextElementWithKey (void const* key, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateNextElementWithKey (key, cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
LocateOrAdd (void const* element, ICursorImpl& cursor)
{ bool isContained = Self::Locate (element, cursor);

  if (! isContained)
    BaseOf (*this).Base::Add (element, cursor);

  return isContained;
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
LocateOrAddElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
INumber
ISortedRelationOnKeySortedBagImpl <Base>::
NumberOfDifferentKeys () const
{ return BaseOf (*this).Base::NumberOfDifferentKeys ();
}

template <class Base>
INumber
ISortedRelationOnKeySortedBagImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
INumber
ISortedRelationOnKeySortedBagImpl <Base>::
NumberOfElementsWithKey (void const* key) const
{ return BaseOf (*this).Base::NumberOfElementsWithKey (key);
}

template <class Base>
IPosition
ISortedRelationOnKeySortedBagImpl <Base>::
PositionAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::PositionAt (cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
Remove (void const* element)
{ bool isContained = Self::Locate (element, CursorOf (*this));

  if (isContained)
    BaseOf (*this).Base::RemoveAt (CursorOf (*this));

  return isContained;
}

template <class Base>
INumber
ISortedRelationOnKeySortedBagImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
ISortedRelationOnKeySortedBagImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
INumber
ISortedRelationOnKeySortedBagImpl <Base>::
RemoveAllElementsWithKey (void const* key)
{ return BaseOf (*this).Base::RemoveAllElementsWithKey (key);
}

template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
RemoveAtPosition (IPosition position)
{ BaseOf (*this).Base::RemoveAtPosition (position);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
RemoveElementWithKey (void const* key)
{ return BaseOf (*this).Base::RemoveElementWithKey (key);
}

template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
RemoveFirst ()
{ BaseOf (*this).Base::RemoveFirst ();
}

template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
RemoveLast ()
{ BaseOf (*this).Base::RemoveLast ();
}

template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
ReplaceAtPosition (IPosition position, void const* element)
{ BaseOf (*this).Base::ReplaceAtPosition (position, element);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
ReplaceElementWithKey (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).ReplaceElementWithKey (element, cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
SetToLast (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToLast (cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
SetToNextWithDifferentKey (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNextWithDifferentKey (cursor);
}

template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
SetToPosition (IPosition position, ICursorImpl& cursor) const
{ BaseOf (*this).Base::SetToPosition (position, cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
SetToPrevious (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToPrevious (cursor);
}

template <class Base>
bool
ISortedRelationOnKeySortedBagImpl <Base>::
operator== (IASortedRelationImpl const& collection) const
{ bool result =
    Self::NumberOfElements () == collection.NumberOfElements ();
  if (result && this != &collection) {
    ICursorImpl& thisCursor = CursorOf (*this),
               & thatCursor = CursorOf (collection);

    for (Self::SetToFirst (thisCursor),
           collection.SetToFirst (thatCursor);
         result && thisCursor.IsValid ();
         Self::SetToNext (thisCursor),
           collection.SetToNext (thatCursor)) {
      result = EqualElements (Self::ElementAt (thisCursor),
                              collection.ElementAt (thatCursor));
    }
  }
  return result;
}

#if ! defined (__INO_STREAMING__)
template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
StreamIn (IDataStream& stream)
{ ReadVersion (stream);
  BaseOf (*this).Base::StreamIn (stream);
}

template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
StreamOut (IDataStream& stream) const
{ WriteVersion (stream);
  BaseOf (*this).Base::StreamOut (stream);
}

template <class Base>
void
ISortedRelationOnKeySortedBagImpl <Base>::
AdoptStreamer (IACollectionStreamer *streamer)
{ (BaseOf (*this).Base::AdoptStreamer(streamer));
}

template <class Base>
IStreamerPtr&
ISortedRelationOnKeySortedBagImpl <Base>::
StreamerOf (IACollectionImpl const& collection)
{ return (BaseOf (*this).Base::StreamerOf(collection));
}
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
