// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <iiexc.h>
#include <iistream.h>
#include <icconsta.h>

#ifdef IC_PAGETUNE
  #define _IISTREAM_CPP_
  #include <ipagetun.h>
#endif


IStreamerPtr::
IStreamerPtr (IACollectionStreamer* ptr)
: ivPtrRc (new PtrRc (ptr))
{
};

IACollectionStreamer*
IStreamerPtr::
operator-> () const
{ if (!ivPtrRc || (ivPtrRc->ivPtr==0))
    throw IStreamerInvalidExceptionImpl
          ("IStreamerPtr","operator->",__FILE__,__LINE__,IC_STREAMER_INVALID);

  return ivPtrRc->ivPtr;
};

IStreamerPtr::
operator IACollectionStreamer* () const
{ if (!ivPtrRc || (ivPtrRc->ivPtr==0))
    throw IStreamerInvalidExceptionImpl
          ("IAStreamerPtr","IACollectionStreamer*",
          __FILE__,__LINE__,IC_STREAMER_INVALID);

  return ivPtrRc->ivPtr;
};

IACollectionStreamer&
IStreamerPtr::
operator* () const
{ if (!ivPtrRc || (ivPtrRc->ivPtr==0))
    throw IStreamerInvalidExceptionImpl
          ("IAStreamerPtr","operator*",__FILE__,__LINE__,IC_STREAMER_INVALID);

  return *ivPtrRc->ivPtr;
}
