// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 84 1.2.1.2 source/core/collect/iitable.inl, collection, ioc.v400, 000302 
#ifndef _IITABLE_INL_
#define _IITABLE_INL_

#include <iiexc.h>

// ----------
// ITableImpl
// ----------

// public members

inline INumber&
ITableImpl::
AddMod (INumber& index1, INumber index2) const
{ return (index1 = 1 + ((index1 + index2 - 1) % ivAllocatedElements));
}

inline bool
ITableImpl::
CanAdd (INumber n) const
{ return (ivNumberOfElements + n <= ivAllocatedElements);
}

inline INumber&
ITableImpl::
DecMod (INumber& index) const
{ IASSERT (index > 0)
  if (--index == 0)
    index = ivAllocatedElements;
  return index;
}

inline INumber&
ITableImpl::
IncMod (INumber& index) const
{ IASSERT (index <= ivAllocatedElements)
  if (index == ivAllocatedElements)
    index = 0;
  return ++index;
}

inline void*
ITableImpl::
NodeAtIndex (INumber index) const
{ IASSERT (index > 0 && index <= ivAllocatedElements)
  return (char*)ivNodes + ivNodeSize * (index - 1);
}

inline INumber
ITableImpl::
Pos (INumber index) const
{ return index >= ivFirst ?
         index - ivFirst + 1:
         ivAllocatedElements - (ivFirst - index) + 1;
}

#endif // _IITABLE_INL_
