// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <ibcllct.h> // bad, bad !!
#include <iivcllct.h>
#include <inotifev.hpp>

#ifdef IC_PAGETUNE
  #define _IIVCLLCT_CPP_
  #include <ipagetun.h>
#endif


#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

INotificationId const IVCollectionImpl::addId =
     "IVCollectionImpl::addId";

INotificationId const IVCollectionImpl::modifyId =
     "IVCollectionImpl::modifyId";

INotificationId const IVCollectionImpl::removeId =
     "IVCollectionImpl::removeId";

INotificationId const IVCollectionImpl::replaceId =
     "IVCollectionImpl::replaceId";

INotificationId const IVCollectionImpl::addedId =
      IVCollectionImpl::addId;

INotificationId const IVCollectionImpl::modifiedId =
      IVCollectionImpl::modifyId;

INotificationId const IVCollectionImpl::removedId =
      IVCollectionImpl::removeId;

INotificationId const IVCollectionImpl::replacedId =
     "IVCollectionImpl::replaceId";


// ----------------
// IVCollectionImpl
// ----------------

// public members

IVCollectionImpl::
IVCollectionImpl ()
{
}

// protected members

IVCollectionImpl::
~IVCollectionImpl ()
{
}

void
IVCollectionImpl::
NotifyOfAddAt (ICursorImpl const& cursor)
{
  //-----------------------------------------------------
  // DEFECT 9119 :
  // Use local cursor, as default cursor is often passed,
  // and is also used for comparison in cursor methods.
  // IF DEFAULT CURSOR WAS USED, !!MUST!! CLONE IT,
  //  OR COULD BE USING A BAD CURSOR POSITION FOR NOTIFY.
  //-----------------------------------------------------
  ICursorImpl* pLocalCursor = cursor.Clone();

  ICursor c ((ICursorImpl*)pLocalCursor);
  IVCollectionEventData <void> d (c);
  INotificationEvent event (addId, *this, true, (void*)&d);
  notifyObservers (event);
  c.ivImpl = (ICursorImpl*)0; // bad, bad !!

  delete pLocalCursor;
  //-----------------------------------------------------
}

void
IVCollectionImpl::
NotifyOfModification ()
{ INotificationEvent event (modifyId, *this);
  notifyObservers (event);
}

void
IVCollectionImpl ::
NotifyOfRemoveAt (ICursorImpl const& cursor)
{ ICursor c ((ICursorImpl*)&cursor);
  IVCollectionEventData <void> d (c);
  INotificationEvent event (removeId, *this, true, (void*)&d);
  notifyObservers (event);
  c.ivImpl = (ICursorImpl*)0; // bad, bad !!
}

void
IVCollectionImpl ::
NotifyOfReplaceAt (ICursorImpl const& cursor, void const* element)
{ ICursor c ((ICursorImpl*)&cursor);
  IVCollectionEventData <void> d (c, element);
  INotificationEvent event (replaceId, *this, true, (void*)&d);
  notifyObservers (event);
  c.ivImpl = (ICursorImpl*)0; // bad, bad !!
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
