// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 90 1.3.1.3 source/core/collect/iivcllct.inl, collection, ioc.v400, 000302 
#ifndef _IIVCLLCT_INL_
#define _IIVCLLCT_INL_

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---------------------
// IVCollectionEventData
// ---------------------

// public members

template <class Element>
inline
IVCollectionEventData <Element>::
IVCollectionEventData (ICursor const& cursor,
                       Element const* element)
: ivCursor (&cursor), ivElement (element)
{
}

template <class Element>
inline ICursor const&
IVCollectionEventData <Element>::
cursor () const
{ return *ivCursor;
}

template <class Element>
inline Element const*const
IVCollectionEventData <Element>::
element () const
{ return ivElement;
}

// ----------------
// IVCollectionImpl
// ----------------

// public members

inline INotifier&
IVCollectionImpl::
DisableNotification ()
{ return disableNotification ();
}

inline INotifier&
IVCollectionImpl::
EnableNotification (bool enable)
{ return enableNotification (enable);
}

inline bool
IVCollectionImpl::
IsEnabledForNotification () const
{ return isEnabledForNotification ();
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IIVCLLCT_INL_
