// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 24 1.4.1.4 source/core/collect/ikbdil.inl, collection, ioc.v400, 000302  
#ifndef _IKBDIL_INL_
#define _IKBDIL_INL_

// ---
// IGKeyBagAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsDilTableCursor <Element, Key, ElementOps>::
IGKeyBagAsDilTableCursor
  (IGKeyBagAsDilTable
    <Element, Key, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGKeyBagAsDilTableCursor <Element, Key, ElementOps>&
IGKeyBagAsDilTableCursor <Element, Key, ElementOps>::
operator=
  (IGKeyBagAsDilTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsDilTableCursor <Element, Key, ElementOps>::
IGKeyBagAsDilTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGKeyBagAsDilTableMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsDilTableMngCursor <Element, Key, ElementOps>::
IGKeyBagAsDilTableMngCursor
  (IGKeyBagAsDilTable
    <Element, Key, ElementOps> const& collection)
: IGKeyBagAsDilTableCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsDilTableMngCursor <Element, Key, ElementOps>::
IGKeyBagAsDilTableMngCursor (ICursorImpl* impl)
: IGKeyBagAsDilTableCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGKeyBagAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsDilTable <Element, Key, ElementOps>::
IGKeyBagAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsDilTable <Element, Key, ElementOps>::
IGKeyBagAsDilTable
  (IGKeyBagAsDilTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGKeyBagAsDilTable <Element, Key, ElementOps>&
IGKeyBagAsDilTable <Element, Key, ElementOps>::
operator= (IGKeyBagAsDilTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsDilTable <Element, Key, ElementOps>::
IGKeyBagAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGKeyBagAsDilTable
 <Element, Key, ElementOps>::Implementation&
IGKeyBagAsDilTable <Element, Key, ElementOps>::
ImplOf (IGKeyBagAsDilTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IKeyBagAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IKeyBagAsDilTable <Element, Key>::
IKeyBagAsDilTable (INumber numberOfElements)
: IGKeyBagAsDilTable
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IKeyBagAsDilTable <Element, Key>::
IKeyBagAsDilTable (PureImplementation& impl)
: IGKeyBagAsDilTable
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGKeyBagAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGKeyBagAsDilTable <Element, Key, ElementOps>::
IVGKeyBagAsDilTable (INumber numberOfElements)
: IGKeyBagAsDilTable
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGKeyBagAsDilTable <Element, Key, ElementOps>::
IVGKeyBagAsDilTable (PureImplementation& impl)
: IGKeyBagAsDilTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVKeyBagAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IVKeyBagAsDilTable <Element, Key>::
IVKeyBagAsDilTable (INumber numberOfElements)
: IVGKeyBagAsDilTable
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVKeyBagAsDilTable <Element, Key>::
IVKeyBagAsDilTable (PureImplementation& impl)
: IVGKeyBagAsDilTable
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}
#endif

#endif // _IKBDIL_INL_
