// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 26 1.4.1.4 source/core/collect/ikbhsh.inl, collection, ioc.v400, 000302  
#ifndef _IKBHSH_INL_
#define _IKBHSH_INL_

// ---
// IGKeyBagAsHshTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsHshTableCursor <Element, Key, ElementOps>::
IGKeyBagAsHshTableCursor
  (IGKeyBagAsHshTable
    <Element, Key, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGKeyBagAsHshTableCursor <Element, Key, ElementOps>&
IGKeyBagAsHshTableCursor <Element, Key, ElementOps>::
operator=
  (IGKeyBagAsHshTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsHshTableCursor <Element, Key, ElementOps>::
IGKeyBagAsHshTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGKeyBagAsHshTableMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsHshTableMngCursor <Element, Key, ElementOps>::
IGKeyBagAsHshTableMngCursor
  (IGKeyBagAsHshTable
    <Element, Key, ElementOps> const& collection)
: IGKeyBagAsHshTableCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsHshTableMngCursor <Element, Key, ElementOps>::
IGKeyBagAsHshTableMngCursor (ICursorImpl* impl)
: IGKeyBagAsHshTableCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGKeyBagAsHshTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsHshTable <Element, Key, ElementOps>::
IGKeyBagAsHshTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsHshTable <Element, Key, ElementOps>::
IGKeyBagAsHshTable
  (IGKeyBagAsHshTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGKeyBagAsHshTable <Element, Key, ElementOps>&
IGKeyBagAsHshTable <Element, Key, ElementOps>::
operator= (IGKeyBagAsHshTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeyBagAsHshTable <Element, Key, ElementOps>::
IGKeyBagAsHshTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGKeyBagAsHshTable
 <Element, Key, ElementOps>::Implementation&
IGKeyBagAsHshTable <Element, Key, ElementOps>::
ImplOf (IGKeyBagAsHshTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IKeyBagAsHshTable
// ---

// public members

template <class Element, class Key>
inline
IKeyBagAsHshTable <Element, Key>::
IKeyBagAsHshTable (INumber numberOfElements)
: IGKeyBagAsHshTable
   <Element, Key, IKEHOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IKeyBagAsHshTable <Element, Key>::
IKeyBagAsHshTable (PureImplementation& impl)
: IGKeyBagAsHshTable
   <Element, Key, IKEHOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGKeyBagAsHshTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGKeyBagAsHshTable <Element, Key, ElementOps>::
IVGKeyBagAsHshTable (INumber numberOfElements)
: IGKeyBagAsHshTable
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGKeyBagAsHshTable <Element, Key, ElementOps>::
IVGKeyBagAsHshTable (PureImplementation& impl)
: IGKeyBagAsHshTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVKeyBagAsHshTable
// ---

// public members

template <class Element, class Key>
inline
IVKeyBagAsHshTable <Element, Key>::
IVKeyBagAsHshTable (INumber numberOfElements)
: IVGKeyBagAsHshTable
   <Element, Key, IKEHOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVKeyBagAsHshTable <Element, Key>::
IVKeyBagAsHshTable (PureImplementation& impl)
: IVGKeyBagAsHshTable
   <Element, Key, IKEHOps <Element, Key> > (impl)
{
}
#endif

#endif // _IKBHSH_INL_
