// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 51 1.4.1.4 source/core/collect/iksdil.inl, collection, ioc.v400, 000302  
#ifndef _IKSDIL_INL_
#define _IKSDIL_INL_

// ---
// IGKeySetAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeySetAsDilTableCursor <Element, Key, ElementOps>::
IGKeySetAsDilTableCursor
  (IGKeySetAsDilTable
    <Element, Key, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGKeySetAsDilTableCursor <Element, Key, ElementOps>&
IGKeySetAsDilTableCursor <Element, Key, ElementOps>::
operator=
  (IGKeySetAsDilTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeySetAsDilTableCursor <Element, Key, ElementOps>::
IGKeySetAsDilTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGKeySetAsDilTableMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeySetAsDilTableMngCursor <Element, Key, ElementOps>::
IGKeySetAsDilTableMngCursor
  (IGKeySetAsDilTable
    <Element, Key, ElementOps> const& collection)
: IGKeySetAsDilTableCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeySetAsDilTableMngCursor <Element, Key, ElementOps>::
IGKeySetAsDilTableMngCursor (ICursorImpl* impl)
: IGKeySetAsDilTableCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGKeySetAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeySetAsDilTable <Element, Key, ElementOps>::
IGKeySetAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGKeySetAsDilTable <Element, Key, ElementOps>::
IGKeySetAsDilTable
  (IGKeySetAsDilTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGKeySetAsDilTable <Element, Key, ElementOps>&
IGKeySetAsDilTable <Element, Key, ElementOps>::
operator= (IGKeySetAsDilTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeySetAsDilTable <Element, Key, ElementOps>::
IGKeySetAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGKeySetAsDilTable
 <Element, Key, ElementOps>::Implementation&
IGKeySetAsDilTable <Element, Key, ElementOps>::
ImplOf (IGKeySetAsDilTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IKeySetAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IKeySetAsDilTable <Element, Key>::
IKeySetAsDilTable (INumber numberOfElements)
: IGKeySetAsDilTable
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IKeySetAsDilTable <Element, Key>::
IKeySetAsDilTable (PureImplementation& impl)
: IGKeySetAsDilTable
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGKeySetAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGKeySetAsDilTable <Element, Key, ElementOps>::
IVGKeySetAsDilTable (INumber numberOfElements)
: IGKeySetAsDilTable
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGKeySetAsDilTable <Element, Key, ElementOps>::
IVGKeySetAsDilTable (PureImplementation& impl)
: IGKeySetAsDilTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVKeySetAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IVKeySetAsDilTable <Element, Key>::
IVKeySetAsDilTable (INumber numberOfElements)
: IVGKeySetAsDilTable
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVKeySetAsDilTable <Element, Key>::
IVKeySetAsDilTable (PureImplementation& impl)
: IVGKeySetAsDilTable
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}
#endif

#endif // _IKSDIL_INL_
