// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 72 1.5.1.4 source/core/collect/iksstab.h, collection, ioc.v400, 000302 
#ifndef _IKSSTAB_
#define _IKSSTAB_

#include <ilanglvl.hpp>
#include <iakss.h>
#include <iickss.h>
#if ! defined (__INO_AVALON__)
#include <iivkss.h>
#endif
#include <iiksstab.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class Key, class ElementOps>
class IGKeySortedSetAsTable;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key, class ElementOps>
class IGKeySortedSetAsTableCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef TYPENAME IGKeySortedSetAsTable
            <Element, Key, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGKeySortedSetAsTableCursor
                            (IGKeySortedSetAsTable
                              <
                               Element, Key, ElementOps> const&);

  IGKeySortedSetAsTableCursor <Element, Key, ElementOps>&
           operator=        (IGKeySortedSetAsTableCursor
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGKeySortedSetAsTableCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGKeySortedSetAsTableCursor\
                            (IGKeySortedSetAsTable\
                              <\
                               Element, Key, ElementOps> const&),\
           operator=,\
           IGKeySortedSetAsTableCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class Key, class ElementOps>
class IGKeySortedSetAsTableMngCursor :
  public IGKeySortedSetAsTableCursor <Element, Key, ElementOps>  {

  typedef  IGKeySortedSetAsTableCursor
            <Element, Key, ElementOps> Cursor;

  typedef TYPENAME IGKeySortedSetAsTable
            <Element, Key, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGKeySortedSetAsTableMngCursor
                            (IGKeySortedSetAsTable
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGKeySortedSetAsTableMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGKeySortedSetAsTableMngCursor\
                            (IGKeySortedSetAsTable\
                              <\
                               Element, Key, ElementOps> const&),\
           IGKeySortedSetAsTableMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class Key, class ElementOps>
class IGKeySortedSetAsTable :
  public IAKeySortedSet <Element, Key> {
protected:

  typedef  IGKeySortedSetAsTable <Element, Key, ElementOps> Self;

  typedef  IKeySortedSetAsTableImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICKeySortedSetImpl
            <PureImplementation> Implementation;
#endif

#define IGKeySortedSetAsTableTypedef(Element, Key, ElementOps)\
  typedef  IKeySortedSetAsTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IGKeySortedSetAsTableTypedef (Element, Key, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

  typedef  IGKeySortedSetAsTableCursor
            <Element, Key, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGKeySortedSetAsTableMngCursor
            <Element, Key, ElementOps> MngCursor;
#endif

           IGKeySortedSetAsTable
                            (INumber = 100);

           IGKeySortedSetAsTable
                            (IGKeySortedSetAsTable
                              <
                               Element, Key, ElementOps> const&);

  IGKeySortedSetAsTable <Element, Key, ElementOps>&
           operator=        (IGKeySortedSetAsTable
                              <
                               Element, Key, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGKeySortedSetAsTable
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGKeySortedSetAsTable
                              <
                               Element, Key, ElementOps> const&);

private:

  friend
  class    IGKeySortedSetAsTableCursor <Element, Key, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGKeySortedSetAsTableMngCursor
            <Element, Key, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGKeySortedSetAsTable\
                            (INumber),\
           operator=,\
           IGKeySortedSetAsTable\
                            (PureImplementation&),\
           ImplOf           (IGKeySortedSetAsTable\
                              <\
                               Element, Key, ElementOps> const&)\
                        )
#endif

};

template <class Element, class Key>
class IKeySortedSetAsTable :
  public IGKeySortedSetAsTable
          <Element, Key, IKCOps <Element, Key> > {

  typedef  IGKeySortedSetAsTable
            <Element, Key,
             IKCOps <Element, Key> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IKeySortedSetAsTable <Element, Key> Self;

#define IKeySortedSetAsTableTypedef(Element, Key)\
  typedef  IKeySortedSetAsTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, IKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IKeySortedSetAsTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IKeySortedSetAsTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IKeySortedSetAsTable\
                              (INumber),\
           IKeySortedSetAsTable\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class Key, class ElementOps>
class IVGKeySortedSetAsTable :
  public IGKeySortedSetAsTable
          <Element, Key, ElementOps > {

  typedef  IVGKeySortedSetAsTable
            <Element, Key, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGKeySortedSetAsTable
            <Element, Key, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVKeySortedSetImpl
            <PureImplementation> Implementation;
#else
  typedef  ICKeySortedSetImpl
            <IVKeySortedSetImpl
              <PureImplementation> > Implementation;
#endif

#define IVGKeySortedSetAsTableTypedef(Element, Key, ElementOps)\
  typedef  IKeySortedSetAsTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IVGKeySortedSetAsTableTypedef (Element, Key, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVGKeySortedSetAsTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGKeySortedSetAsTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGKeySortedSetAsTable\
                              (INumber),\
           IVGKeySortedSetAsTable\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element, class Key>
class IVKeySortedSetAsTable :
  public IVGKeySortedSetAsTable
          <Element, Key, IKCOps <Element, Key> > {

  typedef  IVGKeySortedSetAsTable
            <Element, Key,
             IKCOps <Element, Key> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVKeySortedSetAsTable <Element, Key> Self;

#define IVKeySortedSetAsTableTypedef(Element, Key)\
  typedef  IVKeySortedSetAsTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, IKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVKeySortedSetAsTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVKeySortedSetAsTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVKeySortedSetAsTable\
                              (INumber),\
           IVKeySortedSetAsTable\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <iksstab.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IKSSTAB_
