// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 85 1.4.1.4 source/core/collect/imapdil.inl, collection, ioc.v400, 000302  
#ifndef _IMAPDIL_INL_
#define _IMAPDIL_INL_

// ---
// IGMapAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGMapAsDilTableCursor <Element, Key, ElementOps>::
IGMapAsDilTableCursor
  (IGMapAsDilTable
    <Element, Key, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGMapAsDilTableCursor <Element, Key, ElementOps>&
IGMapAsDilTableCursor <Element, Key, ElementOps>::
operator=
  (IGMapAsDilTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGMapAsDilTableCursor <Element, Key, ElementOps>::
IGMapAsDilTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGMapAsDilTableMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGMapAsDilTableMngCursor <Element, Key, ElementOps>::
IGMapAsDilTableMngCursor
  (IGMapAsDilTable
    <Element, Key, ElementOps> const& collection)
: IGMapAsDilTableCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGMapAsDilTableMngCursor <Element, Key, ElementOps>::
IGMapAsDilTableMngCursor (ICursorImpl* impl)
: IGMapAsDilTableCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGMapAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGMapAsDilTable <Element, Key, ElementOps>::
IGMapAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGMapAsDilTable <Element, Key, ElementOps>::
IGMapAsDilTable
  (IGMapAsDilTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGMapAsDilTable <Element, Key, ElementOps>&
IGMapAsDilTable <Element, Key, ElementOps>::
operator= (IGMapAsDilTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGMapAsDilTable <Element, Key, ElementOps>::
IGMapAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGMapAsDilTable
 <Element, Key, ElementOps>::Implementation&
IGMapAsDilTable <Element, Key, ElementOps>::
ImplOf (IGMapAsDilTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IMapAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IMapAsDilTable <Element, Key>::
IMapAsDilTable (INumber numberOfElements)
: IGMapAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IMapAsDilTable <Element, Key>::
IMapAsDilTable (PureImplementation& impl)
: IGMapAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGMapAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGMapAsDilTable <Element, Key, ElementOps>::
IVGMapAsDilTable (INumber numberOfElements)
: IGMapAsDilTable
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGMapAsDilTable <Element, Key, ElementOps>::
IVGMapAsDilTable (PureImplementation& impl)
: IGMapAsDilTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVMapAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IVMapAsDilTable <Element, Key>::
IVMapAsDilTable (INumber numberOfElements)
: IVGMapAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVMapAsDilTable <Element, Key>::
IVMapAsDilTable (PureImplementation& impl)
: IVGMapAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}
#endif

#endif // _IMAPDIL_INL_
