// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 88 1.4.1.4 source/core/collect/imaphsh.inl, collection, ioc.v400, 000302  
#ifndef _IMAPHSH_INL_
#define _IMAPHSH_INL_

// ---
// IGMapAsHshTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGMapAsHshTableCursor <Element, Key, ElementOps>::
IGMapAsHshTableCursor
  (IGMapAsHshTable
    <Element, Key, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGMapAsHshTableCursor <Element, Key, ElementOps>&
IGMapAsHshTableCursor <Element, Key, ElementOps>::
operator=
  (IGMapAsHshTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGMapAsHshTableCursor <Element, Key, ElementOps>::
IGMapAsHshTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGMapAsHshTableMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGMapAsHshTableMngCursor <Element, Key, ElementOps>::
IGMapAsHshTableMngCursor
  (IGMapAsHshTable
    <Element, Key, ElementOps> const& collection)
: IGMapAsHshTableCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGMapAsHshTableMngCursor <Element, Key, ElementOps>::
IGMapAsHshTableMngCursor (ICursorImpl* impl)
: IGMapAsHshTableCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGMapAsHshTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGMapAsHshTable <Element, Key, ElementOps>::
IGMapAsHshTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGMapAsHshTable <Element, Key, ElementOps>::
IGMapAsHshTable
  (IGMapAsHshTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGMapAsHshTable <Element, Key, ElementOps>&
IGMapAsHshTable <Element, Key, ElementOps>::
operator= (IGMapAsHshTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGMapAsHshTable <Element, Key, ElementOps>::
IGMapAsHshTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGMapAsHshTable
 <Element, Key, ElementOps>::Implementation&
IGMapAsHshTable <Element, Key, ElementOps>::
ImplOf (IGMapAsHshTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IMapAsHshTable
// ---

// public members

template <class Element, class Key>
inline
IMapAsHshTable <Element, Key>::
IMapAsHshTable (INumber numberOfElements)
: IGMapAsHshTable
   <Element, Key, IEKEHOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IMapAsHshTable <Element, Key>::
IMapAsHshTable (PureImplementation& impl)
: IGMapAsHshTable
   <Element, Key, IEKEHOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGMapAsHshTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGMapAsHshTable <Element, Key, ElementOps>::
IVGMapAsHshTable (INumber numberOfElements)
: IGMapAsHshTable
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGMapAsHshTable <Element, Key, ElementOps>::
IVGMapAsHshTable (PureImplementation& impl)
: IGMapAsHshTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVMapAsHshTable
// ---

// public members

template <class Element, class Key>
inline
IVMapAsHshTable <Element, Key>::
IVMapAsHshTable (INumber numberOfElements)
: IVGMapAsHshTable
   <Element, Key, IEKEHOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVMapAsHshTable <Element, Key>::
IVMapAsHshTable (PureImplementation& impl)
: IVGMapAsHshTable
   <Element, Key, IEKEHOps <Element, Key> > (impl)
{
}
#endif

#endif // _IMAPHSH_INL_
