// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <imcllct.h>

#ifdef IC_PAGETUNE
  #define _IMCLLCT_CPP_
  #include <ipagetun.h>
#endif


#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---------------
// IMetaCollection
// ---------------

// protected members

IMetaCollection::
~IMetaCollection ()
{ if (ivImpl != 0)
    ivImpl->Delete ();
}

void
IMetaCollection::
CloneImplOf (IMetaCollection const& collection)
{ if (ivImpl != 0)
    ivImpl->Delete ();
  ivImpl = collection.ivImpl->Clone ();
  ivImpl->Initialize ();
}

void
IMetaCollection::
SetImpl (IACollectionImpl* impl)
{ if (ivImpl != 0)
    ivImpl->Delete ();
  ivImpl = impl;
  if (ivImpl == 0) {
    IACollectionImpl::CheckPointer ((void*)0);
  }
  ivImpl->Initialize ();
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
