// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
#include <imtree.h>

#ifdef IC_PAGETUNE
  #define _IMTREE_CPP_
  #include <ipagetun.h>
#endif


#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

// ---------
// IMetaTree
// ---------

// protected members

IMetaTree::
~IMetaTree ()
{ if (ivImpl != 0)
    ivImpl->Delete ();
}

void
IMetaTree::
CloneImplOf (IMetaTree const& tree)
{ if (ivImpl != 0)
    ivImpl->Delete ();
  ivImpl = tree.ivImpl->Clone ();
  ivImpl->Initialize ();
}

void
IMetaTree::
SetImpl (IATreeImpl* impl)
{ if (ivImpl != 0)
    ivImpl->Delete ();
  ivImpl = impl;
  if (ivImpl == 0) {
    IATreeImpl::CheckPointer ((void*)0);
  }
  ivImpl->Initialize ();
}

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif
