// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 09 1.5.1.4 source/core/collect/ipqudil.h, collection, ioc.v400, 000302 
#ifndef _IPQUDIL_
#define _IPQUDIL_

#include <ilanglvl.hpp>
#include <iapqu.h>
#include <iicksb.h>
#if ! defined (__INO_AVALON__)
#include <iivksb.h>
#endif
#include <iiksbdil.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class Key, class ElementOps>
class IGPriorityQueueAsDilTable;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key, class ElementOps>
class IGPriorityQueueAsDilTableCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef TYPENAME IGPriorityQueueAsDilTable
            <Element, Key, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGPriorityQueueAsDilTableCursor
                            (IGPriorityQueueAsDilTable
                              <
                               Element, Key, ElementOps> const&);

  IGPriorityQueueAsDilTableCursor <Element, Key, ElementOps>&
           operator=        (IGPriorityQueueAsDilTableCursor
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGPriorityQueueAsDilTableCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGPriorityQueueAsDilTableCursor\
                            (IGPriorityQueueAsDilTable\
                              <\
                               Element, Key, ElementOps> const&),\
           operator=,\
           IGPriorityQueueAsDilTableCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class Key, class ElementOps>
class IGPriorityQueueAsDilTableMngCursor :
  public IGPriorityQueueAsDilTableCursor <Element, Key, ElementOps>  {

  typedef  IGPriorityQueueAsDilTableCursor
            <Element, Key, ElementOps> Cursor;

  typedef TYPENAME IGPriorityQueueAsDilTable
            <Element, Key, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGPriorityQueueAsDilTableMngCursor
                            (IGPriorityQueueAsDilTable
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGPriorityQueueAsDilTableMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGPriorityQueueAsDilTableMngCursor\
                            (IGPriorityQueueAsDilTable\
                              <\
                               Element, Key, ElementOps> const&),\
           IGPriorityQueueAsDilTableMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class Key, class ElementOps>
class IGPriorityQueueAsDilTable :
  public IAPriorityQueue <Element, Key> {
protected:

  typedef  IGPriorityQueueAsDilTable <Element, Key, ElementOps> Self;

  typedef  IKeySortedBagAsDilTableImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICKeySortedBagImpl
            <PureImplementation> Implementation;
#endif

#define IGPriorityQueueAsDilTableTypedef(Element, Key, ElementOps)\
  typedef  IKeySortedBagAsDilTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IGPriorityQueueAsDilTableTypedef (Element, Key, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef IRestrictedAccessCollectionGuard<Element> Guard;
#endif

  typedef  IGPriorityQueueAsDilTableCursor
            <Element, Key, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGPriorityQueueAsDilTableMngCursor
            <Element, Key, ElementOps> MngCursor;
#endif

           IGPriorityQueueAsDilTable
                            (INumber = 100);

           IGPriorityQueueAsDilTable
                            (IGPriorityQueueAsDilTable
                              <
                               Element, Key, ElementOps> const&);

  IGPriorityQueueAsDilTable <Element, Key, ElementOps>&
           operator=        (IGPriorityQueueAsDilTable
                              <
                               Element, Key, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGPriorityQueueAsDilTable
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGPriorityQueueAsDilTable
                              <
                               Element, Key, ElementOps> const&);

private:

  friend
  class    IGPriorityQueueAsDilTableCursor <Element, Key, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGPriorityQueueAsDilTableMngCursor
            <Element, Key, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGPriorityQueueAsDilTable\
                            (INumber),\
           operator=,\
           IGPriorityQueueAsDilTable\
                            (PureImplementation&),\
           ImplOf           (IGPriorityQueueAsDilTable\
                              <\
                               Element, Key, ElementOps> const&)\
                        )
#endif

};

template <class Element, class Key>
class IPriorityQueueAsDilTable :
  public IGPriorityQueueAsDilTable
          <Element, Key, IKCOps <Element, Key> > {

  typedef  IGPriorityQueueAsDilTable
            <Element, Key,
             IKCOps <Element, Key> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IPriorityQueueAsDilTable <Element, Key> Self;

#define IPriorityQueueAsDilTableTypedef(Element, Key)\
  typedef  IKeySortedBagAsDilTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, IKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef IRestrictedAccessCollectionGuard<Element> Guard;
#endif

           IPriorityQueueAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IPriorityQueueAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IPriorityQueueAsDilTable\
                              (INumber),\
           IPriorityQueueAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class Key, class ElementOps>
class IVGPriorityQueueAsDilTable :
  public IGPriorityQueueAsDilTable
          <Element, Key, ElementOps > {

  typedef  IVGPriorityQueueAsDilTable
            <Element, Key, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGPriorityQueueAsDilTable
            <Element, Key, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVKeySortedBagImpl
            <PureImplementation> Implementation;
#else
  typedef  ICKeySortedBagImpl
            <IVKeySortedBagImpl
              <PureImplementation> > Implementation;
#endif

#define IVGPriorityQueueAsDilTableTypedef(Element, Key, ElementOps)\
  typedef  IKeySortedBagAsDilTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IVGPriorityQueueAsDilTableTypedef (Element, Key, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef IRestrictedAccessCollectionGuard<Element> Guard;
#endif

           IVGPriorityQueueAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGPriorityQueueAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGPriorityQueueAsDilTable\
                              (INumber),\
           IVGPriorityQueueAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element, class Key>
class IVPriorityQueueAsDilTable :
  public IVGPriorityQueueAsDilTable
          <Element, Key, IKCOps <Element, Key> > {

  typedef  IVGPriorityQueueAsDilTable
            <Element, Key,
             IKCOps <Element, Key> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVPriorityQueueAsDilTable <Element, Key> Self;

#define IVPriorityQueueAsDilTableTypedef(Element, Key)\
  typedef  IVKeySortedBagAsDilTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, IKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef IRestrictedAccessCollectionGuard<Element> Guard;
#endif

           IVPriorityQueueAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVPriorityQueueAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVPriorityQueueAsDilTable\
                              (INumber),\
           IVPriorityQueueAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <ipqudil.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IPQUDIL_
