// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 23 1.4.1.4 source/core/collect/iqudil.inl, collection, ioc.v400, 000302  
#ifndef _IQUDIL_INL_
#define _IQUDIL_INL_

// ---
// IGQueueAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGQueueAsDilTableCursor <Element, ElementOps>::
IGQueueAsDilTableCursor
  (IGQueueAsDilTable
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGQueueAsDilTableCursor <Element, ElementOps>&
IGQueueAsDilTableCursor <Element, ElementOps>::
operator=
  (IGQueueAsDilTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGQueueAsDilTableCursor <Element, ElementOps>::
IGQueueAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGQueueAsDilTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGQueueAsDilTableMngCursor <Element, ElementOps>::
IGQueueAsDilTableMngCursor
  (IGQueueAsDilTable
    <Element, ElementOps> const& collection)
: IGQueueAsDilTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGQueueAsDilTableMngCursor <Element, ElementOps>::
IGQueueAsDilTableMngCursor (ICursorImpl* impl)
: IGQueueAsDilTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGQueueAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGQueueAsDilTable <Element, ElementOps>::
IGQueueAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGQueueAsDilTable <Element, ElementOps>::
IGQueueAsDilTable
  (IGQueueAsDilTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGQueueAsDilTable <Element, ElementOps>&
IGQueueAsDilTable <Element, ElementOps>::
operator= (IGQueueAsDilTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGQueueAsDilTable <Element, ElementOps>::
IGQueueAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGQueueAsDilTable
 <Element, ElementOps>::Implementation&
IGQueueAsDilTable <Element, ElementOps>::
ImplOf (IGQueueAsDilTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IQueueAsDilTable
// ---

// public members

template <class Element>
inline
IQueueAsDilTable <Element>::
IQueueAsDilTable (INumber numberOfElements)
: IGQueueAsDilTable
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IQueueAsDilTable <Element>::
IQueueAsDilTable (PureImplementation& impl)
: IGQueueAsDilTable
   <Element, IStdOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGQueueAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGQueueAsDilTable <Element, ElementOps>::
IVGQueueAsDilTable (INumber numberOfElements)
: IGQueueAsDilTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGQueueAsDilTable <Element, ElementOps>::
IVGQueueAsDilTable (PureImplementation& impl)
: IGQueueAsDilTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVQueueAsDilTable
// ---

// public members

template <class Element>
inline
IVQueueAsDilTable <Element>::
IVQueueAsDilTable (INumber numberOfElements)
: IVGQueueAsDilTable
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVQueueAsDilTable <Element>::
IVQueueAsDilTable (PureImplementation& impl)
: IVGQueueAsDilTable
   <Element, IStdOps <Element> > (impl)
{
}
#endif

#endif // _IQUDIL_INL_
