// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 37 1.5.1.4 source/core/collect/ireldil.h, collection, ioc.v400, 000302 
#ifndef _IRELDIL_
#define _IRELDIL_

#include <ilanglvl.hpp>
#include <iarel.h>
#include <iicrel.h>
#if ! defined (__INO_AVALON__)
#include <iivrel.h>
#endif
#include <iireldil.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class Key, class ElementOps>
class IGRelationAsDilTable;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key, class ElementOps>
class IGRelationAsDilTableCursor :
  public IElementCursor <Element> {

  typedef  IElementCursor <Element> Inherited;

  typedef TYPENAME IGRelationAsDilTable
            <Element, Key, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGRelationAsDilTableCursor
                            (IGRelationAsDilTable
                              <
                               Element, Key, ElementOps> const&);

  IGRelationAsDilTableCursor <Element, Key, ElementOps>&
           operator=        (IGRelationAsDilTableCursor
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGRelationAsDilTableCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGRelationAsDilTableCursor\
                            (IGRelationAsDilTable\
                              <\
                               Element, Key, ElementOps> const&),\
           operator=,\
           IGRelationAsDilTableCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class Key, class ElementOps>
class IGRelationAsDilTableMngCursor :
  public IGRelationAsDilTableCursor <Element, Key, ElementOps>  {

  typedef  IGRelationAsDilTableCursor
            <Element, Key, ElementOps> Cursor;

  typedef TYPENAME IGRelationAsDilTable
            <Element, Key, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGRelationAsDilTableMngCursor
                            (IGRelationAsDilTable
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGRelationAsDilTableMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGRelationAsDilTableMngCursor\
                            (IGRelationAsDilTable\
                              <\
                               Element, Key, ElementOps> const&),\
           IGRelationAsDilTableMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class Key, class ElementOps>
class IGRelationAsDilTable :
  public IARelation <Element, Key> {
protected:

  typedef  IGRelationAsDilTable <Element, Key, ElementOps> Self;

  typedef  IRelationAsDilTableImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICRelationImpl
            <PureImplementation> Implementation;
#endif

#define IGRelationAsDilTableTypedef(Element, Key, ElementOps)\
  typedef  IRelationAsDilTableOps\
            <Element, Key,\
             IWEKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IGRelationAsDilTableTypedef (Element, Key, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

  typedef  IGRelationAsDilTableCursor
            <Element, Key, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGRelationAsDilTableMngCursor
            <Element, Key, ElementOps> MngCursor;
#endif

           IGRelationAsDilTable
                            (INumber = 100);

           IGRelationAsDilTable
                            (IGRelationAsDilTable
                              <
                               Element, Key, ElementOps> const&);

  IGRelationAsDilTable <Element, Key, ElementOps>&
           operator=        (IGRelationAsDilTable
                              <
                               Element, Key, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGRelationAsDilTable
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGRelationAsDilTable
                              <
                               Element, Key, ElementOps> const&);

private:

  friend
  class    IGRelationAsDilTableCursor <Element, Key, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGRelationAsDilTableMngCursor
            <Element, Key, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGRelationAsDilTable\
                            (INumber),\
           operator=,\
           IGRelationAsDilTable\
                            (PureImplementation&),\
           ImplOf           (IGRelationAsDilTable\
                              <\
                               Element, Key, ElementOps> const&)\
                        )
#endif

};

template <class Element, class Key>
class IRelationAsDilTable :
  public IGRelationAsDilTable
          <Element, Key, IEKCOps <Element, Key> > {

  typedef  IGRelationAsDilTable
            <Element, Key,
             IEKCOps <Element, Key> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IRelationAsDilTable <Element, Key> Self;

#define IRelationAsDilTableTypedef(Element, Key)\
  typedef  IRelationAsDilTableOps\
            <Element, Key,\
             IWEKCOps <Element, Key, IEKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IRelationAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IRelationAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IRelationAsDilTable\
                              (INumber),\
           IRelationAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class Key, class ElementOps>
class IVGRelationAsDilTable :
  public IGRelationAsDilTable
          <Element, Key, ElementOps > {

  typedef  IVGRelationAsDilTable
            <Element, Key, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGRelationAsDilTable
            <Element, Key, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVRelationImpl
            <PureImplementation> Implementation;
#else
  typedef  ICRelationImpl
            <IVRelationImpl
              <PureImplementation> > Implementation;
#endif

#define IVGRelationAsDilTableTypedef(Element, Key, ElementOps)\
  typedef  IRelationAsDilTableOps\
            <Element, Key,\
             IWEKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IVGRelationAsDilTableTypedef (Element, Key, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVGRelationAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGRelationAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGRelationAsDilTable\
                              (INumber),\
           IVGRelationAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element, class Key>
class IVRelationAsDilTable :
  public IVGRelationAsDilTable
          <Element, Key, IEKCOps <Element, Key> > {

  typedef  IVGRelationAsDilTable
            <Element, Key,
             IEKCOps <Element, Key> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVRelationAsDilTable <Element, Key> Self;

#define IVRelationAsDilTableTypedef(Element, Key)\
  typedef  IVRelationAsDilTableOps\
            <Element, Key,\
             IWEKCOps <Element, Key, IEKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVRelationAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVRelationAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVRelationAsDilTable\
                              (INumber),\
           IVRelationAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <ireldil.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IRELDIL_
