// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 74 1.5.1.3 source/core/collect/irsrtrel.h, collection, ioc.v400, 000302 
#ifndef _IRSRTREL_
#define _IRSRTREL_

#include <ilanglvl.hpp>
#include <iasr.h>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key, class Base>
class IRSortedRelation : public IASortedRelation <Element, Key> {
public:

  typedef TYPENAME Base::Cursor Cursor;

           IRSortedRelation
                            (Base&);

  IRSortedRelation <Element, Key, Base>&
           operator=        (IRSortedRelation
                              <Element, Key, Base> const&);

protected:

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IRSortedRelation\
                            (Base&),\
           operator=\
                        )
#endif

};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <irsrtrel.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _IRSRTREL_
