// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 83 1.4.1.4 source/core/collect/isbavl.inl, collection, ioc.v400, 000302  
#ifndef _ISBAVL_INL_
#define _ISBAVL_INL_

// ---
// IGSortedBagAsAvlTreeCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsAvlTreeCursor <Element, ElementOps>::
IGSortedBagAsAvlTreeCursor
  (IGSortedBagAsAvlTree
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSortedBagAsAvlTreeCursor <Element, ElementOps>&
IGSortedBagAsAvlTreeCursor <Element, ElementOps>::
operator=
  (IGSortedBagAsAvlTreeCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsAvlTreeCursor <Element, ElementOps>::
IGSortedBagAsAvlTreeCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGSortedBagAsAvlTreeMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsAvlTreeMngCursor <Element, ElementOps>::
IGSortedBagAsAvlTreeMngCursor
  (IGSortedBagAsAvlTree
    <Element, ElementOps> const& collection)
: IGSortedBagAsAvlTreeCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsAvlTreeMngCursor <Element, ElementOps>::
IGSortedBagAsAvlTreeMngCursor (ICursorImpl* impl)
: IGSortedBagAsAvlTreeCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGSortedBagAsAvlTree
// ---

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsAvlTree <Element, ElementOps>::
IGSortedBagAsAvlTree (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSortedBagAsAvlTree <Element, ElementOps>::
IGSortedBagAsAvlTree
  (IGSortedBagAsAvlTree
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSortedBagAsAvlTree <Element, ElementOps>&
IGSortedBagAsAvlTree <Element, ElementOps>::
operator= (IGSortedBagAsAvlTree
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsAvlTree <Element, ElementOps>::
IGSortedBagAsAvlTree (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSortedBagAsAvlTree
 <Element, ElementOps>::Implementation&
IGSortedBagAsAvlTree <Element, ElementOps>::
ImplOf (IGSortedBagAsAvlTree
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISortedBagAsAvlTree
// ---

// public members

template <class Element>
inline
ISortedBagAsAvlTree <Element>::
ISortedBagAsAvlTree (INumber numberOfElements)
: IGSortedBagAsAvlTree
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISortedBagAsAvlTree <Element>::
ISortedBagAsAvlTree (PureImplementation& impl)
: IGSortedBagAsAvlTree
   <Element, ICOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGSortedBagAsAvlTree
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSortedBagAsAvlTree <Element, ElementOps>::
IVGSortedBagAsAvlTree (INumber numberOfElements)
: IGSortedBagAsAvlTree
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSortedBagAsAvlTree <Element, ElementOps>::
IVGSortedBagAsAvlTree (PureImplementation& impl)
: IGSortedBagAsAvlTree
    <Element, ElementOps> (impl)
{
}

// ---
// IVSortedBagAsAvlTree
// ---

// public members

template <class Element>
inline
IVSortedBagAsAvlTree <Element>::
IVSortedBagAsAvlTree (INumber numberOfElements)
: IVGSortedBagAsAvlTree
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSortedBagAsAvlTree <Element>::
IVSortedBagAsAvlTree (PureImplementation& impl)
: IVGSortedBagAsAvlTree
   <Element, ICOps <Element> > (impl)
{
}
#endif

#endif // _ISBAVL_INL_
