// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 86 1.5.1.4 source/core/collect/isbdil.h, collection, ioc.v400, 000302 
#ifndef _ISBDIL_
#define _ISBDIL_

#include <ilanglvl.hpp>
#include <iasb.h>
#include <iicsb.h>
#if ! defined (__INO_AVALON__)
#include <iivsb.h>
#endif
#include <iisbdil.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class ElementOps>
class IGSortedBagAsDilTable;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class ElementOps>
class IGSortedBagAsDilTableCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef TYPENAME IGSortedBagAsDilTable
            <Element, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGSortedBagAsDilTableCursor
                            (IGSortedBagAsDilTable
                              <
                               Element, ElementOps> const&);

  IGSortedBagAsDilTableCursor <Element, ElementOps>&
           operator=        (IGSortedBagAsDilTableCursor
                              <
                               Element, ElementOps> const&);

protected:

           IGSortedBagAsDilTableCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGSortedBagAsDilTableCursor\
                            (IGSortedBagAsDilTable\
                              <\
                               Element, ElementOps> const&),\
           operator=,\
           IGSortedBagAsDilTableCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class ElementOps>
class IGSortedBagAsDilTableMngCursor :
  public IGSortedBagAsDilTableCursor <Element, ElementOps>  {

  typedef  IGSortedBagAsDilTableCursor
            <Element, ElementOps> Cursor;

  typedef TYPENAME IGSortedBagAsDilTable
            <Element, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGSortedBagAsDilTableMngCursor
                            (IGSortedBagAsDilTable
                              <
                               Element, ElementOps> const&);

protected:

           IGSortedBagAsDilTableMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGSortedBagAsDilTableMngCursor\
                            (IGSortedBagAsDilTable\
                              <\
                               Element, ElementOps> const&),\
           IGSortedBagAsDilTableMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class ElementOps>
class IGSortedBagAsDilTable :
  public IASortedBag <Element> {
protected:

  typedef  IGSortedBagAsDilTable <Element, ElementOps> Self;

  typedef  ISortedBagAsDilTableImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICSortedBagImpl
            <PureImplementation> Implementation;
#endif

#define IGSortedBagAsDilTableTypedef(Element, ElementOps)\
  typedef  ISortedBagAsDilTableOps\
            <Element,\
             IWCOps <Element, ElementOps>,\
             Implementation> Instantiation

           IGSortedBagAsDilTableTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

  typedef  IGSortedBagAsDilTableCursor
            <Element, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGSortedBagAsDilTableMngCursor
            <Element, ElementOps> MngCursor;
#endif

           IGSortedBagAsDilTable
                            (INumber = 100);

           IGSortedBagAsDilTable
                            (IGSortedBagAsDilTable
                              <
                               Element, ElementOps> const&);

  IGSortedBagAsDilTable <Element, ElementOps>&
           operator=        (IGSortedBagAsDilTable
                              <
                               Element, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGSortedBagAsDilTable
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGSortedBagAsDilTable
                              <
                               Element, ElementOps> const&);

private:

  friend
  class    IGSortedBagAsDilTableCursor <Element, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGSortedBagAsDilTableMngCursor
            <Element, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGSortedBagAsDilTable\
                            (INumber),\
           operator=,\
           IGSortedBagAsDilTable\
                            (PureImplementation&),\
           ImplOf           (IGSortedBagAsDilTable\
                              <\
                               Element, ElementOps> const&)\
                        )
#endif

};

template <class Element>
class ISortedBagAsDilTable :
  public IGSortedBagAsDilTable
          <Element, ICOps <Element> > {

  typedef  IGSortedBagAsDilTable
            <Element,
             ICOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  ISortedBagAsDilTable <Element> Self;

#define ISortedBagAsDilTableTypedef(Element)\
  typedef  ISortedBagAsDilTableOps\
            <Element,\
             IWCOps <Element, ICOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           ISortedBagAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           ISortedBagAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ISortedBagAsDilTable\
                              (INumber),\
           ISortedBagAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class ElementOps>
class IVGSortedBagAsDilTable :
  public IGSortedBagAsDilTable
          <Element, ElementOps > {

  typedef  IVGSortedBagAsDilTable
            <Element, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGSortedBagAsDilTable
            <Element, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVSortedBagImpl
            <PureImplementation> Implementation;
#else
  typedef  ICSortedBagImpl
            <IVSortedBagImpl
              <PureImplementation> > Implementation;
#endif

#define IVGSortedBagAsDilTableTypedef(Element, ElementOps)\
  typedef  ISortedBagAsDilTableOps\
            <Element,\
             IWCOps <Element, ElementOps>,\
             Implementation> Instantiation

           IVGSortedBagAsDilTableTypedef (Element, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVGSortedBagAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGSortedBagAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGSortedBagAsDilTable\
                              (INumber),\
           IVGSortedBagAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element>
class IVSortedBagAsDilTable :
  public IVGSortedBagAsDilTable
          <Element, ICOps <Element> > {

  typedef  IVGSortedBagAsDilTable
            <Element,
             ICOps <Element> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVSortedBagAsDilTable <Element> Self;

#define IVSortedBagAsDilTableTypedef(Element)\
  typedef  IVSortedBagAsDilTableOps\
            <Element,\
             IWCOps <Element, ICOps <Element> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVSortedBagAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVSortedBagAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVSortedBagAsDilTable\
                              (INumber),\
           IVSortedBagAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <isbdil.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _ISBDIL_
