// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 28 1.4.1.4 source/core/collect/ismdil.inl, collection, ioc.v400, 000302  
#ifndef _ISMDIL_INL_
#define _ISMDIL_INL_

// ---
// IGSortedMapAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGSortedMapAsDilTableCursor <Element, Key, ElementOps>::
IGSortedMapAsDilTableCursor
  (IGSortedMapAsDilTable
    <Element, Key, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGSortedMapAsDilTableCursor <Element, Key, ElementOps>&
IGSortedMapAsDilTableCursor <Element, Key, ElementOps>::
operator=
  (IGSortedMapAsDilTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGSortedMapAsDilTableCursor <Element, Key, ElementOps>::
IGSortedMapAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGSortedMapAsDilTableMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGSortedMapAsDilTableMngCursor <Element, Key, ElementOps>::
IGSortedMapAsDilTableMngCursor
  (IGSortedMapAsDilTable
    <Element, Key, ElementOps> const& collection)
: IGSortedMapAsDilTableCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGSortedMapAsDilTableMngCursor <Element, Key, ElementOps>::
IGSortedMapAsDilTableMngCursor (ICursorImpl* impl)
: IGSortedMapAsDilTableCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGSortedMapAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGSortedMapAsDilTable <Element, Key, ElementOps>::
IGSortedMapAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGSortedMapAsDilTable <Element, Key, ElementOps>::
IGSortedMapAsDilTable
  (IGSortedMapAsDilTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGSortedMapAsDilTable <Element, Key, ElementOps>&
IGSortedMapAsDilTable <Element, Key, ElementOps>::
operator= (IGSortedMapAsDilTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGSortedMapAsDilTable <Element, Key, ElementOps>::
IGSortedMapAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGSortedMapAsDilTable
 <Element, Key, ElementOps>::Implementation&
IGSortedMapAsDilTable <Element, Key, ElementOps>::
ImplOf (IGSortedMapAsDilTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISortedMapAsDilTable
// ---

// public members

template <class Element, class Key>
inline
ISortedMapAsDilTable <Element, Key>::
ISortedMapAsDilTable (INumber numberOfElements)
: IGSortedMapAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
ISortedMapAsDilTable <Element, Key>::
ISortedMapAsDilTable (PureImplementation& impl)
: IGSortedMapAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGSortedMapAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGSortedMapAsDilTable <Element, Key, ElementOps>::
IVGSortedMapAsDilTable (INumber numberOfElements)
: IGSortedMapAsDilTable
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGSortedMapAsDilTable <Element, Key, ElementOps>::
IVGSortedMapAsDilTable (PureImplementation& impl)
: IGSortedMapAsDilTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVSortedMapAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IVSortedMapAsDilTable <Element, Key>::
IVSortedMapAsDilTable (INumber numberOfElements)
: IVGSortedMapAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVSortedMapAsDilTable <Element, Key>::
IVSortedMapAsDilTable (PureImplementation& impl)
: IVGSortedMapAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}
#endif

#endif // _ISMDIL_INL_
