// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 38 1.5.1.4 source/core/collect/isrdil.h, collection, ioc.v400, 000302 
#ifndef _ISRDIL_
#define _ISRDIL_

#include <ilanglvl.hpp>
#include <iasr.h>
#include <iicsr.h>
#if ! defined (__INO_AVALON__)
#include <iivsr.h>
#endif
#include <iisrdil.h>

#if defined (__OSTORE__)
#include <ostore/ostore.hh>
#include <ostore/manschem.hh>
#endif

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#endif

#if defined (__SOM_ENABLED__)
#if defined (__RRBC_IBM__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Element, class Key, class ElementOps>
class IGSortedRelationAsDilTable;

#pragma pack(push,4)
#pragma enum(4)

template <class Element, class Key, class ElementOps>
class IGSortedRelationAsDilTableCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef TYPENAME IGSortedRelationAsDilTable
            <Element, Key, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGSortedRelationAsDilTableCursor
                            (IGSortedRelationAsDilTable
                              <
                               Element, Key, ElementOps> const&);

  IGSortedRelationAsDilTableCursor <Element, Key, ElementOps>&
           operator=        (IGSortedRelationAsDilTableCursor
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGSortedRelationAsDilTableCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGSortedRelationAsDilTableCursor\
                            (IGSortedRelationAsDilTable\
                              <\
                               Element, Key, ElementOps> const&),\
           operator=,\
           IGSortedRelationAsDilTableCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#if ! defined (__INO_MNGCURSOR__)
template <class Element, class Key, class ElementOps>
class IGSortedRelationAsDilTableMngCursor :
  public IGSortedRelationAsDilTableCursor <Element, Key, ElementOps>  {

  typedef  IGSortedRelationAsDilTableCursor
            <Element, Key, ElementOps> Cursor;

  typedef TYPENAME IGSortedRelationAsDilTable
            <Element, Key, ElementOps>::
              Implementation::MngCursor Implementation;

public:

           IGSortedRelationAsDilTableMngCursor
                            (IGSortedRelationAsDilTable
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGSortedRelationAsDilTableMngCursor
                            (ICursorImpl*);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGSortedRelationAsDilTableMngCursor\
                            (IGSortedRelationAsDilTable\
                              <\
                               Element, Key, ElementOps> const&),\
           IGSortedRelationAsDilTableMngCursor\
                            (ICursorImpl*)\
                        )
#endif

};

#endif
template <class Element, class Key, class ElementOps>
class IGSortedRelationAsDilTable :
  public IASortedRelation <Element, Key> {
protected:

  typedef  IGSortedRelationAsDilTable <Element, Key, ElementOps> Self;

  typedef  ISortedRelationAsDilTableImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICSortedRelationImpl
            <PureImplementation> Implementation;
#endif

#define IGSortedRelationAsDilTableTypedef(Element, Key, ElementOps)\
  typedef  ISortedRelationAsDilTableOps\
            <Element, Key,\
             IWEKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IGSortedRelationAsDilTableTypedef (Element, Key, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

  typedef  IGSortedRelationAsDilTableCursor
            <Element, Key, ElementOps> Cursor;

#if ! defined (__INO_MNGCURSOR__)
  typedef  IGSortedRelationAsDilTableMngCursor
            <Element, Key, ElementOps> MngCursor;
#endif

           IGSortedRelationAsDilTable
                            (INumber = 100);

           IGSortedRelationAsDilTable
                            (IGSortedRelationAsDilTable
                              <
                               Element, Key, ElementOps> const&);

  IGSortedRelationAsDilTable <Element, Key, ElementOps>&
           operator=        (IGSortedRelationAsDilTable
                              <
                               Element, Key, ElementOps> const&);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Instantiation::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IGSortedRelationAsDilTable
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGSortedRelationAsDilTable
                              <
                               Element, Key, ElementOps> const&);

private:

  friend
  class    IGSortedRelationAsDilTableCursor <Element, Key, ElementOps>;

#if ! defined (__INO_MNGCURSOR__)
  friend
  class    IGSortedRelationAsDilTableMngCursor
            <Element, Key, ElementOps>;
#endif

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine ()
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IGSortedRelationAsDilTable\
                            (INumber),\
           operator=,\
           IGSortedRelationAsDilTable\
                            (PureImplementation&),\
           ImplOf           (IGSortedRelationAsDilTable\
                              <\
                               Element, Key, ElementOps> const&)\
                        )
#endif

};

template <class Element, class Key>
class ISortedRelationAsDilTable :
  public IGSortedRelationAsDilTable
          <Element, Key, IEKCOps <Element, Key> > {

  typedef  IGSortedRelationAsDilTable
            <Element, Key,
             IEKCOps <Element, Key> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  ISortedRelationAsDilTable <Element, Key> Self;

#define ISortedRelationAsDilTableTypedef(Element, Key)\
  typedef  ISortedRelationAsDilTableOps\
            <Element, Key,\
             IWEKCOps <Element, Key, IEKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           ISortedRelationAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           ISortedRelationAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ISortedRelationAsDilTable\
                              (INumber),\
           ISortedRelationAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#if ! defined (__INO_AVALON__)
template <class Element, class Key, class ElementOps>
class IVGSortedRelationAsDilTable :
  public IGSortedRelationAsDilTable
          <Element, Key, ElementOps > {

  typedef  IVGSortedRelationAsDilTable
            <Element, Key, ElementOps> Inherited;

protected:

  typedef TYPENAME
           IGSortedRelationAsDilTable
            <Element, Key, ElementOps>::PureImplementation PureImplementation;

#if defined (INO_CHECKS)
  typedef  IVSortedRelationImpl
            <PureImplementation> Implementation;
#else
  typedef  ICSortedRelationImpl
            <IVSortedRelationImpl
              <PureImplementation> > Implementation;
#endif

#define IVGSortedRelationAsDilTableTypedef(Element, Key, ElementOps)\
  typedef  ISortedRelationAsDilTableOps\
            <Element, Key,\
             IWEKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IVGSortedRelationAsDilTableTypedef (Element, Key, ElementOps);

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVGSortedRelationAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVGSortedRelationAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVGSortedRelationAsDilTable\
                              (INumber),\
           IVGSortedRelationAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

template <class Element, class Key>
class IVSortedRelationAsDilTable :
  public IVGSortedRelationAsDilTable
          <Element, Key, IEKCOps <Element, Key> > {

  typedef  IVGSortedRelationAsDilTable
            <Element, Key,
             IEKCOps <Element, Key> > Inherited;

protected:

  typedef TYPENAME Inherited::PureImplementation PureImplementation;

  typedef  IVSortedRelationAsDilTable <Element, Key> Self;

#define IVSortedRelationAsDilTableTypedef(Element, Key)\
  typedef  IVSortedRelationAsDilTableOps\
            <Element, Key,\
             IWEKCOps <Element, Key, IEKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

#if ! defined(__INO_L1_LOCKING__)
  typedef ICollectionGuard<Element> Guard;
#endif

           IVSortedRelationAsDilTable
                            (INumber = 100);

#if defined (__OSTORE__)
  static
  os_typespec*
           get_os_typespec  ()
           { return 0; }

  static
  void     os_mark_schema_type ()
           {
             Inherited::os_mark_schema_type ();
#if ! defined (_AIX)
             OS_MARK_SCHEMA_TYPESPEC((Self));
#else
             { Self* _OSMT_ = 0; }
#endif
           }
#endif

protected:

           IVSortedRelationAsDilTable
                              (PureImplementation&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_IBM__)
#pragma SOMDefine (*)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IVSortedRelationAsDilTable\
                              (INumber),\
           IVSortedRelationAsDilTable\
                              (PureImplementation&)\
                        )
#endif

};

#endif

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#if defined (__SOM_ENABLED__) 
#pragma SOMAsDefault (pop)
#endif

#include <isrdil.inl>

#if defined (__OS2__) || defined (__OS400__) || defined (__WINDOWS__)
#pragma info (restore)
#endif

#endif // _ISRDIL_
