// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 39 1.4.1.4 source/core/collect/isrdil.inl, collection, ioc.v400, 000302  
#ifndef _ISRDIL_INL_
#define _ISRDIL_INL_

// ---
// IGSortedRelationAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsDilTableCursor <Element, Key, ElementOps>::
IGSortedRelationAsDilTableCursor
  (IGSortedRelationAsDilTable
    <Element, Key, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGSortedRelationAsDilTableCursor <Element, Key, ElementOps>&
IGSortedRelationAsDilTableCursor <Element, Key, ElementOps>::
operator=
  (IGSortedRelationAsDilTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsDilTableCursor <Element, Key, ElementOps>::
IGSortedRelationAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGSortedRelationAsDilTableMngCursor
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsDilTableMngCursor <Element, Key, ElementOps>::
IGSortedRelationAsDilTableMngCursor
  (IGSortedRelationAsDilTable
    <Element, Key, ElementOps> const& collection)
: IGSortedRelationAsDilTableCursor <Element, Key, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsDilTableMngCursor <Element, Key, ElementOps>::
IGSortedRelationAsDilTableMngCursor (ICursorImpl* impl)
: IGSortedRelationAsDilTableCursor <Element, Key, ElementOps> (impl)
{
}

#endif
// ---
// IGSortedRelationAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsDilTable <Element, Key, ElementOps>::
IGSortedRelationAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsDilTable <Element, Key, ElementOps>::
IGSortedRelationAsDilTable
  (IGSortedRelationAsDilTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGSortedRelationAsDilTable <Element, Key, ElementOps>&
IGSortedRelationAsDilTable <Element, Key, ElementOps>::
operator= (IGSortedRelationAsDilTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGSortedRelationAsDilTable <Element, Key, ElementOps>::
IGSortedRelationAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGSortedRelationAsDilTable
 <Element, Key, ElementOps>::Implementation&
IGSortedRelationAsDilTable <Element, Key, ElementOps>::
ImplOf (IGSortedRelationAsDilTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISortedRelationAsDilTable
// ---

// public members

template <class Element, class Key>
inline
ISortedRelationAsDilTable <Element, Key>::
ISortedRelationAsDilTable (INumber numberOfElements)
: IGSortedRelationAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
ISortedRelationAsDilTable <Element, Key>::
ISortedRelationAsDilTable (PureImplementation& impl)
: IGSortedRelationAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGSortedRelationAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGSortedRelationAsDilTable <Element, Key, ElementOps>::
IVGSortedRelationAsDilTable (INumber numberOfElements)
: IGSortedRelationAsDilTable
    <Element, Key, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGSortedRelationAsDilTable <Element, Key, ElementOps>::
IVGSortedRelationAsDilTable (PureImplementation& impl)
: IGSortedRelationAsDilTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVSortedRelationAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IVSortedRelationAsDilTable <Element, Key>::
IVSortedRelationAsDilTable (INumber numberOfElements)
: IVGSortedRelationAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVSortedRelationAsDilTable <Element, Key>::
IVSortedRelationAsDilTable (PureImplementation& impl)
: IVGSortedRelationAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}
#endif

#endif // _ISRDIL_INL_
