// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 58 1.4.1.4 source/core/collect/issdil.inl, collection, ioc.v400, 000302  
#ifndef _ISSDIL_INL_
#define _ISSDIL_INL_

// ---
// IGSortedSetAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSortedSetAsDilTableCursor <Element, ElementOps>::
IGSortedSetAsDilTableCursor
  (IGSortedSetAsDilTable
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSortedSetAsDilTableCursor <Element, ElementOps>&
IGSortedSetAsDilTableCursor <Element, ElementOps>::
operator=
  (IGSortedSetAsDilTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedSetAsDilTableCursor <Element, ElementOps>::
IGSortedSetAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

#if ! defined (__INO_MNGCURSOR__)
// ---
// IGSortedSetAsDilTableMngCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGSortedSetAsDilTableMngCursor <Element, ElementOps>::
IGSortedSetAsDilTableMngCursor
  (IGSortedSetAsDilTable
    <Element, ElementOps> const& collection)
: IGSortedSetAsDilTableCursor <Element, ElementOps>
    (collection.ivImpl->CreateMngCursor ())
{
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedSetAsDilTableMngCursor <Element, ElementOps>::
IGSortedSetAsDilTableMngCursor (ICursorImpl* impl)
: IGSortedSetAsDilTableCursor <Element, ElementOps> (impl)
{
}

#endif
// ---
// IGSortedSetAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGSortedSetAsDilTable <Element, ElementOps>::
IGSortedSetAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSortedSetAsDilTable <Element, ElementOps>::
IGSortedSetAsDilTable
  (IGSortedSetAsDilTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSortedSetAsDilTable <Element, ElementOps>&
IGSortedSetAsDilTable <Element, ElementOps>::
operator= (IGSortedSetAsDilTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedSetAsDilTable <Element, ElementOps>::
IGSortedSetAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSortedSetAsDilTable
 <Element, ElementOps>::Implementation&
IGSortedSetAsDilTable <Element, ElementOps>::
ImplOf (IGSortedSetAsDilTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISortedSetAsDilTable
// ---

// public members

template <class Element>
inline
ISortedSetAsDilTable <Element>::
ISortedSetAsDilTable (INumber numberOfElements)
: IGSortedSetAsDilTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISortedSetAsDilTable <Element>::
ISortedSetAsDilTable (PureImplementation& impl)
: IGSortedSetAsDilTable
   <Element, ICOps <Element> > (impl)
{
}
#if ! defined (__INO_AVALON__)

// ---
// IVGSortedSetAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSortedSetAsDilTable <Element, ElementOps>::
IVGSortedSetAsDilTable (INumber numberOfElements)
: IGSortedSetAsDilTable
    <Element, ElementOps> (*(Implementation*) *new
#if defined (__OSTORE__)
             (os_segment::of (this),
              Instantiation::get_os_typespec ())
#endif
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSortedSetAsDilTable <Element, ElementOps>::
IVGSortedSetAsDilTable (PureImplementation& impl)
: IGSortedSetAsDilTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVSortedSetAsDilTable
// ---

// public members

template <class Element>
inline
IVSortedSetAsDilTable <Element>::
IVSortedSetAsDilTable (INumber numberOfElements)
: IVGSortedSetAsDilTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSortedSetAsDilTable <Element>::
IVSortedSetAsDilTable (PureImplementation& impl)
: IVGSortedSetAsDilTable
   <Element, ICOps <Element> > (impl)
{
}
#endif

#endif // _ISSDIL_INL_
