#ifndef _ISTACK2_C_
#define _ISTACK2_C_
/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*                                                                              *
*******************************************************************************/
#include <istack2.h>

template <class Element, class Imp>
  ITImpStack< Element, Imp>::ITImpStack( unsigned long numberOfElements)
      : fNumberOfElements(numberOfElements)
{}

template <class Element, class Imp>
  ITImpStack< Element, Imp>::~ITImpStack( )
{}

template <class Element>
  IStack< Element>::IStack( unsigned long numberOfElements )
        : ITImpStack<Element, Element>(numberOfElements)
{}

template <class Element>
  IStack< Element>::~IStack( )
{}


#ifdef IC_USE_STL_VPTR
  template <class Element>
    IVPtrStack< Element>::IVPtrStack( unsigned long numberOfElements )
          : ITImpStack<Element, void*>(numberOfElements)
  {}

  template <class Element>
    IVPtrStack< Element>::~IVPtrStack( )
  {}
#endif

#endif // _ISTACK2_C_
