/*NOSHIP*/
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 62 1.9.1.4 source/core/filesys/fsalias.hpp, filesystem, ioc.v400, 000302 
// FSAlias.h

#ifndef _FSALIAS_
#define _FSALIAS_

#include "ifilesys.hpp"

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)

class IFSAlias : public IMSTREAMABLE {
        StreamableDeclarationsMacro(IFSAlias);
public:
// Standard methods...
                                                IFSAlias( const IFileName& type, const IFileName &host,
                                                                        const IFileName& path );

                                                IFSAlias( const IFSAlias& copy );
        IFSAlias&                       operator=( const IFSAlias& copy );

        virtual                         ~IFSAlias();

// Resolution (stream-in support)

// Accessors
        IFileName                       type() const                                            { return fType; }
        IFileName                       host() const                                            { return fHost; }
        IFileName                       path() const                                            { return fPath; }

        void                            setType( const IFileName& type )        { fType = type; }
        void                            setHost( const IFileName& host )        { fHost = host; }
        void                            setPath( const IFileName& path )        { fPath = path; }

                                                IFSAlias();                                                     // For stream-in only

// Streaming...
        virtual void            writeToStream(IDataStream& towhere) const;
        virtual void            readFromStream(IDataStream& fromwhere);

private:
        IFileName       fType;
        IFileName       fHost;
        IFileName       fPath;
};

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _FSALIAS_
