// Revision: 43 1.5.1.3 source/core/filesys/fsfilrec.cpp, filesystem, ioc.v400, 000302 
//NOSHIP
// fsfilrec.cpp
//
// Contains:    IFSFileRecord
//                              Internal filesystem class that encapsulates file operations.
//
// Author:
//      Laura Werner
//
// COPYRIGHT:
//      IBM Open Class Library
//      (C) Copyright International Business Machines Corporation 1997
//      Licensed Material - Program-Property of IBM - All Rights Reserved.
//      US Government Users Restricted Rights - Use, duplication, or disclosure
//      restricted by GSA ADP Schedule Contract with IBM Corp.
//
#include <ifilesys.hpp>
#include "fsfilrec.hpp"

#ifdef IC_PAGETUNE
    #define _FSFILREC_CPP_
    #include <ipagetun.h>
#endif

//------------------------------------------------------------------------------
// Constructors, etc...
//
IFSFileRecord::IFSFileRecord()
{
}

IFSFileRecord::IFSFileRecord (const IFSFileRecord& )
{
        // Disallowed.
}

IFSFileRecord::~IFSFileRecord ()
{
}

IFSFileRecord&
IFSFileRecord::operator = (const IFSFileRecord& )
{
        // Disallowed.
        return (*this);
}


//------------------------------------------------------------------------------
// Type safety methods...
//
bool
IFSFileRecord::isA      (const IFileKind& kind) const
{
        return kind == IFile::kKind || IFSRecord::isA(kind);
}

IFileKind
IFSFileRecord::kind     () const
{
        return (IFile::kKind);
}


//------------------------------------------------------------------------------
// Volume manipulation...
//
IFileSystemEntity
IFSFileRecord::copyTo(IDirectory &to, const IFileName &newName) const
{
        // A file has no children, so we just have to copy the file itself.
        return copySelf(to, newName);
}



