#ifndef _FSSTREAM_
#define _FSSTREAM_

/*NOSHIP*/
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 66 1.6.1.5 source/core/filesys/fsstream.hpp, filesystem, ioc.v400, 000302 
// fsstream.h
//

#include "ifilesys.hpp"

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

class IFSFileStream {
public:
        virtual                         ~IFSFileStream();

// Subclasses MUST override these methods...
        virtual void            close() = 0;

        virtual ptrdiff_t       doRead  ( void *data, ptrdiff_t count ) = 0;
        virtual void            doWrite ( const void *data, ptrdiff_t count ) = 0;

    // We have to use our own seek_dir enum here, because OpenClass libraries
    // are not allowed to depend on the C++ streams library
    enum seek_dir   { beg=0, cur=1, end=2 };

        virtual IFileSize       doSeek  ( IFileSize position, seek_dir dir ) = 0;

        virtual IFileSize       endOfFile() const = 0;
        virtual void            setEndOfFile(IFileSize newSize) = 0;

protected:
// Abstract class; constructor is protected
                                                IFSFileStream();

private:
                                                IFSFileStream(const IFSFileStream &copy);
        IFSFileStream &         operator = (const IFSFileStream &copy);
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _FSSTREAM_
