/* Revision: 14 1.9.2.3 source/core/filesys/ifilemsg.h, filesystem, ioc.v400, 000302  */
//NOSHIP
// ifilemsg.h
//
// Contains:
//	Exception messages IDs for the File System Interface
//
// Author:
//	Laura Werner, Taligent Inc.
//
// COPYRIGHT:
//	IBM Open Class Library
//      (C) Copyright Taligent, Inc.,  1996
//	(C) Copyright International Business Machines Corporation 1997
//	Licensed Material - Program-Property of IBM - All Rights Reserved.
//	US Government Users Restricted Rights - Use, duplication, or disclosure
//	restricted by GSA ADP Schedule Contract with IBM Corp.
//
#ifndef _IFILEMSG_
#define _IFILEMSG_

#define kCantDeleteVolume		11L	// A file system volume cannot be deleted
#define kCantRenameVolume		12L	// A file system volume cannot be renamed
#define kEntityInvalid			13L	// The file system entity object is invalid
#define kEntityNotFound			14L	// The file system entity was not found
#define kEntityAlreadyExists	15L	// The file system entity already exists
#define kVolumeOffline			16L	// The volume is offline
#define kFileNameInvalid		17L	// The file name is invalid
#define kDirectoryNotEmpty		18L	// The directory is not empty
#define kEntityInUse			19L	// The file system entity is in use
#define kEndOfFile				20L
#define kEntityTypeMismatch		21L	// The file system entity is not the correct type
#define kFileTypeMismatch		22L	// %1 is not a file
#define kDirTypeMismatch		23L	// %1 is not a directory
#define kVolTypeMismatch		24L	// %1 is not a volume
#define kFileOperationCancelled	9L	// The file system operation was cancelled


#endif // _IFILEMSG_
