// Revision: 75 1.7.1.3 source/core/filesys/ifilesys.inl, filesystem, ioc.v400, 000302 
// ifilesys.inl
//
// Contains:
//      Inline functions for classes declared in ifilesys.hpp
//
//      Do not include this file directly! Include <ifilesys.hpp> instead.
//
// Author:
//      Laura Werner
//
// COPYRIGHT:
//      IBM Open Class Library
//      (C) Copyright International Business Machines Corporation 1997
//      Licensed Material - Program-Property of IBM - All Rights Reserved.
//
#ifndef _IFILESYS_INL_
#define _IFILESYS_INL_

//-------------------------------------------------------------------------------
// IFileSystemEntity inline functions...
//

inline bool
IFileSystemEntity::operator!= (const IFileSystemEntity& object) const
{
        return !operator==(object);
}

inline bool
IFileSystemEntity::valid () const
{
         return fRecord ? true : false;
}

inline void
IFileSystemEntity::assertValid () const
{
        if (!fRecord) invalidRecord();
}

inline IFSRecord*
IFileSystemEntity::getRecord () const
{
        assertValid();
        return (fRecord);
}

#endif // _IFILESYS_INL_
