/*NOSHIP*/
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

// Revision: 86 1.8.1.4 source/core/filesys/win32/winfile.hpp, filesystem, ioc.v400, 000302 
// NIFile.h
// Created by laura on Sat, Jan 26, 1996 @ 12:40 PM.

#ifndef _WINFILE_
#define _WINFILE_

#include "fsfilrec.hpp"

#include "winpaths.hpp"

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)

class INTFileRecord : public IFSFileRecord {
public:
// Special functions...
                                                        INTFileRecord(const INTPathName &);
        virtual                                 ~INTFileRecord();

// Comparison....
        virtual bool                            isEqual ( const IFSRecord *) const ;
        virtual bool                            testConnection() const ;

// Manipulation...
        virtual IFileSystemEntity       moveTo(IDirectory &to, const IFileName &newName);
        virtual IFileSystemEntity       copySelf(IDirectory &to, const IFileName &newName) const;
        virtual void                            doDeleteSelf () ;

// Navigation...
        virtual IDirectory                      parent() const ;
        virtual IDirectory                      topmostParent() const ;
        virtual IVolume                         volume () const ;

// Access  properties...
        // TFileSystemEntity properties...
        virtual IFileName                       name() const ;
        virtual void                            setName(const IFileName& newName);
        virtual IHostPathName           hostPath() const ;

        virtual ITimeStamp                      modificationTime() const ;
        virtual void                            setModificationTime(const ITimeStamp& modificationTime);

        // TFile properties...
        virtual IFileSize                       size() const;
        virtual void                            setSize (IFileSize newSize);

// Streaming...
        virtual IFSFileStream*          createStream(int myMode, int otherMode) const;

private:
// Disallowed functions
                                                                INTFileRecord(const INTFileRecord &copy);
        INTFileRecord &                         operator = (const INTFileRecord &copy);

// Private data
        INTPathName                                     fPath;
};

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _WINFILE_
