/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 64 1.9.1.4 source/core/streams/imstrmbf.hpp, oss, ioc.v400, 000302 
//
//
//
// imstrmbf.hpp
//
#ifndef _IMSTRMBF_
#define _IMSTRMBF_

#include <istrmbf.hpp>

#ifdef __MWERKS__
#include <sstream.h>
#endif

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)

//
// IMemoryStreamBuffer
//
class IMemoryStreamBuffer : public IStreamBuffer
{
public:
        IMemoryStreamBuffer();
        virtual ~IMemoryStreamBuffer();

        IDataStream*    createWithStreamEncoding(int encoding);

        virtual void    writeBytes(const char*  data, unsigned long length);
        virtual void    readBytes(char* data, unsigned long length);

        virtual void    reset();
        virtual void    flush();

private:
        IMemoryStreamBuffer(const IMemoryStreamBuffer& other);
        IMemoryStreamBuffer& operator=(const IMemoryStreamBuffer& other);

#ifdef __MWERKS__
        stringbuf       fBuffer;
#else
        char*   fBuffer;
        char*   fPointer;
        char*   fEndPointer;
#endif
};

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IMSTRMBF_
