/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 72 1.8.1.3 source/core/streams/istrmcf.cpp, oss, ioc.v400, 000302 
//
//
//
// istrmcf.cpp
//
#include <istrmcf.hpp>
#include <idatstrm.hpp>
#include <istrmio.hpp>

#ifdef IC_PAGETUNE
    #define _ISTRMCF_CPP_
    #include <ipagetun.h>
#endif

IStreamContextFrame::IStreamContextFrame(IDataStream& dataStream)
        :       fStreamIO(dataStream.streamIO()),
                fSetContext(false)
{
        fSetContext = fStreamIO->establishContext();
}

IStreamContextFrame::~IStreamContextFrame()
{
        if (fSetContext)
                fStreamIO->clearContext();
}

IStreamContextFrame::IStreamContextFrame()
        :       fStreamIO(0),
                fSetContext(false)
{
}

IStreamContextFrame::IStreamContextFrame(const IStreamContextFrame& other)
        :       fStreamIO(0),
                fSetContext(false)
{
}

IStreamContextFrame&
IStreamContextFrame::operator=(const IStreamContextFrame& other)
{
        return *this;
}
