/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 76 1.8.1.3 source/core/streams/istrmfct.cpp, oss, ioc.v400, 000302 
//
//
//
// istrmfct.cpp
//
#include <istrmfct.hpp>
#include <idatstrm.hpp>
#include "ibinstio.hpp"
#include "icntstio.hpp"
#include "idbgstio.hpp"
#include "imstrmbf.hpp"

#include <iexcbase.hpp>
#include "strmexc.h"

#include <iostream.h>

#ifdef IC_PAGETUNE
    #define _ISTRMFCT_CPP_
    #include <ipagetun.h>
#endif

IStreamFactory::IStreamFactory()
{
}

IStreamFactory::~IStreamFactory()
{
}

IStreamFactory::IStreamFactory(const IStreamFactory& other)
{
}

IDataStream*    IStreamFactory::createWithStreamIO(IStreamIO* streamIO)
{
        return new IDataStream(streamIO);
}

IDataStream*    IStreamFactory::createWithStreamEncoding(int encoding, IStreamBuffer* streamBuffer)
{
        IStreamIO* streamIO = 0;

        switch (encoding) {
                case IDataStream::kInteroperableBinary:
                        streamIO = new ICountedStreamIO(streamBuffer);
                        break;
                case IDataStream::kRawBinary:
                        streamIO = new IBinaryStreamIO(streamBuffer);
                        break;
                case IDataStream::kDebug:
                        streamIO = new IDebugStreamIO(streamBuffer);
                        break;
                default:
                        IInvalidParameter exc(IMessageText(kInvalidEncoding, kMsgFileName));
                        ITHROW(exc);
        }
        return new IDataStream(streamIO);
}
