/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 88 1.9.1.3 source/core/streams/ityperep.cpp, oss, ioc.v400, 000302 
//
//
//
// ityperep.cpp
//
#include <ityperep.hpp>
#include <istrmmod.hpp>
#include <imstrmbl.hpp>

#ifdef IC_PAGETUNE
    #define _ITYPEREP_CPP_
    #include <ipagetun.h>
#endif

//
// ITypeRepresentation
//
ITypeRepresentation::ITypeRepresentation(IStreamableFactory* streamableFactory)
        :       fFactory(streamableFactory)
        ,       fNextTypeRep(0)
{
}

ITypeRepresentation::ITypeRepresentation()
        :       fFactory(0)
        ,       fNextTypeRep(0)
{
        // should never be called...
}

ITypeRepresentation::ITypeRepresentation(const ITypeRepresentation& other)
        :       fFactory(0)
        ,       fNextTypeRep(0)
{
        // should never be called...
}

ITypeRepresentation::~ITypeRepresentation()
{
        // should never be called...
}

ITypeRepresentation&
ITypeRepresentation::operator=(const ITypeRepresentation& other)
{
        // should never be called...
        return *this;
}

const char*
ITypeRepresentation::name() const
{
        return fFactory->name();
}

const ITypeName&
ITypeRepresentation::typeName() const
{
        return fFactory->typeName();
}

const IStreamableFactory&
ITypeRepresentation::streamableFactory() const
{
        return *fFactory;
}

const ITypeRepresentation*
ITypeRepresentation::nextTypeInModule() const
{
        return fNextTypeRep;
}

void
ITypeRepresentation::setNext(const ITypeRepresentation* typeRep)
{
        fNextTypeRep = typeRep;
}

const ITypeRepresentation*
ITypeRepresentation::findTypeWithName(const ITypeName& typeName)
{
        return IStreamModule::findTypeWithName(typeName);
}

void
ITypeRepresentation::makeConst() const
{
        fFactory->typeName();
}
