// Revision: 10 1.8.1.4 source/core/testfw/istrwrap.hpp, testfw, ioc.v400, 000302 
#ifndef _ISTRWRAP_
#define _ISTRWRAP_
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

#include <istring.hpp>
#include <iprimtyp.hpp>
#include <itfwpl.hpp>           // pragma library definitions

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

// IStringWrapper is used to store value(IString) and key(IString) in
// key collection classes.
class IStringWrapper
{
        public:
           IStringWrapper();
                 IStringWrapper(const IString& keystr, const IString& valuestr);
           ~IStringWrapper();
           IStringWrapper(const IStringWrapper& other);
           IStringWrapper& operator=(IStringWrapper const& other);

           IString const& getkey() const;
           IString const& value() const;
           bool operator==(IStringWrapper const&) const;
     bool operator<(IStringWrapper const&) const;

        private:
                IString fKey;
                IString fValue;
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

// key access function should be in global space.
IString const& key(IStringWrapper const& ism);

#endif // _ISTRWRAP_

