// Revision: 87 1.5.1.5 source/core/testfw/win32/ismpclck.cpp, testfw, ioc.v400, 000302 
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/

#include <ismpclck.hpp>

#include <math.h>

#include <wtypes.h>
#include <winbase.h>

// Segment definitions
#ifdef IC_PAGETUNE
    #define _ISMPCLCK_CPP_
    #include <ipagetun.h>
#endif

static int gFreqInit = 0;

void  ISimpleClock::timeNow(double& time)
{
        static double gFrequency;

        if (gFreqInit == 0)
        {
                gFreqInit = 1;
                LARGE_INTEGER freq;
                QueryPerformanceFrequency(&freq);
                gFrequency = conversionToDouble (freq.u.HighPart, freq.u.LowPart);
        }

        LARGE_INTEGER t;
        QueryPerformanceCounter(&t);

        time = (conversionToDouble(t.u.HighPart, t.u.LowPart) / gFrequency) * 1000000;

}

double ISimpleClock::conversionToDouble(unsigned long high, unsigned long low)
{
        double Sum = (double)low;

        for (int I = 0; I<=30; I++)
        {
                unsigned long AndOp = pow((double)2,(double)I);
                unsigned long TempSum = high & AndOp;
                TempSum = TempSum >> I;
                Sum = Sum + TempSum * pow((double)2, (double)(32+I));
        }
        return Sum;
}
