/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*       (C) Copyright International Business Machines Corporation, 1997                 *
*       Licensed Material - Program-Property of IBM - All Rights Reserved.              *
*       US Government Users Restricted Rights - Use, duplication, or disclosure         *
*       restricted by GSA ADP Schedule Contract with IBM Corp.                          *
*                                                                                       *
*****************************************************************************************
*
* File CHBKDAT.CPP
*
* Modification History:
*
*       Date            Name            Description
*       02/18/97        aliu            Converted from OpenClass.
*                                                       Recoded kRawMapping table for Unicode::getType() type codes.
*                                                       Made static data members const where appropriate.
*       03/25/97        aliu            Moved into ITextBoundaryData; no longer a subclass.
*****************************************************************************************
*/

// *****************************************************************************
// This file was generated from the java source file CharacterBreakData.java
// *****************************************************************************

#include <itxtbdat.hpp>
#include <iwdbktbl.hpp>
#include <iunicdcm.hpp>
#include <iugnrl.hpp>

#ifdef IC_PAGETUNE
        #define _ICHBKDAT_CPP
        #include <ipagetun.h>
#endif

// *****************************************************************************
// class CharacterBreakData
// *****************************************************************************

const ITextBoundaryData::Node ITextBoundaryData::kCharacterForwardData[] = {
    // acct         base                        cr                              lf
        kStop,          kStop,                  kStop,                  kStop,
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+2),
        (ITextBoundaryData::Node)(kSI+2),  kSI_Stop,            kSI_Stop,               kSI_Stop,
        (ITextBoundaryData::Node)(kSI+2),  kSI_Stop,            kSI_Stop,               (ITextBoundaryData::Node)(kSI+2)
};

const int ITextBoundaryData::kCharacterForwardData_length =
        sizeof(ITextBoundaryData::kCharacterForwardData) / sizeof(ITextBoundaryData::kCharacterForwardData[0]);

IWordBreakTable* ITextBoundaryData::kCharacterForward = new IWordBreakTable(kCharacterCol_count, kCharacterForwardData, kCharacterForwardData_length);

const ITextBoundaryData::Node ITextBoundaryData::kCharacterBackwardData[] = {
    // acct         base                        cr                              lf
        kStop,          kStop,                  kStop,                  kStop,
        (ITextBoundaryData::Node)(kSI+1),  kSI_Stop,            kSI_Stop,               (ITextBoundaryData::Node)(kSI+1)
};

const int ITextBoundaryData::kCharacterBackwardData_length =
        sizeof(ITextBoundaryData::kCharacterBackwardData) / sizeof(ITextBoundaryData::kCharacterBackwardData[0]);

IWordBreakTable* ITextBoundaryData::kCharacterBackward = new IWordBreakTable(kCharacterCol_count, kCharacterBackwardData, kCharacterBackwardData_length);

const ITextBoundaryData::Type ITextBoundaryData::kCharacterRawMapping[] = {
        // Re-coded to match Unicode 2 types [LIU]
        kBaseForm,                      // kNonCharacter                        = 0,
        kBaseForm,                      // kUppercaseLetter                     = 1,
        kBaseForm,                      // kLowercaseLetter                     = 2,
        kBaseForm,                      // kTitlecaseLetter                     = 3,
        kBaseForm,                      // kModifierLetter                      = 4,
        kAccent_diacritic,      // kOtherLetter                         = 5,
        kAccent_diacritic,      // kNonSpacingMark                      = 6,
        kBaseForm,                      // kEnclosingMark                       = 7,
        kBaseForm,                      // kCombiningSpacingMark        = 8,
        kBaseForm,                      // kDecimalNumber                       = 9,
        kBaseForm,                      // kLetterNumber                        = 10,
        kBaseForm,                      // kOtherNumber                         = 11,
        kBaseForm,                      // kSpaceSeparator                      = 12,
        kBaseForm,                      // kLineSeparator                       = 13,
        kBaseForm,                      // kParagraphSeparator          = 14,
        kBaseForm,                      // kControlCharacter            = 15,
        kBaseForm,                      // kFormatCharacter                     = 16,
        kBaseForm,                      // kPrivateUseCharacter         = 17,
        kBaseForm,                      // kSurrogate                           = 18,
        kBaseForm,                      // kDashPunctuation                     = 19,
        kBaseForm,                      // kOpenPunctuation                     = 20,
        kBaseForm,                      // kClosePunctuation            = 21,
        kBaseForm,                      // kConnectorPunctuation        = 22,
        kBaseForm,                      // kOtherPunctuation            = 23,
        kBaseForm,                      // kMathSymbol                          = 24,
        kBaseForm,                      // kCurrencySymbol                      = 25,
        kBaseForm,                      // kModifierSymbol                      = 26,
        kBaseForm,                      // kOtherSymbol                         = 27,
        kBaseForm                       // UNDEFINED                            = 28
};

const int ITextBoundaryData::kCharacterRawMapping_length =
        sizeof(ITextBoundaryData::kCharacterRawMapping) / sizeof(ITextBoundaryData::kCharacterRawMapping[0]);

const ISpecialMapping ITextBoundaryData::kCharacterExceptionChar[] = {
        ISpecialMapping(UASCII::kLineFeed, kBaseLF),
        ISpecialMapping(UASCII::kCarriageReturn, kBaseCR)
};

const int ITextBoundaryData::kCharacterExceptionChar_length =
        sizeof(ITextBoundaryData::kCharacterExceptionChar) / sizeof(ITextBoundaryData::kCharacterExceptionChar[0]);

const bool ITextBoundaryData::kCharacterExceptionFlags[] = {
        false,                  // kNonCharacter                        = 0,
        false,                  // kUppercaseLetter                     = 1,
        false,                  // kLowercaseLetter                     = 2,
        false,                  // kTitlecaseLetter                     = 3,
        false,                  // kModifierLetter                      = 4,
        false,                  // kOtherLetter                         = 5,
        false,                  // kNonSpacingMark                      = 6,
        false,                  // kEnclosingMark                       = 7,
        false,                  // kCombiningSpacingMark        = 8,
        false,                  // kDecimalNumber                       = 9,
        false,                  // kLetterNumber                        = 10,
        false,                  // kOtherNumber                         = 11,
        false,                  // kSpaceSeparator                      = 12,
        false,                  // kLineSeparator                       = 13,
        false,                  // kParagraphSeparator          = 14,
        true,                   // kControlCharacter            = 15,
        false,                  // kFormatCharacter                     = 16,
        false,                  // kPrivateUseCharacter         = 17,
        false,                  // kSurrogate                           = 18,
        false,                  // kDashPunctuation                     = 19,
        false,                  // kOpenPunctuation                     = 20,
        false,                  // kClosePunctuation            = 21,
        false,                  // kConnectorPunctuation        = 22,
        false,                  // kOtherPunctuation            = 23,
        false,                  // kMathSymbol                          = 24,
        false,                  // kCurrencySymbol                      = 25,
        false,                  // kModifierSymbol                      = 26,
        false,                  // kOtherSymbol                         = 27,
        false                   // UNDEFINED                            = 28
};

IUnicodeClassMapping* ITextBoundaryData::kCharacterMap =
        new IUnicodeClassMapping(kCharacterRawMapping, kCharacterRawMapping_length,
                        kCharacterExceptionChar, kCharacterExceptionChar_length, kCharacterExceptionFlags);

/**
 * This is the single instance of ITextBoundaryData containing character
 * break data.
 */
const ITextBoundaryData ITextBoundaryData::kCharacterBreakData(ITextBoundaryData::kCharacterForward,
                                                                                                                         ITextBoundaryData::kCharacterBackward,
                                                                                                                         ITextBoundaryData::kCharacterMap);

//eof
