/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*       (C) Copyright International Business Machines Corporation 1997                  *
*       Licensed Material - Program-Property of IBM - All Rights Reserved.              *
*       US Government Users Restricted Rights - Use, duplication, or disclosure         *
*       restricted by GSA ADP Schedule Contract with IBM Corp.                          *
*                                                                                       *
*****************************************************************************************
*
* File LNBKDAT.CPP
*
* Modification History:
*
*       Date            Name            Description
*       02/18/97        aliu            Converted from OpenClass.
*                                                       Recoded kRawMapping table for Unicode::getType() type codes.
*                                                       Made static data members const where appropriate.
*       03/25/97        aliu            Moved into ITextBoundaryData; no longer a subclass.
*****************************************************************************************
*/

// *****************************************************************************
// This file was generated from the java source file LineBreakData.java
// *****************************************************************************

#include <itxtbdat.hpp>
#include <iwdbktbl.hpp>
#include <iunicdcm.hpp>
#include <iugnrl.hpp>
#include <iumeast.hpp>
#include <iueasia.hpp>
#include <iucmpbty.hpp>

#ifdef IC_PAGETUNE
        #define _ILNBKDAT_CPP
        #include <ipagetun.h>
#endif

// *****************************************************************************
// class LineBreakData
// *****************************************************************************

const ITextBoundaryData::Node ITextBoundaryData::kLineForwardData[] =
{
    // brk          bl              cr              nBl
    // op           nmi             kat             smK
    // sKT          cho             hir             smH
    // sHT          hDi             dia             kan
    // kDi          prJ             poJ
    /*00*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,
    /*01*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  (ITextBoundaryData::Node)(kSI+3),
        (ITextBoundaryData::Node)(kSI+17), (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+5),  (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+7),
        (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+3),
    /*02*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,
    /*03*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  (ITextBoundaryData::Node)(kSI+3),
        (ITextBoundaryData::Node)(kSI+17), (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+3),
    /*04*/
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,
    /*05*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       (ITextBoundaryData::Node)(kSI+12),
        (ITextBoundaryData::Node)(kSI+11), (ITextBoundaryData::Node)(kSI+13), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+12), kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),
    /*06*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+15),
        (ITextBoundaryData::Node)(kSI+14), (ITextBoundaryData::Node)(kSI+16), (ITextBoundaryData::Node)(kSI+15), kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),
    /*07*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        (ITextBoundaryData::Node)(kSI+7),  kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),
    /*08*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  (ITextBoundaryData::Node)(kSI+3),
        (ITextBoundaryData::Node)(kSI+17), (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+5),  (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+7),
        (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+3),
    /*09*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),
    /*10*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  (ITextBoundaryData::Node)(kSI+3),
        (ITextBoundaryData::Node)(kSI+17), (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+5),  (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+7),
        (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+3),
    /*11*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+5),  kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),
    /*12*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       (ITextBoundaryData::Node)(kSI+12),
        (ITextBoundaryData::Node)(kSI+11), (ITextBoundaryData::Node)(kSI+13), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),
    /*13*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       kSI_Stop,
        (ITextBoundaryData::Node)(kSI+11), kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),
    /*14*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+6),  kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),
    /*15*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+15),
        (ITextBoundaryData::Node)(kSI+14), (ITextBoundaryData::Node)(kSI+16), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),
    /*16*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        (ITextBoundaryData::Node)(kSI+14), (ITextBoundaryData::Node)(kSI+16), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),
    /*17*/
        (ITextBoundaryData::Node)(kSI+4), kSI_Stop,       (ITextBoundaryData::Node)(kSI+18),  kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,
    /*18*/
        (ITextBoundaryData::Node)(kSI+4),       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,
};

const int ITextBoundaryData::kLineForwardData_length =
        sizeof(ITextBoundaryData::kLineForwardData) / sizeof(ITextBoundaryData::kLineForwardData[0]);

IWordBreakTable* ITextBoundaryData::kLineForward =
        new IWordBreakTable(kLineCol_count, kLineForwardData, kLineForwardData_length);

const ITextBoundaryData::Node ITextBoundaryData::kLineBackwardData[] =
{
    // brk          bl              cr              nBl
    // op           nmi             kat             smK
    // sKT          cho             hir             smH
    // sHT          hDi             dia             kan
    // kDi          prJ             poJ
    /*00*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,
    /*01*/
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+3),
        (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+16), (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+17), (ITextBoundaryData::Node)(kSI+11),
        (ITextBoundaryData::Node)(kSI+12), (ITextBoundaryData::Node)(kSI+12), (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+7),
        (ITextBoundaryData::Node)(kSI+13), (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+5),
    /*02*/
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  kStop,          (ITextBoundaryData::Node)(kSI+3),
        (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+16), (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+17), (ITextBoundaryData::Node)(kSI+11),
        (ITextBoundaryData::Node)(kSI+12), (ITextBoundaryData::Node)(kSI+12), (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+7),
        (ITextBoundaryData::Node)(kSI+13), (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+5),
    /*03*/
        kStop,          kStop,          kStop,          (ITextBoundaryData::Node)(kSI+3),
        kStop,          (ITextBoundaryData::Node)(kSI+6),  kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+5),
    /*04*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,
    /*05*/
        kStop,          kStop,          kStop,          (ITextBoundaryData::Node)(kSI+3),
        kStop,          (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+16), (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+17), (ITextBoundaryData::Node)(kSI+11),
        (ITextBoundaryData::Node)(kSI+12), (ITextBoundaryData::Node)(kSI+12), (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+7),
        (ITextBoundaryData::Node)(kSI+13), (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+5),
    /*06*/
        (ITextBoundaryData::Node)(kSI+4),  kStop,          kStop,          (ITextBoundaryData::Node)(kSI+3),
        (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+16), (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+17), (ITextBoundaryData::Node)(kSI+11),
        (ITextBoundaryData::Node)(kSI+12), (ITextBoundaryData::Node)(kSI+12), (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+7),
        (ITextBoundaryData::Node)(kSI+13), (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+5),
    /*07*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,
    /*08*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+16), kStop,
        kStop,          kStop,          (ITextBoundaryData::Node)(kSI+17), kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,
    /*09*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+16), (ITextBoundaryData::Node)(9),
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          (ITextBoundaryData::Node)(14),     kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,
    /*10*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+16), (ITextBoundaryData::Node)(9),
        kStop,          (ITextBoundaryData::Node)(9),      kStop,          kStop,
        kStop,          kStop,          (ITextBoundaryData::Node)(14),     kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,
    /*11*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  kStop,          kStop,
        kStop,          kStop,          (ITextBoundaryData::Node)(kSI+17), (ITextBoundaryData::Node)(11),
        kStop,          kStop,          (ITextBoundaryData::Node)(15),     kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,
    /*12*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  kStop,          kStop,
        kStop,          kStop,          (ITextBoundaryData::Node)(kSI+17), (ITextBoundaryData::Node)(11),
        kStop,          (ITextBoundaryData::Node)(12),     (ITextBoundaryData::Node)(15),     kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,
    /*13*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          (ITextBoundaryData::Node)(kSI+7),
        (ITextBoundaryData::Node)(13),     (ITextBoundaryData::Node)(kSI+3),  kStop,
    /*14*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+16), kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,
    /*15*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  kStop,          kStop,
        kStop,          kStop,          (ITextBoundaryData::Node)(kSI+17), kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,
    /*16*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  kStop,          kStop,
        (ITextBoundaryData::Node)(10),     kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,
    /*17*/
        kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+6),  kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        (ITextBoundaryData::Node)(12),     kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop
};

const int ITextBoundaryData::kLineBackwardData_length =
        sizeof(ITextBoundaryData::kLineBackwardData) / sizeof(ITextBoundaryData::kLineBackwardData[0]);

IWordBreakTable* ITextBoundaryData::kLineBackward =
        new IWordBreakTable(kLineCol_count, kLineBackwardData, kLineBackwardData_length);

const ITextBoundaryData::Type ITextBoundaryData::kLineRawMapping[] = {
        // Re-coded to match Unicode 2 types [LIU]
        kLineNonBlank,  // kNonCharacter                        = 0,
        kLineNonBlank,  // kUppercaseLetter                     = 1,
        kLineNonBlank,  // kLowercaseLetter                     = 2,
        kLineNonBlank,  // kTitlecaseLetter                     = 3,
        kLineNonBlank,  // kModifierLetter                      = 4,
        kLineNonBlank,  // kOtherLetter                         = 5,
        kLineNonBlank,  // kNonSpacingMark                      = 6,
        kLineNonBlank,  // kEnclosingMark                       = 7,
        kLineNonBlank,  // kCombiningSpacingMark        = 8,
        kLineNonBlank,  // kDecimalNumber                       = 9,
        kLineNonBlank,  // kLetterNumber                        = 10,
        kLineNonBlank,  // kOtherNumber                         = 11,
        kLineBlank,             // kSpaceSeparator                      = 12,
        kLineBlank,             // kLineSeparator                       = 13,
        kLineBlank,             // kParagraphSeparator          = 14,
        kLineBlank,             // kControlCharacter            = 15,
        kLineNonBlank,  // kFormatCharacter                     = 16,
        kLineNonBlank,  // kPrivateUseCharacter         = 17,
        kLineNonBlank,  // kSurrogate                           = 18,
        kLineOp,                // kDashPunctuation                     = 19,
        kLinePreJwrd,   // kOpenPunctuation                     = 20,
        kLinePostJwrd,  // kClosePunctuation            = 21,
        kLineNonBlank,  // kConnectorPunctuation        = 22,
        kLineNonBlank,  // kOtherPunctuation            = 23,
        kLineNonBlank,  // kMathSymbol                          = 24,
        kLineNonBlank,  // kCurrencySymbol                      = 25,
        kLineNonBlank,  // kModifierSymbol                      = 26,
        kLineNonBlank,  // kOtherSymbol                         = 27,
        kLineNonBlank   // UNDEFINED                            = 28
};

const int ITextBoundaryData::kLineRawMapping_length =
        sizeof(ITextBoundaryData::kLineRawMapping)/sizeof(ITextBoundaryData::kLineRawMapping[0]);

const ISpecialMapping ITextBoundaryData::kLineExceptionChar[] = {
        ISpecialMapping(UASCII::kEndOfText, kLineBreak),
        ISpecialMapping(UASCII::kHorizontalTabulation, UASCII::kFormFeed, kLineBreak),
        ISpecialMapping(UASCII::kCarriageReturn, kLineCR),
        ISpecialMapping(UASCII::kExclamationMark, kLinePostJwrd),
        ISpecialMapping(UASCII::kPercentSign, kLinePostJwrd),
        ISpecialMapping(UASCII::kComma, kLinePostJwrd),
        ISpecialMapping(UASCII::kFullStop, kLinePostJwrd),
        ISpecialMapping(UASCII::kColon, UASCII::kSemicolon, kLinePostJwrd),
        ISpecialMapping(UASCII::kQuestionMark, kLinePostJwrd),
        ISpecialMapping(ULatin1::kSoftHyphen, kLineNonBlank),
        ISpecialMapping(UArabic::kPercentSign, kLinePostJwrd),
        ISpecialMapping(UGeneralPunctuation::kLineSeparator, UGeneralPunctuation::kParagraphSeparator, kLineBreak),
        ISpecialMapping(UGeneralPunctuation::kIdeographicFullStop, kLinePostJwrd),
        ISpecialMapping(UGeneralPunctuation::kPerMilleSign, kLinePostJwrd),
        ISpecialMapping(UGeneralPunctuation::kPerTenThousandSign, kLinePostJwrd),
        ISpecialMapping(UHiragana::kLetterSmallA, UHiragana::kLetterVu, kLineHira),
        ISpecialMapping(UHiragana::kCombiningVoicedSoundMark, UHiragana::kSemiVoicedSoundMark, kLineDiacrit),
        ISpecialMapping(UKatakana::kLetterSmallA, UKatakana::kLetterSmallKe, kLineKata),
        ISpecialMapping(IUnicode::kLowBoundHan, IUnicode::kHighBoundHan, kLineKanji),
        ISpecialMapping(UCJKCompatibility::kF900, UCJKCompatibility::kFA2D, kLineKanji),
};

const int ITextBoundaryData::kLineExceptionChar_length =
        sizeof(ITextBoundaryData::kLineExceptionChar)/sizeof(ITextBoundaryData::kLineExceptionChar[0]);

const bool ITextBoundaryData::kLineExceptionFlags[] = {
        false,                  // kNonCharacter                        = 0,
        false,                  // kUppercaseLetter                     = 1,
        false,                  // kLowercaseLetter                     = 2,
        false,                  // kTitlecaseLetter                     = 3,
        false,                  // kModifierLetter                      = 4,
        true,                   // kOtherLetter                         = 5,
        true,                   // kNonSpacingMark                      = 6,
        false,                  // kEnclosingMark                       = 7,
        false,                  // kCombiningSpacingMark        = 8,
        false,                  // kDecimalNumber                       = 9,
        false,                  // kLetterNumber                        = 10,
        false,                  // kOtherNumber                         = 11,
        false,                  // kSpaceSeparator                      = 12,
        true,                   // kLineSeparator                       = 13,
        true,                   // kParagraphSeparator          = 14,
        true,                   // kControlCharacter            = 15,
        false,                  // kFormatCharacter                     = 16,
        false,                  // kPrivateUseCharacter         = 17,
        false,                  // kSurrogate                           = 18,
        true,                   // kDashPunctuation                     = 19,
        false,                  // kOpenPunctuation                     = 20,
        false,                  // kClosePunctuation            = 21,
        false,                  // kConnectorPunctuation        = 22,
        true,                   // kOtherPunctuation            = 23,
        false,                  // kMathSymbol                          = 24,
        false,                  // kCurrencySymbol                      = 25,
        false,                  // kModifierSymbol                      = 26,
        false,                  // kOtherSymbol                         = 27,
        false                   // UNDEFINED                            = 28
};

IUnicodeClassMapping* ITextBoundaryData::kLineMap = new IUnicodeClassMapping(kLineRawMapping, kLineRawMapping_length, kLineExceptionChar, kLineExceptionChar_length, kLineExceptionFlags);

/**
 * This is the single instance of ITextBoundaryData containing line
 * break data.
 */
const ITextBoundaryData ITextBoundaryData::kLineBreakData(ITextBoundaryData::kLineForward,
                                                                                                                ITextBoundaryData::kLineBackward,
                                                                                                                ITextBoundaryData::kLineMap);

//eof
