/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*       (C) Copyright International Business Machines Corporation 1997                  *
*       Licensed Material - Program-Property of IBM - All Rights Reserved.              *
*       US Government Users Restricted Rights - Use, duplication, or disclosure         *
*       restricted by GSA ADP Schedule Contract with IBM Corp.                          *
*                                                                                       *
*****************************************************************************************
*
* File SNBKDAT.CPP
*
* Modification History:
*
*       Date            Name            Description
*       02/18/97        aliu            Converted from OpenClass.
*                                                       Recoded kRawMapping table for Unicode::getType() type codes.
*                                                       Made static data members const where appropriate.
*       03/25/97        aliu            Moved into ITextBoundaryData; no longer a subclass.
*****************************************************************************************
*/

// *****************************************************************************
// This file was generated from the java source file SentenceBreakData.java
// *****************************************************************************

#include <itxtbdat.hpp>
#include <iwdbktbl.hpp>
#include <iunicdcm.hpp>
#include <iugnrl.hpp>
#include <iueasia.hpp>
#include <iucmpbty.hpp>

#ifdef IC_PAGETUNE
        #define _ISNBKDAT_CPP
        #include <ipagetun.h>
#endif

// *****************************************************************************
// class SentenceBreakData
// *****************************************************************************

const ITextBoundaryData::Node ITextBoundaryData::kSentenceForwardData[] = {
    // other        space           terminator      ambTerm
    // open         close           CJK             PB
    // lower        upper           digit           Quote
        // cr

        // 0
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,

        // 1
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+5),
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+4),
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+1),
        (ITextBoundaryData::Node)(kSI+10),

        // 2
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+5),
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+2),  kSI_Stop,       (ITextBoundaryData::Node)(kSI+4),
        kSI_Stop,       kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+2),
        (ITextBoundaryData::Node)(kSI+10),

        // 3
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),  kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+4),
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        (ITextBoundaryData::Node)(kSI+10),

        // 4
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,

        // 5
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+5),
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+5),  kSI_Stop,       (ITextBoundaryData::Node)(kSI+4),
        (ITextBoundaryData::Node)(kSI+1),  kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+5),
        (ITextBoundaryData::Node)(kSI+10),

        // 6
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+6),  kSI_Stop,       kSI_Stop,
        (ITextBoundaryData::Node)(kSI+7),  (ITextBoundaryData::Node)(kSI+1),  kSI_Stop,       (ITextBoundaryData::Node)(kSI+4),
        (ITextBoundaryData::Node)(kSI+1),  kSI_Stop,       (ITextBoundaryData::Node)(kSI+1),  kSI_Stop,
        (ITextBoundaryData::Node)(kSI+10),

        // 7
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        (ITextBoundaryData::Node)(7),      kSI_Stop,       kSI_Stop,       kSI_Stop,
        (ITextBoundaryData::Node)(kSI+1),  kStop,          kSI_Stop,       kSI_Stop,
        kSI_Stop,

        // 8
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+8),
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+5),  kSI_Stop,       (ITextBoundaryData::Node)(kSI+4),
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+5),
        (ITextBoundaryData::Node)(kSI+10),

        // 9
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+5),  kSI_Stop,       (ITextBoundaryData::Node)(kSI+4),
        (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+1),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+5),
        (ITextBoundaryData::Node)(kSI+10),

        // 10
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+4),
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop
};

const int ITextBoundaryData::kSentenceForwardData_length =
        sizeof(ITextBoundaryData::kSentenceForwardData) / sizeof(ITextBoundaryData::kSentenceForwardData[0]);

IWordBreakTable* ITextBoundaryData::kSentenceForward = new IWordBreakTable(kSentenceCol_count_forward, kSentenceForwardData, kSentenceForwardData_length);

const ITextBoundaryData::Node ITextBoundaryData::kSentenceBackwardData[] = {
    // other        space           terminator      ambTerm
    // open         close           CJK             PB
    // lower        upper           digit                       quote
        // cr

        // 0
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,                  kStop,
        kStop,

        // 1
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  kStop,
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),
        (ITextBoundaryData::Node)(kSI+2),

        // 2
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  kStop,
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),
        kStop,

        // 3
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  kStop,
        (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),
        kStop,

        // 4
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+4),  kSI_Stop,       kSI_Stop,
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  kStop,
        (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+2),
        kStop
};

const int ITextBoundaryData::kSentenceBackwardData_length =
        sizeof(ITextBoundaryData::kSentenceBackwardData) / sizeof(ITextBoundaryData::kSentenceBackwardData[0]);

IWordBreakTable* ITextBoundaryData::kSentenceBackward = new IWordBreakTable(kSentenceCol_count_backward, kSentenceBackwardData, kSentenceBackwardData_length);

const ITextBoundaryData::Type ITextBoundaryData::kSentenceRawMapping[] = {
        // Re-coded to match Unicode 2 types [LIU]
        kOther,                 // kNonCharacter                        = 0,
        kUpperCase,             // kUppercaseLetter                     = 1,
        kLowerCase,             // kLowercaseLetter                     = 2,
        kOther,                 // kTitlecaseLetter                     = 3,
        kOther,                 // kModifierLetter                      = 4,
        kOther,                 // kOtherLetter                         = 5,
        kOther,                 // kNonSpacingMark                      = 6,
        kOther,                 // kEnclosingMark                       = 7,
        kOther,                 // kCombiningSpacingMark        = 8,
        kSNumber,               // kDecimalNumber                       = 9,
        kSNumber,               // kLetterNumber                        = 10,
        kSNumber,               // kOtherNumber                         = 11,
        kSpace,                 // kSpaceSeparator                      = 12,
        kSpace,                 // kLineSeparator                       = 13,
        kSpace,                 // kParagraphSeparator          = 14,
        kOther,                 // kControlCharacter            = 15,
        kOther,                 // kFormatCharacter                     = 16,
        kOther,                 // kPrivateUseCharacter         = 17,
        kOther,                 // kSurrogate                           = 18,
        kOther,                 // kDashPunctuation                     = 19,
        kOpenBracket,   // kOpenPunctuation                     = 20,
        kCloseBracket,  // kClosePunctuation            = 21,
        kOther,                 // kConnectorPunctuation        = 22,
        kOther,                 // kOtherPunctuation            = 23,
        kOther,                 // kMathSymbol                          = 24,
        kOther,                 // kCurrencySymbol                      = 25,
        kOther,                 // kModifierSymbol                      = 26,
        kOther,                 // kOtherSymbol                         = 27,
        kOther                  // UNDEFINED                            = 28
};

const int ITextBoundaryData::kSentenceRawMapping_length =
        sizeof(ITextBoundaryData::kSentenceRawMapping) / sizeof(ITextBoundaryData::kSentenceRawMapping[0]);

const ISpecialMapping ITextBoundaryData::kSentenceExceptionChar[] = {
        ISpecialMapping(UASCII::kHorizontalTabulation, kSpace),
        ISpecialMapping(UASCII::kLineFeed, kParagraphBreak),
        ISpecialMapping(UASCII::kFormFeed, kTerminator),
        ISpecialMapping(UASCII::kCarriageReturn, kSentCR),
        ISpecialMapping(UASCII::kExclamationMark, kTerminator),
        ISpecialMapping(UASCII::kQuotationMark, kQuote),

        ISpecialMapping(UASCII::kApostrophe, kQuote),   //{jf} - added 11/19 to handle single quoted text.

        ISpecialMapping(UASCII::kFullStop, kAmbiguousTerm),
        ISpecialMapping(UASCII::kQuestionMark, kTerminator),
        ISpecialMapping(ULatin1::kNoBreakSpace, kOther),
        ISpecialMapping(UGeneralPunctuation::kParagraphSeparator, kParagraphBreak),
        ISpecialMapping(UGeneralPunctuation::kIdeographicFullStop, kTerminator),
        ISpecialMapping(UHiragana::kLetterSmallA, UHiragana::kLetterVu, kCJK),
        ISpecialMapping(UHiragana::kCombiningVoicedSoundMark, UHiragana::kSemiVoicedSoundMark, kCJK),
        ISpecialMapping(UKatakana::kLetterSmallA, UKatakana::kLetterSmallKe, kCJK),
        ISpecialMapping(IUnicode::kLowBoundHan, IUnicode::kHighBoundHan, kCJK),
        ISpecialMapping(UCJKCompatibility::kF900, UCJKCompatibility::kFA2D, kCJK),
        ISpecialMapping(UGeneralPunctuation::kZeroWidthNoBreakSpace, kOther)
};

const int ITextBoundaryData::kSentenceExceptionChar_length =
        sizeof(ITextBoundaryData::kSentenceExceptionChar) / sizeof(ITextBoundaryData::kSentenceExceptionChar[0]);

const bool ITextBoundaryData::kSentenceExceptionFlags[] = {
        false,                  // kNonCharacter                        = 0,
        false,                  // kUppercaseLetter                     = 1,
        false,                  // kLowercaseLetter                     = 2,
        false,                  // kTitlecaseLetter                     = 3,
        false,                  // kModifierLetter                      = 4,
        true,                   // kOtherLetter                         = 5,
        true,                   // kNonSpacingMark                      = 6,
        false,                  // kEnclosingMark                       = 7,
        false,                  // kCombiningSpacingMark        = 8,
        false,                  // kDecimalNumber                       = 9,
        false,                  // kLetterNumber                        = 10,
        false,                  // kOtherNumber                         = 11,
        true,                   // kSpaceSeparator                      = 12,
        false,                  // kLineSeparator                       = 13,
        true,                   // kParagraphSeparator          = 14,
        true,                   // kControlCharacter            = 15,
        true,                   // kFormatCharacter                     = 16,
        false,                  // kPrivateUseCharacter         = 17,
        false,                  // kSurrogate                           = 18,
        false,                  // kDashPunctuation                     = 19,
        false,                  // kOpenPunctuation                     = 20,
        false,                  // kClosePunctuation            = 21,
        false,                  // kConnectorPunctuation        = 22,
        true,                   // kOtherPunctuation            = 23,
        false,                  // kMathSymbol                          = 24,
        false,                  // kCurrencySymbol                      = 25,
        false,                  // kModifierSymbol                      = 26,
        false,                  // kOtherSymbol                         = 27,
        false                   // UNDEFINED                            = 28
};

IUnicodeClassMapping* ITextBoundaryData::kSentenceMap = new IUnicodeClassMapping(kSentenceRawMapping, kSentenceRawMapping_length, kSentenceExceptionChar, kSentenceExceptionChar_length, kSentenceExceptionFlags);

/**
 * This is the single instance of ITextBoundaryData containing sentence
 * break data.
 */
const ITextBoundaryData ITextBoundaryData::kSentenceBreakData(ITextBoundaryData::kSentenceForward,
                                                                                                                        ITextBoundaryData::kSentenceBackward,
                                                                                                                        ITextBoundaryData::kSentenceMap);

//eof
