// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// *****************************************************************************
// This file was generated from the java source file TextBoundary.java
// *****************************************************************************
 
#include "itxtbdry.hpp"

#include "isimtxbd.hpp"

#include <iprimtyp.hpp>
#include <string.h>

#ifdef IC_PAGETUNE
	#define _ITXTBDRY_CPP
	#include <ipagetun.h>
#endif

// *****************************************************************************
// class ITextBoundary
// *****************************************************************************
 
ITextBoundary::offset_type _EXPORT ITextBoundary::kDone = -1L;

ITextBoundary*
ITextBoundary::createWordBreak(const ILocaleKey& key)
{
	return new ISimpleTextBoundary(&ITextBoundaryData::kWordBreakData);
}
 
// -------------------------------------
 
ITextBoundary*
ITextBoundary::createLineBreak(const ILocaleKey& key)
{
	return new ISimpleTextBoundary(&ITextBoundaryData::kLineBreakData);
}
 
// -------------------------------------
 
ITextBoundary*
ITextBoundary::createCharacterBreak(const ILocaleKey& key)
{
	return new ISimpleTextBoundary(&ITextBoundaryData::kCharacterBreakData);
}
 
// -------------------------------------
 
ITextBoundary*
ITextBoundary::createSentenceBreak(const ILocaleKey& key)
{
	return new ISimpleTextBoundary(&ITextBoundaryData::kSentenceBreakData);
}
 
// -------------------------------------
 
IText
ITextBoundary::getDisplayName(const ILocaleKey& objectLocale, const ILocaleKey& displayLocale)
{
    return objectLocale.displayName(displayLocale);
}

// -------------------------------------

ITextBoundary::~ITextBoundary()
{
}
