/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*       (C) Copyright International Business Machines Corporation 1997                  *
*       Licensed Material - Program-Property of IBM - All Rights Reserved.              *
*       US Government Users Restricted Rights - Use, duplication, or disclosure         *
*       restricted by GSA ADP Schedule Contract with IBM Corp.                          *
*                                                                                       *
*****************************************************************************************
*
* File WDBKDAT.CPP
*
* Modification History:
*
*       Date            Name            Description
*       02/18/97        aliu            Converted from OpenClass.
*                                                       Recoded kRawMapping table for Unicode::getType() type codes.
*                                                       Made static data members const where appropriate.
*       03/25/97        aliu            Moved into TextBoundaryData; no longer a subclass.
*****************************************************************************************
*/

// *****************************************************************************
// This file was generated from the java source file WordBreakData.java
// *****************************************************************************

#include <itxtbdat.hpp>
#include <iwdbktbl.hpp>
#include <iunicdcm.hpp>
#include <iugnrl.hpp>
#include <iumeast.hpp>
#include <iueasia.hpp>
#include <iucmpbty.hpp>

#ifdef IC_PAGETUNE
        #define _IWDBKDAT_CPP
        #include <ipagetun.h>
#endif

// *****************************************************************************
// class WordBreakData
// *****************************************************************************

const ITextBoundaryData::Node ITextBoundaryData::kWordForwardData[] = {
    // brk                      let                             num                             mLe                             mLN
    // prN                      poN                             mNu                             pMN                             blk
    // lf                       kat                             hir                             kan                             dia
        // cr

        // 0
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,

        // 1
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+4),
        (ITextBoundaryData::Node)(kSI+5),  (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+5),  (ITextBoundaryData::Node)(kSI+6),
        (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+11), (ITextBoundaryData::Node)(kSI+12), (ITextBoundaryData::Node)(kSI+9),
        (ITextBoundaryData::Node)(kSI+13),

        // 2
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+7),  (ITextBoundaryData::Node)(kSI+7),
        kSI_Stop,       kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+7),  kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,

        // 3
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  kSI_Stop,       (ITextBoundaryData::Node)(kSI+8),
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+8),  kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,

        // 4
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,

        // 5
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+3),  kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,

        // 6
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+6),
        (ITextBoundaryData::Node)(kSI+4),  kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        (ITextBoundaryData::Node)(kSI+4),

        // 7
        kStop,          (ITextBoundaryData::Node)(kSI+2),  kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,

        // 8
        kStop,          kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,

        // 9
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+11), kSI_Stop,       (ITextBoundaryData::Node)(kSI+9),
        kSI_Stop,

        // 10
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       (ITextBoundaryData::Node)(kSI+10), kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+10),
        kSI_Stop,

        // 11
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+11), kSI_Stop,       (ITextBoundaryData::Node)(kSI+11),
        kSI_Stop,

        // 12
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       (ITextBoundaryData::Node)(kSI+12), kSI_Stop,
        kSI_Stop,

        // 13
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        (ITextBoundaryData::Node)(kSI+4),  kSI_Stop,       kSI_Stop,       kSI_Stop,       kSI_Stop,
        kSI_Stop,
};

const int ITextBoundaryData::kWordForwardData_length =
        sizeof(ITextBoundaryData::kWordForwardData) / sizeof(ITextBoundaryData::kWordForwardData[0]);

IWordBreakTable* ITextBoundaryData::kWordForward = new IWordBreakTable(kWordCol_count, kWordForwardData, kWordForwardData_length);

const ITextBoundaryData::Node ITextBoundaryData::kWordBackwardData[] = {
    // brk                      let                             num                             mLe                             mLN
    // prN                      poN                             mNu                             pMN                             blk
    // lf                       kat                             hir                             kan                             dia
        // cr

        // 0
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,

        // 1
        (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(kSI+4),  (ITextBoundaryData::Node)(kSI+5),
        (ITextBoundaryData::Node)(kSI+6),  (ITextBoundaryData::Node)(kSI+7),  (ITextBoundaryData::Node)(kSI+7),  (ITextBoundaryData::Node)(kSI+5),  (ITextBoundaryData::Node)(kSI+8),
        (ITextBoundaryData::Node)(kSI+8),  (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+10), (ITextBoundaryData::Node)(kSI+12), (ITextBoundaryData::Node)(kSI+11),
        (ITextBoundaryData::Node)(kSI+8),

        // 2
        kStop,          (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  (ITextBoundaryData::Node)(4),      (ITextBoundaryData::Node)(4),
        kStop,          kStop,          kStop,          (ITextBoundaryData::Node)(4),      kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,

        // 3
        kStop,          (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  kStop,          (ITextBoundaryData::Node)(7),
        kSI_Stop,       kStop,          (ITextBoundaryData::Node)(7),      (ITextBoundaryData::Node)(kSI+7),  kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,

        // 4
        kStop,          (ITextBoundaryData::Node)(kSI+2),  kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,

        // 5
        kStop,          (ITextBoundaryData::Node)(kSI+2),  (ITextBoundaryData::Node)(kSI+3),  kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,

        // 6
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,

        // 7
        kStop,          kStop,          (ITextBoundaryData::Node)(kSI+3),  kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,

        // 8
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          (ITextBoundaryData::Node)(kSI+8),
        (ITextBoundaryData::Node)(kSI+8),  kStop,          kStop,          kStop,          kStop,
        (ITextBoundaryData::Node)(kSI+8),

        // 9
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+9),  kStop,          kStop,          (ITextBoundaryData::Node)(9),
        kStop,

        // 10
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          (ITextBoundaryData::Node)(kSI+10), kStop,          (ITextBoundaryData::Node)(10),
        kStop,

        // 11
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          (ITextBoundaryData::Node)(kSI+9),  (ITextBoundaryData::Node)(kSI+10), kStop,          (ITextBoundaryData::Node)(kSI+11),
        kStop,

        // 12
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          kStop,          kStop,
        kStop,          kStop,          kStop,          (ITextBoundaryData::Node)(kSI+12), kStop,
        kStop
};

const int ITextBoundaryData::kWordBackwardData_length =
        sizeof(ITextBoundaryData::kWordBackwardData) / sizeof(ITextBoundaryData::kWordBackwardData[0]);

IWordBreakTable* ITextBoundaryData::kWordBackward = new IWordBreakTable(kWordCol_count, kWordBackwardData, kWordBackwardData_length);

const ITextBoundaryData::Type ITextBoundaryData::kWordRawMapping[] = {
        // Re-coded to match Unicode 2 types [LIU]
        kBreak,         // kNonCharacter                        = 0,
          kLetter,      // kUppercaseLetter                     = 1,
          kLetter,      // kLowercaseLetter                     = 2,
          kLetter,      // kTitlecaseLetter                     = 3,
          kLetter,      // kModifierLetter                      = 4,
          kLetter,      // kOtherLetter                         = 5,
        kBreak,         // kNonSpacingMark                      = 6,
        kBreak,         // kEnclosingMark                       = 7,
        kBreak,         // kCombiningSpacingMark        = 8,
          kNumber,      // kDecimalNumber                       = 9,
          kLetter,      // kLetterNumber                        = 10,
          kNumber,      // kOtherNumber                         = 11,
          kBlank,       // kSpaceSeparator                      = 12,
        kBreak,         // kLineSeparator                       = 13,
        kBreak,         // kParagraphSeparator          = 14,
        kBreak,         // kControlCharacter            = 15,
        kBreak,         // kFormatCharacter                     = 16,
        kBreak,         // kPrivateUseCharacter         = 17,
        kBreak,         // kSurrogate                           = 18,
          kMidLetter, // kDashPunctuation               = 19,
        kBreak,         // kOpenPunctuation                     = 20,
        kBreak,         // kClosePunctuation            = 21,
        kBreak,         // kConnectorPunctuation        = 22,
        kBreak,         // kOtherPunctuation            = 23,
        kBreak,         // kMathSymbol                          = 24,
          kPreNum,      // kCurrencySymbol                      = 25,
        kBreak,         // kModifierSymbol                      = 26,
        kBreak,         // kOtherSymbol                         = 27,
        kBreak          // UNDEFINED                            = 28
};

const int ITextBoundaryData::kWordRawMapping_length =
        sizeof(ITextBoundaryData::kWordRawMapping) / sizeof(ITextBoundaryData::kWordRawMapping[0]);

const ISpecialMapping ITextBoundaryData::kWordExceptionChar[] = {
        ISpecialMapping(UASCII::kHorizontalTabulation, kBlank),
        ISpecialMapping(UASCII::kLineFeed, kLF),
        ISpecialMapping(UASCII::kFormFeed, kLF),
        ISpecialMapping(UASCII::kCarriageReturn, kCR),
        ISpecialMapping(UASCII::kQuotationMark, kMidLetNum),
        ISpecialMapping(UASCII::kNumberSign, kPreNum),
        ISpecialMapping(UASCII::kPercentSign, kPostNum),
        ISpecialMapping(UASCII::kAmpersand, kPostNum),
        ISpecialMapping(UASCII::kApostrophe, kMidLetNum),
        ISpecialMapping(UASCII::kComma, kMidNum),
        ISpecialMapping(UASCII::kFullStop, kPreMidNum),
        ISpecialMapping(ULatin1::kCentSign, kPostNum),
        ISpecialMapping(ULatin1::kSoftHyphen, kMidLetter),
        ISpecialMapping(UArabic::kPercentSign, kPostNum),
        ISpecialMapping(UArabic::kDecimalSeparator, kMidNum),
        ISpecialMapping(UGeneralPunctuation::kHyphenationPoint, kMidLetter),
        ISpecialMapping(UGeneralPunctuation::kLineSeparator, UGeneralPunctuation::kParagraphSeparator, kLF),
        ISpecialMapping(UGeneralPunctuation::kPerMilleSign, kPostNum),
        ISpecialMapping(UGeneralPunctuation::kPerTenThousandSign, kPostNum),
        ISpecialMapping(UHiragana::kLetterSmallA, UHiragana::kLetterVu, kHira),
        ISpecialMapping(UHiragana::kCombiningVoicedSoundMark, UHiragana::kSemiVoicedSoundMark, kDiacrit),
        ISpecialMapping(UKatakana::kLetterSmallA, UKatakana::kLetterSmallKe, kKata),
        ISpecialMapping(IUnicode::kLowBoundHan, IUnicode::kHighBoundHan, kKanji),
        ISpecialMapping(IUnicode::kLowBoundHangulSyllable, IUnicode::kHighBoundHangulSyllable, kLetter),        // did I do this right? (was HANGUL_SYL_LOW and HANGUL_SYL_HIGH)
        ISpecialMapping(UCJKCompatibility::kF900, UCJKCompatibility::kFA2D, kKanji),
};

const int ITextBoundaryData::kWordExceptionChar_length =
        sizeof(ITextBoundaryData::kWordExceptionChar) / sizeof(ITextBoundaryData::kWordExceptionChar[0]);

const bool ITextBoundaryData::kWordExceptionFlags[] = {
        false,                  // kNonCharacter                        = 0,
        false,                  // kUppercaseLetter                     = 1,
        false,                  // kLowercaseLetter                     = 2,
        false,                  // kTitlecaseLetter                     = 3,
        false,                  // kModifierLetter                      = 4,
        true,                   // kOtherLetter                         = 5,
        true,                   // kNonSpacingMark                      = 6,
        false,                  // kEnclosingMark                       = 7,
        false,                  // kCombiningSpacingMark        = 8,
        false,                  // kDecimalNumber                       = 9,
        false,                  // kLetterNumber                        = 10,
        false,                  // kOtherNumber                         = 11,
        false,                  // kSpaceSeparator                      = 12,
        true,                   // kLineSeparator                       = 13,
        true,                   // kParagraphSeparator          = 14,
        true,                   // kControlCharacter            = 15,
        false,                  // kFormatCharacter                     = 16,
        false,                  // kPrivateUseCharacter         = 17,
        false,                  // kSurrogate                           = 18,
        true,                   // kDashPunctuation                     = 19,
        false,                  // kOpenPunctuation                     = 20,
        false,                  // kClosePunctuation            = 21,
        false,                  // kConnectorPunctuation        = 22,
        true,                   // kOtherPunctuation            = 23,
        false,                  // kMathSymbol                          = 24,
        true,                   // kCurrencySymbol                      = 25,
        false,                  // kModifierSymbol                      = 26,
        false,                  // kOtherSymbol                         = 27,
        false                   // UNDEFINED                            = 28
};

IUnicodeClassMapping* ITextBoundaryData::kWordMap = new IUnicodeClassMapping(kWordRawMapping, kWordRawMapping_length, kWordExceptionChar, kWordExceptionChar_length, kWordExceptionFlags);

/**
 * This is the single instance of ITextBoundaryData containing word
 * break data.
 */
const ITextBoundaryData ITextBoundaryData::kWordBreakData(ITextBoundaryData::kWordForward,
                                                                                                                ITextBoundaryData::kWordBackward,
                                                                                                                ITextBoundaryData::kWordMap);

//eof
