// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 71 1.3.1.3 source/core/text/intl/findword/working/main.cpp, text, ioc.v400, 000302  
// Test ITextBoundaryHandle

#include "itxtbhdl.hpp"
#include <iostream.h>

#ifdef IC_PAGETUNE
	#define _MAIN_CPP
	#include <ipagetun.h>
#endif

void
testbreak(ITextBoundaryHandle iter, const IText& message)
{
  cout << endl << "--- " << message << " forward ---" << endl << endl;

  for (size_t pos = *iter++; pos != *iter; pos = *iter++) {
    IText substr = iter.text().substr(pos, *iter - pos);
    cout << pos << ": >" << substr << "<" << endl;
  }

  cout << endl << "--- " << message << " backward ---" << endl << endl;

  for (pos = *iter--; pos != *iter; pos = *iter--) {
    IText substr = iter.text().substr(*iter, pos - *iter);
    cout << *iter << ": >" << substr << "<" << endl;
  }
}

void 
limittest(ITextBoundaryHandle iter, int limit, const IText& message)
{
  cout << endl << "--- " << message << " limit forward ---" << endl << endl;

  while (iter < limit) {
    size_t pos = *iter++;
    IText substr = iter.text().substr(pos, *iter - pos);
    cout << pos << ": >" << substr << "<" << endl;
  }

  cout << endl << "--- " << message << " limit backward ---" << endl << endl;
  
  iter.setToLast();
  while (iter > limit) {
    size_t pos = *iter--;
    IText substr = iter.text().substr(*iter, pos - *iter);
    cout << *iter << ": >" << substr << "<" << endl;
  }
  
}

void
main()
{
  const IText text = "This is a test of \"ITextBoundaryHandle.\"  Wasn't it just \"swell\"?  Or is that \"swell?\"  Or 'swell'?  Or 'swell?'  Or what?";

  testbreak(ITextBoundaryHandle::characterBreak(text), "character break");
  testbreak(ITextBoundaryHandle::wordBreak(text), "word break");
  testbreak(ITextBoundaryHandle::lineBreak(text), "line break");
  testbreak(ITextBoundaryHandle::sentenceBreak(text), "sentence break");

  limittest(ITextBoundaryHandle::lineBreak(text), text.length() / 2, "line break");
}
