// Revision: 32 1.14.1.4 source/core/text/intl/transcod/icodecvt.hpp, text, ioc.v400, 000302 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//      icodecvt.hpp
//
//  This file has a class that supports an ANSI C++ compatibility for the Transcoder Framework.
//
//  This file will be deleted when ANSI C++ Standard Library is available.
//
//      IBM Open Class Library
//      (C) Copyright International Business Machines Corporation 1997
//      Licensed Material - Program-Property of IBM - All Rights Reserved.
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#ifndef _ICODECVT_
#define _ICODECVT_

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

//========================================================================================
// CLASS codecvt_base
// codecvt_base class defines useful constants indicating different codeset conversion results.
// THIS CLASS WILL BE DELETED WHEN THE ANSI C++ STANDARD LIBRARY IS AVAILABLE!
//========================================================================================
class codecvt_base {
public:
        enum result {
                ok,                     // the conversion was completed successfully
                partial,        // not all source characters converted successfully
                error,          // encountered a character that couldn't be converted
                noconv          // no conversion was required
                };
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _ICODECVT_
