/* Revision: 78 1.10.2.3 source/core/text/intl/transcod/transcod.h, text, ioc.v400, 000302  */
/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
//
//      transcod.h
//      Internal header
//      Exception messages for the Transcoder Framework Interface
//

#ifndef _TRANSCOD_
#define _TRANSCOD_

//  Error : Transcoding buffer range specified is invalid
#define kConvBufRangeError               0x0000105L

//  Error : Transcoding flush buffer is invalid
#define kFlushBufRangeError              0x0000106L

//  Error : No transcoder matching the charset and proximity specified
#define kNoAdequateTranscoder            0x0000107L

//  Error : Transcoder for charset or locale specified is not installed
#define kTranscoderNotInstalled          0x0000108L

//  Error : The host transcoder is not portable across a network
#define kTranscoderNotPortable           0x0000109L

//  Error : An input byte does not belong to the input codeset
#define kInvalidInputCharacter           0x0000110L

//  Error : Incomplete character or shift sequence at the end of the input buffer
#define kIncompleteCharOrSequence        0x0000111L

extern const char* kMessageFile;

#endif // _TRANSCOD_
