; IBM Open Class Library
;
; Licensed Materials - Property of IBM
;
; "Restricted Materials of IBM"
;
; (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
;
; $Revision: 1.2 $
; Atomic86.asm
; 
; Atomic get/set operations for the 80x86 processors
;
	title	ntrefcnt.cpp
	.486								; TODO: 386!!!
	ASSUME	DS: FLAT, SS: FLAT

CODE32	segment para use32 public 'CODE'

	align 010h

;;--------------------------------------------------------------------------------------
;; void *	AtomicGet486(void *const volatile *target)
;;
;;	EAX: target
;;
PUBLIC	?AtomicGet486__FPCVPv 
?AtomicGet486__FPCVPv PROC NEAR
		mov			ecx, 0h					; Set ecx to 0
		lock xadd	dword ptr[eax], ecx		; Move value at ecx into eax; put sum into ecx
		xchg		ecx, eax				; Get sum into eax
		ret			0						; Return with result in eax
?AtomicGet486__FPCVPv ENDP

;;--------------------------------------------------------------------------------------
;; void		AtomicSet486(void * volatile *target, void *newValue)
;;
;;	EAX: target
;;	EDX: newValue
;;
PUBLIC	?AtomicSet486__FPVPvPv
?AtomicSet486__FPVPvPv PROC NEAR
		lock xchg 	dword ptr[eax], edx		; Set the value
		ret			0
?AtomicSet486__FPVPvPv ENDP

;;--------------------------------------------------------------------------------------
;; bool		AtomicSwap486(void * volatile* target, void *test, void *newValue)
;; bool		AtomicSwap386(void * volatile* target, void *test, void *newValue)
;;
;; The only difference between these two functions is that the 486 version
;; uses the "lock" prefix to guarantee multiprocessor safety.
;;
;;	EAX: target
;;	EDX: test
;;	ECX: newValue
;;
PUBLIC	?AtomicSwap486__FPVPvPvT2 
?AtomicSwap486__FPVPvPvT2 PROC NEAR
		xchg		eax, edx				; Address goes in EDX, old value in EAX
	lock cmpxchg	dword ptr[edx], ecx		; Compare/Swap.  Sets zero bit if successful.
		je			$SAME4
		mov			eax, 01h				; Compare failed; return 1
		jmp			$EXIT4
$SAME4:	mov			eax, 00h				; Compare succeeded; return 0
$EXIT4:	ret			0	 					; Return with result in AL
?AtomicSwap486__FPVPvPvT2 ENDP

PUBLIC	?AtomicSwap386__FPVPvPvT2 
?AtomicSwap386__FPVPvPvT2 PROC NEAR
		xchg		eax, edx				; Address goes in EDX, old value in EAX
		cmpxchg		dword ptr[edx], ecx		; Compare/Swap.  Sets zero bit if successful.
		je			$SAME3
		mov			eax, 01h				; Compare failed; return 1
		jmp			$EXIT3
$SAME3:	mov			eax, 00h				; Compare succeeded; return 0
$EXIT3:	ret			0	 					; Return with result in AL
?AtomicSwap386__FPVPvPvT2 ENDP

CODE32	ends
end
