// Revision: 18 1.3.1.2 source/dde/iddeccnv.inl, dde, ioc.v400, 000302 
/*******************************************************************************
* FILE NAME: iddeccnv.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in iddeccnv.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved                    *
*                                                                              *
*******************************************************************************/

inline IString IDDEClientConversation :: application ( ) const
{
   return strClApplication;
}

inline IString IDDEClientConversation :: topic ( ) const
{
   return strClTopic;
}

inline bool IDDEClientConversation :: isCaseSensitive ( ) const
{
   return fClCaseSensitive;
}

inline IWindowHandle IDDEClientConversation :: serverHandle ( ) const
{
   return wndhClServer;
}

inline bool IDDEClientConversation :: inConversation ( ) const
{
   if (serverHandle())
      return true;
   else
      return false;
}

inline IWindowHandle IDDEClientConversation :: clientHandle ( ) const
{
   return wndhClClient;
}

inline IDDEClosedConversationSet& IDDEClientConversation :: closedConversations ( ) const
{
   return *pClsdConvSetCl;
}

inline IDDETransactionQueue& IDDEClientConversation :: transactions ( ) const
{
   return *pTransQCl;
}

inline IDDEFormatSet& IDDEClientConversation :: formats ( ) const
{
   return *pFormatSetCl;
}

#ifdef IC_WIN
inline IDDEItemAtomSet& IDDEClientConversation :: itemAtoms ( ) const
{
   return *pItemAtomSetCl;
}
#endif

inline unsigned long IDDEClientConversation :: queueHandle ( ) const
{
   return ulClQHandle;
}

