// Revision: 25 1.3.1.2 source/dde/iddeevt.inl, dde, ioc.v400, 000302 
/*******************************************************************************
* FILE NAME: iddeevt.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in iddeevt.hpp.                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved                    *
*                                                                              *
*******************************************************************************/

inline IString IDDEEvent :: item ( ) const
{
   return strClItem;
}

inline IString IDDEEvent :: format ( ) const
{
   return strClFormat;
}

inline IDDEEvent& IDDEEvent :: setStatus ( unsigned short status )
{
   usClStatus = status;
   return *this;
}

inline unsigned short IDDEEvent :: status ( ) const
{
   return usClStatus;
}

inline IDDEEvent& IDDEEvent :: setBuffer ( IString strBuf )
{
   strClData = strBuf;
   return *this;
}

inline IDDEEvent& IDDEEvent :: setFormat ( IString strFormat )
{
   strClFormat = strFormat;
   return *this;
}

inline IString IDDEEvent :: buffer ( ) const
{
   return strClData;
}

inline unsigned short IDDEAcknowledgeEvent :: transactionType ( ) const
{
   return (unsigned short)eventId();
}

inline IString IDDEServerAcknowledgeEvent :: data ( ) const
{
   return buffer();
}

inline IString IDDEAcknowledgePokeEvent :: pokedData ( ) const
{
   return buffer();
}

inline IString IDDEAcknowledgeExecuteEvent :: commands ( ) const
{
   return buffer();
}

inline IString IDDEDataEvent :: data ( ) const
{
   return buffer();
}

inline IString IDDEPokeEvent :: pokedData ( ) const
{
   return buffer();
}

inline IString IDDEExecuteEvent :: commands ( ) const
{
   return buffer();
}

inline IDDEEndEvent::Source IDDEEndEvent :: sourceOfEnd ( ) const
{
   return sourceCl;
}

inline IString IDDEClientEndEvent :: application ( ) const
{
   return strClApp;
}

inline IString IDDEClientEndEvent :: topic ( ) const
{
   return strClTopic;
}

inline IString IDDEBeginEvent :: application ( ) const
{
   return strClApp;
}

inline IString IDDEBeginEvent :: topic ( ) const
{
   return strClTopic;
}

inline bool IDDEBeginEvent :: isCaseSensitive ( ) const
{
   return bClCaseSens;
}

inline IDDEBeginEvent& IDDEBeginEvent :: setCaseSensitive ( bool caseSensitive )
{
   if (!caseSensitive)
      bClCaseSens = false;
   else
      bClCaseSens = true;
   return *this;
}

