// Revision: 07 1.12 source/ui/baseapp/idefstyl.cpp, basewin, ioc.v400, 000302 
/*******************************************************************************
* FILE NAME: idefstyl.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in idefstyl.h.                                                             *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <idefstyl.h>

//====================================================================
// IWindow styles
//====================================================================
#ifdef IC_MOTIFWIN
const unsigned long
  IWindow__noStyle[]               = {95}, //0,
  IWindow__visible[]               = {28}, //WS_VISIBLE      0x10000000
  IWindow__disabled[]              = {27}, //WS_DISABLED     0x08000000
  IWindow__clipSiblings[]          = {26}, //WS_CLIPSIBLINGS 0x04000000
  IWindow__clipChildren[]          = {25}, //WS_CLIPCHILDREN 0x02000000
  IWindow__clipToParent[]          = {95}, //WS_PARENTCLIP   0x00000000
  IWindow__saveBits[]              = {95}, //WS_SAVEBITS     0x00000000
  IWindow__synchPaint[]            = {95}, //WS_SYNCPAINT    0x00000000
  IWindow__group[]                 = {17}, //WS_GROUP        0x00020000
  IWindow__tabStop[]               = {16}, //WS_TABSTOP      0x00010000
  IWindow__leftToRight[]           = {66},
  IWindow__rightToLeft[]           = {67};
#endif


#ifdef IC_PM
const unsigned long
  IWindow__noStyle[]               = {95}, //0,
  IWindow__visible[]               = {31}, //WS_VISIBLE              0x80000000
  IWindow__disabled[]              = {30}, //WS_DISABLED             0x40000000
  IWindow__clipChildren[]          = {29}, //WS_CLIPCHILDREN         0x20000000
  IWindow__clipSiblings[]          = {28}, //WS_CLIPSIBLINGS         0x10000000
  IWindow__clipToParent[]          = {27}, //WS_PARENTCLIP           0x08000000
  IWindow__saveBits[]              = {26}, //WS_SAVEBITS             0x04000000
  IWindow__synchPaint[]            = {25}, //WS_SYNCPAINT            0x02000000
  IWindow__group[]                 = {16}, //WS_GROUP                0x00010000
  IWindow__tabStop[]               = {17}, //WS_TABSTOP              0x00020000
  IWindow__leftToRight[]           = {66},
  IWindow__rightToLeft[]           = {67};
#endif

//====================================================================
// IFrameWindow styles
//====================================================================
#ifdef IC_MOTIF
const unsigned long
  IFrameWindow__deferCreation[]    = {40}, 
  IFrameWindow__accelerator[]      = {41}, 
  IFrameWindow__menuBar[]          = {42}, 
  IFrameWindow__minimizedIcon[]    = {43}, 
  IFrameWindow__alignNoAdjust[]    = {44}, 
  IFrameWindow__shellPosition[]    = {45}, 
  IFrameWindow__dialogBackground[] = {55}, 
  IFrameWindow__animated[]         = {95}, 
  IFrameWindow__appDBCSStatus[]    = {95}, 
  IFrameWindow__noMoveWithOwner[]  = {95}, 
  IFrameWindow__systemModal[]      = {64}, 
  IFrameWindow__windowList[]       = {50}, 
  IFrameWindow__titleBar[]         = {22}, 
  IFrameWindow__minimizeButton[]   = {17}, 
  IFrameWindow__hideButton[]       = {17}, 
  IFrameWindow__maximizeButton[]   = {16}, 
  IFrameWindow__sizingBorder[]     = {18}, 
  IFrameWindow__systemMenu[]       = {19}, 
  IFrameWindow__horizontalScroll[] = {20}, 
  IFrameWindow__verticalScroll[]   = {21}, 
  IFrameWindow__dialogBorder[]     = {32}, 
  IFrameWindow__border[]           = {23}, 
  IFrameWindow__maximized[]        = {24}, 
  IFrameWindow__minimized[]        = {29}, 
  IFrameWindow__classDefaultStyle[]= {22,16,17,18,19,50},
                                  //  titleBar
                                  //  systemMenu
                                  //  sizingBorder
                                  //  minimizeButton
                                  //  maximizeButton
                                  //  windowList

  // styleBits is mask with just the style bits "on":
  IFrameWindow__styleBits[]         = {16,17,18,19,20,21,22,23,
                                       24,25,26,27,28,29,30,31}; // 0xFFFF0000ul
#endif // IC_MOTIF

#ifdef IC_WIN
const unsigned long
  IFrameWindow__deferCreation[]    = {40}, // 0,IFS_DEFERCREATE 0x00000100
  IFrameWindow__accelerator[]      = {41}, // 0,IFS_ACCELERATOR 0x00000200
  IFrameWindow__menuBar[]          = {42}, // 0,IFS_MENU        0x00000400
  IFrameWindow__minimizedIcon[]    = {43}, // 0,IFS_MINICON     0x00000800
  IFrameWindow__alignNoAdjust[]    = {44}, // 0,IFS_ALIGNNOADJ  0x00001000
  IFrameWindow__shellPosition[]    = {45}, // 0,IFS_SHELLPOS    0x00002000
  IFrameWindow__dialogBackground[] = {55}, // 0,IFS_DLGBACKGND  0x00800000
  IFrameWindow__animated[]         = {95}, // 0,IFS_ANIMATED    0x00000000
  IFrameWindow__appDBCSStatus[]    = {95}, // 0,IFS_APPDBCS     0x00000000
  IFrameWindow__noMoveWithOwner[]  = {95}, // 0,IFS_NOMOVEOWNER 0x00000000
  IFrameWindow__systemModal[]      = {95}, // 0,IFS_SYSMODAL    0x00000000
  IFrameWindow__windowList[]       = {50}, // (0,WS_EX_APPWINDOW 0x00040000
  IFrameWindow__titleBar[]         = {22,23}, // WS_CAPTION   0x00C00000
  IFrameWindow__minimizeButton[]   = {17}, // WS_MINIMIZEBOX  0x00020000
  IFrameWindow__hideButton[]       = {17}, // WS_MINIMIZEBOX  0x00020000
  IFrameWindow__maximizeButton[]   = {16}, // WS_MAXIMIZEBOX  0x00010000
  IFrameWindow__sizingBorder[]     = {18}, // WS_THICKFRAME   0x00040000
  IFrameWindow__systemMenu[]       = {19}, // WS_SYSMENU      0x00080000
  IFrameWindow__horizontalScroll[] = {20}, // WS_HSCROLL      0x00100000
  IFrameWindow__verticalScroll[]   = {21}, // WS_VSCROLL      0x00200000
  IFrameWindow__dialogBorder[]     = {32}, // (0, WS_EX_DLGMODALFRAME 0x00000001
  IFrameWindow__border[]           = {23}, // WS_BORDER       0x00800000
  IFrameWindow__maximized[]        = {24}, // WS_MAXIMIZE     0x01000000
  IFrameWindow__minimized[]        = {29}, // WS_MINIMIZE     0x20000000
  IFrameWindow__classDefaultStyle[]= {22,23,16,17,18,19,50},
                                  //( 0x00CF0000ul, 0x00040000ul ),
                                  //  0x00C00000                titleBar
                                  //  0x00080000                systemMenu
                                  //  0x00040000                sizingBorder
                                  //  0x00020000                minimizeButton
                                  //  0x00010000                maximizeButton
                                  //                0x00040000  windowList

  // styleBits is mask with just the style bits "on":
  IFrameWindow__styleBits[]         = {16,17,18,19,20,21,22,23,
                                       24,25,26,27,28,29,30,31}; // 0xFFFF0000ul
#endif // IC_WIN
#ifdef IC_PM
const  unsigned long
  IFrameWindow__minimizedIcon[]    = {0},  // FS_ICON                0x00000001
  IFrameWindow__accelerator[]      = {1},  // FS_ACCELTABLE          0x00000002
  IFrameWindow__shellPosition[]    = {2},  // FS_SHELLPOSITION       0x00000004
  IFrameWindow__windowList[]       = {3},  // FS_TASKLIST            0x00000008
  IFrameWindow__alignNoAdjust[]    = {4},  // FS_NOBYTEALIGN         0x00000010
  IFrameWindow__noMoveWithOwner[]  = {5},  // FS_NOMOVEWITHOWNER     0x00000020
  IFrameWindow__systemModal[]      = {6},  // FS_SYSMODAL            0x00000040
  IFrameWindow__dialogBorder[]     = {7},  // FS_DLGBORDER           0x00000080
  IFrameWindow__border[]           = {8},  // FS_BORDER              0x00000100
  IFrameWindow__sizingBorder[]     = {11}, // FS_SIZEBORDER          0x00000800
  IFrameWindow__dialogBackground[] = {12}, // FS_AUTOICON            0x00001000
  IFrameWindow__appDBCSStatus[]    = {15}, // FS_DBE_APPSTAT         0x00008000
  IFrameWindow__animated[]         = {22}, // WS_ANIMATE             0x00400000
  IFrameWindow__maximized[]        = {23}, // WS_MAXIMIZED           0x00800000
  IFrameWindow__minimized[]        = {24}, // WS_MINIMIZED           0x01000000
  IFrameWindow__titleBar[]         = {32}, // ( 0, FCF_TITLEBAR )    0x00000001 *
  IFrameWindow__systemMenu[]       = {33}, // ( 0, FCF_SYSMENU )     0x00000002 *
  IFrameWindow__menuBar[]          = {34}, // ( 0, FCF_MENU )        0x00000004 *
  IFrameWindow__hideButton[]       = {35}, // ( 0, IFS_HIDEBUTTON )  0x00000008 *
  IFrameWindow__minimizeButton[]   = {36}, // ( 0, FCF_MINBUTTON )   0x00000010 *
  IFrameWindow__maximizeButton[]   = {37}, // ( 0, FCF_MAXBUTTON )   0x00000020 *
  IFrameWindow__verticalScroll[]   = {38}, // ( 0, FCF_VERTSCROLL )  0x00000040 *
  IFrameWindow__horizontalScroll[] = {39}, // ( 0, FCF_HORZSCROLL )  0x00000080 *
  IFrameWindow__deferCreation[]    = {40}, // ( 0, IFS_DEFERCREATE ) 0x00000100 *
  IFrameWindow__classDefaultStyle[]= {3,11,15,32,33,36,37},
                                  // ( 0x00008808ul, 0x00000033ul ),
                                  //   0x00008000                    appDBCSStatus
                                  //   0x00000800                    sizingBorder
                                  //   0x00000008                    windowList
                                  //                 0x00000001      titleBar
                                  //                 0x00000002      systemMenu
                                  //                 0x00000010      minimizeButton
                                  //                 0x00000020      maximizeButton

  // styleBits is mask with just the PM style bits "on":
  IFrameWindow__styleBits[]        = { 0, 1, 2, 3, 4, 5, 6, 7, 8,11,15,16,17,18,
                                                        19,20,21,22,23,24,25,26,27,28,29,30,31};
                                                     // IFS_MASK | IWS_MASK;     // 0xFFFF89FFul
#endif // IC_PM

//====================================================================
// ISplitCanvas styles
//====================================================================
const unsigned long
  ISplitCanvas__vertical         [] = {33},  // 0, ICNV_VERTICAL     0x00000002
  ISplitCanvas__horizontal       [] = {34},  // 0, ICNV_HORIZONTAL   0x00000004
  ISplitCanvas__noSplitBars      [] = {35},  // 0, ICNV_NOSPLITBARS  0x00000008
#ifdef IC_MOTIFWIN                           // IWindow__visible, ISplitCanvas__vertical
  ISplitCanvas__classDefaultStyle[] = {28,33};
#endif
#ifdef IC_PM
  ISplitCanvas__classDefaultStyle[] = {31,33};
#endif

//====================================================================
// IWindow Event Masks
//====================================================================
const unsigned long
  IWindow__someMouseMoves[]    = { 0 },          // 0x00000001
  IWindow__allMouseMoves[]     = { 1 },          // 0x00000002
  IWindow__mouseEntersLeaves[] = { 2 };          // 0x00000004

//====================================================================
// IMouseHandler Styles
//====================================================================
const unsigned long
  IMouseHandler__noMoves[]           = { 0 },    // 0x00000001
  IMouseHandler__someMoves[]         = { 1 },    // 0x00000002
  IMouseHandler__allMoves[]          = { 2 },    // 0x00000004
  IMouseHandler__entersLeaves[]      = { 3 },    // 0x00000008
  IMouseHandler__classDefaultStyle[] = { 1 };    // 0x00000002


//====================================================================
// IFileDialog Styles
//====================================================================
const unsigned long
#ifdef IC_MOTIFPM
  IFileDialog__helpButton[]        = { 3 },      // 0x00000008
  IFileDialog__multiSelection[]    = { 10 },     // 0x00000400
  IFileDialog__filter[]            = { 2 },      // 0x00000004
  IFileDialog__applyButton[]       = { 4 },      // 0x00000010
  IFileDialog__includeEAS[]        = { 7 },      // 0x00000080
  IFileDialog__modeless[]          = { 6 },      // 0x00000040
  IFileDialog__preload[]           = { 5 },      // 0x00000020
#endif //IC_MOTIFPM
#ifdef IC_WIN
  IFileDialog__helpButton[]        = { 4 },      // 0x00000010
  IFileDialog__multiSelection[]    = { 9 },      // 0x00000200
  IFileDialog__filter[]            = { 95 },     // 0 (ignored)
  IFileDialog__applyButton[]       = { 95 },     // 0 (ignored)
  IFileDialog__includeEAS[]        = { 95 },     // 0 (ignored)
  IFileDialog__modeless[]          = { 47 },     // 0, 0x00008000
  IFileDialog__preload[]           = { 95 },     // 0 (ignored)
#endif //IC_WIN
  IFileDialog__selectableListbox[] = { 11 },     // 0x00000800
  IFileDialog__noStyle[]           = { 95 },     // 0x00000000
  IFileDialog__classDefaultStyle[] = { 95 };     // 0x00000000  (noStyle)

//====================================================================
// IFontDialog styles
//====================================================================
#ifdef IC_MOTIFPM
extern const unsigned long
  IFontDialog__helpButton[]        = { 3 },     // 0x00000008
  IFontDialog__applyButton[]       = { 4 },     // 0x00000010
  IFontDialog__resetButton[]       = { 5 },     // 0x00000020
  IFontDialog__modeless[]          = { 6 },     // 0x00000040
  IFontDialog__proportionalOnly[]  = { 11 },    // 0x00000800
  IFontDialog__bitmapOnly[]        = { 8 },     // 0x00000100
  IFontDialog__vectorOnly[]        = { 9 },     // 0x00000200
  IFontDialog__fixedWidthOnly[]    = { 10 },    // 0x00000400
  IFontDialog__noSynthesize[]      = { 12 },    // 0x00001000
  IFontDialog__noStyle[]           = { 95 },    // 0x00000000
  IFontDialog__classDefaultStyle[] = { 5 };     // 0x00000020 (resetButton)
#endif //IC_MOTIFPM

#ifdef IC_WIN
extern const unsigned long
  IFontDialog__helpButton[]        = { 2 },     // 0x00000004
  IFontDialog__applyButton[]       = { 9 },     // 0x00000200
  IFontDialog__resetButton[]       = { 95 },    // 0 (ignored)
  IFontDialog__modeless[]          = { 47 },    // 0, 0x00008000
  IFontDialog__proportionalOnly[]  = { 95 },    // 0 (ignored)
  IFontDialog__bitmapOnly[]        = { 11 },    // 0x00000800
  IFontDialog__vectorOnly[]        = { 17 },    // 0x00020000
  IFontDialog__fixedWidthOnly[]    = { 14 },    // 0x00004000
  IFontDialog__noSynthesize[]      = { 12 },    // 0x00001000
  IFontDialog__noStyle[]           = { 95 },    // 0x00000000
  IFontDialog__classDefaultStyle[] = { 95 };    // 0 (resetButton)
#endif //IC_WIN


//====================================================================
// IBitmapControl styles
//====================================================================
extern const unsigned long
#ifdef IC_PM
  IBitmapControl__sizeToBitmap[]      = {3},   //SS_BITMAP
  IBitmapControl__classDefaultStyle[] = {31,64},  // visible, sizeToWindow
#endif //IC_PM
#ifdef IC_MOTIFWIN
  IBitmapControl__sizeToBitmap[]      = {32},  //0, 0x00000001
  IBitmapControl__classDefaultStyle[] = {28,64},  // visible, sizeToWindow
#endif //IC_WIN
  IBitmapControl__sizeImageToWindow[] = {64},
  IBitmapControl__sizeWindowToImage[] = {65};

//====================================================================
// IIconControl styles
//====================================================================
extern const unsigned long
#ifdef IC_PM
  IIconControl__sizeToIcon[]        = {3},    //SS_BITMAP
  IIconControl__classDefaultStyle[] = {31,64}, // visible, sizeToWindow
#endif //IC_MOTIFPM
#ifdef IC_MOTIFWIN
  IIconControl__sizeToIcon[]        = {32},   //0, 0x00000001
  IIconControl__classDefaultStyle[] = {28,64}, // visible, sizeToWindow
#endif //IC_MOTIFWIN
  IIconControl__sizeImageToWindow[] = {64},
  IIconControl__sizeWindowToImage[] = {65};

//====================================================================
// IGraphicPushButton styles
//====================================================================
extern const unsigned long
#ifdef IC_MOTIFPM
  IGraphicPushButton__sizeToGraphic[]     = {7},   //BS_ICON
#endif //IC_MOTIFPM
#ifdef IC_WIN
  IGraphicPushButton__sizeToGraphic[]     = {45},  //IBS_ICON (0,0x00002000)
#endif //IC_WIN
  IGraphicPushButton__sizeImageToWindow[] = {64},
  IGraphicPushButton__sizeWindowToImage[] = {65},
#ifdef IC_MOTIFWIN
  IGraphicPushButton__classDefaultStyle[] = {28,64}; // visible, sizeToWindow
#endif
#ifdef IC_PM
  IGraphicPushButton__classDefaultStyle[] = {31,64}; // visible, sizeToWindow
#endif //IC_PM

//====================================================================
// ITabControl styles
//====================================================================
#ifdef IC_PM
extern const unsigned long
  ITabControl__border3D[]          = { 95 },   // 0 (ignored)
  ITabControl__buttons[]           = { 9 },    // BKS_BUTTONAREA          0x00000200
  ITabControl__tabsBottom[]        = { 7 },    // BKS_MAJORTABBOTTOM      0x00000080
  ITabControl__tabsTop[]           = { 6 },    // BKS_MAJORTABTOP         0x00000040
  ITabControl__classDefaultStyle[] = { 6, 31 };
                                               // 0x80000040
                                               // ITabControl__tabsTop, IWindow__visible
#endif // IC_PM

#ifdef IC_WIN
extern const unsigned long
  ITabControl__border3D[]          = { 9 },    // ( 0, WS_EX_CLIENTEDGE ) 0x00000200 *
  ITabControl__buttons[]           = { 32 },   // 0, 0x00000001
  ITabControl__tabsBottom[]        = { 95 },   // 0 (ignored)
  ITabControl__tabsTop[]           = { 95 },   // 0 (ignored)
  ITabControl__classDefaultStyle[] = { 28 };   // 0x80000000
                                               // IWindow__visible
#endif // IC_WIN

//====================================================================
// ITabPage styles
//====================================================================
#ifdef IC_PM
extern const unsigned long
  ITabPage__autoPageSize[]         = { 8 },     // BKA_AUTOPAGESIZE       0x00000100
  ITabPage__noStyle[]              = { 95 },    // 0x00000000
  ITabPage__classDefaultStyle[]    = { 8 };     // 0x00000100
                                                // ITabPage__autoPageSize
#endif // IC_PM

#ifdef IC_WIN
extern const unsigned long
  ITabPage__autoPageSize[]         = { 32 },    // 0, 0x00000001
  ITabPage__noStyle[]              = { 95 },    // 0x00000000
  ITabPage__classDefaultStyle[]    = { 32 };    // 0, 0x00000001
                                                // ITabPage__autoPageSize
#endif // IC_WIN

