// Revision: 08 1.4.1.4 source/ui/baseapp/idievt.cpp, genhdr, ioc.v400, 000302  
/*******************************************************************************
* FILE NAME: idievt.cpp                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in idievt.hpp.                                                             *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#define INCL_WINMENUS
extern "C" {
   #include <iwindefs.h>
}

#include <idievt.hpp>
#if !defined( _IRECT_ )
  #include <irect.hpp>
#endif

#include <itrace.hpp>

#ifdef IC_MOTIF
  #include <iownitem.hpp>
#endif
// Segment definitions
#ifdef IC_PAGETUNE
  #define _IDIEVT_CPP_
  #include <ipagetun.h>
#endif


/*------------------------------------------------------------------------------
| IDrawItemEvent::IDrawItemEvent                                               |
------------------------------------------------------------------------------*/
IDrawItemEvent :: IDrawItemEvent(const IEvent& evt)
  : IDrawItemEvent::Inherited(evt)
{
   pvOwnerItem = (void*)evt.parameter2();
}

/*------------------------------------------------------------------------------
| IDrawItemEvent::~IDrawItemEvent                                              |
------------------------------------------------------------------------------*/
IDrawItemEvent :: ~IDrawItemEvent ( ) {}


/*------------------------------------------------------------------------------
| IDrawItemEvent::itemPresSpaceHandle                                          |
------------------------------------------------------------------------------*/
IPresSpaceHandle IDrawItemEvent::itemPresSpaceHandle() const
{
#ifdef IC_PM
   return IPresSpaceHandle( ((POWNERITEM)pvOwnerItem)->hps,
                            this->controlHandle() );
#endif
#ifdef IC_WIN
   return IPresSpaceHandle( ((LPDRAWITEMSTRUCT)pvOwnerItem)->hDC,
                            this->controlHandle() );
#endif
#ifdef IC_MOTIF
   return *((IOwnerItem *) pvOwnerItem)->fPresSpace;
#endif
}

/*------------------------------------------------------------------------------
| IDrawItemEvent::itemId                                                       |
------------------------------------------------------------------------------*/
unsigned long IDrawItemEvent::itemId() const
{
#ifdef IC_PM
   return ((POWNERITEM)pvOwnerItem)->idItem;
#endif
#ifdef IC_WIN
   return ((LPDRAWITEMSTRUCT)pvOwnerItem)->itemID;
#endif
#ifdef IC_MOTIF
   return ((IOwnerItem *)pvOwnerItem)->fItemId;
#endif
}

/*------------------------------------------------------------------------------
| IDrawItemEvent::itemRect                                                     |
------------------------------------------------------------------------------*/
IRectangle IDrawItemEvent:: itemRect() const
{
#ifdef IC_PM
   POWNERITEM poi = (POWNERITEM)pvOwnerItem;
   return IRectangle(poi->rclItem.xLeft, poi->rclItem.yBottom,
                     poi->rclItem.xRight, poi->rclItem.yTop);
#endif
#ifdef IC_WIN
   LPDRAWITEMSTRUCT poi = (LPDRAWITEMSTRUCT)pvOwnerItem;
   return IRectangle(poi->rcItem.left, poi->rcItem.bottom,
                     poi->rcItem.right, poi->rcItem.top);
#endif
#ifdef IC_MOTIF
   return ((IOwnerItem *)pvOwnerItem)->fItemRectangle; 
#endif
}
