/*NOSHIP*/
#ifndef _IGUILOCK_
#define _IGUILOCK_
/*----------------------------------------------------------------------------*/
/* FILE NAME: iguilock.hpp                                                    */
/*                                                                            */
/* DESCRIPTION:                                                               */
/*   Declaration of the classes:                                              */
/*     IGUIResourceLock                                                       */
/*                                                                            */
/* COPYRIGHT:                                                                 */
/*   IBM Open Class Library                                                   */
/*   Licensed Materials - Property of IBM                                     */
/*                                                                            */
/*   5645-001                                                                 */
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
/*                                                                            */
/*   US Government Users Restricted Rights - Use, duplication, or             */
/*   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.        */
/*                                                                            */
/*----------------------------------------------------------------------------*/
#include <ibase.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IResource;

#pragma pack(push,4)

class IC_EXPORTB IGUIResourceLock {
public:
/*------------------------------- Constructors -------------------------------*/
  IGUIResourceLock  ( IResource& resource,
                      long       timeOut = -1 );
  ~IGUIResourceLock ( );

private:
/*------------------------------ Hidden Members ------------------------------*/
  IGUIResourceLock ( const IGUIResourceLock& resourceLock );
IGUIResourceLock
 &operator=     ( const IGUIResourceLock& resourceLock );

/*--------------------------------- Private ----------------------------------*/

IResource
 *fResource;
bool
  fLock;
}; // IGUIResourceLock

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#include <iguilock.inl>

#endif // _IGUILOCK_
