// Revision: 53 1.1.1.2 source/ui/baseapp/iguilock.inl, thread, ioc.v400, 000302  
/*NOSHIP*/
#ifndef _IGUILOCK_INL_
#define _IGUILOCK_INL_
/*----------------------------------------------------------------------------*/
/* FILE NAME: iguilock.inl                                                    */
/*                                                                            */
/* DESCRIPTION:                                                               */
/*   This file contains the definition of the inline functions for the        */
/*   classes declared in iguilock.hpp.                                        */
/*                                                                            */
/* COPYRIGHT:                                                                 */
/*   IBM Open Class Library                                                   */
/*   Licensed Materials - Property of IBM                                     */
/*                                                                            */
/*   5645-001                                                                 */
/*   (C) Copyright IBM Corporation 1992, 1997  All Rights Reserved.           */
/*                                                                            */
/*   US Government Users Restricted Rights - Use, duplication, or             */
/*   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.        */
/*                                                                            */
/*----------------------------------------------------------------------------*/

#include <ireslock.hpp>
#include <iperfset.hpp>

/*------------------------------------------------------------------------------
| IGUIResourceLock::IGUIResourceLock                                           |
------------------------------------------------------------------------------*/
inline IGUIResourceLock::IGUIResourceLock( IResource& resource,
                                           long       timeOut )
   : fResource( &resource ),
     fLock ( ! IPerformanceSettings::isSettingEnabled (
                  IPerformanceSettings::singleThreadedGUI ) )
{
   if (fLock)
      fResource->lock( timeOut );
}

/*------------------------------------------------------------------------------
| IGUIResourceLock::~IGUIResourceLock                                          |
------------------------------------------------------------------------------*/
inline IGUIResourceLock::~IGUIResourceLock( )
{
   if (fLock)
      fResource->unlock( );
}

#endif // _IGUILOCK_INL_

