// Revision: 88 1.4.1.3 source/ui/baseapp/imbarprv.hpp, menu, ioc.v400, 000302  
/* NOSHIP */
#ifndef _IMBARPRV_
#define _IMBARPRV_
/*******************************************************************************
* FILE NAME: imbarprv.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of classes that are private              *
*   to the implementation of IMenuBar.                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <imenubar.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

/*------------------------------------------------------------------------------
| IMenuBarData                                                          |
|                                                                              |
| This class wrappers the private data for the IMenuBar class.                 |
------------------------------------------------------------------------------*/
class IMenuBarData 
  {
  public:

  IMenuBarData();
  ~IMenuBarData();

/*************************************************************************/
/* bMotifWrapper is set to true when an IMenuBar has been wrappered.     */
/*               A IMenuBar is wrappered in two situations:              */
/*               1.  The IMenuBar::wrapper style is used on ctor         */
/*               2.  The Id of current menubar equals id of menubar      */
/*                   being constructed and they both equal IFrameWindow  */
/*                   id.                                                 */
/*************************************************************************/
  Boolean       bMotifWrapper;

// Wrappered menubar widget
  IWindowHandle frameMBar;
// Owner of the wrappered IMenuBar
  IFrameWindow* frameWin;

  private:

  IMenuBarData::IMenuBarData
                                  (const IMenuBarData&);
  IMenuBarData& operator= (const IMenuBarData&);

};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* _IMBARPRV_ */
