// Revision: 24 1.4 source/ui/baseapp/inbdievt.cpp, notebook, ioc.v400, 000302  
/*******************************************************************************
* FILE NAME: inbdievt.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Implementation of the class(es):                                           *
*     INotebookDrawItemEvent                                                   *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
extern "C" {
  #define INCL_WINMENUS             // for POWNERITEM
  #include <iwindefs.h>

#ifdef IC_WIN
  #ifndef _WIN32
    #define _WIN32
  #endif
  #include <commctrl.h>
#endif
}

#ifndef _INBDIEVT_
  #include <inbdievt.hpp>
#endif

#ifndef _ICCONST_
  #include <icconst.h>
#endif
#ifndef _IEXCEPT_
  #include <iexcept.hpp>
#endif
#ifndef _INOTEBK_
  #include <inotebk.hpp>
#endif

#ifdef IC_WIN
#ifndef _IWCNAME_
  #include <iwcname.hpp>
#endif
#endif //IC_WIN

// Segment definitions
#ifdef IC_PAGETUNE
  #define _INBDIEVT_CPP_
  #include <ipagetun.h>
#endif

/*------------------------------------------------------------------------------
| INotebookDrawItemEvent::INotebookDrawItemEvent                               |
------------------------------------------------------------------------------*/
INotebookDrawItemEvent :: INotebookDrawItemEvent ( IEvent& evt )
  : INotebookDrawItemEvent::Inherited(evt) {;}

/*------------------------------------------------------------------------------
| INotebookDrawItemEvent::~INotebookDrawItemEvent                              |
------------------------------------------------------------------------------*/
INotebookDrawItemEvent :: ~INotebookDrawItemEvent ( )  {;}

/*------------------------------------------------------------------------------
| INotebookDrawItemEvent::page                                                 |
------------------------------------------------------------------------------*/
IPageHandle  INotebookDrawItemEvent :: page ( ) const
{
  IPageHandle topPageHandle (0);

#ifdef IC_WIN
  topPageHandle = (void*)this->itemId();
#else
  topPageHandle = this->itemId();
#endif

  return( topPageHandle );
}

/*------------------------------------------------------------------------------
| INotebookDrawItemEvent::itemId                                               |
------------------------------------------------------------------------------*/
unsigned long  INotebookDrawItemEvent :: itemId ( ) const
{
  unsigned long ulId = 0;

  IWindowHandle
#ifdef IC_WIN
    hwndControl = ((LPDRAWITEMSTRUCT)ownerItemData())->hwndItem;
#else
    hwndControl = ((POWNERITEM)ownerItemData())->hwnd;
#endif

  INotebook* pNotebk = (INotebook*)IWindow::windowWithHandle( hwndControl );
  if (pNotebk)
  {
    if ( pNotebk->isPMCompatible() )
    {
      /************************************************************************/
      /* CUA '91 notebook                                                     */
      /************************************************************************/
#ifdef IC_WIN
      ulId = ((LPDRAWITEMSTRUCT)ownerItemData())->itemID;
#else
      ulId = ((POWNERITEM)ownerItemData())->hItem;
#endif
    }
#ifdef IC_WIN
    else
    {
      /************************************************************************/
      /* Windows tab control                                                  */
      /************************************************************************/
      ulId =
        pNotebk->tabPageHandle( ((LPDRAWITEMSTRUCT)ownerItemData())->itemID ).asUnsigned();
    }
#endif
  }

  return( ulId );
}
