// Revision: 43 1.4.1.3 source/ui/baseapp/ipmexsta.hpp, views, ioc.v400, 000302  
/* NOSHIP */
#ifndef _IPMEXSTA_
#define _IPMEXSTA_
/*******************************************************************************
* FILE NAME: ipmexsta.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the declarations of the static PM Extensions            *
*   functions used by IFontDialog and IFileDialog.                             *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <ihandle.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

struct _FILEDLG;
struct _FONTDLG;
class IDynamicLinkLibrary;

typedef unsigned long
     (_System  IWinFontDlg)( unsigned long, unsigned long, _FONTDLG* );
typedef unsigned long
     (_System  IWinDefFontDlgProc)( unsigned long, unsigned long,
                                    unsigned long, unsigned long );
typedef unsigned long
     (_System  IWinDefFileDlgProc)( unsigned long, unsigned long,
                                    unsigned long, unsigned long );
typedef unsigned long
     (_System  IWinFileDlg)( unsigned long, unsigned long, _FILEDLG*);
typedef bool
     (_System  IWinFreeFileDlgList)( char**);

#pragma enum(4)
#pragma pack(push,4)

class IPMCtlStatics 
{
public:
  ~IPMCtlStatics         ( );

static IDynamicLinkLibrary
 &pmCtlDLL               ( );
static IWindowHandle
  fontDlg        ( IWindowHandle parent,
                   IWindowHandle owner,
                   _FONTDLG*     fontDialog),
  fileDlg        ( IWindowHandle parent,
                   IWindowHandle owner,
                   _FILEDLG*     fileDialog);
static IEventResult
  defFileDlgProc ( IWindowHandle dialog,
                   unsigned long msgId,
                   IEventParameter1 mp1,
                   IEventParameter2 mp2),
  defFontDlgProc ( IWindowHandle dialog,
                   unsigned long msgId,
                   IEventParameter1 mp1,
                   IEventParameter2 mp2);

static IWinProc
 *defFileDlgProcAddr ( ),
 *defFontDlgProcAddr ( );

static bool
  freeFileDlgList( char**        fileNameTable);


private:

static IWinFontDlg
 *entryFontDlg;
static IWinFileDlg
 *entryFileDlg;
static IWinDefFontDlgProc
 *entryDefFontDlgProc;
static IWinDefFileDlgProc
 *entryDefFileDlgProc;
static IWinFreeFileDlgList
 *entryFreeFileDlgList;

static IDynamicLinkLibrary
 *pmCtlDynLinkLib;
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IPMEXSTA_
