// Revision: 38 1.1 source/ui/baseapp/iwinmphd.cpp, userinput, ioc.v400, 000302 
/*******************************************************************************
* FILE NAME: iwinmphd.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in iwinmphd.hpp.                                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
extern "C"
{
  #define INCL_WINTRACKRECT    // TF_xxx
  #define INCL_WINMESSAGEMGR   // WM_HITTEST, WinQueryMsgPos
  #define INCL_WINWINDOWMGR    // WinMapWindowPoints
  #include <iwindefs.h>
}

#include <iwinmphd.hpp>
#include <ievtdata.hpp>
#include <iframe.hpp>
#include <ithread.hpp>
#include <iwindow.hpp>

// Segment definitions.
#ifdef IC_PAGETUNE
  #define _IWINMPHD_CPP_
  #include <ipagetun.h>
#endif

#ifdef IC_PMWIN
/*------------------------------------------------------------------------------
| IWindowMousePointerHandler::IWindowMousePointerHandler                       |
|                                                                              |
| Default constructor here for page tuning.                                    |
------------------------------------------------------------------------------*/
IWindowMousePointerHandler::IWindowMousePointerHandler ( )
 : IWindowMousePointerHandler::Inherited( IMouseHandler::someMouseMoves )
{ }

/*------------------------------------------------------------------------------
| IWindowMousePointerHandler::IWindowMousePointerHandler                       |
|                                                                              |
| Default destructor here for page tuning.                                     |
------------------------------------------------------------------------------*/
IWindowMousePointerHandler::~IWindowMousePointerHandler ( )
{ }

/*------------------------------------------------------------------------------
| IWindowMousePointerHandler::mousePointerChange                               |
|                                                                              |
| This function sets the mouse pointer based on mouse moves.                   |
------------------------------------------------------------------------------*/
bool IWindowMousePointerHandler::mousePointerChange
                                   ( IMousePointerEvent& event )
{
  bool
    stopProcessingEvent = false;
  IWindow
   *window = event.dispatchingWindow();

#if 0
  // Check for special frame window processing.
  // Note: Currently this code is not used because it is debatable
  //       whether we should preserve the standard mouse pointer
  //       behavior on Intel platforms to match Motif behavior.
  IFrameWindow
   *frameWindow = dynamic_cast< IFrameWindow* >( window );
  bool
    done = false,
  if ( frameWindow )
  {
#ifdef IC_WIN
     unsigned long
       hitResult = event.parameter2().lowNumber();
     if ( hitResult >= HTLEFT  &&  hitResult <= HTBOTTOMRIGHT )
     {  // The mouse pointer looks to be over the sizing border of
        // a frame window.  Don't change the mouse pointer in this
        // case.  To better match Motif, continue to use the
        // default mouse pointer that the OS uses instead, by
        // letting this message fall to the default window procedure.
        done = true;
     }
#endif
#ifdef IC_PM
     if ( ! window->mousePointer() )
     {  // No window-specific mouse pointer for this frame window.
        // Always return true, so that the frame window procedure
        // does not route the message to a client window.  Allowing
        // this to happen with a canvas client would result in an
        // infinite loop, because the canvas window procedure
        // routes this message to the owner window of the canvas,
        // even if it is a frame window.  (Frame windows with
        // application-specified mouse pointers are handled further
        // below.)
        event.setMousePointer( event.defaultMousePointer() );
        stopProcessingEvent = true;
     }
     else
     {  // Check if the mouse pointer is over a frame sizing border.
        POINTL
          pointl;
        IQUERYMSGPOS( IThread::current().anchorBlock(), &pointl );
        IMAPWINDOWPOINTS( IWindow::desktopWindow()->handle(),
                          event.dispatchingWindow()->handle(),
                          &pointl, 1 );
        unsigned long
          mousePos;
        PPOINTS
          points = (PPOINTS) &mousePos;
        points->x = (short) pointl.x;
        points->y = (short) pointl.y;
        IEvent
          hitTestEvent( frameWindow,
                        WM_HITTEST,
                        IEventParameter1( mousePos ),
                        IEventParameter2( 0 ) );
        IEventResult
          hitTest = frameWindow->sendEvent( hitTestEvent );
        if ( hitTest & ( TF_LEFT | TF_TOP | TF_RIGHT | TF_BOTTOM ) )
        {  // The mouse pointer looks to be over the sizing border of
           // a frame window.  Don't change the mouse pointer in this
           // case.  To better match Motif, continue to use the
           // default mouse pointer that the OS uses instead.
           event.setMousePointer( event.defaultMousePointer() );
           stopProcessingEvent = true;
        }
     }
#endif // IC_PM
  }

  if ( !stopProcessingEvent  &&  !done  &&  window->mousePointer() )
#else // ! 0
  if ( window->mousePointer() )
#endif // ! 0
  {
     event.setMousePointer( window->mousePointer() );
     stopProcessingEvent = true;
  }

  return stopProcessingEvent;
}
#endif // IC_PMWIN
