// Revision: 39 1.7.1.3 source/ui/basectl/icctlsta.hpp, control, ioc.v400, 000302  
/* NOSHIP */
#ifndef _ICCTLSTA_
#define _ICCTLSTA_
/*******************************************************************************
* FILE NAME: icctlsta.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the declaration(s) of the IControlStatics class, which  *
*   is used to dynamically load the dll for the container, notebook, slider    *
*   and spin button controls.                                                  *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <ihandle.hpp>

#ifdef IC_WIN
// only needed in Windows

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

typedef unsigned long
     (FAR PASCAL *IS32to16SendMessage)( void *, unsigned int,
                                        unsigned long, unsigned long );
typedef unsigned long
     (FAR PASCAL *IS32to16PostMessage)( void *, unsigned int,
                                        unsigned long, unsigned long );
typedef unsigned long
     (FAR PASCAL *IS16to32Message)( void *, unsigned int *,
                                    unsigned long *, unsigned long * );

class IControlStatics
{
public:

static HMODULE
  loadControlDLL        ( );

static HMODULE
  controlDynLinkLib;

static IS32to16SendMessage lpfn32to16SendMessage;
static IS32to16PostMessage lpfn32to16PostMessage;
static IS16to32Message     lpfn16to32Message;
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif  // IC_WIN


// jad 6-4-96 (icl2_7576) - rest of file
#ifdef IC_PM

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IDynamicLinkLibrary;
// only needed for PM (a little redundancy, but safer and cleaner right now...)

#pragma enum(4)
#pragma pack(push,4)


typedef bool
     (_System  IRegisterCircularSlider)( );

class IControlStatics 
{
public:

static bool
  registerCircularSlider  ();

static IDynamicLinkLibrary
  *mmctlDynLinkLib;

static IRegisterCircularSlider
  *entryRegisterCircularSlider;
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif  // IC_PM

#endif // _ICCTLSTA_
