#ifndef _ICVOBSRV_CPP_
#define _ICVOBSRV_CPP_
/*******************************************************************************
* FILE NAME: icvobsrv.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in icvobsrv.hpp.                                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved.                   *
*                                                                              *
*******************************************************************************/

#include <icvobsrv.hpp>
#include <iobservr.hpp>


ICanvasObserver :: ICanvasObserver ( ICanvas* canvas )
 :ICanvasObserver :: Inherited ( ),
  pCanvas( canvas )
{ }

ICanvasObserver :: ~ICanvasObserver ( )
{ }

IObserver&   ICanvasObserver::dispatchNotificationEvent( const INotificationEvent & anEvent )
{
  INotificationId id(anEvent.notificationId());

  if ( ( id == IWindow::attributeAddReplaceId) ||
       ( id == IWindow::attributeRemoveId) )
  {
    IWindow& window = (IWindow&)anEvent.notifier();
    if ( window.parent() == (IWindow*)pCanvas )
    {
    
       pCanvas->setLayoutDistorted(IWindow::layoutChanged |
                                   IWindow::immediateUpdate, 0);
    }
  }
  return *this;
}

#endif // _ICVOBSRV_CPP_

