// Revision: 22 1.5 source/ui/basectl/inotebk0.hpp, notebook, ioc.v400, 000302  
/* NOSHIP */
#ifndef _INOTEBK0_
#define _INOTEBK0_
/*******************************************************************************
* FILE NAME: inotebk0.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     INotebookPageSettingsData                                                *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifdef IC_WIN

extern "C" {
  #ifndef _WIN32
    #define _WIN32
  #endif
  #include <commctrl.h>
}

#include <ibase.hpp>
#include <ihandle.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

struct IOC_ITEM {
  TC_ITEMHEADER  itemHeader;
  unsigned long  ulUserData;
  unsigned long  ulPageStyle;
  IWindowHandle  hPageWindow;
  IWindowHandle  hPageWindowParent;
};

/*------------------------------------------------------------------------------
| INotebookPageSettingsData class definition                                   |
------------------------------------------------------------------------------*/
class INotebookPageSettingsData 
{
public:
  INotebookPageSettingsData  ( );

virtual
  ~INotebookPageSettingsData ( );


IOC_ITEM
  tabCtrlItem;          // IOC Tab control item structure
};

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif //IC_WIN

#endif /* _INOTEBK0_ */

