// Revision: 53 1.5 source/ui/basectl/isetcvwd.inl, canvas, ioc.v400, 000302  
/* NOSHIP */
#ifndef _ISETCVWD_INL_
#define _ISETCVWD_INL_
/*******************************************************************************
* FILE NAME: isetcvwd.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in isetcvwd.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

inline ISetCanvasWindowData::ISetCanvasWindowData
                                ( const IWindowHandle& parentCanvasHandle )
    : fParentHandle( parentCanvasHandle )
    , fInLayout( eUnknown )
#if 0                                  // IC_NOTYET
    , fFirstInDeck( false )
    , fDeckWidth( 0 )
    , fRectangle()
    , fMinimumSize()
#endif                                 // IC_NOTYET
  { }

inline ISetCanvasWindowData& ISetCanvasWindowData::setParentHandle
                                            ( const IWindowHandle& handle )
  {
    fParentHandle = handle;
    return *this;
  }
inline IWindowHandle ISetCanvasWindowData::parentHandle ( ) const
  {
    return fParentHandle;
  }
inline ISetCanvasWindowData& ISetCanvasWindowData::addToLayout ( )
  {
    fInLayout = eAddedToLayout;
    return *this;
  }
inline ISetCanvasWindowData& ISetCanvasWindowData::removeFromLayout ( )
  {
    fInLayout = eRemovedFromLayout;
    return *this;
  }
inline bool ISetCanvasWindowData::isAddedToLayout ( ) const
  {
    return ( fInLayout == eAddedToLayout );
  }
inline bool ISetCanvasWindowData::isRemovedFromLayout ( ) const
  {
    return ( fInLayout == eRemovedFromLayout );
  }

#if 0                                  // IC_NOTYET
inline ISetCanvasWindowData& ISetCanvasWindowData::setFirstInDeck
                                                      ( bool first = true )
  {
    fFirstInDeck = first;
    return *this;
  }
inline ISetCanvasWindowData& ISetCanvasWindowData::setDeckWidth
                                                    ( unsigned long width )
  {
    fDeckWidth = width;
    return *this;
  }
inline bool ISetCanvasWindowData::isFirstInDeck ( ) const
  {
    return fFirstInDeck;
  }
inline unsigned long ISetCanvasWindowData::deckWidth ( ) const
  {
    return fDeckWidth;
  }

inline IPoint ISetCanvasWindowData::topLeftOffset ( ) const
  {
    return fRectangle.bottomLeft();
  }
inline ISize ISetCanvasWindowData::size ( ) const
  {
    return fRectangle.size();
  }
inline ISize ISetCanvasWindowData::minimumSize ( ) const
  {
    return fMinimumSize;
  }
inline IRectangle ISetCanvasWindowData::rect ( ) const
  {
    return fRectangle;
  }
inline ISetCanvasWindowData& ISetCanvasWindowData::saveTopLeftOffset
                                          ( const IPoint& offsetToTopLeft )
  {
    fRectangle.moveTo( offsetToTopLeft );
    return *this;
  }
inline ISetCanvasWindowData& ISetCanvasWindowData::saveTopOffset
                                               ( IPair::Coord offsetToTop )
  {
    fRectangle.moveBy( IPoint( 0, offseToTop - fRectangle.bottom() ) );
    return *this;
  }
inline ISetCanvasWindowData& ISetCanvasWindowData::saveLeftOffset
                                              ( IPair::Coord offsetToLeft )
  {
    fRectangle.moveBy( IPoint( offsetToLeft - fRectangle.left(), 0 ) );
    return *this;
  }
inline ISetCanvasWindowData& ISetCanvasWindowData::saveSize
                                                      ( const ISize& size )
  {
    fRectangle.sizeTo( size );
    return *this;
  }
inline ISetCanvasWindowData& ISetCanvasWindowData::saveMinimumSize
                                                   ( const ISize& minSize )
  {
    fMinimumSize = minSize;
    return *this;
  }
#endif                                 // IC_NOTYET

#endif // _ISETCVWD_INL_
