// Revision: 52 1.12 source/ui/basectl/isliderw.hpp, slidectls, ioc.v400, 000302 
/* NOSHIP */
#ifndef _ISLIDERW_
   #define _ISLIDERW_
/*******************************************************************************
* FILE NAME: isliderw.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*                                                                              *
* Implementation Notes:                                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

#include <icolor.hpp>
#include <icontrol.hpp>
#include <igimage.hpp>
#include <ihitdtec.hpp>
#include <ihandler.hpp>
#include <islider.hpp>
#include <itimer.hpp>
extern "C"
{
  #include <iwindefs.h>
  #include <commctrl.h>
}
#pragma info(none)
  #include <iset2.h>
#pragma info(restore)

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

#pragma info(none)

typedef ISet<unsigned long> TickSet;

class INativeSliderHandler : public IHandler
{
typedef IHandler
  Inherited;
/*******************************************************************************
* The INativeSliderHandler class implements a default handler for native       *
* Windows sliders.                                                             *
*******************************************************************************/
public:

/*------------------------ Constructors ----------------------------------------
| The only way to construct an instance of this class is to use the default.   |
------------------------------------------------------------------------------*/
  INativeSliderHandler( );
 ~INativeSliderHandler( );

protected:
/*----------------------------- Implementation ---------------------------------
| This function is used to implement the class:                                |
|   dispatchHandlerEvent - Routes the size/trackbar events to the trackbar.    |
------------------------------------------------------------------------------*/
virtual bool
  dispatchHandlerEvent  ( IEvent& event       );
};

/*------------------------------------------------------------------------------
| Private data class for IProgressIndicator                                    |
|                                                                              |
| This class contains functions and data necessary for the use of the Windows  |
| trackbar in the IProgressIndicator class.                                    |
------------------------------------------------------------------------------*/
class IProgressIndicatorData  {
public:
  IProgressIndicatorData();
  ~IProgressIndicatorData();

IWindowHandle
  trackbar;

bool
  isWrappered;

unsigned long
  scaleFactor,
  tickPos0,
  numberTicks[2],
  tickSpacing[2],
  longestTick[2],
  pixelRange,
  needsTextMinCalc;

TickSet
  visibleTicks[2];

IPoint
  shaftPosition;

IHitGraphicGroup
  buttons;

IRawArray<IKeyGraphicPair>
  tickText[2];

bool
  textVisible;

IImage
  *leftDown,
  *leftDownPressed,
  *leftDownDisabled,
  *rightUp,
  *rightUpPressed,
  *rightUpDisabled;

ITimer
  *timer;

WNDPROC
  fdefaultTrackbarProc;

INativeSliderHandler
  fdefaultHandler;

static void
  registerSlider();

void
  createNativeSlider( const IWindowHandle& parent,
                      const IWindowHandle& owner,
                      unsigned long        ulStyle,
                      unsigned long        extStyle ),
  destroyNativeSlider( ),
  setupNativeScale( IProgressIndicator::Scale scale ),
  layoutNativeSlider( ),
  drawRibbon( unsigned long newPosition ),
  setButtonState( ),
  buttonPressed (IImage *  button),
  buttonReleased( ),
  startTimer( ),
  cancelTimer( ),
  moveArm( ),
  calcLongestTick( );

unsigned long
  armRangeOffset( ),
  trackbarRange( );

IProgressIndicatorData
  &setArmRangeOffset( unsigned long newPosition );

private:
IProgressIndicatorData
   ( const IProgressIndicatorData& );
IProgressIndicatorData
 &operator=     ( const IProgressIndicatorData& );
}; // IProgressIndicatorData

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif  /* _ISLIDERW_ */
