// Revision: 72 1.6 source/ui/basectl/isplitch.hpp, canvas, ioc.v400, 000302  
/* NOSHIP */
#ifndef _ISPLITCH_
  #define _ISPLITCH_
/*******************************************************************************
* FILE NAME: isplitch.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     ISplitCanvasHandler                                                      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ihandler.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IEvent;
class IPresSpaceHandle;
class IRectangle;
class ISplitCanvas;
class ISplitBar;
class ISplitCanvasHandlerData;

#pragma enum(4)
#pragma pack(push,4)

class ISplitCanvasHandler : public IHandler {
typedef IHandler
  Inherited;
public:
/*-------------------------- Constructor/Destructor ----------------------------
| The only way to construct instances of this class is by using the            |
| default constructor, which does not take any arguments.                      |
------------------------------------------------------------------------------*/
  ISplitCanvasHandler   ( );
virtual
 ~ISplitCanvasHandler   ( );

/*---------------------------- Window Attachment -------------------------------
| These functions permit attaching and detaching the handler object to/from    |
| a split canvas object:                                                       |
|   handleEventsFor       - Attaches the handler to the specified split canvas |
|                           object.                                            |
|   stopHandlingEventsFor - Detaches the handler from the specified split      |
|                           canvas object.                                     |
------------------------------------------------------------------------------*/
virtual ISplitCanvasHandler
 &handleEventsFor       ( ISplitCanvas* canvas ),
 &stopHandlingEventsFor ( ISplitCanvas* canvas );

#ifdef IC_MOTIF
virtual ISplitCanvasHandler
 &handleEventsFor       ( ISplitBar* canvas ),
 &stopHandlingEventsFor ( ISplitBar* canvas );
#endif
protected:
/*-------------------------------- Overrides -----------------------------------
| This class overrides the following protected functions:                      |
|   dispatchHandlerEvent - Processes events as appropriate for a split canvas. |
------------------------------------------------------------------------------*/
virtual bool
  dispatchHandlerEvent  ( IEvent& event );

private:
/*--------------------------------- Private ----------------------------------*/
virtual IHandler
 &handleEventsFor       ( IWindow* window  ),
 &stopHandlingEventsFor ( IWindow* window  );

#ifdef IC_PMWIN
void
  paintSplitBar         ( const ISplitCanvas* canvas,
                          const IPresSpaceHandle& presSpace,
                          const IRectangle& paintArea );
#endif

ISplitCanvasHandlerData
 *fSplitCanvasHandlerData;
}; // ISplitCanvasHandler

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _ISPLITCH_
