#ifndef _PMTOWIN_
#define _PMTOWIN_

/* Revision: 53 1.5 source/ui/cclnt/notebook/pmtowin.h, cclbook, ioc.v400, 000302  */
/**********************************************************************/
/*                                                                    */
/*                         IBM CONFIDENTIAL                           */
/*                                                                    */
/*        (IBM Confidential-Restricted when combined with the         */
/*         aggregated OCO source modules for this program)            */
/*                                                                    */
/*                       OCO SOURCE MATERIALS                         */
/*                                                                    */
/*         20G0400 (C) Copyright IBM Corp. 1992, 1997 (Unpublished)   */
/*                                                                    */
/**********************************************************************/
typedef char    CHAR;
typedef BYTE    UCHAR;
typedef int     SHORT;
typedef WORD    USHORT;
typedef DWORD   ULONG;
typedef WORD    WPARAM;
typedef DWORD   LPARAM;
typedef LPSTR   PCHAR;
typedef LPBYTE  PUCHAR;
typedef LPINT   PSHORT;
typedef LPWORD  PUSHORT;
typedef LPDWORD PULONG;
typedef LPVOID  PVOID;
typedef HANDLE  HWND;
typedef RECT    RECTL;
typedef LONG    MPARAM;
typedef LONG    MRESULT;
typedef LPRECT  PRECTL;
typedef HDC     HPS;
typedef POINT   POINTL;
typedef LPPOINT PPOINTL;
typedef DRAWITEMSTRUCT   OWNERITEM;
typedef LPDRAWITEMSTRUCT POWNERITEM;
typedef LPSTR  PSZ;
typedef NPSTR  NPSZ;
typedef HICON  HPOINTER;
typedef HANDLE HMODULE;
typedef DWORD  PFN;
typedef WORD   SEL;
typedef PBYTE  NPBYTE;
typedef POINT   SIZEL;
typedef POINT FAR *PSIZEL;
typedef long (PASCAL FAR *PFNWP)(HWND, WORD, WORD, DWORD);
typedef TEXTMETRIC FAR *PFONTMETRICS;
typedef PFONTMETRICS  PFATTRS;

#ifdef PBYTE
#undef PBYTE
#define PBYTE LPBYTE
#endif

#define QWL_USER                   0
#define QWL_STYLE                  GWL_STYLE
#define QW_OWNER                   GW_OWNER
#define QWS_ID                     GWW_ID

// typedef FARPROC()               EXPENTRY()
// typedef NEARPROC()              APIENTRY()
#define EXPENTRY                   PASCAL FAR _loadds
#define APIENTRY                   PASCAL FAR

#define MPFROMP(p)                 ((MPARAM)(VOID FAR *)(p))
#define MAKEP(x,y)                 MAKELONG(y,x)
#define MPFROM2SHORT               MAKELONG
#define SELECTOROF                 HIWORD
#define OFFSETOF                   LOWORD
#define MPFROMLONG(p)              ((MPARAM)(ULONG)(p))
#define MPFROMHWND(h)              ((MPARAM)(HWND)(h))
#define LOUSHORT                   LOWORD
#define HIUSHORT                   HIWORD
#define PVOIDFROMMP(mp)            ((PVOID)(mp))
#define SHORT1FROMMP(mp)           ((USHORT)(LOWORD(mp)))
#define SHORT2FROMMP(mp)           ((USHORT)(HIWORD(mp)))
#define LONGFROMMP(mp)             ((ULONG)(mp))

#define PVOIDFROMMR(mr)            ((PVOID)(mr))
#define MRFROMP(p)                 ((MRESULT)(VOID FAR *)(p))
#define MRFROM2SHORT               MAKELONG
#define SHORT1FROMMR(mr)           ((USHORT)(LOWORD(mr)))
#define SHORT2FROMMR(mr)           ((USHORT)(HIWORD(mr)))
#define LONGFROMMR(mr)             ((ULONG)(mr))

/**********************************************************************/
/* System Metrics Constants                                           */
/**********************************************************************/
//      PM CODE                 WIN3 CODE
/**********************************************************************/
#define SV_CXSCREEN             SM_CXSCREEN
#define SV_CYSCREEN             SM_CYSCREEN
#define SV_CXVSCROLL            SM_CXVSCROLL
#define SV_CYHSCROLL            SM_CYHSCROLL
#define SV_CXBORDER             SM_CXBORDER
#define SV_CYBORDER             SM_CYBORDER
#define SV_CXDLGFRAME           SM_CXDLGFRAME
#define SV_CYDLGFRAME           SM_CYDLGFRAME
#define SV_CYMENU               SM_CYMENU
#define SV_CXFULLSCREEN         SM_CXFULLSCREEN
#define SV_CYFULLSCREEN         SM_CYFULLSCREEN
#define SV_CXICON               SM_CXICON
#define SV_CYICON               SM_CYICON
#define SV_CXPOINTER            SM_CXCURSOR
#define SV_CYPOINTER            SM_CYCURSOR


/**********************************************************************/
/* virtual keycodes                                                   */
/**********************************************************************/
//      PM CODE                 WIN3 CODE
/**********************************************************************/
#define VK_BUTTON1              VK_LBUTTON
#define VK_BUTTON2              VK_RBUTTON
//    ???????????????????       VK_MBUTTON
#define VK_BUTTON3              VK_RBUTTON
#define VK_BREAK                VK_CANCEL
#define VK_BACKSPACE            VK_BACK
#define VK_NEWLINE              VK_RETURN
#define VK_CTRL                 VK_CONTROL
#define VK_ALT                  VK_MENU
#define VK_CAPSLOCK             VK_CAPITAL
#define VK_ESC                  VK_ESCAPE
#define VK_PAGEUP               VK_PRIOR
#define VK_PAGEDOWN             VK_NEXT
#define VK_ENTER                VK_EXECUTE
#define VK_PRINTSCRN            VK_SNAPSHOT

/**********************************************************************/
/* macros                                                             */
/**********************************************************************/
#define MP1FROMMP2(mp2) { mp1 = *(PULONG)mp2;       \
                          mp2 = (ULONG)((PULONG)mp2+1); }
//                          mp2 = *((PULONG)mp2+1); }

#define MP2ISVALUE(mp2) { mp2 = *(PULONG)mp2; }

/**********************************************************************/
/* functions                                                          */
/**********************************************************************/
BOOL DrawRectangle( HDC, LPRECT ) ;
#define WM_CONTROL        WM_COMMAND
#define WM_BUTTON1DBLCLK  WM_LBUTTONDBLCLK
#define WM_BUTTON1DOWN    WM_LBUTTONDOWN
#define WM_BUTTON1UP      WM_LBUTTONUP
#define WM_BUTTON2DBLCLK  WM_MBUTTONDOWN
#define WM_BUTTON2DOWN    WM_MBUTTONDBLCLK
#define WM_BUTTON2UP      WM_MBUTTONUP
#define WM_BUTTON3DBLCLK  WM_RBUTTONDOWN        /* if a 2 button mouse,       */
#define WM_BUTTON3DOWN    WM_RBUTTONDBLCLK      /* WM_RBUTTON* is WM_BUTTON2* */
#define WM_BUTTON3UP      WM_RBUTTONUP
#define WM_CONTROLPOINTER WM_SETCURSOR

#define WinQueryWindowUShort GetWindowWord
#define WinQueryWindowULong  GetWindowLong
#define WinSetWindowUShort   SetWindowWord
#define WinSetWindowULong    SetWindowLong
#define WinQueryWindowRect   GetWindowRect
#define WinGetPS             GetDC
#define WinReleasePS         ReleaseDC
#define WinQueryAnchorBlock  {}
#define WinInflateRect(w,x,y,z)   InflateRect(x,y,z)
#define WinIntersectRect(w,x,y,z) IntersectRect(x,y,z)
#define WinPtInRect(x,y,z)        PtInRect(y,z)
#define WinSetActiveWindow(y,z)   SetActiveWindow(z)
#define WinSetFocus(y,z)     SetFocus(z)
#define WinSetCapture(y,z)   SetCapture(z)
#define WinSendMsg           SendMessage
#define WinQueryWindow(x,y,z) GetWindow(x,y)
#define WinInvalidateRect    InvalidateRect
#define WinFillRect          FillRect
#define GpiSavePS            SaveDC
#define GpiRestorePS         RestoreDC
#define WinSetPointer(x,y)   SetCursor(y)
#define GpiCreateRegion(x,y,pRectl)  CreateRectRgn(pRectl->left, \
                             pRectl->top, pRectl->right, pRectl->bottom)
#define GpiSetClipRegion(x,y,z) SelectClipRgn(x,y)
#define GpiPolyLine(x,y,z)   PolyLine(x,z,y)
#define WinQuerySysValue(x,y) GetSystemMetrics(y)
#define GpiDeleteBitmap      DeleteObject
#define GpiSetBitmap         SelectObject
#define WinSetRect(u,v,w,x,y,z) SetRect(v,w,x,y,z)
#define WinGetKeyState(x,y)  GetKeyState(y)
#define WinSetDlgItemShort(x,y,z,w)   SetDlgItemInt(x,y,z,w)

BOOL PASCAL PMPtInRect      (LPRECT lpRect, POINT pt);
int  PASCAL PMCopyRect      (LPRECT lprcDest, LPRECT lprcSrc);
BOOL PASCAL PMIsRectEmpty   (LPRECT lprc);
void PASCAL PMOffsetRect    (LPRECT lprc, int cx, int cy);
int  PASCAL PMUnionRect     (LPRECT lprcDest, LPRECT lprcSrc1, LPRECT lprcSrc2);
void PASCAL PMInflateRect   (LPRECT lprc, int cx, int cy);
void PASCAL PMSetRect       (LPRECT lprc, int left, int bottom, int right, int top);
int  PASCAL PMIntersectRect (LPRECT lprcDest, LPRECT lprcSrc1, LPRECT lprcSrc2);
void PASCAL PMInvalidateRect(HWND hwnd, LPRECT lpRect, BOOL bErase);
int  PASCAL PMFillRect      (HDC hDC, LPRECT lpRect, HBRUSH hBrush);
BOOL PASCAL PMEqualRect     (LPRECT lpRect1, LPRECT lpRect2);
HDC  PASCAL PMGetFlippedDC  (HWND);
VOID PASCAL PMFlipDC        (HWND, HDC);
VOID PASCAL PMGetClientRect (HWND, LPRECT);
VOID PASCAL PMFlipRect      (LPRECT);
VOID PASCAL PMGetCursorPos  (LPPOINT);
VOID PASCAL PMFlipPoint     (HWND, LPDWORD);
#endif // PMTOWIN header guard
