#ifndef _SLIDEWIN_
#define _SLIDEWIN_

/* Revision: 65 1.4 source/ui/cclnt/slider/slidewin.h, cclslid, ioc.v400, 000302  */
/**********************************************************************/
/*                                                                    */
/*              Licensed Materials - Property of IBM                  */
/*              20G0400 (C) Copyright IBM Corp. 1992, 1997.           */
/*                    See Copyright Instructions.                     */
/*                                                                    */
/**********************************************************************/
/**********************************************************************/
/*                                                                    */
/* CUA Controls Library/2 Version 1.0                       (Windows) */
/*                                                                    */
/* Sample Application Code                                            */
/* Slider Control                                                     */
/*                                                                    */
/* File:  slidewin.h                                                  */
/*                                                                    */
/* This header file includes macro includes for the slider sample     */
/* application (slidewin.c).                                          */
/*                                                                    */
/**********************************************************************/


#define IDR_HOUR               1    /* slider id's                    */
#define IDR_MINUTE             2
#define IDR_SECOND             3
#define IDR_COMPLETE           4
#define IDR_START              11   /* button id's                    */
#define IDR_STOP               12
#define ID_TIMER               21   /* timer id                       */

#define ID_RESOURCE            100  /* menu items                     */
#define IDM_FILE               110
#define IDM_SUBEXIT            111

#define SLD_POS_HOUR_X         20   /* x-position of hour slider      */
#define SLD_POS_HOUR_Y         65   /* y-position of hour slider      */
#define SLD_LEN_HOUR_X         300  /* x-length of hour slider        */
#define SLD_LEN_HOUR_Y         85   /* y-length of hour slider        */
#define SLD_TEXTINCR_HOUR      2    /* number every 2nd tick          */

#define SLD_POS_MINUTE_X       20   /* x-position of minute slider    */
#define SLD_POS_MINUTE_Y       175  /* y-position of minute slider    */
#define SLD_LEN_MINUTE_X       300  /* x-length of minute slider      */
#define SLD_LEN_MINUTE_Y       85   /* y-length of minute slider      */
#define SLD_TEXTINCR_MINUTE    5    /* number every 5th tick          */

#define SLD_POS_SECOND_X       20   /* x-position of second slider    */
#define SLD_POS_SECOND_Y       285  /* y-position of second slider    */
#define SLD_LEN_SECOND_X       300  /* x-length of second slider      */
#define SLD_LEN_SECOND_Y       85   /* y-length of second slider      */
#define SLD_TEXTINCR_SECOND    5    /* number every 5th tick          */

#define SLD_POS_COMPLETE_X     400  /* x-position of complete slider  */
#define SLD_POS_COMPLETE_Y     25   /* y-position of complete slider  */
#define SLD_LEN_COMPLETE_X     85   /* x-length of complete slider    */
#define SLD_LEN_COMPLETE_Y     345  /* y-length of complete slider    */
#define SLD_TEXTINCR_COMPLETE  5    /* number every 5th tick          */

#define BTN_POS_START_X        50   /* x-position of start button     */
#define BTN_POS_START_Y        373  /* y-position of start button     */
#define BTN_LEN_START_X        100  /* x-length of start button       */
#define BTN_LEN_START_Y        30   /* y-length of start button       */

#define BTN_POS_STOP_X         200  /* x-position of stop button      */
#define BTN_POS_STOP_Y         373  /* y-position of stop button      */
#define BTN_LEN_STOP_X         100  /* x-length of stop button        */
#define BTN_LEN_STOP_Y         30   /* y-length of stop button        */


/**********************************************************************/
/* Function prototypes                                                */
/**********************************************************************/
LRESULT CALLBACK ClientWndProc (HWND, UINT, WPARAM, LPARAM);
BOOL            SetUpTimer (HANDLE, WORD, BOOL);
char            *BuildTimeString (LONG, char *);
VOID            MakeChildren (HANDLE, HANDLE, HFONT);
VOID            createSlider (HANDLE, HANDLE, WORD, DWORD, WORD, WORD, WORD,
                              WORD, LPSLDCDATA, WORD, BOOL, BOOL, HFONT);
BOOL            setSliderPosition (HANDLE, WORD, DWORD);
DWORD           getSliderPosition (HANDLE, WORD);

#endif // SLIDEWIN header guard
