/* Revision: 70 1.3.1.2 source/ui/cclnt/spinbtn/spinreg.c, cclspin, ioc.v400, 000302  */
/****************************************************************************/
/*                                                                          */
/*                         IBM CONFIDENTIAL                                 */
/*                                                                          */
/*        (IBM Confidential-Restricted when combined with the               */
/*         aggregated OCO source modules for this program)                  */
/*                                                                          */
/*                       OCO SOURCE MATERIALS                               */
/*                                                                          */
/*         20G0400 (C) Copyright IBM Corp. 1992, 1997 (Unpublished)         */
/*                                                                          */
/****************************************************************************/
/****************************************************************************/
/*                                                                          */
/* MODULE = SPINREG.C                                                       */
/* COMPONENT = SPIN BUTTON                                                  */
/* USAGE = SPIN BUTTON REGISTRATION SOURCE                                  */
/*                                                                          */
/*                                                                          */
/* NOTES =                                                                  */
/*     NONE.                                                                */
/*                                                                          */
/*   RESTRICTIONS =                                                         */
/*                                                                          */
/*     NONE.                                                                */
/*                                                                          */
/*                                                                          */
/****************************************************************************/
/******************************************************************************/
/* Filename: SPINREG.C - Spin button class registration procedure             */
/*                                                                            */
/* Flag    Date    Defect  Description                                        */
/* ----  --------  -----  --------------------------------------------------- */
/* MAB2  01/24/96  6714   Initialization of cppwot3.dll failing sporatically. */
/* RKK1  04/30/96  7680   Change "SPINBTNP.H" to "spinbtnp.h"                 */
/******************************************************************************/

/****************************************************************************/
/* Includes                                                                 */
/****************************************************************************/

#include <windows.h>
#include "iclspbw.h"

#include "spinbtnp.h"                    /*RKK1*/

// Segment definitions
#ifdef IC_PAGETUNE
  #define _SPINREG_C_
  #include "icltune.h"
#endif

#if !defined(CCL_SEPARATE_DLL)
#define LibMain SpinbuttonLibMain
#endif

HANDLE hSpinInstance = 0;

INT  APIENTRY LibMain(HANDLE hInstance, DWORD ul_reason_being_called,
                      LPVOID lpReserved);

#if defined(CCL_SEPARATE_DLL)

#if defined(__IBMC__)

/* _CRT_init is the C run-time environment initialization function.         */
/* It will return 0 to indicate success and -1 to indicate failure.         */
int _CRT_init(void);

/* _DLL_InitTerm is the function that gets called by the operating system   */
/* loader when it loads and frees this DLL for each process that accesses   */
/* this DLL.  However, it only gets called the first time the DLL is loaded */
/* and the last time it is freed for a particular process.  The system      */
/* linkage convention MUST be used because the operating system loader is   */
/* calling this function.                                                   */
/* See DllEntryPoint in SDK documentation                                   */

INT APIENTRY          _DLL_InitTerm(HANDLE hInstance,
                                    DWORD  reasonCalled,
                                    LPVOID reserved );

INT APIENTRY          _DLL_InitTerm(HANDLE hInstance,
                                    DWORD  reasonCalled,
                                    LPVOID reserved )
{
   INT  rc = FALSE;     /* failed */
   switch (reasonCalled)
      {
      case  DLL_PROCESS_ATTACH:
         /*******************************************************************/
         /* The C run-time environment initialization function must be      */
         /* called before any calls to C run-time functions that are not    */
         /* inlined.                                                        */
         /*******************************************************************/

         if (_CRT_init() != -1)
            {
            /* initialize the controls */
            rc = LibMain( hInstance, reasonCalled, reserved );
            }
         break;

      case  DLL_THREAD_ATTACH:
      case  DLL_THREAD_DETACH:
      case  DLL_PROCESS_DETACH:
         /* We currently don't do anything with these */
         break;
      }
   return rc;
}

#endif

#endif  //CCL_SEPARATE_DLL


/*******************************************************************************
   FUNCTION: LibMain(HANDLE, DWORD, LPVOID)

   PURPOSE:  LibMain is called by Windows when
             the DLL is initialized, Thread Attached, and other times.
             Refer to SDK documentation, as to the different ways this
             may be called.

             The LibMain function should perform additional initialization
             tasks required by the DLL.  In this example, no initialization
             tasks are required.  LibMain should return a value of 1 if
             the initialization is successful.

*******************************************************************************/
INT  APIENTRY LibMain(HANDLE hInstance,
                      DWORD  ul_reason_being_called,
                      LPVOID lpReserved)
{
  WNDCLASS wndclass;
  BOOL     rc;

 /*-------------------------------------------------------------------*
  *  Register client class and check for prior existence
  *-------------------------------------------------------------------*/
  if ( !hSpinInstance )
  {
    wndclass.style         = CS_GLOBALCLASS | CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc   = SpinButtonWndProc;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = sizeof (LPLONG) * 2;
    wndclass.hInstance     = hInstance;
    wndclass.hIcon         = NULL;
    wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
    wndclass.hbrBackground = NULL;
    wndclass.lpszMenuName  = NULL;
    wndclass.lpszClassName = ICL_SPINBTN;

    rc = RegisterClass(&wndclass);

    if (!rc)
    {
      return (FALSE);
    }
    hSpinInstance = hInstance;

   /*----------------------------------------------------------------*
    *  Register up/down arrow window class
    *----------------------------------------------------------------*/
    wndclass.style         = CS_GLOBALCLASS | CS_HREDRAW | CS_VREDRAW |
                             CS_DBLCLKS;
    wndclass.lpfnWndProc   = ArrowWndProc;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = sizeof (DWORD);
    wndclass.hInstance     = hInstance;
    wndclass.hIcon         = NULL;
    wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
    wndclass.hbrBackground = NULL;
    wndclass.lpszMenuName  = NULL;
    wndclass.lpszClassName = WC_ARROWS;

    rc = RegisterClass(&wndclass);

    if (!rc)
    {
      hSpinInstance = 0;
      return (FALSE);
    }
  }

  return (TRUE);

  ul_reason_being_called;
  lpReserved;
}
