// Revision: 90 1.1.1.2 source/ui/cnr/icnrclst.cpp, container, ioc.v400, 000302 
/*******************************************************************************
* FILE NAME: icnrclst.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of ICnrControlList.                  *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <itrace.hpp>
#include <icnrclst.hpp>
#include <iset2.h>

// Segment definitions
#ifdef IC_PAGETUNE
  #define _ICNRCLST_CPP_
  #include <ipagetun.h>
#endif



class ICnrControlListImp : public IVPtrSet<IContainerControl*>
{
  
};

                                       


ICnrControlList::Cursor::Cursor (const ICnrControlList& controlList)
         : fControlListImp(controlList.fControlListImp),
           fControlCursorImp(new ICnrControlListImp::Cursor(*fControlListImp))  
{}
       
ICnrControlList::Cursor::~Cursor ( )
{
   delete (ICnrControlListImp::Cursor*)fControlCursorImp;
}


bool ICnrControlList::Cursor::setToFirst ()
{ 
   return ((ICnrControlListImp::Cursor*)fControlCursorImp)->setToFirst();
}


bool ICnrControlList::Cursor::setToNext ()
{ 
   return ((ICnrControlListImp::Cursor*)fControlCursorImp)->setToNext();
}


bool ICnrControlList::Cursor::isValid() const
{ 
   return ((ICnrControlListImp::Cursor*)fControlCursorImp)->isValid();
}

void ICnrControlList::Cursor::invalidate ( )
{ 
   ((ICnrControlListImp::Cursor*)fControlCursorImp)->invalidate();
}


IContainerControl* const ICnrControlList::Cursor::element ( ) const
{ 
   return ((const ICnrControlListImp::Cursor*)fControlCursorImp)->element();
}     




ICnrControlList :: ICnrControlList() 
    : fControlListImp(new ICnrControlListImp)
{}


ICnrControlList :: ICnrControlList(const ICnrControlList& containerList) 
    : fControlListImp(new ICnrControlListImp(*(containerList.fControlListImp)))
{}

ICnrControlList :: ~ICnrControlList() 
{
  delete fControlListImp;   
}


bool ICnrControlList::add ( IContainerControl* const& object)
{
   return fControlListImp->add(object);
}


IContainerControl* ICnrControlList::elementAt   ( const Cursor& cursor) const
{
  return fControlListImp->elementAt(*(ICnrControlListImp::Cursor*)(cursor.fControlCursorImp));
}

bool ICnrControlList::isEmpty ( ) const 
{
  return fControlListImp->isEmpty();
}

unsigned long ICnrControlList::numberOfElements ( ) const 
{
  return fControlListImp->numberOfElements();
}

unsigned long ICnrControlList::removeAll ( )
{
  return fControlListImp->removeAll();
}

unsigned long ICnrControlList::removeAll ( bool (*predicateFunction)(IContainerControl* const& , void*), void* data)
{
  return fControlListImp->removeAll(predicateFunction, data);
}

void ICnrControlList::removeAt ( Cursor& cursor)
{
  fControlListImp->removeAt(*(ICnrControlListImp::Cursor*)cursor.fControlCursorImp);
}


void ICnrControlList::replaceAt ( const Cursor& cursor, 
                                IContainerControl* const& control)
{
  fControlListImp->replaceAt(*(const ICnrControlListImp::Cursor*)cursor.fControlCursorImp, control);
}




