// Revision: 19 1.2.2.2 source/ui/cnr/icnrobj1.cpp, container, ioc.v400, 000302  
/*******************************************************************************
* FILE NAME: icnrobj1.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in icnrobj.hpp.                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/


#define INCL_WINSTDDRAG
#define INCL_WINSTDCNR

#include <icnrrec.hpp>  // Must be first for OS flags

#include <ireslib.hpp>
#include <itrace.hpp>
#include <iexcept.hpp>
#include <icnrobj.hpp>
#include <icconst.h>


// Segment definitions
#ifdef IC_PAGETUNE
  #define _ICNROBJ1_CPP_
  #include <ipagetun.h>
#endif


/*------------------------------------------------------------------------------
| IContainerObject::objectCopy                                                 |
|                                                                              |
| Called when it is necessary to make a copy of an object.  This occurs when   |
| IContainerControl::copyObjectTo is called.  This function is required to     |
| support the container's drag and drop handlers.                              |
------------------------------------------------------------------------------*/
IContainerObject* IContainerObject::objectCopy()
{
   /* Change to resource file */
   if(flClState & subclassed)
   {
     ITHROWLIBRARYERROR(IC_CNROBJ_INVALID_OBJECTCOPY,
                         IBaseErrorInfo::invalidRequest,
                         IException::recoverable);
   }
   return new IContainerObject(*this);
}

/*------------------------------------------------------------------------------
| IContainerObject::operator==                                                 |
|                                                                              |
| Determine if two objects are the same.                                       |
------------------------------------------------------------------------------*/
bool IContainerObject :: operator== (const IContainerObject& cnrobj)
{
  return (this == &cnrobj);

}
