// Revision: 26 1.4.1.3 source/ui/cnr/icnrobjw.hpp, container, ioc.v400, 000302  
/* NOSHIP */
#ifndef _ICNROBJW_
   #define _ICNROBJW_
/*******************************************************************************
* FILE NAME: icnrobjw.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*                                                                              *
* Implementation Notes:                                                        *
*   Private data classes for IContainerObject for native windows support.      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

#include <iset2.h>
#include <icnrctl.hpp>

extern "C"
{
  #include <iwindefs.h>
  #include <commctrl.h>
}

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)
#pragma info(none)

class ICnrObjSetInfo  {
public:
  ICnrObjSetInfo ( IContainerControl* pCnrCtl,
                   HTREEITEM          pTreeViewItem,
                   int                imageListIndex );
 ~ICnrObjSetInfo ( );
  ICnrObjSetInfo ( const ICnrObjSetInfo& object      );

ICnrObjSetInfo
  &operator=     ( const ICnrObjSetInfo& object      );

ICnrObjSetInfo
  &setObjectState( unsigned long     stateOff,
                   unsigned long     stateOn,
                   IContainerObject* pCnrObj=0       );

IContainerControl
  *pContainer;
HTREEITEM
  pTVItem;
int
  imageIndex;
unsigned long
  objectState;
};


class ICnrObjSet : public ISet < ICnrObjSetInfo* > {
public:
  ICnrObjSet  ();
 ~ICnrObjSet  ();

HTREEITEM
  treeItemFromObject ( IContainerControl* pCnrCtl  );

bool
  containsObject     ( IContainerControl* pCnrCtl  ),
  remove             ( IContainerControl* pCnrCtl  ),
  isDropOnable       ( IContainerControl* pCnrCtl  ),
  isReadOnly         ( IContainerControl* pCnrCtl  ),
  isInUse            ( IContainerControl* pCnrCtl  );

ICnrObjSet&
  updateTreeItem     ( IContainerControl* pCnrCtl,
                       HTREEITEM treeItem          );

int
  imageIndexFromCnr  ( IContainerControl* pCnrCtl  );

ICnrObjSetInfo*
  objectFromCnr      ( IContainerControl* pCnrCtl  );
};



class ICnrObjPrivateData {
public:
  ICnrObjPrivateData( );
 ~ICnrObjPrivateData( );

static int
  listItemFromCnr    ( const IContainerControl* pCnrCtl,
                       const IContainerObject*  pObject,
                       int   startFrom = -1              );

ICnrObjSet
  *pCnrSet;
};


#pragma pack(pop)
#pragma enum(pop)
#pragma info(restore)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif  /* _ICNROBJW_ */
