// Revision: 27 1.2.2.2 source/ui/cnr/icnrobs.cpp, container, ioc.v400, 000302  
/*******************************************************************************
* FILE NAME: icnrobs.cpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of functions that have been replaced *
*   and are now obsolete.  They have been placed here to provide compatibility *
*   with prior releases.                                                       *
*   Platform independent obsolete functions                                    *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1997                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _ICNRCTL_
  #include <icnrctl.hpp>
#endif

#ifndef _ICNRCOL_
  #include <icnrcol.hpp>
#endif

#ifndef _ICNROBJ_
  #include <icnrobj.hpp>
#endif

#ifndef _ICNRREC_
  #include <icnrrec.hpp>
#endif

#ifndef _ICOLOR_
  #include <icolor.hpp>
#endif

// Segment definitions
#ifdef IC_PAGETUNE
  #define _ICNROBS_CPP_
  #include <ipagetun.h>
#endif

#if (IC_OBSOLETE <= IC_OBSOLETE_1)
//
// Obsolete code ... block 1
//
/**************************************************************/
/* setColor - Change the window attribute color using Red,    */
/* Green and Blue mix.                                        */
/**************************************************************/
IContainerControl& IContainerControl::setColor(ColorArea value,
                                               const IColor& color)
{
   switch (value) {
     case background:
       setBackgroundColor(color);
       break;
     case border:
       setBorderColor(color);
       break;
     case foreground:
       setForegroundColor(color);
       break;
     case highlightBackground:
       setHiliteBackgroundColor(color);
       break;
     case highlightForeground:
       setHiliteForegroundColor(color);
       break;
   } /* endswitch */
   return *this;
}

/***************************************************************/
/* color - Return the color of window attribute.               */
/***************************************************************/
IColor IContainerControl::color(ColorArea value) const
{
   IColor color(IColor::black);

   switch (value) {
     case background:
       color = backgroundColor();
       break;
     case border:
       color = borderColor();
       break;
     case foreground:
       color = foregroundColor();
       break;
     case highlightBackground:
       color = hiliteBackgroundColor();
       break;
     case highlightForeground:
       color = hiliteForegroundColor();
       break;
   } /* endswitch */
   return  color;
}


/*-----------------------------------------------------------------------------
 IContainerColumn::isReadOnly

 Returns true if the column data cannot be edited.
------------------------------------------------------------------------------*/
bool IContainerColumn::isReadOnly ( ) const
{
  return( !isWriteable() );
}


/*-----------------------------------------------------------------------------
 IContainerColumn::isHeadingReadOnly

 Returns true if the column heading cannot be edited.
------------------------------------------------------------------------------*/
bool IContainerColumn::isHeadingReadOnly ( ) const
{
  return( !isHeadingWriteable() );
}


/*-----------------------------------------------------------------------------
 Function Name: IContainerControl :: isReadOnly

 Implementation: Determine if this object can be edited.
------------------------------------------------------------------------------*/
bool IContainerControl :: isReadOnly(const IContainerObject* pcnrobj) const
{
  return( !isWriteable(pcnrobj) );
}


/*-----------------------------------------------------------------------------
 Function Name: IContainerControl :: detailObjectRectangle

 Implementation: Query an object's details view rectangle.
------------------------------------------------------------------------------*/
IRectangle IContainerControl :: detailObjectRectangle
                                       (const IContainerObject* object,
                                        bool fRightWindow ) const
{
  return ( detailsObjectRectangle( object, fRightWindow) );
}


/*-----------------------------------------------------------------------------
 Function Name: IContainerControl :: detailObjectRectangle

 Implementation: Query an object's column rectangle (the cell).
                 Returns rectangle in window coordinates.
------------------------------------------------------------------------------*/
IRectangle IContainerControl :: detailObjectRectangle
                                       (const IContainerObject* object,
                                        const IContainerColumn* column) const
{
  return ( detailsObjectRectangle( object, column) );
}


/*------------------------------------------------------------------------------
| IContainerObject::isReadOnly                                                 |
|                                                                              |
| Query if this object can be edited.                                          |
------------------------------------------------------------------------------*/
bool IContainerObject :: isReadOnly(IContainerControl* pcnrctl) const
{
   return ( !isWriteable(pcnrctl) );
}


/*------------------------------------------------------------------------------
| IContainerObject::iconOffset                                                 |
|                                                                              |
| Returns the offset of the object's IPointerHandle for the icon.              |
------------------------------------------------------------------------------*/
unsigned long IContainerObject :: iconOffset()
{
  return (IFIELDINBASE + (unsigned long)&(((IMiniCnrRecord *)0)->hptrIcon));
}

/*------------------------------------------------------------------------------
| IContainerObject::iconTextOffset                                             |
|                                                                              |
| Returns the offset of the object's IString.                                  |
------------------------------------------------------------------------------*/
unsigned long IContainerObject :: iconTextOffset()
{
  return (IFIELDINBASE + (unsigned long)&(((IMiniCnrRecord *)0)->strIcon));
}


//
// End obsolete code ... block 1
//

#endif  //IC_OBSOLETE_1
