// Revision: 66 1.4.1.3 source/ui/drag/idmdrsrc.hpp, dragdrop, ioc.v400, 000302 
/* NOSHIP */
#ifndef _IDMDRSRC_
#define _IDMDRSRC_
/*******************************************************************************
* FILE NAME: idmdrsrc.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IDMDropSource                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifdef WIN32_LEAN_AND_MEAN
  #undef WIN32_LEAN_AND_MEAN
#endif
#ifdef _OLE2_H_
  #undef _OLE2_H_
#endif
#define IUSING_OLE

extern "C"
  {
  #ifndef _WIN32
    #define _WIN32
  #endif
  #define INC_OLE2
  #include <windows.h>
  #include <commctrl.h>
  }


#include <ibase.hpp>
#include <ipoint.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

class IDMImage;
class IDMDropSourceData;

#pragma enum(4)
#pragma pack(push,4)

class IDMDropSource : public IDropSource

  {
  public:
    IDMDropSource();
    virtual
      ~IDMDropSource();

    virtual HRESULT __stdcall
      QueryInterface( REFIID refiid,
                      void **ppvoid );
    virtual ULONG __stdcall
      AddRef( );
    virtual ULONG __stdcall
      Release( );

    virtual HRESULT __stdcall
      QueryContinueDrag( BOOL fEscapePressed,
                         DWORD grfKeyState);

    virtual HRESULT __stdcall
      GiveFeedback( DWORD dwEffect);
  /*----------------------------------------------------*/
  /*    Member Function for images                      */
  /*----------------------------------------------------*/
    virtual void
      setImage( IDMImage &image, const IPoint& stackHotspot );
    virtual unsigned long
       keyState() ;

  private:
    IDMDropSourceData
     *fDMDropSourceData;

    IPoint hotSpot;

  };

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif

