// Revision: 81 1.5.1.2 source/ui/drag/idmimage.inl, dragdrop, ioc.v400, 000302 
#ifndef _IDMIMAGE_INL_
#define _IDMIMAGE_INL_
/*******************************************************************************
* FILE NAME: idmimage.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in idmimage.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved                    *
*                                                                              *
*******************************************************************************/

inline IPointerHandle IDMImage::pointer () const
{
  return (this->pointerImage);
}

inline IBitmapHandle IDMImage::bitmap () const
{
  return (this->bitmapImage);
}

inline ISize IDMImage::pointerOffset () const
{
  return (this->ptrOffset);
}

inline ISize IDMImage::stretchSize () const
{
  return (this->imageStretchSize);
}

inline IDMImage::Style IDMImage::style ()
{
  return (this->imgStyle);
}

inline unsigned long IDMImage::numberOfPoints ()
{
  return (this->points);
}

inline unsigned long* IDMImage::pointArray()
{
  return (this->pPointArray);
}

inline IDMImage& IDMImage::setPointerOffset (const ISize& pointerOffset)
{
  this->ptrOffset = pointerOffset;
  return (*this);
}

inline IDMImage& IDMImage::setStyle (const Style& style)
{
  this->imgStyle = style;
  return (*this);
}

inline IDMImage& IDMImage::setNumberOfPoints (unsigned long pts)
{
  this->points = pts;
  return (*this);
}
#endif // _IDMIMAGE_INL_
