// Revision: 16 1.3.1.3 source/ui/drag/iimagels.hpp, dragdrop, ioc.v400, 000302  
/* NOSHIP */
#ifndef _IIMAGELS_
#define _IIMAGELS_
/*******************************************************************************
* FILE NAME: iimagels.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IImageList                                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifdef WIN32_LEAN_AND_MEAN
  #undef WIN32_LEAN_AND_MEAN
#endif
#ifdef _OLE2_H_
  #undef _OLE2_H_
#endif
#define IUSING_OLE

extern "C"
  {
  #ifndef _WIN32
    #define _WIN32
  #endif
  #define INC_OLE2
  #include <windows.h>
  #include <commctrl.h>
  }

#include <ibase.hpp>
#include <ipoint.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

class IImageList

  {
  public:
    IImageList();
    IImageList( HIMAGELIST existingImageList );
    virtual
     ~IImageList();

    IImageList
     &create( const ISize &imageSize,
              unsigned flags,
              int initialImageListSize,
              int growthFactor ),
     &setActiveImage( int imageNumber ),
     &switchDragImage( const IPoint &hotSpot,
                       const IPoint &cursorPos );

    int
      activeImage() const;

    HICON
      icon( int index = -1 );

    int
      addIconFromImageList( IImageList &fromImageList ),
      addIconAsSeeThru( HICON &icon ),
      addIcon( HICON icon ),
      addCursor( HCURSOR cursor ),
      mergeImagesIntoDest( int   backgroundImage,
                           const IImageList &foregroundImageList,
                           int   foregroundImage,
                           const IPoint     &offset,
                           IImageList &destination  ),
      add( HBITMAP bitmap );

    int
      numberOfImages() const;

    HIMAGELIST
      imageList() const;
    ISize
      imageSize() const;

  private:
    HIMAGELIST
      _imageList;
    int
      _activeImage;
  };

#pragma pack(pop)  
#pragma enum(pop)
  
#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif
