// Revision: 33 1.6.1.2 source/ui/extapp/iclipimp.inl, clipboard, ioc.v400, 000302  
#ifndef _ICLIPIMP_INL_
#define _ICLIPIMP_INL_
/*******************************************************************************
* FILE NAME: iclipimp.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in iclipimp.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/


inline IWindowHandle IClipboardImp::owner ( )
  { return fOwnerHandle; }

inline bool IClipboardImp::isOpen ( )
  { return fOpened; }

// AutoOpen means that we opened the clipboard because we needed
// it open.  This is turned off when the user calls open.
inline bool IClipboardImp::isAutoOpen ( )
  { return fAutoOpened; }

inline void IClipboardImp::setOpen  ( bool open)
  { fOpened = open; }

inline void IClipboardImp::setAutoOpen  ( bool open)
  { fAutoOpened = open; }

inline void IClipboardImp::setOwner ( const IWindowHandle& owner)
  { fOwnerHandle = owner; }

#endif // _ICLIPIMP_INL_
