/* NOSHIP */
// Revision: 92 1.4 source/ui/extapp/icustbdd.hpp, toolbar, ioc.v400, 000302 
#ifndef _ICUSTBDD_
#define _ICUSTBDD_
/*******************************************************************************
* FILE NAME: icustbdd.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*    Declaration of the classes:                                               *
*      ICustomButtonDrawData                                                   *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

#include <ibase.hpp>
#include <i2dghand.hpp>
#include <icustbev.hpp>
#include <igimage.hpp>
#include <iwindow.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

#ifdef IC_MOTIF
class ICustomButtonDrawData : public IWindowData {
typedef IWindowData
  Inherited;
public:
/*------------------------------- Constructors -------------------------------*/
  ICustomButtonDrawData  ( );
virtual
  ~ICustomButtonDrawData ( );

/*------------------------------- Images -------------------------------------*/
IGImage
  *image          ( ICustomButtonDrawEvent::ButtonState state,
                    bool enabledImage=true ) const;
ICustomButtonDrawData
  &adoptImage       ( ICustomButtonDrawEvent::ButtonState state,
                      IGImage* image=0,
                      bool     enabledImage=true );
IBitmapHandle
  imageHandle     ( ICustomButtonDrawEvent::ButtonState state,
                    bool     enabledImage=true ) const;

bool
  isImageValid    ( ICustomButtonDrawEvent::ButtonState state ) const;

bool
   invalidateAll  ( unsigned long invalidateReason );
unsigned long
   invalidateReason( ) const;

/*--------------------------- Button state -----------------------------------*/
ICustomButtonDrawData
  &setButtonState        ( ICustomButtonDrawEvent::ButtonState state );
ICustomButtonDrawEvent::ButtonState
  buttonState            ( ) const;
ICustomButtonDrawData&
  setDrawEnabled         (bool drawEnabled = true);
bool
  isDrawEnabled          () const;

/*--------------------------- System data ------------------------------------*/
ICustomButtonDrawData
  &setSystemData         (void* data);
void*
  systemData             () const;

/*--------------------------- Access handle ----------------------------------*/
static IWindow::DataHandle
  dataHandle ( );

private:
/*--------------------------------- Private ----------------------------------*/
  ICustomButtonDrawData( const ICustomButtonDrawData& another );
  ICustomButtonDrawData& operator=( const ICustomButtonDrawData& another );

  IGImage*                            fUpImage;
  IGImage*                            fUpImageDisabled;
  IGImage*                            fLatchedImage;
  IGImage*                            fLatchedImageDisabled;
  IGImage*                            fDownImage;
  IGImage*                            fDownImageDisabled;
  
  ICustomButtonDrawEvent::ButtonState fState;
  void*                               fSystemData;
  unsigned long                       fInvalidateReason;
  bool                                fDrawEnabled;
};
#endif //IC_MOTIF

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* _ICUSTBDD_ */
