// Revision: 51 1.3.1.3 source/ui/extapp/itbpriv.hpp, toolbar, ioc.v400, 000302 
/* NOSHIP */
#ifndef _ITBPRIV_
#define _ITBPRIV_
/*******************************************************************************
* FILE NAME: itbfpriv.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file defines message sub-ids used for tool bar implementation.        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

/*------------------------------ Message IDs -----------------------------------
| These message sub-ids are used as the first parameter on the IC_UM_TOOLBAR   |
| message to handle implementation of the toolbar:                             |
|                                                                              |
|   IC_UM_TBAR_SET_LOCATION     - Changes the internal toolbar location        |
|                                 without actually modifiying the toolbar.     |
|                                 The second parameter is the new location.    |
|   IC_UM_TBAR_SETEXPAND_BTN    - Sets the floating toolbar's expand button    |
|                                 state.  The second parameter is a boolean    |
|                                 with true indicating the toolbar is expanded |
|                                 and false indicating the toolbar is          |
|                                 collapsed.                                   |
|   IC_UM_TBAR_MOVE             - Changes the toolbar location.  The second    |
|                                 parameter is the new location.               |
|   IC_UM_TBAR_AFTER            - Moves a toolbar to be after another toolbar  |
|   IC_UM_TBAR_BEFORE           - Moves a toolbar to be before another toolbar |
|   IC_UM_TBAR_TARGET_ENTER     - Allows a toolbar or toolbar button to        |
|                                 identify themselves when target enter        |
|                                 events occur over them                       |
|   IC_UM_TBAR_BIDI_CAHNGE      - The frame BIDI attributes have changed       |
------------------------------------------------------------------------------*/

#define  IC_UM_TBAR_SET_LOCATION    1
#define  IC_UM_TBAR_SETEXPAND_BTN   2
#define  IC_UM_TBAR_MOVE            3
#define  IC_UM_TBAR_AFTER           4
#define  IC_UM_TBAR_TARGET_ENTER    5
#define  IC_UM_TBAR_BEFORE          6
#define  IC_UM_TBAR_BIDI_CHANGE     7

#endif /* _ITBPRIV_ */
