/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*   US Government Users Restricted Rights - Use, duplication, or disclosure             *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                              *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 92 1.8.1.4 source/core/text/unicode/iuprdata.hpp, text, ioc.v400, 000302 
//
//      File:       iuprdata.hpp
//      Function:   Contains the raw character and layout property data for Unicode
//
//      CREATED
//              Monday, February 1, 1996
//
//      CREATED BY
//              Text & International Team
//
//      29 Feb 1996             hsys            conform OpenClass coding guideline and update unicode info
//
//      DESCRIPTION
//              This file defines the unicode classes
//
//      COPYRIGHT
//
//
//
//********************************************************************************************


#ifndef _IUPRDATA_
#define _IUPRDATA_

#include <iunicode.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)


IUnicode::ICharacterProperties gCharacterData[] = {
        0x8001, 0x8002, 0x8003, 0x8004, 0x8005, 0x8006, 0x8007, 0x1D1E,
        0x1D1E, 0x8008, 0x8009, 0x800A, 0x800B, 0x800C, 0x800D, 0x1D1E,
        0x800E, 0x800F, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x8010, 0x8011,
        0x8012, 0x8013, 0x8014, 0x8015, 0x8016, 0x8017, 0x8018, 0x8019,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x801A, 0x801B, 0x801C, 0x801D, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x801E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x801F, 0x1C03, 0x8020, 0x8021, 0x0703, 0x8022, 0x8023, 0x8024,

        //      U+0000 - U+00FF

        0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C,
        0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C,
        0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C,
        0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C,
        0x1D18, 0x1D10, 0x1D10, 0x1D15, 0x1D14, 0x1D10, 0x1D15, 0x1D10,
        0x1D0E, 0x1D0F, 0x1D15, 0x1D13, 0x1D10, 0x1D11, 0x1D10, 0x1D10,
        0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A,
        0x1D0A, 0x1D0A, 0x1D10, 0x1D10, 0x1D13, 0x1D13, 0x1D13, 0x1D10,
        0x1D15, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
        0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
        0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
        0x0000, 0x0000, 0x0000, 0x1D0E, 0x1D10, 0x1D0F, 0x1D02, 0x1D15,
        0x1D02, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
        0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
        0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
        0x0001, 0x0001, 0x0001, 0x1D0E, 0x1D15, 0x1D0F, 0x1D15, 0x1D1C,  // HSYS : 0x1D1E -> ox1D1C
        0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C,
        0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C,
        0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C,
        0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C,
        0x1D18, 0x1D10, 0x1D14, 0x1D14, 0x1D14, 0x1D14, 0x1D15, 0x1D15,
        0x1D02, 0x1D15, 0x1D15, 0x1D0E, 0x1D13, 0x1D10, 0x1D15, 0x1D02,
        0x1D15, 0x1D13, 0x1D15, 0x1D15, 0x1D02, 0x1D15, 0x1D15, 0x1D10,
        0x1D02, 0x1D15, 0x1D15, 0x1D0F, 0x1D15, 0x1D15, 0x1D15, 0x1D10,
        0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
        0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
        0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x1D13,
        0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001,
        0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
        0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
        0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x1D13,
        0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,

        //      U+0100 - U+01FF

        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000,
        0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000,
        0x0001, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0001,
        0x0001, 0x0000, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0000,
        0x0001, 0x0000, 0x0000, 0x0000, 0x0001, 0x0001, 0x0000, 0x0000,
        0x0000, 0x0000, 0x0001, 0x0000, 0x0000, 0x0001, 0x0000, 0x0000,
        0x0000, 0x0001, 0x0001, 0x0001, 0x0000, 0x0000, 0x0001, 0x0000,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0000,
        0x0001, 0x0000, 0x0003, 0x0001, 0x0000, 0x0001, 0x0000, 0x0000,
        0x0001, 0x0000, 0x0000, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000,
        0x0000, 0x0001, 0x0001, 0x0003, 0x0000, 0x0001, 0x0003, 0x0003,
        0x0003, 0x0003, 0x0003, 0x0003, 0x0000, 0x0003, 0x0001, 0x0000,
        0x0003, 0x0001, 0x0000, 0x0003, 0x0001, 0x0000, 0x0001, 0x0000,
        0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000,
        0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0001, 0x0000, 0x0003, 0x0001, 0x0000, 0x0001, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,

        //      U+0200 - U+02FF

        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101, 0x0101,
        0x0101, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102,
        0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102,
        0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102,
        0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102,
        0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102,
        0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x1D1E,
        0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102, 0x0102,
        0x0102, 0x0102, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+0300 - U+03FF

        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D06, 0x1D06, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0215, 0x0215, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x0202, 0x1D1E, 0x1D1E, 0x1D1E, 0x0210, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0202, 0x0202, 0x0200, 0x0210,
        0x0200, 0x0200, 0x0200, 0x1D1E, 0x0200, 0x1D1E, 0x0200, 0x0200,
        0x0201, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200,
        0x0200, 0x0200, 0x1D1E, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x1D1E,
        0x0201, 0x0201, 0x0200, 0x0200, 0x0200, 0x0201, 0x0201, 0x1D1E,
        0x1D1E, 0x1D1E, 0x0200, 0x1D1E, 0x0200, 0x1D1E, 0x0200, 0x1D1E,
        0x0200, 0x1D1E, 0x0200, 0x0201, 0x0200, 0x0201, 0x0200, 0x0201,
        0x0200, 0x0201, 0x0200, 0x0201, 0x0200, 0x0201, 0x0200, 0x0201,
        0x0201, 0x0201, 0x0201, 0x0203, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+0400 - U+04FF

        0x1D1E, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300,
        0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x1D1E, 0x0300, 0x0300,
        0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300,
        0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300,
        0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300,
        0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300, 0x0300,
        0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301,
        0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301,
        0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301,
        0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301,
        0x1D1E, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x0301,
        0x0301, 0x0301, 0x0301, 0x0301, 0x0301, 0x1D1E, 0x0301, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0315, 0x0306, 0x0306, 0x0306, 0x0306, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0303, 0x0300, 0x0301, 0x0300, 0x0301, 0x1D1E, 0x1D1E, 0x0300,
        0x0301, 0x1D1E, 0x1D1E, 0x0300, 0x0301, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x1D1E, 0x1D1E, 0x0300, 0x0301,
        0x0300, 0x0301, 0x0300, 0x0301, 0x0300, 0x0301, 0x1D1E, 0x1D1E,
        0x0300, 0x0301, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+0500 - U+05FF

        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500,
        0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500,
        0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500,
        0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500,
        0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x0500, 0x1D1E,
        0x1D1E, 0x0502, 0x0510, 0x0510, 0x0510, 0x0510, 0x0510, 0x0510,
        0x1D1E, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501,
        0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501,
        0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501,
        0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501,
        0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501,
        0x1D1E, 0x0510, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0606, 0x0606, 0x0606, 0x0606, 0x0606, 0x0606, 0x0606, 0x0606,
        0x0606, 0x0606, 0x1D1E, 0x0606, 0x0606, 0x0606, 0x0610, 0x0606,
        0x0610, 0x0606, 0x0606, 0x0610, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603,
        0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603,
        0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603,
        0x0603, 0x0603, 0x0603, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0603, 0x0603, 0x0603, 0x0610, 0x0610, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+0600 - U+06FF

        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0710, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x0710, 0x1D1E, 0x1D1E, 0x1D1E, 0x0710,
        0x1D1E, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0706, 0x0706, 0x0706, 0x0706, 0x0706,
        0x0706, 0x0706, 0x0706, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x070A, 0x070A, 0x070A, 0x070A, 0x070A, 0x070A, 0x070A, 0x070A,
        0x070A, 0x070A, 0x0715, 0x0715, 0x0715, 0x0715, 0x1D1E, 0x1D1E,
        0x0706, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x1D1E, 0x1D1E, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x1D1E,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x1D1E,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0710, 0x0703, 0x0706, 0x0706,
        0x0706, 0x0706, 0x0706, 0x0706, 0x0706, 0x0706, 0x0706, 0x0706,
        0x0706, 0x0706, 0x0706, 0x0706, 0x0706, 0x0702, 0x0702, 0x0706,
        0x0706, 0x0715, 0x0706, 0x0706, 0x0706, 0x0706, 0x1D1E, 0x1D1E,
        0x070A, 0x070A, 0x070A, 0x070A, 0x070A, 0x070A, 0x070A, 0x070A,
        0x070A, 0x070A, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+0900 - U+09FF

        0x1D1E, 0x0906, 0x0906, 0x0907, 0x1D1E, 0x0903, 0x0903, 0x0903,
        0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903,
        0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903,
        0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903,
        0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903,
        0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903,
        0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903,
        0x0903, 0x0903, 0x1D1E, 0x1D1E, 0x0906, 0x0910, 0x0907, 0x0907,
        0x0907, 0x0906, 0x0906, 0x0906, 0x0906, 0x0906, 0x0906, 0x0906,
        0x0906, 0x0907, 0x0907, 0x0907, 0x0907, 0x0906, 0x1D1E, 0x1D1E,
        0x0915, 0x0906, 0x0906, 0x0906, 0x0906, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903, 0x0903,
        0x0903, 0x0903, 0x0906, 0x0906, 0x0915, 0x0915, 0x090A, 0x090A,
        0x090A, 0x090A, 0x090A, 0x090A, 0x090A, 0x090A, 0x090A, 0x090A,
        0x0910, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x0A06, 0x0A07, 0x0A07, 0x1D1E, 0x0A03, 0x0A03, 0x0A03,
        0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x1D1E, 0x1D1E, 0x0A03,
        0x0A03, 0x1D1E, 0x1D1E, 0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03,
        0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03,
        0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03,
        0x0A03, 0x1D1E, 0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03, 0x0A03,
        0x0A03, 0x1D1E, 0x0A03, 0x1D1E, 0x1D1E, 0x1D1E, 0x0A03, 0x0A03,
        0x0A03, 0x0A03, 0x1D1E, 0x1D1E, 0x0A06, 0x1D1E, 0x0A07, 0x0A07,
        0x0A07, 0x0A06, 0x0A06, 0x0A06, 0x0A06, 0x1D1E, 0x1D1E, 0x0A07,
        0x0A07, 0x1D1E, 0x1D1E, 0x0A07, 0x0A07, 0x0A06, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0A07,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0A03, 0x0A03, 0x1D1E, 0x0A03,
        0x0A03, 0x0A03, 0x0A06, 0x0A06, 0x1D1E, 0x1D1E, 0x0A0A, 0x0A0A,
        0x0A0A, 0x0A0A, 0x0A0A, 0x0A0A, 0x0A0A, 0x0A0A, 0x0A0A, 0x0A0A,
        0x0A03, 0x0A03, 0x0A15, 0x0A15, 0x0A15, 0x0A15, 0x0A15, 0x0A15,
        0x0A15, 0x0A15, 0x0A15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+0A00 - U+0AFF

        0x1D1E, 0x1D1E, 0x0B06, 0x1D1E, 0x1D1E, 0x0B03, 0x0B03, 0x0B03,
        0x0B03, 0x0B03, 0x0B03, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0B03,
        0x0B03, 0x1D1E, 0x1D1E, 0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03,
        0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03,
        0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03,
        0x0B03, 0x1D1E, 0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x0B03,
        0x0B03, 0x1D1E, 0x0B03, 0x0B03, 0x1D1E, 0x0B03, 0x0B03, 0x1D1E,
        0x0B03, 0x0B03, 0x1D1E, 0x1D1E, 0x0B06, 0x1D1E, 0x0B07, 0x0B07,
        0x0B07, 0x0B06, 0x0B06, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0B06,
        0x0B06, 0x1D1E, 0x1D1E, 0x0B06, 0x0B06, 0x0B06, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x0B03, 0x0B03, 0x0B03, 0x0B03, 0x1D1E, 0x0B03, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0B0A, 0x0B0A,
        0x0B0A, 0x0B0A, 0x0B0A, 0x0B0A, 0x0B0A, 0x0B0A, 0x0B0A, 0x0B0A,
        0x0B06, 0x0B06, 0x0B15, 0x0B15, 0x0B15, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x0C06, 0x0C06, 0x0C07, 0x1D1E, 0x0C03, 0x0C03, 0x0C03,
        0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x1D1E, 0x0C03, 0x1D1E, 0x0C03,
        0x0C03, 0x0C03, 0x1D1E, 0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03,
        0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03,
        0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03,
        0x0C03, 0x1D1E, 0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03, 0x0C03,
        0x0C03, 0x1D1E, 0x0C03, 0x0C03, 0x1D1E, 0x0C03, 0x0C03, 0x0C03,
        0x0C03, 0x0C03, 0x1D1E, 0x1D1E, 0x0C06, 0x0C10, 0x0C07, 0x0C07,
        0x0C07, 0x0C06, 0x0C06, 0x0C06, 0x0C06, 0x0C06, 0x1D1E, 0x0C06,
        0x0C06, 0x0C07, 0x1D1E, 0x0C07, 0x0C07, 0x0C06, 0x1D1E, 0x1D1E,
        0x0C15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0C03, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0C0A, 0x0C0A,
        0x0C0A, 0x0C0A, 0x0C0A, 0x0C0A, 0x0C0A, 0x0C0A, 0x0C0A, 0x0C0A,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+0B00 - U+0BFF

        0x1D1E, 0x0D06, 0x0D07, 0x0D07, 0x1D1E, 0x0D03, 0x0D03, 0x0D03,
        0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x1D1E, 0x1D1E, 0x0D03,
        0x0D03, 0x1D1E, 0x1D1E, 0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03,
        0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03,
        0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03,
        0x0D03, 0x1D1E, 0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03, 0x0D03,
        0x0D03, 0x1D1E, 0x0D03, 0x0D03, 0x1D1E, 0x1D1E, 0x0D03, 0x0D03,
        0x0D03, 0x0D03, 0x1D1E, 0x1D1E, 0x0D06, 0x0D10, 0x0D07, 0x0D06,
        0x0D07, 0x0D06, 0x0D06, 0x0D06, 0x1D1E, 0x1D1E, 0x1D1E, 0x0D07,
        0x0D07, 0x1D1E, 0x1D1E, 0x0D07, 0x0D07, 0x0D06, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0D06, 0x0D07,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0D03, 0x0D03, 0x1D1E, 0x0D03,
        0x0D03, 0x0D03, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0D0A, 0x0D0A,
        0x0D0A, 0x0D0A, 0x0D0A, 0x0D0A, 0x0D0A, 0x0D0A, 0x0D0A, 0x0D0A,
        0x0D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x0E06, 0x0E07, 0x1D1E, 0x0E03, 0x0E03, 0x0E03,
        0x0E03, 0x0E03, 0x0E03, 0x1D1E, 0x1D1E, 0x1D1E, 0x0E03, 0x0E03,
        0x0E03, 0x1D1E, 0x0E03, 0x0E03, 0x0E03, 0x0E03, 0x1D1E, 0x1D1E,
        0x1D1E, 0x0E03, 0x0E03, 0x1D1E, 0x0E03, 0x1D1E, 0x0E03, 0x0E03,
        0x1D1E, 0x1D1E, 0x1D1E, 0x0E03, 0x0E03, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0E03, 0x0E03, 0x0E03, 0x1D1E, 0x1D1E, 0x1D1E, 0x0E03, 0x0E03,
        0x0E03, 0x0E03, 0x0E03, 0x0E03, 0x0E03, 0x0E03, 0x1D1E, 0x0E03,
        0x0E03, 0x0E03, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0E07, 0x0E07,
        0x0E06, 0x0E07, 0x0E07, 0x1D1E, 0x1D1E, 0x1D1E, 0x0E07, 0x0E07,
        0x0E07, 0x1D1E, 0x0E07, 0x0E07, 0x0E07, 0x0E06, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0E07,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0E0A,
        0x0E0A, 0x0E0A, 0x0E0A, 0x0E0A, 0x0E0A, 0x0E0A, 0x0E0A, 0x0E0A,
        0x0E0B, 0x0E0B, 0x0E0B, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+0C00 - U+0CFF

        0x1D1E, 0x0F07, 0x0F07, 0x0F07, 0x1D1E, 0x0F03, 0x0F03, 0x0F03,
        0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x1D1E, 0x0F03, 0x0F03,
        0x0F03, 0x1D1E, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03,
        0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03,
        0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03,
        0x0F03, 0x1D1E, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x0F03,
        0x0F03, 0x0F03, 0x0F03, 0x0F03, 0x1D1E, 0x0F03, 0x0F03, 0x0F03,
        0x0F03, 0x0F03, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0F06, 0x0F06,
        0x0F06, 0x0F07, 0x0F07, 0x0F07, 0x0F07, 0x1D1E, 0x0F06, 0x0F06,
        0x0F06, 0x1D1E, 0x0F06, 0x0F06, 0x0F06, 0x0F06, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0F06, 0x0F06, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0F03, 0x0F03, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0F0A, 0x0F0A,
        0x0F0A, 0x0F0A, 0x0F0A, 0x0F0A, 0x0F0A, 0x0F0A, 0x0F0A, 0x0F0A,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1007, 0x1007, 0x1D1E, 0x1003, 0x1003, 0x1003,
        0x1003, 0x1003, 0x1003, 0x1003, 0x1003, 0x1D1E, 0x1003, 0x1003,
        0x1003, 0x1D1E, 0x1003, 0x1003, 0x1003, 0x1003, 0x1003, 0x1003,
        0x1003, 0x1003, 0x1003, 0x1003, 0x1003, 0x1003, 0x1003, 0x1003,
        0x1003, 0x1003, 0x1003, 0x1003, 0x1003, 0x1003, 0x1003, 0x1003,
        0x1003, 0x1D1E, 0x1003, 0x1003, 0x1003, 0x1003, 0x1003, 0x1003,
        0x1003, 0x1003, 0x1003, 0x1003, 0x1D1E, 0x1003, 0x1003, 0x1003,
        0x1003, 0x1003, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1007, 0x1006,
        0x1007, 0x1007, 0x1007, 0x1007, 0x1007, 0x1D1E, 0x1006, 0x1007,
        0x1007, 0x1D1E, 0x1007, 0x1007, 0x1006, 0x1006, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1007, 0x1007, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1003, 0x1D1E,
        0x1003, 0x1003, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x100A, 0x100A,
        0x100A, 0x100A, 0x100A, 0x100A, 0x100A, 0x100A, 0x100A, 0x100A,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+0D00 - U+0DFF

        0x1D1E, 0x1D1E, 0x1107, 0x1107, 0x1D1E, 0x1103, 0x1103, 0x1103,
        0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1D1E, 0x1103, 0x1103,
        0x1103, 0x1D1E, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103,
        0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103,
        0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103,
        0x1103, 0x1D1E, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103,
        0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103, 0x1103,
        0x1103, 0x1103, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1107, 0x1107,
        0x1107, 0x1106, 0x1106, 0x1106, 0x1D1E, 0x1D1E, 0x1107, 0x1107,
        0x1107, 0x1D1E, 0x1107, 0x1107, 0x1107, 0x1106, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1107,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1103, 0x1103, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x110A, 0x110A,
        0x110A, 0x110A, 0x110A, 0x110A, 0x110A, 0x110A, 0x110A, 0x110A,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+0E00 - U+0EFF

        0x1D1E, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303,
        0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303,
        0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303,
        0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303,
        0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303,
        0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303,
        0x1303, 0x1306, 0x1303, 0x1303, 0x1306, 0x1306, 0x1306, 0x1306,
        0x1306, 0x1306, 0x1306, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1314,
        0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1303, 0x1306,
        0x1306, 0x1306, 0x1306, 0x1306, 0x1306, 0x1306, 0x1306, 0x1303,
        0x130A, 0x130A, 0x130A, 0x130A, 0x130A, 0x130A, 0x130A, 0x130A,
        0x130A, 0x130A, 0x1303, 0x1303, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1403, 0x1403, 0x1D1E, 0x1403, 0x1D1E, 0x1D1E, 0x1403,
        0x1403, 0x1D1E, 0x1403, 0x1D1E, 0x1D1E, 0x1403, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1403, 0x1403, 0x1403, 0x1403,
        0x1D1E, 0x1403, 0x1403, 0x1403, 0x1403, 0x1403, 0x1403, 0x1403,
        0x1D1E, 0x1403, 0x1403, 0x1403, 0x1D1E, 0x1403, 0x1D1E, 0x1403,
        0x1D1E, 0x1D1E, 0x1403, 0x1403, 0x1D1E, 0x1403, 0x1403, 0x1410,
        0x1403, 0x1406, 0x1403, 0x1403, 0x1406, 0x1406, 0x1406, 0x1406,
        0x1406, 0x1406, 0x1D1E, 0x1406, 0x1406, 0x1403, 0x1D1E, 0x1D1E,
        0x1403, 0x1403, 0x1403, 0x1403, 0x1403, 0x1D1E, 0x1415, 0x1D1E,
        0x1406, 0x1406, 0x1406, 0x1406, 0x1406, 0x1406, 0x1D1E, 0x1D1E,
        0x140A, 0x140A, 0x140A, 0x140A, 0x140A, 0x140A, 0x140A, 0x140A,
        0x140A, 0x140A, 0x1D1E, 0x1D1E, 0x1415, 0x1415, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+1000 - U+10FF

        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400,
        0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400,
        0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400,
        0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400,
        0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401,
        0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401,
        0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401,
        0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401,
        0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x0410, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+1100 - U+11FF

        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+1E00 - U+1EFF

        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0001, 0x0001,
        0x0001, 0x0001, 0x0001, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0001,
        0x0000, 0x0001, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+1F00 - U+1FFF

        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x1D1E, 0x1D1E,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x1D1E, 0x1D1E,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x1D1E, 0x1D1E,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x1D1E, 0x1D1E,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x1D1E, 0x0200, 0x1D1E, 0x0200, 0x1D1E, 0x0200, 0x1D1E, 0x0200,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x1D1E, 0x1D1E,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0200,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x1D1E, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0202, 0x0202, 0x0202,
        0x0202, 0x0202, 0x0201, 0x0201, 0x0201, 0x1D1E, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0202, 0x0202, 0x0202,
        0x0201, 0x0201, 0x0201, 0x0201, 0x1D1E, 0x1D1E, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x1D1E, 0x0202, 0x0202, 0x0202,
        0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0202, 0x0202, 0x0202,
        0x1D1E, 0x1D1E, 0x0201, 0x0201, 0x0201, 0x1D1E, 0x0201, 0x0201,
        0x0200, 0x0200, 0x0200, 0x0200, 0x0200, 0x0202, 0x0202, 0x1D1E,

        //      U+2000 - U+20FF

        0x1D18, 0x1D18, 0x1D18, 0x1D18, 0x1D18, 0x1D18, 0x1D18, 0x1D18,
        0x1D18, 0x1D18, 0x1D18, 0x1D18, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C,
        0x1D11, 0x1D11, 0x1D11, 0x1D11, 0x1D11, 0x1D11, 0x1D10, 0x1D10,
        0x1D0E, 0x1D0F, 0x1D10, 0x1D10, 0x1D0E, 0x1D0F, 0x1D10, 0x1D10,
        0x1D10, 0x1D10, 0x1D10, 0x1D10, 0x1D10, 0x1D10, 0x1D10, 0x1D10,
        0x1D19, 0x1D1A, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1E,
        0x1D10, 0x1D10, 0x1D10, 0x1D10, 0x1D10, 0x1D10, 0x1D10, 0x1D10,
        0x1D10, 0x1D0E, 0x1D0F, 0x1D10, 0x1D10, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D0E, 0x1D0F, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C, 0x1D1C,
        0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D11, 0x1D15, 0x1D0E, 0x1D0F, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D11, 0x1D15, 0x1D0E, 0x1D0F, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D14, 0x1D14, 0x1D14, 0x1D14, 0x1D14, 0x1D14, 0x1D14, 0x1D14,
        0x1D14, 0x1D14, 0x1D14, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D06,
        0x1D06, 0x1D06, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+2100 - U+21FF

        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+2200 - U+22FF

        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13, 0x1D13,
        0x1D13, 0x1D13, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+2300 - U+23FF

        0x1D15, 0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D0E, 0x1D0F, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+2400 - U+24FF

        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A,
        0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A,
        0x1D0A, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D0A, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+2500 - U+25FF

        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+2600 - U+26FF

        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+2700 - U+27FF

        0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D15, 0x1D1E, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D15, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E,
        0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+3000 - U+30FF

        0x1D18, 0x1D10, 0x1D10, 0x1D10, 0x1D15, 0x1D10, 0x1D10, 0x1D0B,
        0x1D0E, 0x1D0F, 0x1D0E, 0x1D0F, 0x1D0E, 0x1D0F, 0x1D0E, 0x1D0F,
        0x1D0E, 0x1D0F, 0x1D15, 0x1D15, 0x1D0E, 0x1D0F, 0x1D0E, 0x1D0F,
        0x1D0E, 0x1D0F, 0x1D0E, 0x1D0F, 0x1D11, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D0B, 0x1D0B, 0x1D0B, 0x1D0B, 0x1D0B, 0x1D0B, 0x1D0B,
        0x1D0B, 0x1D0B, 0x1C06, 0x1C06, 0x1C06, 0x1C06, 0x1B06, 0x1B06,
        0x1D11, 0x1915, 0x1915, 0x1915, 0x1915, 0x1915, 0x1D15, 0x1D15,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D15,
        0x1D1E, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1906, 0x1906, 0x1902, 0x1902, 0x1902, 0x1902, 0x1D1E,
        0x1D1E, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1910, 0x1902, 0x1902, 0x1902, 0x1D1E,

        //      U+3100 - U+31FF

        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1A03, 0x1A03, 0x1A03,
        0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03,
        0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03,
        0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03,
        0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03,
        0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1A03, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+3200 - U+32FF

        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E,

        //      U+3300 - U+33FF

        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E,

        //      U+9F00 - U+9FFF

        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+F800 - U+F8FF

        0x1D1E, /* HSYS 0xF800 */ 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D11,/* HSYS */ 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1D, 0x1D1E, 0x1D03, 0x1D03, 0x1D03, 0x1D03, 0x1D03,
        0x1D03, 0x1D03, 0x1D03, 0x1D03, 0x1D03, 0x1D03, 0x1D03, 0x1D03,
        0x1D03, 0x1D03, 0x1D03, 0x1D03, 0x1D03, 0x1D03, 0x1D03, 0x1D1D,

        //      U+FA00 - U+FAFF

        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03,
        0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1C03, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+FB00 - U+FBFF

        0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x0501, 0x0501, 0x0501, 0x0501, 0x0501,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x0606, 0x0603,
        0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603,
        0x0603, 0x0613, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603,
        0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x1D1E,
        0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x1D1E, 0x0603, 0x1D1E,
        0x0603, 0x0603, 0x1D1E, 0x0603, 0x0603, 0x1D1E, 0x0603, 0x0603,
        0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603, 0x0603,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,

        //      U+FD00 - U+FDFF

        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x070E, 0x070F,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x1D1E, 0x1D1E, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,

        //      U+FE00 - U+FEFF

        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D06, 0x1D06, 0x1D06, 0x1D06, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1C15, 0x1C15, 0x1C15, 0x1C15, 0x1C15, 0x1C0E, 0x1C0F, 0x1C0E,
        0x1C0F, 0x1C0E, 0x1C0F, 0x1C0E, 0x1C0F, 0x1C0E, 0x1C0F, 0x1C0E,
        0x1C0F, 0x1C0E, 0x1C0F, 0x1C0E, 0x1C0F, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1C15, 0x1C15, 0x1C15, 0x1C15, 0x1C15, 0x1C15, 0x1C15,
        0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x1D0E, 0x1D0F, 0x1D0E, 0x1D0F, 0x1D0E, 0x1D0F, 0x1D15,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x0703, 0x0703, 0x0703, 0x1D1E, 0x0703, 0x1D1E, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x0703,
        0x0703, 0x0703, 0x0703, 0x0703, 0x0703, 0x1D1E, 0x1D1E, 0x1D18,

        //      U+FF00 - U+FFFF

        0x1D1E, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D0E, 0x1D0F, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A, 0x1D0A,
        0x1D0A, 0x1D0A, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15,
        0x1D15, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
        0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
        0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
        0x0000, 0x0000, 0x0000, 0x1D0E, 0x1D15, 0x1D0F, 0x1D15, 0x1D15,
        0x1D15, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
        0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
        0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001,
        0x0001, 0x0001, 0x0001, 0x1D0E, 0x1D15, 0x1D0F, 0x1D15, 0x1D1E,
        0x1D1E, 0x1915, 0x190E, 0x190F, 0x1915, 0x1915, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1915, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903,
        0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1903, 0x1915, 0x1915,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1D1E, 0x1D1E, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1D1E, 0x1D1E, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03, 0x1B03,
        0x1D1E, 0x1D1E, 0x1B03, 0x1B03, 0x1B03, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E,
        0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D15, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E,
        0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D1E, 0x1D15, 0x1D1E, 0x1D1E
        };



IUnicode::ICharacterLayoutProperties gLayoutData[] = {
        0x03, 0x00, 0x05, 0x07, 0x09, 0x0B, 0x0D, 0x00,
        0x00, 0x0F, 0x11, 0x13, 0x15, 0x17, 0x19, 0x00,
        0x1B, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x1D, 0x1F, 0x21, 0x23, 0x25, 0x27, 0x29, 0x2B,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x2D, 0x2F, 0x31, 0x33, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x35, 0x50, 0x37, 0x39, 0x3B,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
        0x20, 0x20, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0xAC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x00, 0x50, 0x50, 0x50, 0xA0, 0x50,
        0xA0, 0x50, 0x50, 0xA0, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0xA0, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0xA0, 0x00, 0x00, 0x00, 0xA0,
        0x00, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
        0x10, 0x10, 0x50, 0x5C, 0x5C, 0x50, 0x00, 0x00,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x00, 0x00, 0x50, 0x50, 0x50, 0x50, 0x50, 0x00,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x00,
        0x50, 0x50, 0x50, 0x50, 0xAC, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x00, 0x00,
        0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
        0x10, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0xA0, 0xA0, 0x20, 0x20,
        0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
        0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0xA0, 0xA0, 0x00, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00, 0x00,
        0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0xA0, 0xA0, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0xA0, 0xA0, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
        0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80,
        0x80, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xA0,
        0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
        0x20, 0x20, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
        0x20, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0xAC, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0xA0, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0x00, 0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0xA0, 0xA0, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0xA0, 0xA0,
        0xA0, 0xA0, 0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0xA0, 0x00, 0xA0,
        0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0xA0, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xAC, 0xA0, 0xA0, 0xA0,
        0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0xAC, 0xAC, 0xAC, 0xAC, 0xAC, 0xA0, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0xA0, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x90,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x00,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x00, 0x50, 0x00,
        0x50, 0x50, 0x00, 0x50, 0x50, 0x00, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x00, 0x00, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50, 0x50,
        0x50, 0x50, 0x50, 0x50, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00,
        0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0x00, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0x00, 0xA0, 0x00, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0xA0,
        0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0,
        0x00, 0x00, 0xA0, 0xA0, 0xA0, 0x00, 0x00, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0xA0, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00, 0x00
        };

#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif // _IUPRDATA_

